#pragma comment(linker, "/opt:NOWIN98")
#pragma comment(linker, "/ALIGN:16384 ")


//MSVCRTD.LIB 
///nodefaultlib:"libcmtd" /nodefaultlib:"libcd" // stdin fails

#include <windows.h>
#include <stdio.h>

#include "..\ppServices\ppServices.h"

#include "common.h"

#include <malloc.h>

#if defined (_MSC_VER) // use in ppSetStaticVar, ppSetVar
 #define ALLOC _alloca
#else
 #define ALLOC malloc
#endif

BOOL replaceCharWithEscSeq(IN LPCTSTR pszStringIn, OUT LPSTR pszStringOut);

void addHexChar(LPSTR pszStringOut, BYTE byteOfChar);
void txData(LPSTR pszStdinBuf);

void terminateMsg(LPSTR pszMsg, BOOL bUsage);

CHAR  setEscChar();

//nicked from ppServicesClient

VOID  ppSetVar(LPSTR pszVar, LPSTR pszValue, HWND hwndServer);
BOOL  ppSetStaticVar(LPSTR pszName, LPSTR pszScript, LPSTR pszVal, BOOL bCreate, HWND hwndServer);
BOOL  ppEvalExpr(LPSTR pszExpr, HWND hwndServer);

LPSTR getMappedFile(HWND hwnd, OUT PHANDLE phmem);
void  closeMappedFile(LPSTR pszFileMap, HANDLE hmem);


static const CHAR*  g_pszSpecialChars =        "\n\r\t\x01\xFE";
static const CHAR   g_cSpecialCharEscapes[] =  {'n', 'r', 't', '\x01', '\xFE'};
static const char   G_C_ESC_Q =                '\"'; // '\xFD'; 

LPSTR               g_pszVarName =             "";
LPSTR               g_pszStaticScript =        "";
LPSTR               g_pszAction =              "";
LPSTR               g_pszActionFolder =        "";
UINT                g_uiScriptToCallLen =      0; 
LPSTR               g_pszInsertionMark =       "#";
BOOL                g_bInsertEachLine =        0;
CHAR                g_cEsc =                   '\\';

FILE*               g_fhInput =                NULL;
HWND                g_hwndServer =             NULL;



//static const UINT   G_TOP_LOW_VALUE_CHAR_ESCAPED = 0x20;
//static const UINT   G_BOTTOM_HIGH_VALUE_CHAR_ESCAPED = 0x7F;

#define BLOCK_SIZE 1024 //arbitrary value, reduce to reduce memory footprint or increase to improve performance

int main(int argc, char **argv) 
{
 unsigned int nStdinBufLen = BLOCK_SIZE;	

 char *ptr; //a pointer for use with fgets and realloc

 LPSTR pszStdinBuf = malloc(BLOCK_SIZE);
 LPSTR pszStdinBufPtr = pszStdinBuf; 
 LPSTR pszMarkerDiv = "";

 FILE* fhInput = stdin;

 LPSTR pszFile = NULL;

 if (!init()) // sets g_hwndPowerPro; in common.c
  return(1);

 toPPviaCopyData("ppservices.start");

 g_hwndServer = FindWindow("PowerProServicesServerWinClass", "PowerProServicesServerWin");
 if (!g_hwndServer)
   terminateMsg("can't launch ppServices", 0);

 g_cEsc = setEscChar();


// printf("waitinf thirty seconds\n"); // was trying to attqach debuger to process
// Sleep(30000);

 if (argc >= 2)
  g_pszVarName =        argv[1];

 if (argc >= 3)
  g_pszStaticScript =   argv[2];

 if (argc >= 4)
 {
  g_pszAction =   argv[3];
 }

 g_uiScriptToCallLen = strlen(g_pszAction); 

// if (argc >= 5)
//  g_pszActionFolder =   argv[4];

 if (argc >= 5  && *(argv[4]) != 0)
 {
  if (*(argv[4]) != '1' && *(argv[4]) != '0')
   terminateMsg("per_line_flag must be 0 or 1", 1);

  g_bInsertEachLine =   atol(argv[4]);
 }

 if (argc >= 6 && *(argv[5]) != 0)
 {
  LPSTR pszBreak;
  g_pszInsertionMark =  argv[5];
  pszBreak = strchr(g_pszInsertionMark, ' ');
  if (!pszBreak)
   pszBreak = strchr(g_pszInsertionMark, '\t');

  if (pszBreak)
  {
   *pszBreak++ = 0;
   while (*pszBreak == ' ' || *pszBreak == '\t') pszBreak++;
   pszMarkerDiv = pszBreak;
  }

 }

 if (*g_pszAction)
 {
  LPSTR pszActionFolder = strstr(g_pszAction, pszMarkerDiv);
  if (pszActionFolder)
    g_pszActionFolder = pszActionFolder;
 }

/*
 if (*g_pszInsertionMark && !(g_pszAction))
 {
  toPPviaCopyData("message error in 2pp2: insertion_marker parameter requires command parameter"); // requires g_hwndPowerPro; ; in common.c
  return(1);
 }

 if (argc >= 7 && *(argv[6]) != 0)
  g_cEsc = *(argv[6]);

*/

 if (argc >= 7 && *(argv[6]) != 0)
  pszFile = argv[6];

 if (pszStdinBuf == 0) 
  terminateMsg("memory allocation error", 0);

 *pszStdinBuf = 0;

 if (argc < 2)
  terminateMsg("at least one argument required", 1);


 if (pszFile)
 {
  g_fhInput = fopen(pszFile, "r");

  if (!g_fhInput)
   terminateMsg("can't open file; file_to_read doesn't exist? unquoted?", 1);

  fhInput = g_fhInput;
 }


 while (TRUE)
 {
//read a line fron stdin/file
  UINT uiBuffNew = 0;

  ptr = fgets(pszStdinBufPtr, nStdinBufLen, fhInput);
  if (!ptr)
   break;

  uiBuffNew = strlen(pszStdinBufPtr);
  if (strlen(pszStdinBufPtr) + 1 == nStdinBufLen) 
  {
// buffer filled, expand it
   nStdinBufLen += uiBuffNew + BLOCK_SIZE;
   ptr = realloc(pszStdinBuf, nStdinBufLen);
   if (ptr == 0) 
    terminateMsg("memory allocation error", 0);

   pszStdinBuf = ptr;
   pszStdinBufPtr = pszStdinBuf + uiBuffNew;
   nStdinBufLen = BLOCK_SIZE;
   continue;
  }

  if (g_bInsertEachLine)
  {
   if (*pszStdinBufPtr != '\n' && *pszStdinBufPtr != 0) 
   {
    if (*pszStdinBuf != 0)
     txData(pszStdinBuf);
   }
   *pszStdinBuf = 0;
  }
  else
  {
   nStdinBufLen   -= uiBuffNew;
   pszStdinBufPtr += uiBuffNew;
// pszStdinBufPtr--;
  } // g_bInsertEachLine

 } // while (TRUE)

//if (!g_bInsertEachLine)
 if (*pszStdinBuf != '\n' && *pszStdinBuf != 0) 
  txData(pszStdinBuf);

 if (g_fhInput) fclose(g_fhInput);

 exit(0);
}

//////////////////////////////////////////////////////////////////////////

void txData(LPSTR pszStdinBuf)
{
//remove trailing eol
 LPSTR pszStdinBufEnd = pszStdinBuf + strlen(pszStdinBuf) - 1;
 if (*pszStdinBufEnd == '\n')
  *(pszStdinBufEnd) = 0;
 if (*(pszStdinBufEnd - 1) == '\r') 
  *(pszStdinBufEnd - 1) = 0;

 if (*g_pszVarName)
 {
  if (*g_pszStaticScript)
  {
   if (!ppSetStaticVar(g_pszVarName, g_pszStaticScript, pszStdinBuf, 1, g_hwndServer))
    terminateMsg("can't write to static variable", 1);
  }
  else
   ppSetVar(g_pszVarName, pszStdinBuf, g_hwndServer);
 }

 if (!(*g_pszAction))
  return;

//send script
 if (*g_pszInsertionMark) //maybe with inserted literal text
 {
  LPSTR pszMarker;
  CHAR pszCmd[PP_MAX_CMD_LEN + 1];
  LPSTR pszCmdPtr = pszCmd;

  strcpy(pszCmd, g_pszAction);

  pszMarker = strstr(pszCmd, g_pszInsertionMark);

  if (pszMarker)
  {
   UINT uiMarkerLen = strlen(g_pszInsertionMark);
   CHAR pszDataEscaped[PP_MAX_CMD_LEN + 1];

   if (!replaceCharWithEscSeq(pszStdinBuf, pszDataEscaped) || 
        (strlen(g_pszAction) + strlen(g_pszActionFolder) + strlen(pszDataEscaped) - uiMarkerLen + 15) > PP_MAX_CMD_LEN)
    terminateMsg("expression to long to execute;\nuse per_line?", 1);

   if (*(pszMarker - 2) == '?' && *(pszMarker - 1) == *(pszMarker + uiMarkerLen)) 
   {
//  remove delimiters, gonna use esc(..)
    *(pszMarker - 2) = 0; 
    uiMarkerLen++;
   }
   else
    *pszMarker = 0;

   pszCmdPtr += strlen(pszCmd);
   *(pszCmdPtr++) = G_C_ESC_Q;
   *(pszCmdPtr) = 0;

   strcpy(pszCmdPtr, pszDataEscaped);
   pszCmdPtr += strlen(pszCmdPtr);

   *(pszCmdPtr++) = G_C_ESC_Q;
   *(pszCmdPtr) = 0;

   pszMarker = strstr(g_pszAction, g_pszInsertionMark);

   if (pszMarker)
   {
    strcpy(pszCmdPtr, pszMarker + uiMarkerLen); // step over insertion mark, plus maybe trailing ?c..c delimiter
    pszCmdPtr += strlen(pszMarker + uiMarkerLen);
   } 
   if (*g_pszActionFolder)
   {
    *(pszCmdPtr++) = '\x01'; 
    strcpy(pszCmdPtr, g_pszActionFolder);
   }
   toPPviaCopyData(pszCmd);

   return;
  }
 }

 toPPviaCopyData(g_pszAction);
}

//////////////////////////////////////////////////////////////////////////

BOOL replaceCharWithEscSeq(IN LPCTSTR pszStringIn, OUT LPSTR pszStringOut)
{
 const INT iNoSpecChars = strlen(g_pszSpecialChars);
 LPSTR pszStringOutPtr = pszStringOut;
// *(pszStringOut++) = '\"';
 
 LPSTR pszStringInLocal = (LPSTR) pszStringIn;
 LPSTR pszNextChar = pszStringInLocal;

 *pszStringOutPtr = '\0';

 while (*pszNextChar)
 {
  LPSTR pszFoundChar = strchr(g_pszSpecialChars, *pszNextChar);
  if(pszFoundChar) 
  {
   *(pszStringOutPtr++) = g_cEsc; //G_C_ESC;
   *(pszStringOutPtr++) = g_cSpecialCharEscapes[pszFoundChar- g_pszSpecialChars];
  }
  else if (*pszNextChar == g_cEsc || *pszNextChar == G_C_ESC_Q)
  {
//((*pszNextChar >= 1 && (unsigned char) *pszNextChar <= G_TOP_LOW_VALUE_CHAR_ESCAPED) || 
//         (unsigned char) *pszNextChar >= G_BOTTOM_HIGH_VALUE_CHAR_ESCAPED || 
   *(pszStringOutPtr++) = g_cEsc; // G_C_ESC;
   *(pszStringOutPtr++) = 'x';
   addHexChar(pszStringOutPtr++, LOBYTE((*pszNextChar >> 4) & 0x0F)); 
   addHexChar(pszStringOutPtr++, LOBYTE((*pszNextChar) & 0x0F)); 
  }
  else
   *(pszStringOutPtr++) = *pszNextChar;

  if (pszStringOutPtr - pszStringOut > PP_MAX_CMD_LEN)
   return FALSE;
  pszNextChar++;

 } // while (*pszNextChar)

 *(pszStringOutPtr++) = '\0';

 if (pszStringOutPtr - pszStringOut > PP_MAX_CMD_LEN)
  return FALSE;

 return TRUE;
}

//////////////////////////////////////////////////////////////////////////

void addHexChar(LPSTR pszStringOut, BYTE byteOfChar)
{
 if (byteOfChar <= 9)
  byteOfChar += '0';
 else 
  byteOfChar += ('A' - 10);
 *(pszStringOut) = byteOfChar;
}

//////////////////////////////////////////////////////////////////////////

CHAR setEscChar()
{
 CHAR pszExpr[PP_MAX_CMD_LEN + 1];
 LPSTR pszExprPtr = pszExpr; // + 6;
 UINT uiChar = 0x20;


//any char greater than 128
//else any non-numeric, non-alphabetic, non blank >0x20
 *(pszExprPtr++) = '\"'; //open quotes

 for (uiChar = 0x21; uiChar < 255; uiChar++)
 {
  if (uiChar != '\"' && uiChar != ' ' && uiChar != '\xFE' && (uiChar > 128 || !isalnum(uiChar)))
  {
   *(pszExprPtr++) = uiChar; 
   *(pszExprPtr++) = 'n';
  }
 }
 *(pszExprPtr++) = '\"'; //close quotes
 *pszExprPtr = 0;

 if (ppEvalExpr(pszExpr, g_hwndServer))
 {
  HANDLE hmem;
  LPSTR pszFileMap = getMappedFile(g_hwndServer, &hmem);
  if (pszFileMap)
  {
   LPSTR pszNewline = strchr(pszFileMap, '\n');
   if (pszNewline)
   {
    LPSTR pszChar = pszExpr;
    *pszNewline = 0;
    if (pszNewline > pszFileMap) 
    {
//   backup to previous character
     pszNewline -= 2;
//   find previous character in original express; 
     pszChar = strchr(pszExpr, *pszNewline);
//   match is net char along
     pszChar += 2;
    }
    return *pszChar;
   }
  }
  closeMappedFile(pszFileMap, hmem);
 }
 return '\\';
}

//////////////////////////////////////////////////////////////////////////
//nicked from ppServicesClient

VOID ppSetVar(LPSTR pszVar, LPSTR pszValue, HWND hwndServer)
{
 COPYDATASTRUCT cd;
 LRESULT lResult = 0;
 struct PowerProServiceRequest* pPowerProServiceRequest;
 UINT uiVar = strlen(pszVar) + 1;
 UINT uiValue = strlen(pszValue) + 1;
 UINT uiBufLen = sizeof(struct PowerProServiceRequest) + uiVar + uiValue;

 cd.lpData = (PVOID) ALLOC(uiBufLen);
 memset(cd.lpData, 0, uiBufLen);

 cd.cbData = uiBufLen; // sizeof(struct PowerProServiceRequest);
 pPowerProServiceRequest = (struct PowerProServiceRequest*) cd.lpData;

 pPowerProServiceRequest->ppServType = ppServiceSetVar;

 pPowerProServiceRequest->ad[0].uiOff = sizeof(struct PowerProServiceRequest);
 pPowerProServiceRequest->ad[0].dwLen =    uiVar;
 strcpy(PP_STR_ARG(pPowerProServiceRequest, 0), pszVar);

 pPowerProServiceRequest->ad[1].uiOff = pPowerProServiceRequest->ad[0].uiOff + uiVar;
 pPowerProServiceRequest->ad[1].dwLen =    uiValue;
 strcpy(PP_STR_ARG(pPowerProServiceRequest, 1), pszValue);

 SendMessage(hwndServer, WM_COPYDATA, (WPARAM) NULL, (LPARAM) &cd);

#if !defined (_MSC_VER)
 free((PVOID) cd.lpData);
#endif

 return;
}

//////////////////////////////////////////////////////////////////////////
//nicked from ppServicesClient

BOOL ppSetStaticVar(LPSTR pszName, LPSTR pszScript, LPSTR pszVal, BOOL bCreate, HWND hwndServer)
{
 COPYDATASTRUCT cd;
 LRESULT lResult = 0;
 struct PowerProServiceRequest* pPowerProServiceRequest;
 UINT uiName =   strlen(pszName) + 1;
 UINT uiScript = strlen(pszScript) + 1;
 UINT uiVal =    strlen(pszVal) + 1;
 UINT uiBufLen = sizeof(struct PowerProServiceRequest) + uiName  + uiScript + uiVal;

 cd.lpData = (PVOID) ALLOC(uiBufLen);
 memset(cd.lpData, 0, uiBufLen);

 cd.cbData = uiBufLen; // sizeof(struct PowerProServiceRequest);
 pPowerProServiceRequest = (struct PowerProServiceRequest*) cd.lpData;

 pPowerProServiceRequest->ppServType = ppServiceSetVar;

 pPowerProServiceRequest->ad[0].uiOff = sizeof(struct PowerProServiceRequest);
 pPowerProServiceRequest->ad[0].dwLen = uiName;
 strcpy(PP_STR_ARG(pPowerProServiceRequest, 0), pszName);

 pPowerProServiceRequest->ad[1].uiOff = pPowerProServiceRequest->ad[0].uiOff + uiName;
 pPowerProServiceRequest->ad[1].dwLen = uiScript;
 strcpy(PP_STR_ARG(pPowerProServiceRequest, 1), pszScript);

 pPowerProServiceRequest->ad[2].uiOff = pPowerProServiceRequest->ad[1].uiOff + uiScript;
 pPowerProServiceRequest->ad[2].dwLen = uiVal;
 strcpy(PP_STR_ARG(pPowerProServiceRequest, 2), pszVal);

 pPowerProServiceRequest->ad[3].dw = bCreate;

 if (SendMessage(hwndServer, WM_COPYDATA, (WPARAM) NULL, (LPARAM) &cd))
  lResult = SendMessage(hwndServer, MSG_TO_SERVICE_PLUGIN_TO_GET_DWORD_RESULT, 0, 0);

#if !defined (_MSC_VER)
 free((PVOID) cd.lpData);
#endif

 return lResult;
}

/////////////////////////////////////////////////////////////////////////////
//nicked from ppServicesClient

BOOL ppEvalExpr(LPSTR pszExpr, HWND hwndServer)
{
 COPYDATASTRUCT cd;
 LRESULT lResult = 0;
// LPSTR pszPtr = NULL;

 struct PowerProServiceRequest* pPowerProServiceRequest;
 UINT uiBufLen = sizeof(struct PowerProServiceRequest) + PP_MAX_CMD_LEN + 1;

 cd.lpData = (PVOID) ALLOC(uiBufLen);
 memset(cd.lpData, 0, uiBufLen);

 cd.dwData = 0;
 cd.cbData = uiBufLen; // sizeof(struct PowerProServiceRequest);
 pPowerProServiceRequest = (struct PowerProServiceRequest*) cd.lpData;

 pPowerProServiceRequest->ppServType = ppServiceEvalExpr;
 pPowerProServiceRequest->ad[0].uiOff = sizeof(struct PowerProServiceRequest);
 pPowerProServiceRequest->ad[0].dwLen = PP_MAX_CMD_LEN + 1;
// pszPtr = PP_STR_ARG(pPowerProServiceRequest, 0); 
 strcpy(PP_STR_ARG(pPowerProServiceRequest, 0), pszExpr);

 lResult = SendMessage(hwndServer, WM_COPYDATA, (WPARAM) NULL, (LPARAM) &cd);

#if !defined (_MSC_VER)
 free((PVOID) cd.lpData);
#endif

 return lResult;
}

/////////////////////////////////////////////////////////////////////////////
//service routines used by any of above that return a string
/////////////////////////////////////////////////////////////////////////////

LPSTR getMappedFile(HWND hwnd, OUT PHANDLE phmem)
{
 *phmem = OpenFileMapping(FILE_MAP_ALL_ACCESS, FALSE, FILE_MAP_NAME);
 if (*phmem)
 {
  UINT uiFileMapDataLen = SendMessage(hwnd, MSG_TO_SERVICE_PLUGIN_TO_GET_STRING_RESULT_LEN, 0, 0);
//If is zero, the entire file is mapped.                        dwNumberOfBytesToMap
  return (LPSTR) MapViewOfFile(*phmem, FILE_MAP_ALL_ACCESS, 0, 0, uiFileMapDataLen);
 }
 return NULL;
}

//////////////////////////////////////////////////////////////////////////

void closeMappedFile(LPSTR pszFileMap, HANDLE hmem)
{
 if (pszFileMap) UnmapViewOfFile(pszFileMap);
 if (hmem)       CloseHandle(hmem);
}

//////////////////////////////////////////////////////////////////////////

void terminateMsg(LPSTR pszMsg, BOOL bUsage)
{
 CHAR pszBuff[256];

 sprintf(pszBuff, "message error in 2pp2: %s", pszMsg);
// if (bUsage)
//  strcat(pszBuff, "usage:\n2pp2 variable_name [static_script [command [insertion_marker [per_line [file_to_read]]]]]");

 toPPviaCopyData(pszBuff); // requires g_hwndPowerPro; in common.c
 printf("%s\n", pszBuff);

 if (g_fhInput) fclose(g_fhInput);
 exit(1);
}

/////////////////////////////////////////////////////////////////////////////
