#!/bin/sh
# the next line restarts using wish \
exec wish8.0 "$0" "$@"
load powerpro.dll
set Counter 0;
# counter variables
set i 0;

set ccprev_ent "";
set cccurr_ent "";
set cc_nb 0;
set cc_sp 0;

#procedure for generating calculator errors
proc generror { x } {
	set y [ format "%[ expr [ string length $x ]/2 -3 ]s" " " ];
	tk_dialog .calc.error "Error !!" "$y ERROR !!\n$x" "" 0 "Ok";
};

# procedures for mathematical functions
proc Abs { x } {
	return [ expr abs($x) ]; };

proc Random { x y } {
	return [ expr $x+int(rand()*($y-$x+1)) ]; };

proc Ceil { x } {
	return [ expr ceil($x) ]; };

proc Double { x } {
	return [ expr double(int($x)) ]; };

proc Floor { x } {
	return [ expr floor($x) ]; };

proc Int { x } {
	return [ expr int($x) ]; };

proc Round { x } {
	return [ expr round($x) ]; };

proc Acos { x } {
	if { ($x < -1.0) || ($x > +1.0) } { return "undef"; };
	return [ expr acos($x) ]; };

proc Asin { x } {
	if { ($x < -1.0) || ($x > +1.0) } { return "undef"; };
	return [ expr asin($x) ]; };

proc Atan { x } {
	return [ expr atan($x) ]; };

proc Cos { x } {
	return [ expr cos($x) ]; };

proc Sin { x } {
	return [ expr sin($x) ]; };

proc Tan { x } {
	global PI;
	global ErrorIncr;
	set n [ expr int($x/$PI*2.0) ];
	if  { ( $x >= [ expr $n*$PI/2.0 - $ErrorIncr ] ) && ( $x <= [ expr $n*$PI/2.0 + $ErrorIncr ] ) } { return "undef" };
	return [ expr tan($x) ] ; };

proc Cosh { x } {
	return [ expr cosh($x) ]; };

proc Sinh { x } {
	return [ expr sinh($x) ]; };

proc Tanh { x } {
	return [ expr tanh($x) ]; };

proc Exp { x } {
	return [ expr exp($x) ]; };

proc Log { x } {
	if { $x <= 0.0 } { return "undef" };
	return [ expr log($x) ] ; };

proc Log10 { x } {
	if { $x <= 0.0 } { return "undef" };
	return [ expr log10($x) ] ; };

proc Pow { x y } {
	if { [ catch { set a [ expr pow($x,$y) ] } ] == 1 } { return "undef" };
	return $a; };

proc Sqrt { x } {
	if { $x < 0.0 } { return "undef" };
	return [ expr sqrt($x) ] ; };

proc Asinh { x } {
	return [ expr log( $x  + sqrt( 4 *  $x  *  $x  + 1)) ]; };

proc Acosh1 { x } {
	if { $x < 0.0 } { return "undef" };
	return [ expr log($x + sqrt(4*$x * $x - 1))]; };

proc Acosh2 { x } {
	if { $x < 0.0 } { return "undef" };
	return [ expr log($x - sqrt(4*$x * $x - 1))]; };

proc Atanh { x } {
	global ErrorIncr;
	if { ( $x <= [ expr 1.0 - $ErrorIncr ]) && ( $x >= [ expr 1.0 + $ErrorIncr ]) } { return "undef" };
	return [ expr ( $x + 1.0)/(1.0 - $x) ]; };

proc Sgn { x } {
	if { $x < 0.0 } { return -1 };
	if { $x > 0.0 } { return +1 };
	return 0.0; };

# procedure for actually sketching graph
proc draw_graph { } {
	global Counter spc Xpix Ypix RHS Draw_axes Draw_grid 3_Dim numcanvas Persp LabelAxis;
	global Xfactor Yfactor theta cabfact k npiter niter point xmax ymax zmax;

	incr Counter;

	catch { .canvas$numcanvas.can delete axisx axisy; };
	catch { .canvas$numcanvas.can delete axisz; };
	catch { .canvas$numcanvas.can delete textx texty ; }
	catch { .canvas$numcanvas.can delete textz; };
	catch { .canvas$numcanvas.can delete arrowx arrowy ; };
	catch { .canvas$numcanvas.can delete arrowz; };
	for { set l -2.5 } { $l < 3 } { set l [ expr $l +1 ] } {
		 set clx([ expr $l+2.5]) "clx$l";
		 set llx([ expr $l+2.5]) "llx$l";
		 set cly([ expr $l+2.5]) "cly$l";
		 set lly([ expr $l+2.5]) "lly$l";
		 set clz([ expr $l+2.5]) "clz$l";
		 set llz([ expr $l+2.5]) "llz$l";
		 catch { .canvas$numcanvas.can delete $clx([ expr $l+2.5 ]) $cly([ expr $l+2.5 ]);
	 	 .canvas$numcanvas.can delete $clz([ expr $l+2.5 ]);
		 .canvas$numcanvas.can delete $llx([ expr $l+2.5 ]) $lly([ expr $l+2.5 ]);
		 .canvas$numcanvas.can delete $llz([ expr $l+2.5 ]); }; };

	if { $3_Dim == 0 } { set Persp 30; };

	if { $Draw_grid == 1 } {
		for { set x $spc } { $x < $Xpix } { incr x $spc } {
			.canvas$numcanvas.can create line $x 0 $x $Ypix -fill "#ffff00"; };
		for { set y $spc } { $y < $Ypix } { incr y $spc } {
			.canvas$numcanvas.can create line 0 $y $Xpix $y -fill "#ffff00"; }; };

	if { $Draw_axes == 1 } {
		.canvas$numcanvas.can create line [ expr $Xpix/2 ] 0 [ expr $Xpix/2 ] $Ypix -fill "#ff0000" -tags axisx;
		.canvas$numcanvas.can create line 0 [ expr $Ypix/2 ] $Xpix [ expr $Ypix/2 ] -fill "#ff0000" -tags axisy;
		if { $3_Dim == 1 } {
			.canvas$numcanvas.can create line [ expr $Xpix/2 - $Xpix*cos($theta)/$k ] [ expr $Ypix/2 + $Xpix*sin($theta)/$k ] [ expr $Xpix/2 + $Xpix*cos($theta)/$k ] [ expr $Ypix/2 - $Xpix*sin($theta)/$k ] -fill "#ff0000" -tags axisz; };
		}

	if { $LabelAxis == 1 } {
		if { $RHS == 0 } {
			switch $Persp {
				10 { set lx 1; set ly 1; set lz -1;
				     set dx "z"; set dy "y"; set dz "x"; }
				11 { set lx -1; set ly 1; set lz 1;
				     set dx "z"; set dy "y"; set dz "x"; }
				20 { set lx 1; set ly 1; set lz -1;
				     set dx "x"; set dy "z"; set dz "y"; }
				21 { set lx -1; set ly 1; set lz 1;
				     set dx "x"; set dy "z"; set dz "y"; }
				30 { set lx -1; set ly 1; set lz -1;
				     set dx "x"; set dy "y"; set dz "z"; }
				31 { set lx 1; set ly 1; set lz 1;
				     set dx "x"; set dy "y"; set dz "z"; } }; } else {
			switch $Persp {
				10 { set lx -1; set ly 1; set lz -1;
				     set dx "z"; set dy "y"; set dz "x"; }
				11 { set lx 1; set ly 1; set lz 1;
				     set dx "z"; set dy "y"; set dz "x"; }
				20 { set lx -1; set ly 1; set lz -1;
				     set dx "x"; set dy "z"; set dz "y"; }
				21 { set lx 1; set ly 1; set lz 1;
				     set dx "x"; set dy "z"; set dz "y"; }
				30 { set lx 1; set ly 1; set lz -1;
				     set dx "x"; set dy "y"; set dz "z"; }
				31 { set lx -1; set ly 1; set lz 1;
				     set dx "x"; set dy "y"; set dz "z"; } }; };


		.canvas$numcanvas.can create line [ expr $Xpix/2 + $lx*$Xpix*.42 + 5*$lx] [ expr $Ypix/2 ] [ expr $Xpix/2 + $lx*$Xpix*.42 + 10*$lx ] [ expr $Ypix/2 ] -arrow last -tags arrowx -fill "#000000";
		.canvas$numcanvas.can create text [ expr $Xpix/2 + $lx*$Xpix*.42 +10 ] [ expr $Ypix/2 + 10 ] -text $dx -tags textx -fill "#000000";
		.canvas$numcanvas.can create line [ expr $Xpix/2 ] [ expr $Ypix/2 - $ly*$Ypix*.42 - 5*$lx ] [ expr $Xpix/2 ] [ expr $Ypix/2 - $ly*$Ypix*.42 - 10*$ly ] -arrow last -tags arrowy -fill "#000000";
		.canvas$numcanvas.can create text [ expr $Xpix/2 +10 ] [ expr $Ypix/2 - $ly*$Ypix*.42-10*$ly ] -text $dy -tags texty -fill "#000000";
		if { $3_Dim == 1 } {
			.canvas$numcanvas.can create line [ expr $Xpix/2 + $lz*cos($theta)/$k*$Xpix*1.2/2.0 ] [ expr $Ypix/2 - $lz*sin($theta)/$k*$Xpix*1.2/2.0 ] [ expr $Xpix/2 + $lz*cos($theta)/$k*($Xpix+10)*1.2/2.0 ] [ expr $Ypix/2 - $lz*sin($theta)/$k*($Xpix+10)*1.2/2.0 ] -arrow last -tags arrowz -fill "#000000";
			.canvas$numcanvas.can create text [ expr $Xpix/2 + $lz*cos($theta)/$k*$Xpix*1.2/2.0 + 8 ] [ expr $Ypix/2 - $lz*sin($theta)/$k*$Xpix*1.2/2.0 +8 ] -text $dz -tags textz -fill "#000000" ; };
		for { set l -2.5 } { $l < 3 } { set l [ expr $l +1 ] } {
			if { ($l != 0) && ($l != 1) && ($l != -1) } {
				 set vx [ string range [ expr ($Xpix*.42/$l + 5*$l/abs($l))/$Xfactor ] 0 [ expr [ string first "." [ expr ($Xpix*.42/$l + 5*$l/abs($l))/$Xfactor ]  ] +1 ] ];
				 set vy [ string range [ expr ($Ypix*.42/$l + 5*$l/abs($l))/$Yfactor ] 0 [ expr [ string first "." [ expr ($Ypix*.42/$l + 5*$l/abs($l))/$Yfactor ] ] +1 ] ];
				 set vz [ string range [ expr ($k*$Xpix*1.2/2.0/$l)/$Xfactor/$cabfact ] 0 [ expr [ string first "." [ expr ($k*$Xpix*1.2/2.0/$l)/$Xfactor/$cabfact ] ] +1 ] ];
				 set clx([ expr $l+2.5]) "clx$l";
				 set llx([ expr $l+2.5]) "llx$l";
				 set cly([ expr $l+2.5]) "cly$l";
				 set lly([ expr $l+2.5]) "lly$l";
				 set clz([ expr $l+2.5]) "clz$l";
				 set llz([ expr $l+2.5]) "llz$l";
				.canvas$numcanvas.can create line [ expr $Xpix/2 +$lx*$Xpix*.42/$l + 5*$lx*$l/abs($l) ] [ expr $Ypix/2 ] [ expr $Xpix/2 + $lx*$Xpix*.42/$l + 10*$lx*$l/abs($l) ] [ expr $Ypix/2 ] -arrowshape { 2 4 2 } -arrow last -tags $clx([ expr $l+2.5 ]) -fill "#ff0000";
				.canvas$numcanvas.can create text [ expr $Xpix/2 + $lx*$Xpix*.42/$l +10*$l/abs($l) ] [ expr $Ypix/2 + 10 ] -tags $llx([ expr $l+2.5 ]) -text $vx -fill "#0000ff";
				.canvas$numcanvas.can create line [ expr $Xpix/2 ] [ expr $Ypix/2 - $ly*$Ypix*.42/$l - 5*$ly*$l/abs($l) ] [ expr $Xpix/2 ] [ expr $Ypix/2 - $ly*$Ypix*.42/$l -10*$ly*$l/abs($l) ] -arrowshape { 2 4 2 } -arrow last -tags $cly([ expr $l+2.5 ]) -fill "#ff0000";
				.canvas$numcanvas.can create text [ expr $Xpix/2 + 20 ] [ expr $Ypix/2 - $ly*$Ypix*.42/$l - 10*$ly*$l/abs($l) ] -tags $lly([ expr $l+2.5 ]) -text $vy -fill "#0000ff";
				if { $3_Dim == 1 } {
					.canvas$numcanvas.can create line [ expr $Xpix/2 + $lz*cos($theta)/$k*$Xpix*1.2/2.0/$l ] [ expr $Ypix/2 - $lz*sin($theta)/$k*$Xpix*1.2/2.0/$l ] [ expr $Xpix/2 + $lz*cos($theta)/$k*($Xpix+10)*1.2/2.0/$l ] [ expr $Ypix/2 - $lz*sin($theta)/$k*($Xpix+10)*1.2/2.0/$l ] -arrowshape { 2 4 2 } -arrow last -tags $clz([ expr $l+2.5 ]) -fill "#ff0000" ;
					.canvas$numcanvas.can create text [ expr $Xpix/2 + $lz*cos($theta)/$k*$Xpix*1.2/2.0/$l +14 ] [ expr $Ypix/2 - $lz*sin($theta)/$k*$Xpix*1.2/2.0/$l +14 ] -tags $llz([ expr $l+2.5 ]) -text $vz -fill "#0000ff" ; };
			}; }; };

	if { $RHS == 0 } {
		switch $Persp {
			10 { set exprx {$point($i,$j,2)-$point($i,$j,0)*cos($theta)*$cabfact};
			     set expry {$point($i,$j,1)-$point($i,$j,0)*sin($theta)*$cabfact}; }
			11 { set exprx {-$point($i,$j,2)+$point($i,$j,0)*cos($theta)*$cabfact};
			     set expry {$point($i,$j,1)+$point($i,$j,0)*sin($theta)*$cabfact}; }
			20 { set exprx {$point($i,$j,0)-$point($i,$j,1)*cos($theta)*$cabfact};
			     set expry {$point($i,$j,2)-$point($i,$j,1)*sin($theta)*$cabfact}; }
			21 { set exprx {-$point($i,$j,0)+$point($i,$j,1)*cos($theta)*$cabfact};
			     set expry {$point($i,$j,2)+$point($i,$j,1)*sin($theta)*$cabfact}; }
			30 { set exprx {-$point($i,$j,0)-$3_Dim*$point($i,$j,2)*cos($theta)*$cabfact};
			     set expry {$point($i,$j,1)-$3_Dim*$point($i,$j,2)*sin($theta)*$cabfact}; }
			31 { set exprx {$point($i,$j,0)+$point($i,$j,2)*cos($theta)*$cabfact};
			     set expry {$point($i,$j,1)+$point($i,$j,2)*sin($theta)*$cabfact}; } }; } else {

		switch $Persp {
			10 { set exprx {-$point($i,$j,2)-$point($i,$j,0)*cos($theta)*$cabfact};
			     set expry {$point($i,$j,1)-$point($i,$j,0)*sin($theta)*$cabfact}; }
			11 { set exprx {$point($i,$j,2)+$point($i,$j,0)*cos($theta)*$cabfact};
			     set expry {$point($i,$j,1)+$point($i,$j,0)*sin($theta)*$cabfact}; }
			20 { set exprx {-$point($i,$j,0)-$point($i,$j,1)*cos($theta)*$cabfact};
			     set expry {$point($i,$j,2)-$point($i,$j,1)*sin($theta)*$cabfact}; }
			21 { set exprx {$point($i,$j,0)+$point($i,$j,1)*cos($theta)*$cabfact};
			     set expry {$point($i,$j,2)+$point($i,$j,1)*sin($theta)*$cabfact}; }
			30 { set exprx {$point($i,$j,0)-$3_Dim*$point($i,$j,2)*cos($theta)*$cabfact};
			     set expry {$point($i,$j,1)-$3_Dim*$point($i,$j,2)*sin($theta)*$cabfact}; }
			31 { set exprx {-$point($i,$j,0)+$point($i,$j,2)*cos($theta)*$cabfact};
			     set expry {$point($i,$j,1)+$point($i,$j,2)*sin($theta)*$cabfact}; } }; };


	for { set i 0 } { $i < $niter } { incr i } {
		set d1c 0;
		for { set j 0 } { ! (( $j > $npiter($i)) && ( $i == 0) || ( $j == $npiter($i)) && ( $i > 0) )  } { incr j } {
			if { ($point($i,$j,0) != "undef" ) && ($point($i,$j,1) !="undef" ) && ($point($i,$j,2) != "undef" ) } {
				 if { [ catch { set dispx [ expr $Xpix/2.0 + int( $Xfactor * ( [ eval expr $exprx ] ) + 0.5 ) ]; } ] == 1 } { set dispx [ expr ( $Xpix/2.0*[ Sgn [ eval expr $exprx ] ] + $Xpix/2.0 ) / $k ]; };
				 if { [ catch { set dispy [ expr $Ypix/2.0 - int( $Yfactor * ( [ eval expr $expry ] ) + 0.5 ) ]; } ] == 1 } { set dispy [ expr ( - $Ypix/2.0*[ Sgn [ eval expr $expry ] ] + $Ypix/2.0 )/$k ] ; };
				if { $d1c == 0 } {
					set dispx1 $dispx;
					set dispy1 $dispy;
					set d1c 1; } else {

					set o [ catch { .canvas$numcanvas.can create line $dispx1 $dispy1 $dispx $dispy ; } ];
					set dispx1 $dispx;
					set dispy1 $dispy; }; } else {
					set d1c 0; }; }; };
};

# procedure for calculating parametres for graph plotting
proc sketch_graph {} {
	global NumConst Const ErrorIncr spc cabfact RHS PI LabelAxis numcanvas Draw_axes Draw_grid Persp Func 3_Dim Draw_axes Draw_grid Persp Xpix Ypix Grph_nparam Grph_param Grph_paramlim Variab Udf Udfdet NumUdf;

	global Xfactor Yfactor theta k point npiter niter xmax ymax zmax ;

	if { $3_Dim == 1 } { set ndim 3; } else { set ndim 2; set Func(3) "0"; };

	for { set i 1 } { $i <= $ndim } { incr i } {

		set a "";
		set b "";
		set c "";
		set d "";
		set e "";

		set expre $Func($i);
		set expre [ string trim $expre " " ];
		regsub -all {\ +} $expre " " a;
		set expre $a;

		for { set f 0 } { $f < $NumUdf } { incr f } {
			regsub -all "$Udf($f)" $expre "UDF_$Udf($f)" a;
			set expre $a; };

		regsub -all {VAR_([a-zA-Z0-9_]*)} $expre {$Variab(\1)} a;
		set expre $a;

		while { [ string first "CST_" $expre ] != -1 } {
			regexp {CST_([a-zA-Z0-9_]*)} $expre a b;
			for { set i 0 } { $i < $NumConst } { incr i } {
				if { $Const($i,0) == $b } { break; }; };
			if { $i == $NumConst } { set temp "undef"; return $temp; }
			regsub {CST_([a-zA-Z0-9_]*)} $expre "$Const($i,1)" a;
			set expre $a;
		};

		regsub -all {PAR_([a-zA-Z0-9_]*)} $expre {$varval(\1)} a;
		set expre $a;

		set st [ string first "UDF_" $expre ];
		while { $st != -1 } {
			set t $st;
			set j [ string index $expre $t ];
			while { $j != "(" } { incr t;set j [ string index $expre $t ]; };
			set nb 1;
			set t1 $t;
			set nparm 0;
			set udfname [ string trim [ string range $expre [ expr $st +4 ] [ expr $t1 -1] ] " " ];
			while { $nb != 0 } {
				incr t;
				set j [ string index $expre $t ];
				if { $j == "(" } { incr nb +1; };
				if { $j == ")" } {
					incr nb -1;
					if { $nb == 0 } {
						set udfparm($nparm) [ string trim [ string range $expre [ expr $t1 +1 ] [ expr $t -1 ] ] " " ];
						set t1 $t;
						incr nparm; }; };
				if { ($j == ",") && ( $nb == 1 ) } {
					set udfparm($nparm) [ string trim [ string range $expre [ expr $t1 +1 ] [ expr $t -1 ] ] " " ];
					set t1 $t;
					incr nparm; }; };
			set t2 $t;
			for { set j 0 } { $j < $NumUdf } { incr j } {
				if { $Udf($j) == $udfname } { break; }; };
			if { $j == $NumUdf } {
				tk_dialog .parser.error "Error !!" "     ERROR !!\nUndefined function\n" "" 0 "Ok";			   set temp $EntryVal;
				return $temp ; };
			set udfindex $j;
			set udffunc $Udfdet($udfindex,1);
			for { set j 0 } { $j < $nparm } { incr j } {
				regsub -all $Udfdet($udfindex,[ expr $j +2 ]) $udffunc $udfparm($j) a;
				set udffunc $a; }
			set expr2 [ format "%s(%s)%s" [ string range $expre 0 [ expr $st -1 ] ] $udffunc [ string range $expre [ expr $t2 +1 ] end ] ];
			set expre $expr2;
			set st [ string first "UDF_" $expre ];
		}

		regsub -all "Sqrt" $expre "MDF_Sqrt" a; set expre $a;
		regsub -all "Abs" $expre "MDF_Abs" a; set expre $a;
		regsub -all "Random" $expre "MDF_Random" a; set expre $a;
		regsub -all "Ceil" $expre "MDF_Ceil" a; set expre $a;
		regsub -all "Double" $expre "MDF_Double" a; set expre $a;
		regsub -all "Floor" $expre "MDF_Floor" a; set expre $a;
		regsub -all "Int" $expre "MDF_Int" a; set expre $a;
		regsub -all "Round" $expre "MDF_Round" a; set expre $a;
		regsub -all "Acos" $expre "MDF_Acos" a; set expre $a;
		regsub -all "Asin" $expre "MDF_Asin" a; set expre $a;
		regsub -all "Atan" $expre "MDF_Atan" a; set expre $a;
		regsub -all "Cos" $expre "MDF_Cos" a; set expre $a;
		regsub -all "Sin" $expre "MDF_Sin" a; set expre $a;
		regsub -all "Tan" $expre "MDF_Tan" a; set expre $a;
		regsub -all "Cosh" $expre "MDF_Cosh" a; set expre $a;
		regsub -all "Sinh" $expre "MDF_Sinh" a; set expre $a;
		regsub -all "Tanh" $expre "MDF_Tanh" a; set expre $a;
		regsub -all "Exp" $expre "MDF_Exp" a; set expre $a;
		regsub -all "Log" $expre "MDF_Log" a; set expre $a;
		regsub -all "Log10" $expre "MDF_Log10" a; set expre $a;
		regsub -all "Pow" $expre "MDF_Pow" a; set expre $a;
		regsub -all "Asinh" $expre "MDF_Asinh" a; set expre $a;
		regsub -all "Acosh1" $expre "MDF_Acosh1" a; set expre $a;
		regsub -all "Acosh2" $expre "MDF_Acosh2" a; set expre $a;
		regsub -all "Atanh" $expre "MDF_Atanh" a; set expre $a;
		regsub -all "Sgn" $expre "MDF_Sgn" a; set expre $a;

		set st [ string first "MDF_" $expre ];
		while { $st != -1 } {
			set t $st;
			set j [ string index $expre $t ];
			while { $j != "(" } { incr t;set j [ string index $expre $t ]; };
			set nb 1;
			set t1 $t;
			set nparm 0;
			set udfname [ string trim [ string range $expre [ expr $st +4 ] [ expr $t1 -1] ] " " ];
			while { $nb != 0 } {
				incr t;
				set j [ string index $expre $t ];
				if { $j == "(" } { incr nb +1; };
				if { $j == ")" } {
					incr nb -1;
					if { $nb == 0 } {
						set udfparm($nparm) [ string trim [ string range $expre [ expr $t1 +1 ] [ expr $t -1 ] ] " " ];
						set t1 $t;
						incr nparm; }; };
				if { ($j == ",") && ( $nb == 1 ) } {
					set udfparm($nparm) [ string trim [ string range $expre [ expr $t1 +1 ] [ expr $t -1 ] ] " " ];
					set t1 $t;
					incr nparm; }; };
			set t2 $t;
			set udffunc "";
			for { set j 0 } { $j < $nparm } { incr j } {
				regsub -all {\ +} $udfparm($j) "" a;
				set udfparm($j) $a;
				set udffunc [ format { %s [ expr %s ] } $udffunc $udfparm($j) ]; };
			set udffunc [ format {[ %s %s ]} $udfname $udffunc ];
			set expr2 [ format "%s(%s)%s" [ string range $expre 0 [ expr $st -1 ] ] $udffunc [ string range $expre [ expr $t2 +1] end ] ];
			set expre $expr2;
			set st [ string first "MDF_" $expre ];
		};
		set Func($i) $expre;
	};

	for { set i 0 } { $i < $Grph_nparam } { incr i } {
		set varval($Grph_param($i)) $Grph_paramlim($i,0) ; };

	set ErrorIncr $Grph_paramlim(0,2);
	for { set i 0 } { $i < $Grph_nparam } { incr i } {
		if { $ErrorIncr < $Grph_paramlim($i,2) } { set ErrorIncr $Grph_paramlim($i,2) }; };

	set niter 0;
	set piter -1;
	set xmax 0.0;
	set ymax 0.0;
	set zmax 0.0;

	for { set i 0 } { $i < $Grph_nparam } { incr i } {
		set varval($Grph_param($i)) [ expr $varval($Grph_param($i)) - $Grph_paramlim($i,2) ] ; };

	for { set i 0 } { $i >= 0 } { incr i 0 } {
		set varval($Grph_param($i)) [ expr $varval($Grph_param($i)) + $Grph_paramlim($i,2) ] ;
		if { $varval($Grph_param($i)) > $Grph_paramlim($i,1)  } {

			incr piter;
			if { [ catch { set point($niter,$piter,0) [ eval expr $Func(1) ]; } ] == 1 } { set point($niter,$piter,0) "undef" ; };
			if { [ catch { set point($niter,$piter,1) [ eval expr $Func(2) ]; } ] == 1 } { set point($niter,$piter,1) "undef" ; };
			if { [ catch { set point($niter,$piter,2) [ eval expr $Func(3) ]; } ] == 1 } { set point($niter,$piter,2) "undef" ; };
			if { ($point($niter,$piter,0) != "undef") && ($xmax < [ expr abs( $point($niter,$piter,0)) ]) } {
				set xmax [ expr abs( $point($niter,$piter,0)) ]; }
			if { ($point($niter,$piter,1) != "undef") && ( $ymax < [ expr abs( $point($niter,$piter,1)) ] ) } {
				set ymax [ expr abs( $point($niter,$piter,1)) ]; }
			if { ($point($niter,$piter,2) != "undef") && ( $zmax < [ expr abs( $point($niter,$piter,2)) ] ) } {
				set zmax [ expr abs( $point($niter,$piter,2)) ]; }

			set varval($Grph_param($i)) [ expr $Grph_paramlim($i,0) - $Grph_paramlim($i,2) ] ;
			incr i -1;
			set npiter($niter) $piter;
			incr niter;
			set piter -1;
			continue;}
		incr i;
		if { $i == $Grph_nparam } {
			incr piter;
			if { [ catch { set point($niter,$piter,0) [ eval expr $Func(1) ]; } ] == 1 } { set point($niter,$piter,0) "undef" ; };
			if { [ catch { set point($niter,$piter,1) [ eval expr $Func(2) ]; } ] == 1 } { set point($niter,$piter,1) "undef" ; };
			if { [ catch { set point($niter,$piter,2) [ eval expr $Func(3) ]; } ] == 1 } { set point($niter,$piter,2) "undef" ; };
			if { ($point($niter,$piter,0) != "undef") && ($xmax < [ expr abs( $point($niter,$piter,0)) ]) } {
				set xmax [ expr abs( $point($niter,$piter,0)) ]; }
			if { ($point($niter,$piter,1) != "undef") && ( $ymax < [ expr abs( $point($niter,$piter,1)) ] ) } {
				set ymax [ expr abs( $point($niter,$piter,1)) ]; }
			if { ($point($niter,$piter,2) != "undef") && ( $zmax < [ expr abs( $point($niter,$piter,2)) ] ) } {
				set zmax [ expr abs( $point($niter,$piter,2)) ]; }
			incr i -1;
			};
		};

	if { [ expr int($Persp/10) ] == 1 } {
		if { [ catch { set Xfactor [ expr $Xpix/2.0/( $zmax + $xmax*cos($theta)*$cabfact)/$k ]; } ] == 1} { generror "Unable to draw desired graph"; return; };
		if { [ catch { set Yfactor [ expr $Ypix/2.0/( $ymax + $xmax*sin($theta)*$cabfact)/$k ]; } ] == 1} { generror "Unable to draw desired graph"; return; }; };
	if { [ expr int($Persp/10) ] == 2 } {
		if { [ catch { set Xfactor [ expr $Xpix/2.0/( $xmax + $ymax*cos($theta)*$cabfact)/$k ]; } ] == 1} { generror "Unable to draw desired graph"; return; };
		if { [ catch { set Yfactor [ expr $Ypix/2.0/( $zmax + $ymax*sin($theta)*$cabfact)/$k ]; } ] == 1} { generror "Unable to draw desired graph"; return; }; };
	if { [ expr int($Persp/10) ] == 3 } {
		if { [ catch { set Xfactor [ expr $Xpix/2.0/( $xmax + $zmax * cos($theta)*$cabfact)/$k ]; } ] == 1 } { generror "Unable to draw desired graph"; return ; };
		if { [ catch { set Yfactor [ expr $Ypix/2.0/($ymax + $zmax * sin($theta)*$cabfact)/$k ]; } ] == 1 } { generror "Unable to draw desired graph"; return; }; };
	if { $Xfactor < 1.0 } { set Xfactor 1.0; };
	if { $Yfactor < 1.0 } { set Yfactor 1.0; };

	if { $numcanvas == 0 } {
		set numcanvas 1;
		toplevel .canvas$numcanvas -class dialog;
		wm title .canvas$numcanvas "Graphing Curves";
		wm geometry .canvas$numcanvas +500+100;
		wm iconname .canvas$numcanvas Dialog;
		canvas .canvas$numcanvas.can -width $Xpix -height $Ypix -relief raised -background "#ffffff";
		pack .canvas$numcanvas.can -side top -padx 2 -pady 2;
		frame .canvas$numcanvas.but -relief raised;
		pack .canvas$numcanvas.but -side bottom -fill both;
		frame .canvas$numcanvas.but.r0 -relief flat;
		frame .canvas$numcanvas.but.r1 -relief flat;
		frame .canvas$numcanvas.but.r2 -relief flat;
		pack .canvas$numcanvas.but.r0 .canvas$numcanvas.but.r1 .canvas$numcanvas.but.r2 -side top -fill both;

		button .canvas$numcanvas.but.r1.fact   -background "#ffffcc" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "Display Factors" -relief raised -width 12 -command {
			set tempret 0;
			mult_arg .canvas$numcanvas.but.r1.fact.in "Manual control of display factors" "Enter the desired value of Display Factors\nCurrent X Factor = $Xfactor\nCurrent Y factor = $Yfactor\n" "" 2 {
				global Xfactor Yfactor;
				if { [ catch { set VarVal(1) [ expr_eval $VarVal(1) ]; } ] == 1 } { set $VarVal(1) 0.0; };
				if { [ catch { set VarVal(2) [ expr_eval $VarVal(2) ]; } ] == 1 } { set $VarVal(2) 0.0; };
				if { $VarVal(1) > 0 } { set Xfactor $VarVal(1); }
				if { $VarVal(2) > 0 } { set Yfactor $VarVal(2); };
					 } "X Factor" "Y Factor" "Reduction Factor";
				if { $tempret != -0.6714 } {
				catch { .canvas$numcanvas.can delete textx texty ; }
				catch { .canvas$numcanvas.can delete textz; };
				catch { .canvas$numcanvas.can delete arrowx arrowy ; };
				catch { .canvas$numcanvas.can delete arrowz; };
				for { set l -2.5 } { $l < 3 } { set l [ expr $l +1 ] } {
					 set clx([ expr $l+2.5]) "clx$l";
					 set llx([ expr $l+2.5]) "llx$l";
					 set cly([ expr $l+2.5]) "cly$l";
					 set lly([ expr $l+2.5]) "lly$l";
					 set clz([ expr $l+2.5]) "clz$l";
					 set llz([ expr $l+2.5]) "llz$l";
					 catch { .canvas$numcanvas.can delete $clx([ expr $l+2.5 ]) $cly([ expr $l+2.5 ]);
					 	 .canvas$numcanvas.can delete $clz([ expr $l+2.5 ]);
						 .canvas$numcanvas.can delete $llx([ expr $l+2.5 ]) $lly([ expr $l+2.5 ]);
						 .canvas$numcanvas.can delete $llz([ expr $l+2.5 ]); }; };
				if { [ catch { draw_graph; } ] == 1 } {
					generror "Unable to draw desired graph"; };
				};
				unset tempret; };
		button .canvas$numcanvas.but.r1.persp -background "#ffffcc" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "Perspective" -relief raised -width 12 -command {
		if { $3_Dim == 1 } {
			set tmparr(0) "Along +X";
			set tmparr(1) "Along -X";
			set tmparr(2) "Along +Y";
			set tmparr(3) "Along -Y";
			set tmparr(4) "Along +Z";
			set tmparr(5) "Along -Z";
			set Win_name ".canvas$numcanvas.perspective";
			set temp -0.6714;
			set temp2 -0.6714;
			select_list "Perspective" "Double click to select" "persp" tmparr 0 5 20 10 ;
			if { $temp != -0.6714 } {
				if { $temp == "+X" } { set Persp 10; }
				if { $temp == "-X" } { set Persp 11; }
				if { $temp == "+Y" } { set Persp 20; }
				if { $temp == "-Y" } { set Persp 21; }
				if { $temp == "+Z" } { set Persp 30; }
				if { $temp == "-Z" } { set Persp 31; }
				catch { .canvas$numcanvas.can delete textx texty ; };
				catch { .canvas$numcanvas.can delete textz; };
				catch { .canvas$numcanvas.can delete arrowx arrowy; };
				catch { .canvas$numcanvas.can delete arrowz; };
				for { set l -2.5 } { $l < 3 } { set l [ expr $l +1 ] } {
					 set clx([ expr $l+2.5]) "clx$l";
					 set llx([ expr $l+2.5]) "llx$l";
					 set cly([ expr $l+2.5]) "cly$l";
					 set lly([ expr $l+2.5]) "lly$l";
					 set clz([ expr $l+2.5]) "clz$l";
					 set llz([ expr $l+2.5]) "llz$l";
					 catch { .canvas$numcanvas.can delete $clx([ expr $l+2.5 ]) $cly([ expr $l+2.5 ]); }
					 catch { .canvas$numcanvas.can delete $clz([ expr $l+2.5 ]); }
				       	 catch { .canvas$numcanvas.can delete $llx([ expr $l+2.5 ]) $lly([ expr $l+2.5 ]); }
					 catch { .canvas$numcanvas.can delete $llz([ expr $l+2.5 ]); }; };
				if { [ catch { draw_graph; } ] == 1 } {
					puts "Overall error";
					generror "Unable to draw desired graph"; };
				};
		unset tmparr temp temp2 Win_name; }; };
		button .canvas$numcanvas.but.r1.redraw -activebackground "#336697" -background "#ffffcc" -foreground "#336697" -activeforeground "#ffffff" -text "Redraw" -relief raised -width 12 -command {
			catch { .canvas$numcanvas.can delete textx texty ; };
			catch { .canvas$numcanvas.can delete textz; };
			catch { .canvas$numcanvas.can delete arrowx arrowy; };
			catch { .canvas$numcanvas.can delete arrowz; };
			for { set l -2.5 } { $l < 3 } { set l [ expr $l +1 ] } {
				 set clx([ expr $l+2.5]) "clx$l";
				 set llx([ expr $l+2.5]) "llx$l";
				 set cly([ expr $l+2.5]) "cly$l";
				 set lly([ expr $l+2.5]) "lly$l";
				 set clz([ expr $l+2.5]) "clz$l";
				 set llz([ expr $l+2.5]) "llz$l";
				 catch { .canvas$numcanvas.can delete $clx([ expr $l+2.5 ]) $cly([ expr $l+2.5 ]); }
				 catch { .canvas$numcanvas.can delete $clz([ expr $l+2.5 ]); }
			       	 catch { .canvas$numcanvas.can delete $llx([ expr $l+2.5 ]) $lly([ expr $l+2.5 ]); }

				 catch { .canvas$numcanvas.can delete $llz([ expr $l+2.5 ]); }; };
			if { [ catch { draw_graph; } ] == 1 } {
				generror "Unable to draw desired graph"; };
			};
		checkbutton .canvas$numcanvas.but.r0.rhs -activebackground "#336697" -background "#ffffcc" -foreground "#336697" -activeforeground "#ffffff" -text "Right Handed System" -relief raised -width 18 -variable RHS;
		pack .canvas$numcanvas.but.r0.rhs -expand 1 -fill both;
		pack .canvas$numcanvas.but.r1.fact .canvas$numcanvas.but.r1.persp .canvas$numcanvas.but.r1.redraw -expand 1 -fill both -side left ;

		button .canvas$numcanvas.but.r2.clear -activebackground "#336697" -background "#ffffcc" -foreground "#336697" -activeforeground "#ffffff" -text "Clear" -relief raised -width 6 -command {
		set o [ lindex [ .canvas$numcanvas.can configure -background ] 4 ];
		.canvas$numcanvas.can create rectangle 0 0 $Xpix $Ypix -fill $o -outline $o;
		};
		button .canvas$numcanvas.but.r2.save -activebackground "#336697" -background "#ffffcc" -foreground "#336697" -activeforeground "#ffffff" -text "Save" -relief raised -width 6 -command {
			trace vdelete EntryVal r read_entry;
			trace vdelete EntryVal w write_entry;
			set TEMP $EntryVal;
			set EntryVal "";
			set FileName "";
			set tempret 0;
			mult_arg .calc.graphsave "Save Present Graph" "Enter filename in which to save (.ps)" "" 1 {
				global $FileName;
				set FileName $VarVal(1); } "File Name";
			if { $tempret != -0.6714 } {
			if { [ catch { .canvas$numcanvas.can postscript -file $FileName; } ] == 1 } {
				tk_dialog .calc.error "Error !!" "            ERROR !!\nUnable to open file for writing\n" "" 0 "Ok"; };
			unset FileName; };
			unset tempret; };
		button .canvas$numcanvas.but.r2.close -activebackground "#336697" -background "#ffffcc" -foreground "#336697" -activeforeground "#ffffff" -text "Close" -relief raised -width 6 -command {
			destroy .canvas$numcanvas;
			set numcanvas 0;
			unset Xfactor Yfactor point npiter niter xmax ymax zmax;
			global EntryVal EntryDisp;
			trace vdelete EntryVal r read_entry;
			trace vdelete EntryVal w write_entry;

			if { ( $EntryDisp == "undef" ) || ( $EntryDisp == "-inf" ) || ( $EntryDisp == "+inf" ) } {
				set EntryVal 0.0;
				set EntryDisp "0.0";
			};
			if { $EntryDisp == "" } { set EntryVal 0.0 } else {
			if { $EntryVal=="" } { set EntryVal 0.0; };
			set ent_disp [ update_entry $EntryVal ];
			if { $ent_disp != $EntryDisp } {
				if { [catch { set EntryVal [ expr double($EntryDisp) ]; } ] == 1 } {
				set EntryDisp "";
				set EntryVal 0.0; };
			}; };

			trace variable EntryVal w write_entry;
			trace variable EntryVal r read_entry;
			return; };
		pack .canvas$numcanvas.but.r2.clear .canvas$numcanvas.but.r2.save .canvas$numcanvas.but.r2.close -expand 1 -fill both -side left -padx 2 -pady 2; };

	if { [ catch { draw_graph; } ] == 1 } {
		generror "Unable to draw graph"; };
};

# procedure to generate list
proc gen_list { expre startn endn location } {

	global NumConst Const ListName NumList CurrList Variab Udf NumUdf Udfdet;

	set a "";
	set b "";
	set c "";
	set d "";
	set e "";

	set expre [ string trim $expre " " ];
	regsub -all {\ +} $expre " " a;
	set expre $a;

  # evaluate expression
	for { set i 0 } { $i < $NumUdf } { incr i } {
		regsub -all "$Udf($i)" $expre "UDF_$Udf($i)" a;
		set expre $a; };

	regsub -all {VAR_([a-zA-Z0-9_]*)} $expre {$Variab(\1)} a;
	set expre $a;

	while { [ string first "CST_" $expre ] != -1 } {
		regexp {CST_([a-zA-Z0-9_]*)} $expre a b;
		for { set i 0 } { $i < $NumConst } { incr i } {
			if { $Const($i,0) == $b } { break; }; };
		if { $i == $NumConst } { set temp "undef"; return $temp; }
		regsub {CST_([a-zA-Z0-9_]*)} $expre "$Const($i,1)" a;
		set expre $a;
	};

	set st [ string first "UDF_" $expre ];
	while { $st != -1 } {
		set t $st;
		set j [ string index $expre $t ];
		while { $j != "(" } { incr t;set j [ string index $expre $t ]; };
		set nb 1;
		set t1 $t;
		set nparm 0;
		set udfname [ string trim [ string range $expre [ expr $st +4 ] [ expr $t1 -1] ] " " ];
		while { $nb != 0 } {
			incr t;
			set j [ string index $expre $t ];
			if { $j == "(" } { incr nb +1; };
			if { $j == ")" } {
				incr nb -1;
			if { $nb == 0 } {
				set udfparm($nparm) [ string trim [ string range $expre [ expr $t1 +1 ] [ expr $t -1 ] ] " " ];
				set t1 $t;
				incr nparm; }; };
			if { ($j == ",") && ( $nb == 1 ) } {
				set udfparm($nparm) [ string trim [ string range $expre [ expr $t1 +1 ] [ expr $t -1 ] ] " " ];
				set t1 $t;
				incr nparm; }; };
		set t2 $t;
		for { set j 0 } { $j < $NumUdf } { incr j } {
			if { $Udf($j) == $udfname } { break; }; };
		if { $j == $NumUdf } {
			tk_dialog .parser.error "Error !!" "     ERROR !!\nUndefined function\n" "" 0 "Ok";
			set temp $EntryVal;
			return $temp ; };
		set udfindex $j;
		set udffunc $Udfdet($udfindex,1);
		for { set j 0 } { $j < $nparm } { incr j } {
			regsub -all $Udfdet($udfindex,[ expr $j +2 ]) $udffunc $udfparm($j) a;
			set udffunc $a; }
		set expr2 [ format "%s(%s)%s" [ string range $expre 0 [ expr $st -1 ] ] $udffunc [ string range $expre [ expr $t2 +1 ] end ] ];
		set expre $expr2;
		set st [ string first "UDF_" $expre ];
	}

	regsub -all "Sqrt" $expre "MDF_Sqrt" a; set expre $a;
	regsub -all "Abs" $expre "MDF_Abs" a; set expre $a;
	regsub -all "Random" $expre "MDF_Random" a; set expre $a;
	regsub -all "Ceil" $expre "MDF_Ceil" a; set expre $a;
	regsub -all "Double" $expre "MDF_Double" a; set expre $a;
	regsub -all "Floor" $expre "MDF_Floor" a; set expre $a;
	regsub -all "Int" $expre "MDF_Int" a; set expre $a;
	regsub -all "Round" $expre "MDF_Round" a; set expre $a;
	regsub -all "Acos" $expre "MDF_Acos" a; set expre $a;
	regsub -all "Asin" $expre "MDF_Asin" a; set expre $a;
	regsub -all "Atan" $expre "MDF_Atan" a; set expre $a;
	regsub -all "Cos" $expre "MDF_Cos" a; set expre $a;
	regsub -all "Sin" $expre "MDF_Sin" a; set expre $a;
	regsub -all "Tan" $expre "MDF_Tan" a; set expre $a;
	regsub -all "Cosh" $expre "MDF_Cosh" a; set expre $a;
	regsub -all "Sinh" $expre "MDF_Sinh" a; set expre $a;
	regsub -all "Tanh" $expre "MDF_Tanh" a; set expre $a;
	regsub -all "Exp" $expre "MDF_Exp" a; set expre $a;
	regsub -all "Log" $expre "MDF_Log" a; set expre $a;
	regsub -all "Log10" $expre "MDF_Log10" a; set expre $a;
	regsub -all "Pow" $expre "MDF_Pow" a; set expre $a;
	regsub -all "Asinh" $expre "MDF_Asinh" a; set expre $a;
	regsub -all "Acosh1" $expre "MDF_Acosh1" a; set expre $a;
	regsub -all "Acosh2" $expre "MDF_Acosh2" a; set expre $a;
	regsub -all "Atanh" $expre "MDF_Atanh" a; set expre $a;
	regsub -all "Sgn" $expre "MDF_Sgn" a; set expre $a;

	set st [ string first "MDF_" $expre ];
	while { $st != -1 } {
		set t $st;
		set j [ string index $expre $t ];
		while { $j != "(" } { incr t;set j [ string index $expre $t ]; };
		set nb 1;
		set t1 $t;
		set nparm 0;
		set udfname [ string trim [ string range $expre [ expr $st +4 ] [ expr $t1 -1] ] " " ];
		while { $nb != 0 } {
			incr t;
			set j [ string index $expre $t ];
			if { $j == "(" } { incr nb +1; };
			if { $j == ")" } {
				incr nb -1;
				if { $nb == 0 } {
					set udfparm($nparm) [ string trim [ string range $expre [ expr $t1 +1 ] [ expr $t -1 ] ] " " ];
					set t1 $t;
					incr nparm; }; };
			if { ($j == ",") && ( $nb == 1 ) } {
				set udfparm($nparm) [ string trim [ string range $expre [ expr $t1 +1 ] [ expr $t -1 ] ] " " ];
				set t1 $t;
				incr nparm; }; };
		set t2 $t;
		set udffunc "";
		for { set j 0 } { $j < $nparm } { incr j } {
			regsub -all {\ +} $udfparm($j) "" a;
			set udfparm($j) $a;
			set udffunc [ format { %s [ expr %s ] } $udffunc $udfparm($j) ]; };
		set udffunc [ format {[ %s %s ]} $udfname $udffunc ];
		set expr2 [ format "%s(%s)%s" [ string range $expre 0 [ expr $st -1 ] ] $udffunc [ string range $expre [ expr $t2 +1] end ] ];
			set expre $expr2;
		set st [ string first "MDF_" $expre ];
	};

	regsub -all {CNT} $expre {$CNT} expre2;
	set expre $expre2;

	set st [ string first "PRE" $expre ];
	while { $st != -1 } {
		set t $st;
		set j [ string index $expre $t ];
		while { $j != "(" } { incr t;set j [ string index $expre $t ]; };
		set nb 1;
		set t1 $t;
		set nparm 0;
		set udfname [ string trim [ string range $expre [ expr $st +3 ] [ expr $t1 -1] ] " " ];
		while { $nb != 0 } {
			incr t;
			set j [ string index $expre $t ];
			if { $j == "(" } { incr nb +1; };
			if { $j == ")" } {
				incr nb -1;
				if { $nb == 0 } {
					set udfparm($nparm) [ string trim [ string range $expre [ expr $t1 +1 ] [ expr $t -1 ] ] " " ];
					set t1 $t;
					incr nparm; }; };
			if { ($j == ",") && ( $nb == 1 ) } {
				set udfparm($nparm) [ string trim [ string range $expre [ expr $t1 +1 ] [ expr $t -1 ] ] " " ];
				set t1 $t;
				incr nparm; }; };
		set t2 $t;
		set udffunc $udfparm(0);
		set expr2 [ format {%s($ListName($CurrList,[ expr %s + 1 ]))%s} [ string range $expre 0 [ expr $st -1 ] ] $udffunc [ string range $expre [ expr $t2 +1] end ] ];
			set expre $expr2;
		set st [ string first "PRE" $expre ];
	};

	set CNT 0;

	if { $location == "genlist" } {
		for { set i $startn } { $i <= $endn } { incr i } {
			set CNT $i ;
			if { [ catch { set ListName($CurrList,$ListName($CurrList,1)) [ eval expr $expre ]; } ] == 0 } {
				incr ListName($CurrList,1); } else {
				tk_dialog .calc.error "Error !!" "            ERROR !!\nUnable to evaluate for element $CNT\n" "" 0 "Ok";
				break; }; }; } else {
		set sum 0;
		for { set i $startn } { $i <= $endn } { incr i } {
			set CNT $i;
			if { [ catch { set sum [ expr $sum + [ eval expr $expre ] ]; } ] == 1 } {
				tk_dialog .calc.error "Error !!" "            ERROR !!\nUnable to evaluate for element $CNT\n" "" 0 "Ok";
				break; }; };
		return $sum; };
};

# procedure to update value to display
proc update_entry { ent_val } {
	global Disp_prec Base;

	if { $ent_val == "" } { set $ent_val 0.0 };
	set i [ string first "." $ent_val ];
	if { ($i == -1) || ( $i == [ expr [ string length $ent_val ] -1 ] ) } { set ent_val [ expr double($ent_val) ]; };
	set i [ string first "." $ent_val ];
	set j [ string first "e" $ent_val ];
	if { $j == -1 } {
		set ipart [ string range $ent_val 0 [ expr $i -1 ] ];
		set dpart [ string range $ent_val [ expr $i +1] end ];
		if { $dpart == 0 } { set $dpart "0"; };
		if { $ipart == 0 } { set $ipart "0"; };
		if { [ string length $dpart ] > $Disp_prec } {
		    	set dpart [ string range $dpart 0 [ expr $Disp_prec -1] ]; };
		set ret [ format "%s.%s" $ipart $dpart ]; } else {
		set ipart [ string range $ent_val 0 [ expr $i -1 ] ];
		set dpart [ string range $ent_val [ expr $i +1] [ expr $j -1 ] ];
		if { $dpart == 0 } { set $dpart "0"; };
		if { $ipart == 0 } { set $ipart "0"; };
		set epart [ string range $ent_val [ expr $j +2] end ];
		if { $epart == 0 } { set $epart "0"; };
		set esgn [ string index $ent_val [ expr $j +1 ] ];
		if { [ string length $dpart ] > $Disp_prec } {
		    	set dpart [ string range $dpart 0 [ expr $Disp_prec -1] ]; };
		set ret [ format "%s.%se%s%s" $ipart $dpart $esgn $epart ];
	};
	return $ret;
}

# procedure invoked when $EntryVal written to
proc write_entry { name element op } {
	upvar $name EntryVal;
	global EntryDisp;
	if { $EntryVal == "" } { set EntryVal 0.0 };
	if { ( $EntryVal == "undef" ) || ( $EntryVal == "-inf" ) || ( $EntryVal == "+inf" ) } {
		tk_dialog .calc.error "Error !!" "         ERROR !!\nArgument out of range\n" "" 0 "Ok";
		set EntryDisp $EntryVal; return; };
	set EntryDisp [ update_entry $EntryVal ];
	if { $EntryDisp == 0.0 } { set EntryDisp ""; };
};

# procedure invoked when $EntryVal read from
proc read_entry { name element op } {
	upvar $name EntryVal;
	global EntryDisp;

	if { ( $EntryDisp == "undef" ) || ( $EntryDisp == "-inf" ) || ( $EntryDisp == "+inf" ) } {
		set EntryVal 0.0;
		set EntryDisp "0.0";
		return; };
	if { $EntryDisp == "" } { set EntryVal 0.0 } else {
		set ent_disp [ update_entry $EntryVal ];
		if { $ent_disp != $EntryDisp } {
			if { [catch { set EntryVal [ expr double($EntryDisp) ]; } ] == 1 } {
				tk_dialog .calc.error "Error !!" "       ERROR !!\nArgument out of range\n" "" 0 "Ok";
				set EntryDisp "";
				set EntryVal 0.0; };
			}; };

}

# procedure for evaluation of expression
proc expr_eval { expre } {
	global EntryVal temp Variab NumUdf Udf Udfdet NumConst Const;

	set a "";
	set b "";
	set c "";
	set d "";
	set e "";

	set expre [ string trim $expre " " ];
	regsub -all {\ +} $expre " " a;
	set expre $a;

  # set <variable name> <value>
	if { [string first "set" $expre ] == 0 } {
		regexp {^set ([a-zA-Z0-9_]*) (.*)$} $expre a b c;
		if { $c != "" } {
			set expre [ format {%s %s [ expr_eval %s ]} "set" $b $c ]; };
		set i [ regsub {^set ([a-zA-Z0-9_]*)} $expre {set Variab(\1)} e ];
		if { $c != "" } {
			set temp $c;
			eval $e;
			return $temp; } else {
			regexp {^set ([a-zA-Z0-9_]*)$} $expre a b;
			set temp $EntryVal;
			eval "$e $temp";
			return $temp; };
		};

  # disp <variable name>
	if { [string first "disp" $expre ] == 0 } {
		regexp {^disp ([a-zA-Z0-9_]*)$} $expre a b;
		set temp $Variab($b);
		return $temp; };

  # evaluate expression
	for { set i 0 } { $i < $NumUdf } { incr i } {
		regsub -all "$Udf($i)" $expre "UDF_$Udf($i)" a;
		set expre $a; };

	regsub -all {VAR_([a-zA-Z0-9_]*)} $expre {$Variab(\1)} a;
	set expre $a;

	while { [ string first "CST_" $expre ] != -1 } {
		regexp {CST_([a-zA-Z0-9_]*)} $expre a b;
		for { set i 0 } { $i < $NumConst } { incr i } {
			if { $Const($i,0) == $b } { break; }; };
		if { $i == $NumConst } { set temp "undef"; return $temp; }
		regsub {CST_([a-zA-Z0-9_]*)} $expre "$Const($i,1)" a;
		set expre $a;
	};

	set st [ string first "UDF_" $expre ];
	while { $st != -1 } {
		set t $st;
		set j [ string index $expre $t ];
		while { $j != "(" } { incr t;set j [ string index $expre $t ]; };
		set nb 1;
		set t1 $t;
		set nparm 0;
		set udfname [ string trim [ string range $expre [ expr $st +4 ] [ expr $t1 -1] ] " " ];
		while { $nb != 0 } {
			incr t;
			set j [ string index $expre $t ];
			if { $j == "(" } { incr nb +1; };
			if { $j == ")" } {
				incr nb -1;
				if { $nb == 0 } {
					set udfparm($nparm) [ string trim [ string range $expre [ expr $t1 +1 ] [ expr $t -1 ] ] " " ];
					set t1 $t;
					incr nparm; }; };
			if { ($j == ",") && ( $nb == 1 ) } {
				set udfparm($nparm) [ string trim [ string range $expre [ expr $t1 +1 ] [ expr $t -1 ] ] " " ];
				set t1 $t;
				incr nparm; }; };
		set t2 $t;
		for { set j 0 } { $j < $NumUdf } { incr j } {
			if { $Udf($j) == $udfname } { break; }; };
		if { $j == $NumUdf } {
			tk_dialog .parser.error "Error !!" "     ERROR !!\nUndefined function\n" "" 0 "Ok";			   set temp $EntryVal;
			return $temp ; };
		set udfindex $j;
		set udffunc $Udfdet($udfindex,1);
		for { set j 0 } { $j < $nparm } { incr j } {
			regsub -all $Udfdet($udfindex,[ expr $j +2 ]) $udffunc $udfparm($j) a;
			set udffunc $a; }
		set expr2 [ format "%s(%s)%s" [ string range $expre 0 [ expr $st -1 ] ] $udffunc [ string range $expre [ expr $t2 +1 ] end ] ];
		set expre $expr2;
		set st [ string first "UDF_" $expre ];
	}

	regsub -all "Sqrt" $expre "MDF_Sqrt" a; set expre $a;
	regsub -all "Abs" $expre "MDF_Abs" a; set expre $a;
	regsub -all "Random" $expre "MDF_Random" a; set expre $a;
	regsub -all "Ceil" $expre "MDF_Ceil" a; set expre $a;
	regsub -all "Double" $expre "MDF_Double" a; set expre $a;
	regsub -all "Floor" $expre "MDF_Floor" a; set expre $a;
	regsub -all "Int" $expre "MDF_Int" a; set expre $a;
	regsub -all "Round" $expre "MDF_Round" a; set expre $a;
	regsub -all "Acos" $expre "MDF_Acos" a; set expre $a;
	regsub -all "Asin" $expre "MDF_Asin" a; set expre $a;
	regsub -all "Atan" $expre "MDF_Atan" a; set expre $a;
	regsub -all "Cos" $expre "MDF_Cos" a; set expre $a;
	regsub -all "Sin" $expre "MDF_Sin" a; set expre $a;
	regsub -all "Tan" $expre "MDF_Tan" a; set expre $a;
	regsub -all "Cosh" $expre "MDF_Cosh" a; set expre $a;
	regsub -all "Sinh" $expre "MDF_Sinh" a; set expre $a;
	regsub -all "Tanh" $expre "MDF_Tanh" a; set expre $a;
	regsub -all "Exp" $expre "MDF_Exp" a; set expre $a;
	regsub -all "Log" $expre "MDF_Log" a; set expre $a;
	regsub -all "Log10" $expre "MDF_Log10" a; set expre $a;
	regsub -all "Pow" $expre "MDF_Pow" a; set expre $a;
	regsub -all "Asinh" $expre "MDF_Asinh" a; set expre $a;
	regsub -all "Acosh1" $expre "MDF_Acosh1" a; set expre $a;
	regsub -all "Acosh2" $expre "MDF_Acosh2" a; set expre $a;
	regsub -all "Atanh" $expre "MDF_Atanh" a; set expre $a;
	regsub -all "Sgn" $expre "MDF_Sgn" a; set expre $a;

	set st [ string first "MDF_" $expre ];
	while { $st != -1 } {
		set t $st;
		set j [ string index $expre $t ];
		while { $j != "(" } { incr t;set j [ string index $expre $t ]; };
		set nb 1;
		set t1 $t;
		set nparm 0;
		set udfname [ string trim [ string range $expre [ expr $st +4 ] [ expr $t1 -1] ] " " ];
		while { $nb != 0 } {
			incr t;
			set j [ string index $expre $t ];
			if { $j == "(" } { incr nb +1; };
			if { $j == ")" } {
				incr nb -1;
				if { $nb == 0 } {
					set udfparm($nparm) [ string trim [ string range $expre [ expr $t1 +1 ] [ expr $t -1 ] ] " " ];
					set t1 $t;
					incr nparm; }; };
			if { ($j == ",") && ( $nb == 1 ) } {
				set udfparm($nparm) [ string trim [ string range $expre [ expr $t1 +1 ] [ expr $t -1 ] ] " " ];
				set t1 $t;
				incr nparm; }; };
		set t2 $t;
		set udffunc "";
		for { set j 0 } { $j < $nparm } { incr j } {
			regsub -all {\ +} $udfparm($j) "" a;
			set udfparm($j) $a;
			set udffunc [ format { %s [ expr %s ] } $udffunc $udfparm($j) ]; };
		set udffunc [ format {[ %s %s ]} $udfname $udffunc ];
		set expr2 [ format "%s(%s)%s" [ string range $expre 0 [ expr $st -1 ] ] $udffunc [ string range $expre [ expr $t2 +1] end ] ];
		set expre $expr2;
		set st [ string first "MDF_" $expre ];
	};

	if { [ catch { set temp [ eval expr "$expre" ]; } ] == 1 } {
		tk_dialog .exprerror "Error !!" "          ERROR !!\nArguments out of range\n" "" 0 "Ok"; set temp 0.0; };
	return $temp;
}

# procedure for evaluation of calculator stack
proc ccstack_eval {} {
	global ccprev_ent cccurr_ent cc_sp cc_nb cc_stack EntryVal EntryDisp;

	if { $cccurr_ent == "cl_bract" } {
		set cccurr_ent $ccprev_ent;
		set cc_stack($cc_sp,1) 0;
		ccstack_eval;
		incr cc_sp -1;
		set EntryVal $cc_stack($cc_sp,0);
		set i [ string length $EntryDisp ];
		.calc.oper.r1.entryval icursor $i;
		update idletasks;
		incr cc_sp -1;
		return;
		} else {
		if { $cc_sp > 0 } {
			while { ( $cc_stack([ expr $cc_sp -1],1) != 30 )&&( [ expr int($cc_stack([ expr $cc_sp -1],1)/10) ] >= [ expr int($cc_stack($cc_sp,1)/10) ] ) } {
				incr cc_sp -1;
				switch $cc_stack($cc_sp,1) {
					10 {
						set cc_stack($cc_sp,0) [ expr $cc_stack($cc_sp,0) + $cc_stack([expr $cc_sp +1],0) ];
						set cc_stack($cc_sp,1) $cc_stack([ expr $cc_sp +1],1); }
					11 {
						set cc_stack($cc_sp,0) [ expr $cc_stack($cc_sp,0) - $cc_stack([expr $cc_sp +1],0) ];
						set cc_stack($cc_sp,1) $cc_stack([ expr $cc_sp +1],1); }
					20 {
						set cc_stack($cc_sp,0) [ expr $cc_stack($cc_sp,0) * $cc_stack([expr $cc_sp +1],0) ];
						set cc_stack($cc_sp,1) $cc_stack([ expr $cc_sp +1],1); }
					21 {
						if { $cc_stack([ expr $cc_sp +1],0) == 0 } {
							tk_dialog .calc.error "Error !!" "    ERROR !!\ndivision by zero\n" "" 0 "Ok";
							set $EntryVal 0.0;
							set $cc_sp 0;
							set $cc_nb 0;
							set $ccprev_ent "";
							set $cccurr_ent "";
							return; } else {
							set cc_stack($cc_sp,0) [ expr $cc_stack($cc_sp,0) / $cc_stack([expr $cc_sp +1],0) ]
							set cc_stack($cc_sp,1) $cc_stack([ expr $cc_sp +1],1);
					   } }
					22 {
						if { $cc_stack([ expr $cc_sp +1],0) == 0 } {
							tk_dialog .calc.error "Error !!" "    ERROR !!\ndivision by zero\n" "" 0 "Ok";
							set $EntryVal 0.0;
							set $cc_sp 0;
							set $cc_nb 0;
							set $ccprev_ent "";
							set $cccurr_ent "";
							return; } else {
							set cc_stack($cc_sp,0) [ expr int($cc_stack($cc_sp,0)) % int($cc_stack([expr $cc_sp +1],0)) ];
							set $cc_stack($cc_sp,1) $cc_stack([ expr $cc_sp +1],1);
						} }
					}
				if { $cc_sp == 0 } { break; };
			}
			switch $cc_stack($cc_sp,1) {
				10 -
				11 -
				20 -
				21 -
				22 { set cccurr_ent "bin_oper"; }
				30 { set cccurr_ent "op_bract"; }
			}
		}
		incr cc_sp;
		set EntryVal 0.0;
		set i [ string length $EntryDisp];
		.calc.oper.r1.entryval icursor $i;
		update idletasks;
	}
}

# initialize procedure
proc initialize {} {
	global spc k theta cabfact RHS ErrorIncr LabelAxis numcanvas Draw_grid Func Xpix Ypix Grph_paramlim Grph_param Grph_nparam NumList CurrList PI Base Angular Disp_prec Draw_axes Hyperbol Inverse 3_Dim EntryVal EntryDisp ExprVal Memreg Varreg Persp StoreVar NumConst NumUdf NumHist Save Const Udf AnsHist Msgtext;

	set PI [ expr atan(1.0) * 4.0 ];
	set Base 10;               # base 10(decimal)
	set Angular "deg";         # degrees
	set Disp_prec 10;          # precision after decimal point
	set Draw_axes 1;           # enable draw axes
	set 3_Dim 0;               # disable 3-dim plotting
	set Persp 30;              # view graph along +Z
	set Draw_grid 0;	   # draw a grid
	set LabelAxis 1;
	set RHS 1;                 # Right handed system
	set Xpix 400;		   # x-pixels
	set Ypix 400;              # y-pixels
	set Grph_nparam 1;         # number of defining parametres
	set StoreVar 1;            # store value in register
	set Hyperbol 0;            # hyperblic trog functions
	set Inverse 0;             # inverse trig func
	set numcanvas 0;
	set ErrorIncr 0;
	set theta [ expr 45*$PI/180 ];
	set k 1.1;
	set cabfact [ expr 1.0/2.0 ];
	set spc 25;

	set Func(1) "";
	set Func(2) "";
	set Func(3) "";

	set Save(0) 1;             # save constants
	set Save(1) 0;             # unsave variables
	set Save(2) 0;             # unsave memory
	set Save(3) 1;             # save udfs
	set Save(4) 1;             # save lists
	set Save(5) 1;             # save general settings
	set Save(6) 1;             # save graph settings

	set EntryVal 0.0;          # value in entry
	set EntryDisp "";          # value to be displayed
	set ExprVal "";            # value in expr

	set Memreg 0.0;            # value in memory regigter
	set Varreg(0) 0.0;         # value in variable register
	set Varreg(1) 0.0;
	set Varreg(2) 0.0;
	set Varreg(3) 0.0;
	set Varreg(4) 0.0;
	set Varreg(5) 0.0;

	set NumList 0;             # number of lists in memory
	set CurrList 0;

	set NumConst 19;            # number of constants
	set Const(0,0) "Pi";
	set Const(0,1) [ expr atan(1.0)*4 ];
	set Const(1,0) "e";
	set Const(1,1) [ expr exp(1) ];
	set Const(2,0) "c";
	set Const(2,1) [ expr 2.99792458*pow(10.0,8.0) ];
	set Const(3,0) "h";
	set Const(3,1) [ expr 6.6260755*pow(10.0,-34.0) ];
	set Const(4,0) "G";
	set Const(4,1) [ expr 6.67259*pow(10.0,-11.0) ];
	set Const(5,0) "NA";
	set Const(5,1) [ expr 6.0221367*pow(10.0,23.0) ];
	set Const(6,0) "Rg";
	set Const(6,1) [ expr 8.314510 ];
	set Const(7,0) "k";
	set Const(7,1) [ expr 1.380658*pow(10.0,-23.0) ];
	set Const(8,0) "SBc";
	set Const(8,1) [ expr 5.67051*pow(10.0,-8.0) ];
	set Const(9,0) "b";
	set Const(9,1) [ expr 2.897756*pow(10.0,-3.0) ];
	set Const(10,0) "Ce";
	set Const(10,1) [ expr 1.60217733*pow(10.0,-19.0) ];
	set Const(11,0) "Me";
	set Const(11,1) [ expr 9.1093897*pow(10.0,-31.0) ];
	set Const(12,0) "Mp";
	set Const(12,1) [ expr 1.6726231*pow(10.0,-27.0) ];
	set Const(13,0) "Mn";
	set Const(13,1) [ expr 1.6749286*pow(10.0,-27.0) ];
	set Const(14,0) "Mew0";
	set Const(14,1) [ expr $Const(0,1)*4.0*pow(10.0,-7.0) ];
	set Const(15,0) "Ep0";
	set Const(15,1) [ expr 1.0/$Const(14,1)/$Const(2,1)/$Const(2,1) ];
	set Const(16,0) "F";
	set Const(16,1) [ expr 96485.3029 ];
	set Const(17,0) "Ry";
	set Const(17,1) [ expr 1.0973731534*pow(10.0,7.0) ];
	set Const(18,0) "A0";
	set Const(18,1) [ expr 5.29177249*pow(10.0,-11.0) ];

	set NumUdf 0;             # number of udfs

	set NumHist 0;            # number of elements in history

}

# factorial of a number
proc factorial { a } {
	global EntryVal EntryDisp;
	set prod 1.0;
	set a [ expr int($a) ];
	for { set i 1 } { $i <= $a } { incr i } { set prod [expr $prod*$i]; }
	set EntryVal $prod;
	set i [ string length $EntryDisp ];
	.calc.oper.r1.entryval icursor $i;
	update idletasks;
}

# variable handling procedure
proc main_var { i } {
	global StoreVar EntryVal Varreg EntryDisp;

	if { $StoreVar == 1 } {
		set Varreg($i) $EntryVal;
	} else {
		set EntryVal $Varreg($i);
		set i [ string length $EntryDisp ];
		.calc.oper.r1.entryval icursor $i;
		update idletasks;
	}
}

# input window for selection from list
proc select_list { title text flag name start finish widthx widthy } {
	global List_selection Win_name temp i temp2;
	upvar $name list_arr;

	set List_selection 0;
	set temp "";

	toplevel $Win_name -class dialog;
	wm title $Win_name  $title;
	wm geometry $Win_name +200+200;
	wm iconname $Win_name Dialog;

	frame $Win_name.top -relief raised -bd 1;
	pack $Win_name.top -side top -fill both;
	frame $Win_name.list -relief flat -bd 1;
	pack $Win_name.list -side top -fill both;
	frame $Win_name.bot -relief raised -bd 1;
	pack $Win_name.bot -side bottom -fill both;

	label $Win_name.top.label  -foreground "#000000" -text $text  -relief flat -width $widthx;
	pack $Win_name.top.label -side top -ipadx 2 -ipady 2 -padx 1 -fill x -pady 4;

	listbox $Win_name.list.sel -background "#ffffcc" -foreground "#336697" -height $widthy -relief raised -bd 2 -width $widthx -yscrollcommand "$Win_name.list.scroll set";
	pack $Win_name.list.sel -side left -ipadx 2 -ipady 2;
	scrollbar $Win_name.list.scroll  -background "#ffffff" -command "$Win_name.list.sel yview";
	pack $Win_name.list.scroll -side right -fill y -ipadx 2 -ipady 2;
	if { $flag == "stat" } {
		for { set i $start } { $i <= $finish } { incr i } {
			set u $list_arr($i,1);
			if { $name == "ListName" } { incr u -2; };
			$Win_name.list.sel insert end "$list_arr($i,0)  $u"; }; } else {
		for { set i $start } { $i <= $finish } { incr i } {
			$Win_name.list.sel insert end "$list_arr($i)" ; }; };
	set i 0;

button $Win_name.bot.ok -background "#c9f9ff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text Ok -relief raised -width 6 -command {
		set List_selection 1; };
	pack $Win_name.bot.ok -side left -padx 2 -pady 2;
	button $Win_name.bot.cancel -background "#c9f9ff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text Cancel -relief raised -width 6 -command {
		set List_selection 2; };
	pack $Win_name.bot.cancel -side right -padx 2 -pady 2;

	set oldfocus [ focus ];
        grab set $Win_name;
	focus $Win_name;
	uplevel {
		bind $Win_name.list.sel <Double-Button-1> {
		set temp2 [ $Win_name.list.sel get active ];
		set i [ string last " " $temp2 ];
		set temp [ string range $temp2 [expr $i +1] end ];
		if { $temp == "" } { set temp 0.0; }; }; };

	tkwait variable List_selection;
	if { $List_selection == 2 } { set temp -0.6714; };
	if { $temp == "" } { set temp -0.6714; };

	uplevel { bind $Win_name <Double-Button-1> { }; };
	destroy $Win_name;
	focus $oldfocus;
	unset List_selection;
}

# input window for draw graph
proc grph_draw { w title nwin text param prompt body badin } {
	global Mult_Arg_button;
	global Grph_nparam Grph_param Grph_paramlim Func;

	toplevel $w -class dialog;
	wm title $w $title;
	wm geometry $w +200+200;
	wm iconname $w Dialog;

	frame $w.f0 -relief raised -bd 1;
	frame $w.f1 -relief raised -bd 1;
	frame $w.f2 -relief raised -bd 1;
	frame $w.f3 -relief raised -bd 1;
	frame $w.f4 -relief raised -bd 1;
	frame $w.f5 -relief raised -bd 1;
	frame $w.f6 -relief raised -bd 1;
	frame $w.buttons -relief raised -bd 1;
	pack $w.f0 $w.f1 $w.f2 $w.f3 $w.f4 $w.f5 $w.f6 $w.buttons -side top -fill both;

	for { set i 0 } { $i < $nwin } { incr i } {
		message $w.f$i.text -background "#ffffcc" -foreground "#000000" -text [ lindex $text $i ] -width 1000 -justify left;
		pack $w.f$i.text -side top -fill both -expand 1  -padx 3 -pady 3;

		for { set j 0 } { $j < [ expr [ lindex $param $i ] ] } { incr j } {
			frame $w.f$i.f$j -relief raised -bd 1;
			pack $w.f$i.f$j -side top -fill both;

			if { $i == 0 } { label $w.f$i.f$j.label$j  -foreground "#000000" -text [ lindex $prompt $j ]; } else {
					 label $w.f$i.f$j.label$j  -foreground "#000000" -text [ lindex $badin $j ]; };
			entry $w.f$i.f$j.value$j -background "#ffffff" -width 30 -relief sunken -bd 2 -textvariable VarVal($i,$j);
			pack $w.f$i.f$j.label$j -side left -padx 1 -pady 1;
			pack $w.f$i.f$j.value$j -side right -padx 1 -pady 1; };
		};

	set oldfocus [ focus ];
	grab set $w;
	focus $w.f0.f0.value0;

	button $w.buttons.ok  -background "#c9f9ff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -relief raised -text Ok -width 7 -command { set Mult_Arg_button 0 };
	pack $w.buttons.ok -side left -ipadx 2 -ipady 1 -padx 2 -pady 2;
	button $w.buttons.cancel -background "#c9f9ff" -foreground "#336697" -activeforeground "#ffffff" -activebackground "#336697" -relief raised -text Cancel -width 7 -command { set Mult_Arg_button 1; };
	pack $w.buttons.cancel -side right -ipadx 2 -ipady 1 -padx 2 -pady 2;

	set rret 0;
	tkwait variable Mult_Arg_button;
	if { $Mult_Arg_button == 0 } { uplevel $body;
	     set rret 1; };
	for { set i 1 } { $i <= $param } { incr i } {
		if { $VarVal($i) == "" } { set $VarVal($i) 0.0; }; };
	destroy $w;
	focus $oldfocus;
	unset Mult_Arg_button;
	return $rret;
}

# input window for functions requiring multiple arguments
proc mult_arg { w title text prompt param body args } {
	global EntryVal VarVal Mult_Arg_button EntryDisp temp temp1;
	set Mult_Arg_button 0;

	toplevel $w -class dialog;
	wm title $w $title;
	wm geometry $w +200+200;
	wm iconname $w Dialog;
	frame $w.top -relief raised -bd 1;
	pack $w.top -side top -fill both;
	for { set i 1 } { $i <= $param } { incr i } {
		frame $w.bot$i -relief raised -bd 1;
		pack $w.bot$i -side top -fill both;
		set VarVal($i) ""; }
	frame $w.buttons -relief flat -bd 2;
	pack $w.buttons -side top -fill both;

	message $w.top.msg -background "#ffffcc" -foreground "#000000" -text $text -width 1000 -justify left;
	pack $w.top.msg -side left -expand 1 -fill both -padx 3 -pady 3;

	set i 0;
	set j 0;
	foreach varname $args {
		incr i;
		label $w.bot$i.varname$i  -foreground "#000000" -text "$prompt $varname :";
		pack $w.bot$i.varname$i -side left -padx 1 -pady 1;
		entry $w.bot$i.varval$i  -background "#ffffff" -width 30 -relief sunken -bd 2 -textvariable VarVal($i);
		pack $w.bot$i.varval$i -side right -padx 1 -pady 1;
		if { $i == $param } { break; };  }

	set VarVal(1) $EntryVal;
	set j [ string length $VarVal(1) ];
	$w.bot1.varval1 icursor $j;
	update idletasks;

	set oldfocus [ focus ];
	grab set $w;
	focus $w.bot1.varval1;

	button $w.buttons.ok -background "#c9f9ff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -relief raised -text Ok -width 7 -command { set Mult_Arg_button 0 };
	pack $w.buttons.ok -side left -ipadx 2 -ipady 1 -padx 2 -pady 2;
	button $w.buttons.cancel -background "#c9f9ff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff"  -relief raised -text Cancel -width 7 -command { set Mult_Arg_button 1; };
	pack $w.buttons.cancel -side right -ipadx 2 -ipady 1 -padx 2 -pady 2;

	tkwait variable Mult_Arg_button;
	global tempret;
	set tempret 0;
	if { $Mult_Arg_button == 0 } { uplevel 1 $body; };
	if { $Mult_Arg_button == 1 } { set tempret -0.6714; };
	for { set i 1 } { $i <= $param } { incr i } {
		if { $VarVal($i) == "" } { set $VarVal($i) 0.0; }; };
	destroy $w;
	focus $oldfocus;
	unset VarVal Mult_Arg_button;
}

# procedure to display list in a window
proc view_list { w title } {
	global CurrList NumList ListName Win_name1 Title_name

	set Win_name1 $w;
	set Title_name $title;
	toplevel $w -class dialog;
	wm title $w $title;
	wm geometry $w +300+100;
	wm iconname $w Dialog;

	frame $w.top -relief raised -bd 1;
	frame $w.bot -relief flat -bd 1;
	pack $w.top $w.bot -side top -fill both;

	button $w.top.button -background "#c9f9ff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text Close -relief raised -command { destroy $Win_name1; unset Win_name1; };
	pack $w.top.button -side left -ipadx 2 -ipady 2;
	button $w.top.update  -background "#c9f9ff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -relief raised -text Update -command { destroy $Win_name1; view_list $Win_name1 $Title_name; };
	pack $w.top.update -side right -ipadx 2 -ipady 3 ;

	set temp "";
	for { set i 2 } { $i < $ListName($CurrList,1) } { incr i } { set temp [ format "%s  %s" $temp $ListName($CurrList,$i) ]; };
	message $w.bot.msg -background "#ffffcc" -foreground "#000000" -width 550 -justify left -relief flat -bd 2 -text $temp;
	pack $w.bot.msg -side left -padx 2 -pady 2;
	unset temp;
}

# input window for selecting display values
proc select_val { w title text button1 body param args } {
	global EntryVal VarVal Select_button EntryDisp;
	set Select_button 0;

	toplevel $w -class dialog;
	wm title $w $title;
	wm geometry $w +200+200;
	wm iconname $w Dialog;
	frame $w.top -relief raised -bd 1;
	pack $w.top -side top -fill both;
	for { set i 1 } { $i <= $param } { incr i } {
		frame $w.bot$i -relief raised -bd 1;
		pack $w.bot$i -side top -fill both; }
	frame $w.buttons -relief flat -bd 2;
	pack $w.buttons -side top -fill both;

	message $w.top.msg -background "#ffffcc" -foreground "#000000" -text $text -width 200 -justify left;
	pack $w.top.msg -side left -expand 1 -fill both -padx 3 -pady 3;

	set i 0;
	set j 0;

	foreach varname $args {
		incr i;
		label $w.bot$i.varname$i  -foreground "#000000" -text "Param $varname : ";
		entry $w.bot$i.varval$i  -background "#ffffff" -relief sunken -width 30 -bd 2 -textvariable VarVal($i);
		pack $w.bot$i.varname$i $w.bot$i.varval$i -side left -padx 1 -pady 1;
button  $w.bot$i.select  -background "#c9f9ff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text Select -relief raised -width 6 -command [list set Select_button $i; ];
		pack $w.bot$i.select -side right -ipadx 2 -ipady 2; };

	button $w.buttons.button1   -background "#c9f9ff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff"  -relief raised -text $button1 -width 7 -command { set Select_button -1; };
	button $w.buttons.cancel   -background "#c9f9ff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -relief raised -text Cancel -width 7 -command { set Select_button 0; };
	pack $w.buttons.button1 -side left -ipadx 2 -ipady 2 -padx 50 -pady 2;
	pack $w.buttons.cancel -side right -ipadx 2 -ipady 1 -padx 50 -pady 2;

	set oldfocus [ focus ];
	grab set $w;

	tkwait variable Select_button;
	global tempret2;
	set tempret2 0;
	if { $Select_button == -1 } {
		uplevel $body; } else {
		if { $Select_button != 0 } {

			if { [ catch { set VarVal($Select_button) [ expr_eval $VarVal($Selct_button) ] } ] == 1 } { set VarVal($Select_button 0.0; }
			set EntryVal $VarVal($Select_button);
			set i [ string length $EntryDisp ];
			.calc.oper.r1.entryval icursor $i;
			update idletasks; } }
	if { $Select_button == 0 } { set tempret2 -0.6714; };
	destroy $w;
	focus $oldfocus;
	unset VarVal Select_button;
}

# greatest common divisor( x > y)
proc gcd { x y } {
	set r [ expr $x % $y ];
	while { $r != 0 } {
		set x $y;
		set y $r;
		set r [ expr $x % $y ]; }
	return $y;
}

# convert decimal to proper fraction
proc dtoabc { x } {
	global VarVal EntryVal EntryDisp;

	if { $x == ""} { set x 0 };
	set i [ string first "." $x ];
	if { ($i == -1) || ( $i == [ expr [ string length $x ] -1 ] ) } { set a [ expr int($x) ]; set b 0; set c 1; } else {
		if { [string range $x [ expr $i +1] end ] == 0 } { set a [ expr int($x) ] ; set b 0; set c 1; } else {
		set a [ string range $x 0 [ expr $i -1 ] ];
		set b [ string range $x [ expr $i +1 ] end ];
		set i [ string length $b ];
		set c [ expr int(pow(10.0,$i)) ];
		set g [ gcd int($c) int($b) ];
		set b [ expr $b / $g ];
		set c [ expr $c / $g ]; }; };

	set VarVal(1) $a;
	set VarVal(2) $b;
	set VarVal(3) $c;

	set tempret2 0;
	select_val .calc.selectabc "function a b/c" "Select desired value" "Value" {
		if { [ catch { set VarVal(1) [ expr_eval $VarVal(1) ] } ] == 1 } { set VarVal(1) 0.0; }

		if { [ catch { set VarVal(2) [ expr_eval $VarVal(2) ] } ] == 1 } { set VarVal(2) 0.0; }
		if { [ catch { set VarVal(3) [ expr_eval $VarVal(3) ] } ] == 1 } { set VarVal(3) 0.0; }
		set EntryVal [ expr double($VarVal(1))+double($VarVal(2))/double($VarVal(3))];
		set i [string length $EntryDisp ];
		.calc.oper.r1.entryval icursor $i;
		update idletasks; } 3 a b c;
	unset tempret2;
}

# convert decimal to improper fraction
proc dtodc { x } {
	global VarVal EntryVal EntryDisp;

	if { $x == ""} { set x 0.0 };
	set i [ string first "." $x ];
	if { ($i == -1) || ( $i == [ expr [ string length $x ] -1 ] ) } { set d [ expr int($x) ]; set c 1; } else {
		if { [string range $x [ expr $i +1] end ] == 0 } { set d [ expr int($x) ]; set c 1; } else {
		set a [ string range $x 0 [ expr $i -1 ] ];
		set b [ string range $x [ expr $i +1 ] end ];
		set i [ string length $b ];
		set c [ expr int(pow(10.0,$i)) ];
		set g [ gcd int($c) int($b) ];
		set b [ expr $b / $g ];
		set c [ expr $c / $g ];
		set d [ expr $a * $c +$b ]; }; };

	set VarVal(1) $d;
	set VarVal(2) $c;

	set tempret2 0;
	select_val .calc.selectdc "function d/c" "Select desired value" "Value" {
		if { [ catch { set VarVal(1) [ expr_eval $VarVal(1) ] } ] == 1 } { set VarVal(1) 0.0; }
		if { [ catch { set VarVal(1) [ expr_eval $VarVal(1) ] } ] == 1 } { set VarVal(1) 0.0; }
		set EntryVal [ expr double($VarVal(1))/double($VarVal(2)) ];
		set i [string length $EntryDisp ];
		.calc.oper.r1.entryval icursor $i;
		update idletasks; } 2 d c;
	unset tempret2;
}

# initialize control variables
initialize;
set tcl_precision 14;

# title
wm title . "Maths Wizard-1.0 by Aaditeshwar Seth";

# framing
frame .menubar -relief raised -bd 2;
frame .calc -relief flat;
frame .parser -relief flat;
frame .msgbox -relief raised -bd 2;
pack .menubar .calc .parser .msgbox -side top -fill x;
frame .calc.oper -relief flat;
frame .calc.list -relief flat;
frame .calc.stat -relief flat;
pack .calc.oper .calc.list .calc.stat -side left -fill y;
frame .calc.oper.r1 -relief flat;
frame .calc.oper.r2 -relief flat;
frame .calc.oper.r3 -relief flat;
frame .calc.oper.r35 -relief flat;
frame .calc.oper.r4 -relief flat;
frame .calc.oper.r5 -relief flat;
frame .calc.oper.r6 -relief flat;
frame .calc.oper.r7 -relief flat;
frame .calc.oper.r75 -relief flat;
frame .calc.oper.r8 -relief flat;
frame .calc.oper.r9 -relief flat;
pack .calc.oper.r1 .calc.oper.r2 .calc.oper.r3 .calc.oper.r35 .calc.oper.r4 .calc.oper.r5 .calc.oper.r6 .calc.oper.r7 .calc.oper.r8 .calc.oper.r9 .calc.oper.r75 -side top -fill x;
frame .calc.list.top -relief flat;
frame .calc.list.var -relief flat;
pack .calc.list.top .calc.list.var -side top -fill x;
frame .calc.list.top.udf -relief flat;
frame .calc.list.top.hist -relief flat;
pack .calc.list.top.udf .calc.list.top.hist -side left -fill y;
frame .calc.list.var.left -relief flat;
frame .calc.list.var.right -relief flat;
pack .calc.list.var.left .calc.list.var.right -side left -fill y;
frame .calc.list.var.right.c1 -relief flat;
frame .calc.list.var.right.c2 -relief flat;
pack .calc.list.var.right.c1 .calc.list.var.right.c2 -side top -fill x;

# top menu bar
menubutton .menubar.file -text File -menu .menubar.file.menu -foreground "#336797";
menubutton .menubar.disp -text Configure -foreground "#336797" -menu .menubar.disp.menu;
menubutton .menubar.angu -text Angular -foreground "#336797" -menu .menubar.angu.menu;
menubutton .menubar.grph -text Graph -foreground "#336797" -menu .menubar.grph.menu;
menubutton .menubar.about -text About -foreground "#336797" -menu .menubar.about.menu;
pack .menubar.file .menubar.disp .menubar.angu .menubar.grph -side left;
pack .menubar.about -side right

# about menu
menu .menubar.about.menu -background "#ffffff" -foreground "#336697";
	.menubar.about.menu add command -label Help.. -command {
		if { [ catch { set fp [ open "mwiz.help" ] } ] == 1 } {
			generror "Unable to open help file for reading"; } else {

			toplevel .calc.help -class dialog;
			wm title .calc.help "Help Window";
			wm geometry .calc.help +300+100;
			wm iconname .calc.help Dialog;
			text .calc.help.text -wrap word -background "#ffffcc" -foreground "#336697" -relief raised -bd 2 -yscrollcommand ".calc.help.scroll set";
			scrollbar .calc.help.scroll -command ".calc.help.text yview";
			pack .calc.help.text -side left;
			pack .calc.help.scroll -side right -fill y;
			.calc.help.text delete 1.0 end;
			while { ! [ eof $fp ] } {
				.calc.help.text insert end [ read $fp 1000 ]; };
			close $fp;
			unset fp; }; };
	.menubar.about.menu add command -label About.. -command {
		if { [ catch { set fp [ open "mwiz.about" ] } ] == 1 } {
			generror "Unable to open about file for reading"; } else {

			toplevel .calc.about -class dialog;
			wm title .calc.about "About Window";
			wm geometry .calc.about +350+100;
			wm iconname .calc.about Dialog;
			text .calc.about.text -wrap word -background "#ffffcc" -foreground "#336697" -relief raised -bd 2 -yscrollcommand ".calc.about.scroll set";
			scrollbar .calc.about.scroll -command ".calc.about.text yview";
			pack .calc.about.text -side left;
			pack .calc.about.scroll -side right -fill y;
			.calc.about.text delete 1.0 end;
			while { ! [ eof $fp ] } {
				.calc.about.text insert end [ read $fp 1000 ]; };
			close $fp;
			unset fp; }; };

# file menu
menu .menubar.file.menu -background "#ffffff" -foreground "#336697";
	.menubar.file.menu add command -label New -command {
			initialize;
			for { set i 0 } { $i < 4 } { incr i } {
				.calc.oper.r9.mainconst$i configure -text $Const($i,0); };

			bind .calc.list.top.udf.func <Double-Button-1> { };
			destroy .calc.list.top.udf.label;
			destroy .calc.list.top.udf.func;
			destroy .calc.list.top.udf.scroll;
			label .calc.list.top.udf.label  -foreground "#000000" -text "User Def. Funcs." -relief groove -width 15;
			listbox .calc.list.top.udf.func  -background "#ffffcc" -foreground "#336697" -height 13 -relief raised -bd 2 -width 15 -yscrollcommand ".calc.list.top.udf.scroll set";
			pack .calc.list.top.udf.label -side top -ipadx 2 -ipady 2 -padx 1 -fill x -pady 4;
			pack .calc.list.top.udf.func -side left -ipadx 2 -ipady 2;
			scrollbar .calc.list.top.udf.scroll  -background "#ffffff" -command ".calc.list.top.udf.func yview";
			pack .calc.list.top.udf.scroll -side right -fill y -ipadx 2 -ipady 2;
			for { set i 0 } { $i < $NumUdf } { incr i } { .calc.list.top.udf.func insert end $Udf($i); };
			bind .calc.list.top.udf.func <Double-Button-1> {
				set temp1 [ .calc.list.top.udf.func get active ];
				for { set i 0 } { $i < $NumUdf } { incr i } { if { $Udf($i) == $temp1 } { break; } };
				set udfi $i;
				set temp2 {};
				for { set j 0 } { $j < $Udfdet($udfi,0) } { incr j } { lappend temp2 "$Udfdet($udfi,[ expr $j +2 ])"; }
				set tempret 0;
				mult_arg .calc.udfcall "UDF Function $temp1" "Enter values of parametres" "Param" $Udfdet($udfi,0) {
					global udfi;
					set temp {};
					lappend temp $VarVal(1);
					for { set u 1 } { $u < $Udfdet($udfi,0) } { incr u } { lappend temp $VarVal([ expr $u +1 ]);}
					set temp [ join [ split $temp " " ] "," ];
					set temp3 [ list $temp1 "(" $temp ")" ];
					regsub -all {\ *} $temp3 {} temp;
					set temp [ expr_eval "$temp" ];
					set EntryVal $temp;
					set o [ string length $EntryDisp ];
					.calc.oper.r1.entryval icursor $o;
					update idletasks;
				 } [ lindex $temp2 0 ] [ lindex $temp2 1 ] [ lindex $temp2 2 ] [ lindex $temp2 3 ] [lindex $temp2 4 ] [ lindex $temp2 5 ] [ lindex $temp2 6 ] [lindex $temp2 7 ] [ lindex $temp2 8 ] [ lindex $temp2 9 ] [ lindex $temp2 10 ] [ lindex $temp2 11 ] [ lindex $temp2 12 ] [ lindex $temp2 13 ] [lindex $temp2 14 ] [ lindex $temp2 15 ] [ lindex $temp2 16 ] [ lindex $temp2 17 ] [ lindex $temp2 18 ] [ lindex $temp2 19 ];
			 unset tempret;
			 unset j temp1 temp2 udfi; }; };
	.menubar.file.menu add command -label Load -command {
		trace vdelete EntryVal r read_entry;
		trace vdelete EntryVal w write_entry;
		set TEMP $EntryVal;
		set EntryVal "";
		set tempret 0;
		mult_arg .calc.loaddef "Load default settings" "Enter filename from which to load" "" 1 {
		global FileName;
		set FileName $VarVal(1); } "FileName" ;
		set EntryVal $TEMP;
		trace variable EntryVal r read_entry;
		trace variable EntryVal w write_entry;
		if { $tempret != -0.6714 } {
		if { [ catch [ set fp [ open $FileName r ] ] ] == 0 } {
			tk_dialog .menubar.file.menu.error "Error !!" "            ERROR !!\nUnable to open file for reading\n" "" 0 "Ok" ; } else {
				gets $fp ;
				gets $fp NumConst;         # number of constants
				for { set i 0 } { $i < $NumConst } { incr i } {
					gets $fp Const($i,0);gets $fp Const($i,1); };
				gets $fp ;
				for { set i 0 } { $i < 6 } { incr i } {
					gets $fp Varreg($i); };
				gets $fp ;
				gets $fp Memreg;
				gets $fp ;
				gets $fp NumUdf;
				for { set i 0 } { $i < $NumUdf } { incr i } {
					gets $fp Udf($i);                 # name
					gets $fp Udfdet($i,0);            # no. of param
					gets $fp Udfdet($i,1);            # return value
					for { set j 0 } { $j < $Udfdet($i,0) } { incr j } {
						set r [ expr $j +2 ];
						gets $fp Udfdet($i,$r); }; };
				gets $fp ;
				gets $fp NumList;                 # no. of lists
				gets $fp CurrList;                # Current list
				for { set i 0 } { $i < $NumList } { incr i } {
					gets $fp ListName($i,0);
					gets $fp ListName($i,1);
					for { set j 2 } { $j < $ListName($i,1) } { incr j } {
						gets $fp Listname($i,$j); }; };
				gets $fp ;
				gets $fp code;
				if { $code == 1 } {
					gets $fp Angular;
					gets $fp Disp_prec;
					gets $fp Hyperbol";
					gets $fp Inverse;
					gets $fp StoreVar; };
				gets $fp ;
				gets $fp code;
				if { $code == 1 } {
					gets $fp RHS;
					gets $fp LabelAxis;
					gets $fp Draw_grid;
					gets $fp Xpix;
					gets $fp Ypix;
					gets $fp Draw_axes;
					gets $fp 3_Dim;
					gets $fp Persp;
					gets $fp theta;
					gets $fp k; };
			close $fp;
			unset TEMP i fp FileName code;

			for { set i 0 } { $i < 4 } { incr i } {
				.calc.oper.r9.mainconst$i configure -text $Const($i,0); };

			bind .calc.list.top.udf.func <Double-Button-1> { };
			destroy .calc.list.top.udf.label;
			destroy .calc.list.top.udf.func;
			destroy .calc.list.top.udf.scroll;
			label .calc.list.top.udf.label  -foreground "#000000" -text "User Def. Funcs." -relief groove -width 15;
			listbox .calc.list.top.udf.func  -background "#ffffcc" -foreground "#336697" -height 13 -relief raised -bd 2 -width 15 -yscrollcommand ".calc.list.top.udf.scroll set";
			pack .calc.list.top.udf.label -side top -ipadx 2 -ipady 2 -padx 1 -fill x -pady 4;
			pack .calc.list.top.udf.func -side left -ipadx 2 -ipady 2;
			scrollbar .calc.list.top.udf.scroll  -background "#ffffff" -command ".calc.list.top.udf.func yview";
			pack .calc.list.top.udf.scroll -side right -fill y -ipadx 2 -ipady 2;
			for { set i 0 } { $i < $NumUdf } { incr i } { .calc.list.top.udf.func insert end $Udf($i); };
			bind .calc.list.top.udf.func <Double-Button-1> {
				set temp1 [ .calc.list.top.udf.func get active ];
				for { set i 0 } { $i < $NumUdf } { incr i } { if { $Udf($i) == $temp1 } { break; } };
				set udfi $i;
				set temp2 {};
				for { set j 0 } { $j < $Udfdet($udfi,0) } { incr j } { lappend temp2 "$Udfdet($udfi,[ expr $j +2 ])"; }
				set tempret 0;
				mult_arg .calc.udfcall "UDF Function $temp1" "Enter values of parametres" "Param" $Udfdet($udfi,0) {
					global udfi;
					set temp {};
					lappend temp $VarVal(1);
					for { set u 1 } { $u < $Udfdet($udfi,0) } { incr u } { lappend temp $VarVal([ expr $u +1 ]);}
					set temp [ join [ split $temp " " ] "," ];
					set temp3 [ list $temp1 "(" $temp ")" ];
					regsub -all {\ *} $temp3 {} temp;
					set temp [ expr_eval "$temp" ];
					set EntryVal $temp;
					set o [ string length $EntryDisp ];
					.calc.oper.r1.entryval icursor $o;
					update idletasks;
				 } [ lindex $temp2 0 ] [ lindex $temp2 1 ] [ lindex $temp2 2 ] [ lindex $temp2 3 ] [lindex $temp2 4 ] [ lindex $temp2 5 ] [ lindex $temp2 6 ] [lindex $temp2 7 ] [ lindex $temp2 8 ] [ lindex $temp2 9 ] [ lindex $temp2 10 ] [ lindex $temp2 11 ] [ lindex $temp2 12 ] [ lindex $temp2 13 ] [lindex $temp2 14 ] [ lindex $temp2 15 ] [ lindex $temp2 16 ] [ lindex $temp2 17 ] [ lindex $temp2 18 ] [ lindex $temp2 19 ];
			 unset tempret;
			 unset j temp1 temp2 udfi; }; };
	}; unset tempret; };
	.menubar.file.menu add cascade -label Save -menu .menubar.file.menu.save;
	.menubar.file.menu add command -label Close -command { exit; };

# display menu
menu .menubar.disp.menu  -background "#ffffff" -foreground "#336697";
	.menubar.disp.menu add command -label "Precision" -command {
		trace vdelete EntryVal r read_entry;
		trace vdelete EntryVal w write_entry;
		set TEMP $EntryVal;
		set EntryVal $Disp_prec;
		set tempret 0;

		mult_arg .prec "Decimal Precision" "Enter the desired value of precision" "Decimal " 1 {
			global Disp_prec;
			if { [ catch { set VarVal(1) [ expr_eval $VarVal(1) ] } ] == 1 } { set VarVal(1) 0.0; }
			if { ( $VarVal(1) >= 1 ) && ( $VarVal(1) <= 14 ) } { set Disp_prec [ expr int($VarVal(1)) ]; }
		} Precision;
		trace variable EntryVal r read_entry;
		trace variable EntryVal w write_entry;
		set EntryVal $TEMP;
		unset TEMP;
		set i [ string length $EntryDisp ];
		.calc.oper.r1.entryval icursor $i;
		update idletasks; };
	.menubar.disp.menu add separator;
	.menubar.disp.menu add command -label "Add Const" -command {
		set tempret 0;
		mult_arg .calc.addconst "Add Constant" "Enter value and name of Const" "Constant" 2 {
			global NumConst Const;
			set Const($NumConst,0) [ string range $VarVal(2) 0 6 ];

			if { [ catch { set VarVal(1) [ expr_eval $VarVal(1) ] } ] == 1 } { set VarVal(1) 0.0; }
			set Const($NumConst,1) $VarVal(1);
			incr NumConst;
		} value name;
		unset tempret; };
	.menubar.disp.menu add command -label "Delete Const" -command {
		set Win_name ".calc.others";
		set temp -0.6714;
		set temp2 -0.6714;
		select_list "Delete Constants" "Double click to select" "stat" Const 4 [ expr $NumConst -1 ] 20 10 ;
		if { $temp != -0.6714 } {
				set temp2 [ string range $temp2 0 [ expr [ string first " " $temp2 ] -1 ] ];
				set i 4;
				while { ($Const($i,0) != $temp2) && ($Const($i,0) != $temp) && ($i != $NumConst) } { incr i };
				if { $i != $NumConst } {
					for { set j $i } { $j < [ expr $NumConst -1] } { incr j } {
						set Const($j,0) $Const([ expr $j +1],0);
						set Const($j,1) $Const([ expr $j +1],1); };
					incr NumConst -1;
				};
			};
		unset temp Win_name temp2; };
	.menubar.disp.menu add command -label "Display Const" -command {
		set Win_name ".calc.dconst";
		set temp -0.6714;
		set temp2 -0.6714;
		set Selbut(0,0) "Button"; set Selbut(0,1) 1;
		set Selbut(1,0) "Button"; set Selbut(1,1) 2;
		set Selbut(2,0) "Button"; set Selbut(2,1) 3;
		set Selbut(3,0) "Button"; set Selbut(3,1) 4;
		select_list "Change display of constants" "Select button to change" "stat" Selbut 0 3 18 4;
		if { $temp != -0.6714 } {
			set bchange [ expr $temp -1 ];
			set temp -0.6714;
			set temp2 -0.6714;
			select_list "Button to be displayed" "Select button to display" "stat" Const 4 [ expr $NumConst -1 ] 20 10 ;
			if { $temp != -0.6714 } {
				set i 4;
				set temp2 [ string range $temp2 0 [ expr [ string first " " $temp2 ] -1 ] ];
				while { ($Const($i,0) != $temp2) && ($Const($i,0) != $temp) && ($i != $NumConst) } { incr i };
				if { $i != $NumConst } {
					set temp3(0) $Const($bchange,0);
					set temp3(1) $Const($bchange,1);
					set Const($bchange,0) $Const($i,0);
					set Const($bchange,1) $Const($i,1);
					set Const($i,0) $temp3(0);
					set Const($i,1) $temp3(1);
					.calc.oper.r9.mainconst$bchange configure -text $Const($bchange,0);
					update idletasks;
					unset temp3;
				}; }; };
		unset Win_name temp temp2 ; };
	.menubar.disp.menu add separator;
	.menubar.disp.menu add command -label "Add User Def Func" -command {
		trace vdelete EntryVal r read_entry;
		trace vdelete EntryVal w write_entry;
		set TEMP $EntryVal;
		set EntryVal "";
		set tempret 0;
		mult_arg .calc.addudf "Addition to UDF library" "Enter the parametres required" "" 4 {
			global Udf NumUdf Udfdet;
			if { $VarVal(1) != "" } {
			set Udf($NumUdf) $VarVal(1);
			if { [ catch { set VarVal(2) [ expr_eval $VarVal(2) ] } ] == 1 } { set VarVal(2) 0.0; };
			set Udfdet($NumUdf,0) $VarVal(2);
			set Udfdet($NumUdf,1) $VarVal(4);
			regsub -all {\ *} $VarVal(3) {} VarVal(5);
			set paramname [ split $VarVal(5) ";" ];
			for { set z 0 } { $z <= $VarVal(2) } { incr z } {
				set Udfdet($NumUdf,[ expr $z +2 ]) [ lindex $paramname $z ]; };
			.calc.list.top.udf.func insert end $Udf($NumUdf);
			incr NumUdf; };
		} "UDF Name" "No. of Param" "Param Names" "Return Value";
			set EntryVal $TEMP;
			trace variable EntryVal r read_entry;
			trace variable EntryVal w write_entry;
			unset TEMP;
			unset tempret;
			};
	.menubar.disp.menu add command -label "Delete User Def Func" -command {
		set Win_name ".calc.deludf";
		set temp -0.6714;
		set temp2 -0.6714;
		select_list "Delete User Def Func" "Double click to select" "nostat" Udf 0 [ expr $NumUdf -1 ] 20 10 ;
		if { $temp != -0.6714 } {
			for { set i 0 } { $i < $NumUdf } { incr i } {
				if { $Udf($i) == $temp2 } { break; }; };
			for { set j $i } { $j < [ expr $NumUdf -1 ] } { incr j } {
				set Udf($j) $Udf([ expr $j +1 ]);
				for { set q 0 } { $q < $Udfdet([ expr $j +1 ],0) } { incr q } {
					set Udfdet($j,$q) $Udfdet([ expr $j +1],$q); }; };
			incr NumUdf -1;

			bind .calc.list.top.udf.func <Double-Button-1> { };
			destroy .calc.list.top.udf.label;
			destroy .calc.list.top.udf.func;
			destroy .calc.list.top.udf.scroll;

			label .calc.list.top.udf.label  -foreground "#000000" -text "User Def. Funcs." -relief groove -width 15;
			listbox .calc.list.top.udf.func -background "#ffffcc" -foreground "#336607" -height 13 -relief raised -bd 2 -width 15 -yscrollcommand ".calc.list.top.udf.scroll set";
			pack .calc.list.top.udf.label -side top -ipadx 2 -ipady 2 -padx 1 -fill x -pady 4;
			pack .calc.list.top.udf.func -side left -ipadx 2 -ipady 2;
			scrollbar .calc.list.top.udf.scroll -background "#ffffff" -command ".calc.list.top.udf.func yview";
			pack .calc.list.top.udf.scroll -side right -fill y -ipadx 2 -ipady 2;
			for { set i 0 } { $i < $NumUdf } { incr i } { .calc.list.top.udf.func insert end $Udf($i); };
			bind .calc.list.top.udf.func <Double-Button-1> {
				set temp1 [ .calc.list.top.udf.func get active ];
				for { set i 0 } { $i < $NumUdf } { incr i } { if { $Udf($i) == $temp1 } { break; } };
				set udfi $i;
				set temp2 {};
				for { set j 0 } { $j < $Udfdet($udfi,0) } { incr j } { lappend temp2 "$Udfdet($udfi,[ expr $j +2 ])"; }
				set tempret 0;
				mult_arg .calc.udfcall "UDF Function $temp1" "Enter values of parametres" "Param" $Udfdet($udfi,0) {
					global udfi;
					set temp {};
					lappend temp $VarVal(1);
					for { set u 1 } { $u < $Udfdet($udfi,0) } { incr u } { lappend temp $VarVal([ expr $u +1 ]);}
					set temp [ join [ split $temp " " ] "," ];
					set temp3 [ list $temp1 "(" $temp ")" ];
					regsub -all {\ *} $temp3 {} temp;
					set temp [ expr_eval "$temp" ];
					set EntryVal $temp;
					set o [ string length $EntryDisp ];
					.calc.oper.r1.entryval icursor $o;
					update idletasks;
				 } [ lindex $temp2 0 ] [ lindex $temp2 1 ] [ lindex $temp2 2 ] [ lindex $temp2 3 ] [lindex $temp2 4 ] [ lindex $temp2 5 ] [ lindex $temp2 6 ] [lindex $temp2 7 ] [ lindex $temp2 8 ] [ lindex $temp2 9 ] [ lindex $temp2 10 ] [ lindex $temp2 11 ] [ lindex $temp2 12 ] [ lindex $temp2 13 ] [lindex $temp2 14 ] [ lindex $temp2 15 ] [ lindex $temp2 16 ] [ lindex $temp2 17 ] [ lindex $temp2 18 ] [ lindex $temp2 19 ];
			unset tempret;
			unset j temp1 temp2 udfi; };
		       	unset temp Win_name; }; };

# angular menu
menu .menubar.angu.menu  -background "#ffffff" -foreground "#336697";
	.menubar.angu.menu add radiobutton -label Radian -variable Angular -value rad;
	.menubar.angu.menu add radiobutton -label Degree -variable Angular -value deg;
	.menubar.angu.menu add radiobutton -label Grad -variable Angular -value gra;

# graph menu
menu .menubar.grph.menu  -background "#ffffff" -foreground "#336697";
	.menubar.grph.menu add command -label "Size of graph" -command {
		set Temp $EntryVal;
		trace vdelete EntryVal r read_entry;
		trace vdelete EntryVal w write_entry;
		set EntryVal "";
		set tempret 0;
		mult_arg .calc.cansize "Size of Graph" "Enter the size in pixels" "Screen" 2 {
			global Xpix Ypix;
			if { [ catch { set VarVal(1) [ expr_eval $VarVal(1) ] } ] == 1 } { set VarVal(1) 0.0; }

			if { [ catch { set VarVal(2) [ expr_eval $VarVal(2) ] } ] == 1 } { set VarVal(2) 0.0; }
			catch { set Xpix [ expr int($VarVal(1)) ]; }
			catch { set Ypix [ expr int($VarVal(2)) ]; }; } "X size" "Y size";
		set EntryVal $Temp;
		unset tempret;
		trace variable EntryVal r read_entry;
		trace variable EntryVal w write_entry;
		unset Temp;
		if { $numcanvas != 0 } {
			destroy .canvas$numcanvas;
			set numcanvas 0;
			unset Xfactor Yfactor point npiter niter xmax ymax zmax;
			}; };
	.menubar.grph.menu add command -label "Ang of Depth Axis" -command {
		set TEMP $EntryVal;
		trace vdelete EntryVal r read_entry;
		trace vdelete EntryVal w write_entry;
		set EntryVal [ expr $theta*180/$PI ];
		set tempret 0;
		mult_arg .calc.settheta "Manual Control of Angle of Depth Axis" "Enter the required angle in degrees" "" 1 {
			global theta PI;
			if { [ catch { set VarVal(1) [ expr_eval $VarVal(1) ] } ] == 1 } { set VarVal(1) 0.0; }
			catch { set theta [ expr $VarVal(1)*$PI/180 ] ; }; } "Angle";
		set EntryVal $TEMP;
		unset TEMP;
		unset tempret;
		trace variable EntryVal r read_entry;
		trace variable EntryVal w write_entry; };
	.menubar.grph.menu add command -label "Cabinet Factor" -command {
			set TEMP $EntryVal;
			trace vdelete EntryVal r read_entry;
			trace vdelete EntryVal w write_entry;
			set EntryVal [ expr $cabfact ];
			set tempret 0;
			mult_arg .calc.cabfact "Manual Control of Cabinet Reduction Factor" "Enter the required factor" "" 1 {
				global cabfact;
				if { [ catch { set VarVal(1) [ expr_eval $VarVal(1) ] } ] == 1 } { set VarVal(1) 0.0; }
				catch { set cabfact $VarVal(1); }; } "Factor";
			set EntryVal $TEMP;
			unset TEMP;
			unset tempret;
			trace variable EntryVal r read_entry;
			trace variable EntryVal w write_entry; };
	.menubar.grph.menu add command -label "Grid Spacing" -command {
			set TEMP $EntryVal;
			trace vdelete EntryVal r read_entry;
			trace vdelete EntryVal w write_entry;
			set EntryVal $spc;
			set tempret 0;
			mult_arg .calc.gridspc "Manual Control of Grid Spacing" "Enter the desired grid Spacing in pixels" "" 1 {
				global spc;
				if { [ catch { set VarVal(1) [ expr_eval $VarVal(1) ]; } ] == 1 } { set VarVal(1) 0; };
				catch { set spc [ expr int($VarVal(1)) ] }; } "Spacing";
			set EntryVal $TEMP;
			unset TEMP;
			unset tempret;
			trace variable EntryVal r read_entry;
			trace variable EntryVal w write_entry; };

	.menubar.grph.menu add separator;
	.menubar.grph.menu add cascade -label Perspective -menu .menubar.grph.menu.persp;
	.menubar.grph.menu add checkbutton -label "3-Dimensional" -variable 3_Dim;
	.menubar.grph.menu add checkbutton -label "Draw Axes" -variable Draw_axes;
	.menubar.grph.menu add checkbutton -label "Draw Grid" -variable Draw_grid;
	.menubar.grph.menu add checkbutton -label "Label Axes" -variable LabelAxis;
	.menubar.grph.menu add checkbutton -label "Right Handed System" -variable RHS;
	.menubar.grph.menu add separator;
	.menubar.grph.menu add command -label Parametres -command {
		set Temp $EntryVal;
		trace vdelete EntryVal r read_entry;
		trace vdelete EntryVal w write_entry;
		set EntryVal "";
		set tempret 0;
		mult_arg .calc.graphparam "Parametres for functions" "Enter the required data" "" 2 {
			global Grph_param Grph_nparam;

			if { [ catch { set VarVal(1) [ expr_eval $VarVal(1) ] } ] == 1 } { set VarVal(1) 0.0; }
			if { $VarVal(1) != 0 } {
			set Grph_nparam $VarVal(1);
			regsub -all {\ +} $VarVal(2) {} v;
			set VarVal(2) $v;
			set G_param [ split $VarVal(2) ";" ];
			for { set v 0 } { $v < $Grph_nparam } { incr v } {
				set Grph_param($v) [ lindex $G_param $v ];
				 }; }; } "Number of param" "Names of param";
		unset tempret;
		set Entryval $Temp;
		trace variable EntryVal r read_entry;
		trace variable EntryVal w write_entry;
		unset Temp; };
	.menubar.grph.menu add command -label Draw -command {
		set temp {};
		for { set i 0 } { $i < $Grph_nparam } { incr i } { lappend temp "Param $Grph_param($i) : " ; };
		set rret [ grph_draw .calc.graphdraw "Parametres for graph" 3 { "Function in terms of parametres declared" "Limits of Parametres" "Increments of parametres" } { 3 $Grph_nparam $Grph_nparam } { "Cartesian X = " "Cartesian Y = " "Cartesian Z = " } {
			set Func(1) $VarVal(0,0);
			set Func(2) $VarVal(0,1);
			set Func(3) $VarVal(0,2);
			for { set v 0 } { $v < $Grph_nparam } { incr v } {
				set p [ split $VarVal(1,$v) ";" ];
				set Grph_paramlim($v,0) [ lindex $p 0 ];
				set Grph_paramlim($v,1) [ lindex $p 1 ];
				if { [ catch { set Grph_paramlim($v,0) [ expr_eval $Grph_paramlim($v,0) ] } ] == 1 } { set Grph_paramlim($v,0)  0.0; };

				if { [ catch { set Grph_paramlim($v,1) [ expr_eval $Grph_paramlim($v,1) ] } ] == 1 } { set Grph_paramlim($v,1)  0.0; };
				if { $VarVal(2,$v) == "" } { set VarVal(2,$v) 0.0 };
				if { [ catch { set VarVal(2,$v) [ expr_eval $VarVal(2,$v) ] } ] == 1 } { set VarVal(2,$v)  0.0; };
				if { ($VarVal(2,$v) == 0) && ($Grph_paramlim($v,0) != $Grph_paramlim($v,1)) } {
					set Grph_paramlim($v,2) [ expr 1/double(( $Grph_paramlim($v,1) - $Grph_paramlim($v,0) )) ]; } else {
					set Grph_paramlim($v,2) [ expr_eval $VarVal(2,$v) ]; }; };

			} $temp ] ;
		unset temp;
		if { $rret == 1 } {
		sketch_graph; }; };

tk_menuBar .menubar .menubar.file .menubar.disp .menubar.argu .menubar.grph .menubar.about;

# file_save menu
menu .menubar.file.menu.save  -background "#ffffff" -foreground "#336697";
	.menubar.file.menu.save add checkbutton -label Constants -variable Save(0);
	.menubar.file.menu.save add checkbutton -label Variables -variable Save(1);
	.menubar.file.menu.save add checkbutton -label Memory -variable Save(2);
	.menubar.file.menu.save add checkbutton -label "User def. Functions" -variable Save(3);
	.menubar.file.menu.save add checkbutton -label "Statistical Lists" -variable Save(4);
	.menubar.file.menu.save add checkbutton -label "General Settings" -variable Save(5);
	.menubar.file.menu.save add checkbutton -label "Graph Settings" -variable Save(6);
	.menubar.file.menu.save add separator;
	.menubar.file.menu.save add command -label "Save ..." -command {
		trace vdelete EntryVal r read_entry;
		trace vdelete EntryVal w write_entry;
		set TEMP $EntryVal;
		set EntryVal "";
		set tempret 0;
		mult_arg .calc.savedef "Save default settings" "Enter filename in which to save" "" 1 {
		global FileName;
		set FileName $VarVal(1); } "FileName" ;
		set EntryVal TEMP;
		trace variable EntryVal r read_entry;
		trace variable EntryVal w write_entry;
		if { $tempret != -0.6714 } {
		if { [ catch [ set fp [ open $FileName w ] ] ] == 0 } {
			tk_dialog .menubar.file.menu.save.error "Error !!" "            ERROR !!\nUnable to open file for writeing\n" "" 0 "Ok" ; } else {
			if { $Save(0) == 0 } {
				puts $fp "Constants";
				puts $fp "4";         # number of constants
				for { set i 0 } { $i < 4 } { incr i } {
					puts $fp " ";puts $fp "0.0"; }; } else {
				puts $fp "Constants";
				puts $fp "$NumConst";
				for { set i 0 } { $i < $NumConst } { incr i } {
					puts $fp "$Const($i,0)"; puts $fp "$Const($i,1)"; }; };
			if {  $Save(1) == 0 } {
				puts $fp "Variables";
				for { set i 0 } { $i < 6 } { incr i } {
					puts $fp "0.0"; }; } else {
				puts $fp "Variables";
				for { set i 0 } { $i < 6 } { incr i } {
					puts $fp "$Varreg($i)"; }; };
			if { $Save(2) == 0 } {
				puts $fp "Memory";
				puts $fp "0.0"; } else {
				puts $fp "Memory";
				puts $fp "$Memreg"; };
			if { $Save(3) == 0 } {
				puts $fp "Udfs" ;
				puts $fp "$NumUdf"; } else {
				puts $fp "Udfs" ;
				puts $fp "$NumUdf";
				for { set i 0 } { $i < $NumUdf } { incr i } {
					puts $fp "$Udf($i)";                 # name
					puts $fp "$Udfdet($i,0)";            # no. of param
					puts $fp "$Udfdet($i,1)";            # return value
					for { set j 0 } { $j < $Udfdet($i,0) } { incr j } {
						puts $fp "$Udfdet($i,[ expr $j +2 ])"; }; }; };
			if { $Save(4) == 0 } {
				puts $fp "Lists";
				puts $fp "0";
				puts $fp "0"; } else {
				puts $fp "Lists";
				puts $fp "$NumList";                 # no. of lists
				puts $fp "$CurrList";                # Current list
				for { set i 0 } { $i < $NumList } { incr i } {
					for { set j 0 } { $j < $ListName($i,1) } { incr j } {
						puts $fp $Listname($i,$j); }; }; };
			if { $Save(5) == 0 } {
				puts $fp "General";
				puts $fp "0"; } else {
				puts $fp "General";
				puts $fp "1";
				puts $fp "$Angular";
				puts $fp "$Disp_prec";
				puts $fp "$Hyperbol";
				puts $fp "$Inverse";
				puts $fp "$StoreVar"; };
			if { $Save(6) == 0 } {
				puts $fp "Graph";
				puts $fp 0; } else {
				puts $fp "Graph";
				puts $fp "1";
				puts $fp "$RHS";
				puts $fp "$LabelAxis";
				puts $fp "$Draw_grid";
				puts $fp "$Xpix";
				puts $fp "$Ypix";
				puts $fp "$Draw_axes";
				puts $fp "$3_Dim";
				puts $fp "$Persp";
				puts $fp "$theta";
				puts $fp "$k"; };
			close $fp;
			unset TEMP i fp FileName; };
	};
		unset tempret; };

# graph_perspective menu
menu .menubar.grph.menu.persp  -background "#ffffff" -foreground "#336697";
	.menubar.grph.menu.persp add radiobutton -label "Along +X" -variable Persp -value 10;
	.menubar.grph.menu.persp add radiobutton -label "Along -X" -variable Persp -value 11;
	.menubar.grph.menu.persp add radiobutton -label "Along +Y" -variable Persp -value 20;
	.menubar.grph.menu.persp add radiobutton -label "Along -Y" -variable Persp -value 21;
	.menubar.grph.menu.persp add radiobutton -label "Along +Z" -variable Persp -value 30;
	.menubar.grph.menu.persp add radiobutton -label "Along -Z" -variable Persp -value 31;

# entry of number
label .calc.oper.r1.entrylabel  -foreground "#000000" -text "Number : ";
entry .calc.oper.r1.entryval -width 30 -relief sunken -bd 2 -textvariable EntryDisp;
button .calc.oper.r1.maineq  -background "#e17571" -foreground "#ffffff" -activebackground "#336697" -activeforeground "#ffffff" -text "=" -relief raised -width 6 -command {
	if { $cc_nb != 0 } {
		tk_dialog .calc.error "Error !!" "        ERROR !!\nAll brackets not closed\n" "" 0 "Ok";
		} else {
		set cc_stack($cc_sp,0) $EntryVal ;
		set cc_stack($cc_sp,1) 0;
		set cccurr_ent "evaluate";
		ccstack_eval;
		set cc_sp 0;
		set cc_nb 0;
		set ccprev_ent "";
		set cccurr_ent "";
		set EntryVal $cc_stack(0,0);
		set i [ string length $EntryDisp ];
		.calc.oper.r1.entryval icursor $i;
		update idletasks;
		set AnsHist($NumHist) $EntryVal ;
		.calc.list.top.hist.val insert end $AnsHist($NumHist);
		ppcommand "*Debug $EntryVal"
		incr NumHist;
		} };
pack .calc.oper.r1.entrylabel .calc.oper.r1.entryval .calc.oper.r1.maineq -side left -padx 2 -pady 2;

# main function and operators
button .calc.oper.r2.mainplus  -background "#ffdc00" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "+" -relief raised -width 6 -command {
	if { ( $ccprev_ent == "" ) || ( $ccprev_ent == "bin_oper" ) || ( $ccprev_ent == "cl_bract" ) || ( $ccprev_ent == "op_bract" ) } {
		set cc_stack($cc_sp,0) $EntryVal ;
		set cc_stack($cc_sp,1) 10;
		set cccurr_ent "bin_oper";
		ccstack_eval;
		set ccprev_ent $cccurr_ent; } else {
		tk_dialog .calc.error "Error !!" "     ERROR !!\nIncorrect usage of\n binary operator \n" "" 0 "Ok";
	} };
button .calc.oper.r2.mainsub  -background "#ffdc00" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "-" -relief raised -width 6 -command {
	if { ( $ccprev_ent == "" ) || ( $ccprev_ent == "bin_oper" ) || ( $ccprev_ent == "cl_bract" ) || ( $ccprev_ent == "op_bract" )  } {
		set cc_stack($cc_sp,0) $EntryVal;
		set cc_stack($cc_sp,1) 11;
		set cccurr_ent "bin_oper";
		ccstack_eval;
		set ccprev_ent $cccurr_ent; } else {
		tk_dialog .calc.error "Error !!" "     ERROR !!\nIncorrect usage of\n binary operator \n" "" 0 "Ok";
	} };
button .calc.oper.r2.mainmult  -background "#ffdc00" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "*" -relief raised -width 6  -command {
	if { ( $ccprev_ent == ""  ) || ( $ccprev_ent == "bin_oper" ) || ( $ccprev_ent == "cl_bract" ) || ( $ccprev_ent == "op_bract" ) } {
		set cc_stack($cc_sp,0) $EntryVal;
		set cc_stack($cc_sp,1) 20;
		set cccurr_ent "bin_oper";
		ccstack_eval;
		set ccprev_ent $cccurr_ent; } else {
		tk_dialog .calc.error "Error !!" "     ERROR !!\nIncorrect usage of\n binary operator \n" "" 0 "Ok";
	} };
button .calc.oper.r2.maindiv  -background "#ffdc00" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "/" -relief raised -width 6 -command {
	if { ( $ccprev_ent == "" ) || ( $ccprev_ent == "bin_oper" ) || ( $ccprev_ent == "cl_bract") || ( $ccprev_ent == "op_bract" ) } {
		set cc_stack($cc_sp,0) $EntryVal;
		set cc_stack($cc_sp,1) 21;
		set cccurr_ent "bin_oper";
		ccstack_eval;
		set ccprev_ent $cccurr_ent; } else {
		tk_dialog .calc.error "Error !!" "     ERROR !!\nIncorrect usage of\n binary operator \n" "" 0 "Ok";
	} };
button .calc.oper.r2.mainmod  -background "#ffdc00" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "Mod" -relief raised -width 6  -command {
	if { ( $ccprev_ent == "" ) || ( $ccprev_ent == "bin_oper" ) || ( $ccprev_ent == "cl_bract") || ( $ccprev_ent == "op_bract" ) } {
		set cc_stack($cc_sp,0) $EntryVal;
		set cc_stack($cc_sp,1) 22;
		set cccurr_ent "bin_oper";
		ccstack_eval;
		set ccprev_ent $cccurr_ent; } else {
		tk_dialog .calc.error "Error !!" "     ERROR !!\nIncorrect usage of\n binary operator \n" "" 0 "Ok";
	} };
pack .calc.oper.r2.mainplus .calc.oper.r2.mainsub .calc.oper.r2.mainmult .calc.oper.r2.maindiv .calc.oper.r2.mainmod -ipadx 4 -ipady 1 -side left;

button .calc.oper.r3.mainbop  -background "#c9f9ff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "(" -relief raised -width 6 -command {
	if { ( $ccprev_ent == "bin_oper" ) || ( $ccprev_ent == "" ) || ( $ccprev_ent == "op_bract" ) } {
		set cc_stack($cc_sp,0) 0;
		set cc_stack($cc_sp,1) 30;
		set cccurr_ent "op_bract";
		incr cc_sp;
		incr cc_nb;
		} else {
		tk_dialog .calc.error "Error !!" "     ERROR !!\nIncorrect usage of\n bracket operator \n" "" 0 "Ok";
	} };
button .calc.oper.r3.mainbcl  -background "#c9f9ff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text ")" -relief raised -width 6 -command {
	if { ( $ccprev_ent == "bin_oper" ) || ( $ccprev_ent == "op_bract" ) } {
		set cc_stack($cc_sp,0) $EntryVal;
		set cc_stack($cc_sp,1) 31;
		set cccurr_ent "cl_bract";
		ccstack_eval;
		set ccprev_ent $cccurr_ent;
		incr cc_nb -1; } else {
		tk_dialog .calc.error "Error !!" "     ERROR !!\nIncorrect Usage of\n bracket operator \n" "" 0 "Ok";
	} };
button .calc.oper.r3.mainnot  -background "#c9f9ff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "Not" -relief raised -width 6 -command {
	set EntryVal [ expr ~ int($EntryVal) ];
	set i [ string length $EntryDisp ];
	.calc.oper.r1.entryval icursor $i;
	update idletasks; };
button .calc.oper.r3.mainper  -background "#c9f9ff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "%" -relief raised -width 6 -command {
	set EntryVal [ expr $EntryVal * 100.0 ];
	set i [ string length $EntryDisp ];
        .calc.oper.r1.entryval icursor $i;
	update idletasks; };
button .calc.oper.r3.mainsgn  -background "#c9f9ff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "+/-" -relief raised -width 6 -command {
	set EntryVal [ expr - $EntryVal ];
	set i [ string length $EntryDisp ];
        .calc.oper.r1.entryval icursor $i;
	update idletasks; };
pack .calc.oper.r3.mainbop .calc.oper.r3.mainbcl .calc.oper.r3.mainper .calc.oper.r3.mainnot .calc.oper.r3.mainsgn -ipadx 4 -ipady 1 -side left;

checkbutton .calc.oper.r35.hyper  -background "#00bcd6" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "Hype" -relief raised -width 6 -variable Hyperbol;
checkbutton .calc.oper.r35.inverse  -background "#00bcd6" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "Inv" -relief raised -width 6 -variable Inverse;
button .calc.oper.r35.sin  -background "#c9f9ff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "Sin" -relief raised -width 6 -command {
	if { ( $Hyperbol == 0 ) && ( $Inverse == 0 ) } {
		switch $Angular {
			"deg" { set EntryVal [ expr $EntryVal * $PI/180 ]; }
			"gra" { set EntryVal [ expr $EntryVal * $PI/200 ]; }
				};
	set EntryVal [ Sin $EntryVal   ]; };
	if { ( $Hyperbol == 0 ) && ( $Inverse == 1 ) } {
		set EntryVal [ Asin $EntryVal ];
		switch $Angular {
			"deg" { set EntryVal [ expr $EntryVal * 180/$PI ]; }
			"gra" { set EntryVal [ expr $EntryVal * 200/$PI ]; }
				}; };
	if { ( $Hyperbol == 1 ) && ( $Inverse == 0 ) } { set EntryVal [ Sinh $EntryVal  ]; };
	if { ( $Hyperbol == 1 ) && ($Inverse == 1) } { set EntryVal [ Asinh $EntryVal ]; };
	set i [ string length $EntryDisp ];
	.calc.oper.r1.entryval icursor $i;
	update idletasks; };
button .calc.oper.r35.cos   -background "#c9f9ff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "Cos" -relief raised -width 6 -command {
	if { ($Hyperbol ==0) && ($Inverse == 0) } {
		switch $Angular {
			"deg" { set EntryVal [ expr $EntryVal * $PI/180 ]; }
			"gra" { set EntryVal [ expr $EntryVal * $PI/200 ]; }
				};
		set EntryVal [ Cos $EntryVal  ]; };
	if { ($Hyperbol == 0) && ($Inverse == 1) } {
		set EntryVal [ Acos $EntryVal  ];
		switch $Angular {
			"deg" { set EntryVal [ expr $EntryVal * 180/$PI ]; }
			"gra" { set EntryVal [ expr $EntryVal * 200/$PI ]; }
				}; };
	if { ($Hyperbol == 1) && ($Inverse == 0) } { set EntryVal [ Cosh $EntryVal  ]; };
	if { ($Hyperbol == 1) && ($Inverse == 1) } { set EntryVal [ Acosh1 $EntryVal ]; };
	set i [ string length $EntryDisp ];
	.calc.oper.r1.entryval icursor $i;
	update idletasks; };
button .calc.oper.r35.tan   -background "#c9f9ff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "Tan" -relief raised -width 6 -command {
	if { ($Hyperbol ==0) && ($Inverse == 0) } {
		switch $Angular {
			"deg" { set EntryVal [ expr $EntryVal * $PI/180 ]; }
			"gra" { set EntryVal [ expr $EntryVal * $PI/200 ]; }
				};
		set EntryVal [ Tan $EntryVal  ]; };
	if { ($Hyperbol == 0) && ($Inverse == 1) } {
		set EntryVal [ Atan $EntryVal  ];
		switch $Angular {
			"deg" { set EntryVal [ expr $EntryVal * 180/$PI ]; }
			"gra" { set EntryVal [ expr $EntryVal * 200/$PI ]; }
				}; };
	if { ($Hyperbol == 1) && ($Inverse == 0) } { set EntryVal [ Tanh $EntryVal  ]; };
	if { ($Hyperbol == 1) && ($Inverse == 1) } { set EntryVal [ Atanh $EntryVal ]; };
	set i [ string length $EntryDisp ];
	.calc.oper.r1.entryval icursor $i;
	update idletasks; };
pack .calc.oper.r35.hyper .calc.oper.r35.inverse .calc.oper.r35.sin .calc.oper.r35.cos .calc.oper.r35.tan -side left -ipadx 4 -ipady 1;

button .calc.oper.r4.main10x   -background "#c9f9ff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "10^x" -relief raised -width 6 -command {
	set EntryVal [ Pow 10.0 $EntryVal ];
	set i [ string length $EntryDisp ];
        .calc.oper.r1.entryval icursor $i;
	update idletasks; };
button .calc.oper.r4.mainex   -background "#c9f9ff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "e^x" -relief raised -width 6 -command {
	set EntryVal [ Exp $EntryVal  ];
	set i [ string length $EntryDisp ];
        .calc.oper.r1.entryval icursor $i;
	update idletasks; };
button .calc.oper.r4.mainxy    -background "#c9f9ff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "x^y" -relief raised -width 6 -command {
	set tempret 0;
	mult_arg .calc.multargxy "Function x^y" "Enter values of parametres" "Param " 2 {
		if { [ catch { set VarVal(1) [ expr_eval $VarVal(1) ] } ] == 1 } { set VarVal(1) 0.0; }
		if { [ catch { set VarVal(2) [ expr_eval $VarVal(2) ] } ] == 1 } { set VarVal(2) 0.0; }
		set EntryVal [ Pow $VarVal(1) $VarVal(2)  ];
		set j [ string length $EntryDisp ];
		.calc.oper.r1.entryval icursor $j;
		update idletasks; } x y;
		unset tempret; };
button .calc.oper.r4.mainx2 -background "#c9f9ff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff"  -text "x^2" -relief raised -width 6 -command {
	set EntryVal [ expr $EntryVal * $EntryVal ];
	set i [ string length $EntryDisp ];
        .calc.oper.r1.entryval icursor $i;
	update idletasks; };
button .calc.oper.r4.main1x  -background "#c9f9ff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "1/x" -relief raised -width 6 -command {
	if { $EntryVal == 0 } {
		tk_dialog .calc.error "Error !!" "   ERROR !!\nDivison by zero\n" "" 0 "Ok";
		} else {
		set EntryVal [ expr 1.0 / $EntryVal ];
		set i [ string length $EntryDisp ];
   		.calc.oper.r1.entryval icursor $i;
		update idletasks;
	} };
pack .calc.oper.r4.main10x .calc.oper.r4.mainex .calc.oper.r4.mainxy .calc.oper.r4.mainx2 .calc.oper.r4.main1x -ipadx 4 -ipady 1 -side left;

button .calc.oper.r5.mainlog  -background "#c9f9ff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "Log" -relief raised -width 6 -command {
		set EntryVal [ Log10 $EntryVal  ];
		set i [ string length $EntryDisp ];
   		.calc.oper.r1.entryval icursor $i;
		update idletasks;
		};
button .calc.oper.r5.mainln  -background "#c9f9ff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "Ln" -relief raised -width 6 -command {
		set EntryVal [ Log $EntryVal  ];
		set i [ string length $EntryDisp ];
   		.calc.oper.r1.entryval icursor $i;
		update idletasks;
		 };

button .calc.oper.r5.mainxiy  -background "#c9f9ff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "x^1/y" -relief raised -width 6 -command {
	set tempret 0;
	mult_arg .calc.multargx1y "Function x^1/y" "Enter values of parametres" "Param " 2 {
		if { [ catch { set VarVal(1) [ expr_eval $VarVal(1) ] } ] == 1 } { set VarVal(1) 0.0; }
		if { [ catch { set VarVal(2) [ expr_eval $VarVal(2) ] } ] == 1 } { set VarVal(2) 0.0; }
		set EntryVal [ Pow $VarVal(1) [ expr 1.0/$VarVal(2) ] ];
		set j [ string length $EntryDisp ];
		.calc.oper.r1.entryval icursor $j;
		update idletasks; } x y;
		unset tempret; };
button .calc.oper.r5.mainxi2  -background "#c9f9ff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -width 6 -text "x^1/2" -relief raised -command {
		set EntryVal [ Sqrt $EntryVal  ];
		set i [ string length $EntryDisp ];
   		.calc.oper.r1.entryval icursor $i;
		update idletasks;
		};
button .calc.oper.r5.mainxi3  -background "#c9f9ff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "x^3" -relief raised -width 6  -command {
	set EntryVal [ Pow $EntryVal [ expr 1.0/3.0 ] ];
	set i [ string length $EntryDisp ];
   	.calc.oper.r1.entryval icursor $i;
	update idletasks;
}
pack .calc.oper.r5.mainlog .calc.oper.r5.mainln .calc.oper.r5.mainxiy .calc.oper.r5.mainxi2 .calc.oper.r5.mainxi3 -ipadx 4 -ipady 1 -side left;

button .calc.oper.r6.mainxf  -background "#c9f9ff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "x!" -relief raised -width 6 -command {factorial $EntryVal; };

button .calc.oper.r6.mainand  -background "#c9f9ff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "And" -relief raised -width 6 -command {
	set tempret 0;
	mult_arg .calc.multargand "Function Bitwise And" "Enter values of parametres" "Param " 2 {
		if { [ catch { set VarVal(1) [ expr_eval $VarVal(1) ] } ] == 1 } { set VarVal(1) 0.0; }
		if { [ catch { set VarVal(2) [ expr_eval $VarVal(2) ] } ] == 1 } { set VarVal(2) 0.0; }
		set EntryVal [ expr int($VarVal(1)) & int($VarVal(2)) ];
		set j [ string length $EntryDisp ];
		.calc.oper.r1.entryval icursor $j;
		update idletasks; } x y;
		unset tempret; };
button .calc.oper.r6.mainor  -background "#c9f9ff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "Or" -relief raised -width 6 -command {
	set tempret 0;
	mult_arg .calc.multargor "Function Bitwise Or" "Enter values of parametres" "Param " 2 {
		if { [ catch { set VarVal(1) [ expr_eval $VarVal(1) ] } ] == 1 } { set VarVal(1) 0.0; }
		if { [ catch { set VarVal(2) [ expr_eval $VarVal(2) ] } ] == 1 } { set VarVal(2) 0.0; }
		set EntryVal [ expr int($VarVal(1)) | int($VarVal(2)) ];
		set j [ string length $EntryDisp ];
		.calc.oper.r1.entryval icursor $j;
		update idletasks; } x y;
		unset tempret; };
button .calc.oper.r6.mainxor  -background "#c9f9ff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "Xor" -relief raised -width 6 -command {
	set tempret 0;
	mult_arg .calc.multargxor "Function Bitwise Xor" "Enter values of parametres" "Param " 2 {
		if { [ catch { set VarVal(1) [ expr_eval $VarVal(1) ] } ] == 1 } { set VarVal(1) 0.0; }
		if { [ catch { set VarVal(2) [ expr_eval $VarVal(2) ] } ] == 1 } { set VarVal(2) 0.0; }
		set EntryVal [ expr int($VarVal(1)) ^ int($VarVal(2)) ];
		set j [ string length $EntryDisp ];
		.calc.oper.r1.entryval icursor $j;
		update idletasks; } x y;
		unset tempret; };
button .calc.oper.r6.mainxnor  -background "#c9f9ff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "XNor" -relief raised -width 6 -command {
	set tempret 0;
	mult_arg .calc.multargxnor "Function Bitwise XNor" "Enter values of parametres" "Param " 2 {
		if { [ catch { set VarVal(1) [ expr_eval $VarVal(1) ] } ] == 1 } { set VarVal(1) 0.0; }
		if { [ catch { set VarVal(2) [ expr_eval $VarVal(2) ] } ] == 1 } { set VarVal(2) 0.0; }
		set EntryVal [ expr ~(int($VarVal(1)) ^ int($VarVal(2))) ];
		set j [ string length $EntryDisp ];
		.calc.oper.r1.entryval icursor $j;
		update idletasks; } x y;
		unset tempret; };
pack .calc.oper.r6.mainxf .calc.oper.r6.mainand .calc.oper.r6.mainor .calc.oper.r6.mainxor .calc.oper.r6.mainxnor -ipadx 4 -ipady 1 -side left;

button .calc.oper.r7.mainncr  -background "#c9f9ff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "nCr" -relief raised -width 6 -command {
	set tempret 0;
	mult_arg .calc.multargncr "Function nCr" "Enter values of parametres" "Param " 2 {
		set dummy 1.0;
		if { [ catch { set VarVal(1) [ expr_eval $VarVal(1) ] } ] == 1 } { set VarVal(1) 0.0; }
		if { [ catch { set VarVal(2) [ expr_eval $VarVal(2) ] } ] == 1 } { set VarVal(2) 0.0; }
		for { set j 1 } { $j <= $VarVal(2) } { incr j } { set dummy [ expr double($dummy) * [ expr $VarVal(1) - $VarVal(2) + $j ] / double($j) ] ; };
		set EntryVal $dummy;
		set j [ string length $EntryDisp ];
		.calc.oper.r1.entryval icursor $j;
		update idletasks; } n r;
		unset tempret; };
button .calc.oper.r7.mainnpr  -background "#c9f9ff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "nPr" -relief raised -width 6 -command {
	set tempret 0;
	mult_arg .calc.multargnpr "Function nPr" "Enter values of parametres" "Param " 2 {
		set dummy 1;
		if { [ catch { set VarVal(1) [ expr_eval $VarVal(1) ] } ] == 1 } { set VarVal(1) 0.0; }
		if { [ catch { set VarVal(2) [ expr_eval $VarVal(2) ] } ] == 1 } { set VarVal(2) 0.0; }
		for { set j 1 } { $j <= $VarVal(2) } { incr j } { set dummy [ expr double($dummy) * [ expr $VarVal(1) - $VarVal(2) + $j ] ] ; };
		set EntryVal $dummy;
		set j [ string length $EntryDisp ];
		.calc.oper.r1.entryval icursor $j;
		update idletasks; } n r;
		unset tempret; };
button .calc.oper.r7.mainrnd  -background "#c9f9ff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "Rnd" -relief raised -width 6 -command {
	set EntryVal [ expr rand() ];
	set i [ string length $EntryDisp ];
	.calc.oper.r1.entryval icursor $i; };
button .calc.oper.r7.mainabc  -background "#c9f9ff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "a b/c" -relief raised -width 6 -command { dtoabc $EntryVal; };
button .calc.oper.r7.maindc  -background "#c9f9ff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "d/c" -relief raised -width 6 -command {dtodc $EntryVal; };
pack .calc.oper.r7.mainncr .calc.oper.r7.mainnpr .calc.oper.r7.mainrnd .calc.oper.r7.mainabc .calc.oper.r7.maindc -ipadx 4 -ipady 1 -side left;

# quadratic and simultaneous equation solving
button .calc.oper.r75.mainquad  -background "#c9f9ff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "Quadratic Equation" -relief raised -width 21 -command {
	set tempret 0;
	mult_arg .calc.quadeqn "Quadratic Equation" "Equation is : ax^2 + bx + c\n Enter values of parametres" "Param " 3 {
		global temp12 temp13;
		if { [ catch { set VarVal(1) [ expr_eval $VarVal(1) ] } ] == 1 } { set VarVal(1) 0.0; }
		if { [ catch { set VarVal(2) [ expr_eval $VarVal(2) ] } ] == 1 } { set VarVal(2) 0.0; }

		if { [ catch { set VarVal(3) [ expr_eval $VarVal(3) ] } ] == 1 } { set VarVal(3) 0.0; }
		if { [ catch { set temp12 [ expr ( -$VarVal(2) - sqrt($VarVal(2)*$VarVal(2) - 4.0*$VarVal(1)*$VarVal(3) )) / 2.0 / $VarVal(1) ] } ] == 1 } { set temp12 "undef"; };
		if { [ catch { set temp13 [ expr ( -$VarVal(2) + sqrt($VarVal(2)*$VarVal(2) - 4.0*$VarVal(1)*$VarVal(3) )) / 2.0 / $VarVal(1) ] } ] == 1 } { set temp13 "undef"; };
		} a b c;
		if { $tempret != -0.6714 } {
		if { [ catch { set a $temp12; } ] != 1 } {
			set VarVal(1) $temp12;
			set VarVal(2) $temp13;
			set tempret2 0;
			select_val .calc.selectquad "Solution to Quadratic Equation" "Select desired value" "Value" { } 2 "+ve root" "-ve Root";
			unset tempret2;
			unset temp12 temp13 a; };
		}; unset tempret; };
button .calc.oper.r75.mainsimu  -background "#c9f9ff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "Simultaneous Equation" -relief raised -width 21 -command {
		set tempret 0;
		mult_arg .calc.simuleqn "Simultaneous Equations in 2 variables" "Equations are : a1x + b1y = c1\n                   a2x + b2y = c2\n  Enter values of parametres" "Param " 6 {
		global temp12 temp13;
		if { [ catch { set VarVal(1) [ expr_eval $VarVal(1) ] } ] == 1 } { set VarVal(1) 0.0; }
		if { [ catch { set VarVal(2) [ expr_eval $VarVal(2) ] } ] == 1 } { set VarVal(2) 0.0; }
		if { [ catch { set VarVal(3) [ expr_eval $VarVal(3) ] } ] == 1 } { set VarVal(3) 0.0; }
		if { [ catch { set VarVal(4) [ expr_eval $VarVal(4) ] } ] == 1 } { set VarVal(4) 0.0; }
		if { [ catch { set VarVal(2) [ expr_eval $VarVal(5) ] } ] == 1 } { set VarVal(5) 0.0; }
		if { [ catch { set VarVal(2) [ expr_eval $VarVal(6) ] } ] == 1 } { set VarVal(6) 0.0; }
		if { [ catch { set temp12 [ expr - ( $VarVal(6)*$VarVal(2) - $VarVal(3)*$VarVal(5) ) / ( $VarVal(1)*$VarVal(5) - $VarVal(4)*$VarVal(2) ) ] ; } ] == 1 } { set temp12 "undef"; };
		if { [ catch { set temp13 [ expr ( $VarVal(6)*$VarVal(1) - $VarVal(3)*$VarVal(4) ) / ( $VarVal(1)*$VarVal(5) - $VarVal(4)*$VarVal(2) ) ] ; } ] == 1 } { set temp13 "undef"; };
		} a1 b1 c1 a2 b2 c2;
		if { $tempret != -0.6714 } {
		if { [ catch { set a $temp12; } ] != 1 } {
			set VarVal(1) $temp12;
			set VarVal(2) $temp13;
			set tempret2 0;
			select_val .calc.selectsimu "Solution to Simultaneous Equations" "Select desired value" "Value" { } 2 "x" "y";
			unset tempret2;
			unset temp12 temp13 a; };
			}; unset tempret; };
pack .calc.oper.r75.mainquad -ipadx 1 -ipady 1 -side left;
pack .calc.oper.r75.mainsimu -ipadx 1 -ipady 1 -side right;

# main memory functions
button .calc.oper.r8.mainmplus  -background "#ffffff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "M+" -relief raised -width 6 -command {
	set Memreg [ expr $Memreg + $EntryVal ]; };
button .calc.oper.r8.mainmsub  -background "#ffffff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "M-" -relief raised -width 6 -command {
	set Memreg [ expr $Memreg - $EntryVal ]; };
button .calc.oper.r8.mainmmult  -background "#ffffff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "M*" -relief raised -width 6 -command {
	set Memreg [ expr $Memreg * $EntryVal ]; };
button .calc.oper.r8.mainmdiv  -background "#ffffff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "M/" -relief raised -width 6 -command {
	if { $EntryVal == 0 } {
		tk_dialog .calc.error "Error !!" "   ERROR !!\nDivison by zero\n" "" 0 "Ok";
		} else {
		set Memreg [ expr $Memreg / $EntryVal ]; };
	}
button .calc.oper.r8.mainmrcl  -background "#ffffff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "M Rcl" -relief raised -width 6 -command {
	set EntryVal $Memreg;
	set i [ string length $EntryDisp ];
   	.calc.oper.r1.entryval icursor $i;
	update idletasks; };
pack .calc.oper.r8.mainmplus .calc.oper.r8.mainmsub .calc.oper.r8.mainmmult .calc.oper.r8.mainmdiv .calc.oper.r8.mainmrcl -ipadx 4 -pady 2 -side left;

# constants
button .calc.oper.r9.mainconst0   -background "#ffffcc" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text $Const(0,0) -relief raised -width 6 -command {
	set EntryVal $Const(0,1);
	set i [ string length $EntryDisp ];
   	.calc.oper.r1.entryval icursor $i;
	update idletasks;
	};
button .calc.oper.r9.mainconst1   -background "#ffffcc" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text $Const(1,0) -relief raised -width 6 -command {
	set EntryVal $Const(1,1);
	set i [ string length $EntryDisp ];
   	.calc.oper.r1.entryval icursor $i;
	update idletasks;
	};
button .calc.oper.r9.mainconst2   -background "#ffffcc" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text $Const(2,0) -relief raised -width 6 -command {
	set EntryVal $Const(2,1);
	set i [ string length $EntryDisp ];
   	.calc.oper.r1.entryval icursor $i;
	update idletasks;
	};
button .calc.oper.r9.mainconst3   -background "#ffffcc" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text $Const(3,0) -relief raised -width 6 -command {
	set EntryVal $Const(3,1);
	set i [ string length $EntryDisp ];
   	.calc.oper.r1.entryval icursor $i;
	update idletasks;
	};
button .calc.oper.r9.maincsto   -background "#e8fff9" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text Others -relief raised -width 6 -command {
	set Win_name ".calc.others";
	set temp -0.6714;
	select_list "Other Constants" "Double click to select" "stat" Const 4 [ expr $NumConst -1 ] 20 10 ;
	if { $temp != -0.6714 } {
		set EntryVal $temp;
		set i [ string length $EntryDisp ];
		.calc.oper.r1.entryval icursor $i;
		update idletasks;
		};
	unset temp Win_name; };
pack .calc.oper.r9.mainconst0 .calc.oper.r9.mainconst1 .calc.oper.r9.mainconst2 .calc.oper.r9.mainconst3 .calc.oper.r9.maincsto -ipadx 4 -pady 2 -side left;

# parser
button .parser.activ   -background "#e17571" -foreground "#000000" -activebackground "#336697" -activeforeground "#ffffff" -text Parser -width 6 -relief raised -command {
	focus .parser.expr; };
label .parser.label -foreground "#000000" -text "Expression : ";
entry .parser.expr -width 65 -relief sunken -bd 2 -textvariable ExprVal;
button .parser.eval   -background "#e17571" -foreground "#000000" -activebackground "#336697" -activeforeground "#ffffff" -text "Evaluate" -width 12 -relief raised -command {
	set temp [ expr_eval $ExprVal ];
	set EntryVal $temp;
	set i [ string length EntryDisp ];
	.calc.oper.r1.entryval icursor $i;
	set ExprVal "";
	set i 0;
	.parser.expr icursor $i;
	update idletasks;
	unset temp; };
pack .parser.activ .parser.label .parser.expr .parser.eval -side left -padx 2;

# statistical
button .calc.stat.nlst   -background "#80d7ff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "New List" -width 12 -height 1 -relief raised -command {
	set Temp $EntryVal;
	trace vdelete EntryVal r read_entry;
	trace vdelete EntryVal w write_entry;
	set EntryVal "";
	set tempret 0;
	mult_arg .calc.newlist "New List" "Enter name of new list:" "Name" 1 {
		global NumList CurrList ListName;
		set ListName($NumList,0) $VarVal(1);
		set ListName($NumList,1) 2;
		set CurrList $NumList;
		incr NumList; } " ";
	unset tempret;
	set EntryVal $Temp;
	unset Temp;
	trace variable EntryVal r read_entry;
	trace variable EntryVal w write_entry; };
button .calc.stat.slst   -background "#80d7ff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "Select List" -width 12 -height 1 -relief raised -command {
	if { $NumList != 0 } {
	set Win_name ".calc.sellst";
	set temp -0.6714;
	set temp2 -0.6714;
	select_list "Select List" "Double click to select" "stat" ListName 0 [ expr $NumList -1 ] 20 10;
	if { $temp != -0.6714 } {
		set temp2 [ string range $temp2 0 [ expr [ string first " " $temp2 ] -1 ] ];
		set i 0;
		while { ($i < $NumList) && ($ListName($i,0) != $temp2) } { incr i };
		if { $i != $NumList } { set CurrList $i }; };
	unset temp temp2 Win_name; }; };
button .calc.stat.ielem   -background "#80d7ff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "Insert Element" -width 12 -height 1 -relief raised -command {
	if { $NumList != 0 } {
		set tempret 0;
		mult_arg .calc.inselem$CurrList "Insert Element" "Enter element to insert" "Value" 1 {
			global CurrList NumList ListName;
			if { [ catch { set VarVal(1) [ expr_eval $VarVal(1) ] } ] == 1 } { set VarVal(1) 0.0; }
			set ListName($CurrList,$ListName($CurrList,1)) $VarVal(1);
			incr ListName($CurrList,1);
			} " ";
		unset tempret; }; };
button .calc.stat.relem   -background "#80d7ff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "Retrieve Elem" -width 12 -height 1 -relief raised -command {
	if { $NumList != 0 } {
		set tempret 0;
		mult_arg .calc.retelem$CurrList "Retrieve Element" "Enter element number to retrieve" "Elem Number" 1 {
			global CurrList NumList ListName ;
			if { [ catch { set VarVal(1) [ expr_eval $VarVal(1) ] } ] == 1 } { set VarVal(1) 0.0; }
			if { $ListName($CurrList,1) > $VarVal(1) } {
				set EntryVal $ListName($CurrList,[ expr $VarVal(1) +1 ]);}; } " " ;
		unset tempret; }; };
button .calc.stat.delem   -background "#80d7ff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "Delete Element" -width 12 -height 1 -relief raised -command {
	if { $NumList != 0 } {
		set tempret 0;
		mult_arg .calc.delelem$CurrList "Delete Element" "Enter element number to delete" "Elem Number" 1 {
			global CurrList NumList ListName;

			if { [ catch { set VarVal(1) [ expr_eval $VarVal(1) ] } ] == 1 } { set VarVal(1) 0.0; }
			if { $ListName($CurrList,1) > $VarVal(1) } {
				set VarVal(1) [ expr int($VarVal(1))+1 ];
				for { set q $VarVal(1) } { $q < [ expr $ListName($CurrList,1) -1] } { incr q } {
					set ListName($CurrList,$q) $ListName($CurrList,[ expr $q +1]); };
				incr ListName($CurrList,1) -1; }; } " ";
		unset tempret; }; };
button .calc.stat.genlst   -background "#80d7ff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "Generate List" -width 12 -height 1 -relief raised -command {
	if { $NumList != 0 } {
	trace vdelete EntryVal r read_entry;
	trace vdelete EntryVal w write_entry;
	set TEMP $EntryVal;
	set EntryVal "";
	set tempexpr "";
	set tempend 0;
	set tempret 0;
	mult_arg .calc.genlist$CurrList "Generate List" "Enter the required parametres" "" 2 {
		global tempexpr tempend;
		set tempexpr $VarVal(1);

		if { [ catch { set VarVal(2) [ expr_eval $VarVal(2) ] } ] == 1 } { set VarVal(2) 0.0; }
		set tempend $VarVal(2);
		} "Recursive x(n) = " "Terminating n";
	if { $tempret != -0.6714 } {
		gen_list $tempexpr [ expr $ListName($CurrList,1) -1 ] $tempend "genlist";
		set EntryVal $TEMP;
		trace variable EntryVal r read_entry;
		trace variable EntryVal w write_entry;
		unset tempexpr tempend TEMP; }; unset tempret; }; };
button .calc.stat.srtlst   -background "#80d7ff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "Sort List" -width 12 -height 1 -relief raised -command {
	if { $NumList != 0 } {
	set i 0;
	set j 0;
	set t 0;
	for { set i [ expr $ListName($CurrList,1) -2 ] } { $i >= 2 } { incr i -1 } {
		for { set j [ expr $i +1 ] } { $j < $ListName($CurrList,1) } { incr j } {
			if { $ListName($CurrList,[ expr $j -1 ]) > $ListName($CurrList,$j) } {
				set t $ListName($CurrList,$j);
				set ListName($CurrList,$j) $ListName($CurrList,[ expr $j -1 ]);
				set ListName($CurrList,[ expr $j -1]) $t;
				}; }; };
	unset j t; }; };
button .calc.stat.vlst   -background "#80d7ff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "View List" -width 12 -height 1 -relief raised -command {
	if { $NumList > 0 } {
		catch { destroy $Win_name1; unset Win_name1; };
		view_list .calc.viewlist "List $ListName($CurrList,0)" ; }; };
button .calc.stat.oper   -background "#80d7ff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "Operations" -width 12 -height 1 -relief raised -command {
	if { $NumList != 0 } {
	if { $ListName($CurrList,1) == 2 } {
		generror "List $ListName($CurrList,0) is empty"; } else {
	set Win_name ".calc.statoper";
	set temp -0.6714;
	set temp2 -0.6714;
	set temp3 0.0;
	set sigx 0.0;
	set sigx2 0.0;
	set ret 0.0;
	set sig 0.0;
	set meanx 0.0;
	set marr(0,0) "Mean x";set marr(0,1) " ";
	set marr(1,0) "Sigma x";set marr(1,1) " ";
	set marr(2,0) "Sigma x^2";set marr(2,1) " ";
	set marr(3,0) "Standard deviation";set marr(3,1) " ";
	set marr(4,0) "Variance";set marr(4,1) " ";
	set marr(5,0) "Count x";set marr(5,1) " ";
	set marr(6,0) "Sigma f(i)";set marr(6,1) " ";
	select_list "Statistical Operations" "Double click to select" "stat" marr 0 6 20 10;
	set temp3 $temp2;
	set temp2 [ string range $temp2 0 [ expr [ string first " " $temp2 ] -1 ] ];
	if { $temp != -0.6714 } {
		for { set i 2 } { $i < $ListName($CurrList,1) } { incr i } {
			set sigx [ expr $sigx + $ListName($CurrList,$i) ];
			set sigx2 [ expr $sigx2 + $ListName($CurrList,$i)*$ListName($CurrList,$i) ]; }
		set meanx [ expr $sigx/( $ListName($CurrList,1) -2 ) ];
		for { set i 2 } { $i < $ListName($CurrList,1) } { incr i } {
			set sig [ expr $sig + ($ListName($CurrList,1) - $meanx) * ($ListName($CurrList,1) - $meanx) ]; };
		set sig [ expr $sig/($ListName($CurrList,1) -2) ];

		if { $temp2 == "Sigma" } {
			if { [ string index $temp3 8 ] == "2" } { set temp2  "Sigma x^2"; };
			if { [ string index $temp3 8 ] == "i" } { set temp2 "Sigma f(i)"; }; };
		if { $temp2 == "Mean" }  { set ret $meanx; }
		if { $temp2 == "Sigma" } { set ret $sigx; }
		if { $temp2 == "Sigma x^2" } { set ret $sigx2; }
		if { $temp2 == "Standard" } { set ret [ expr sqrt($sig) ]; }
		if { $temp2 == "Variance" } { set ret $sig; }
		if { $temp2 == "Count" } { set ret [ expr $ListName($CurrList,1) -2 ]; }
		if { $temp2 == "Sigma f(i)" } {
			trace vdelete EntryVal r read_entry;
			trace vdelete EntryVal w write_entry;
			set TEMP $EntryVal;
			set EntryVal "";
			set tempexpr "";
			set tempstart 0;
			set tempend 0;
			set tempret 0;
			mult_arg .calc.sigmafi$CurrList "Summation on the nth term" "Enter the required parametres" "" 3 {
				global tempexpr tempstart tempend;
				set tempexpr $VarVal(1);
				if { [ catch { set VarVal(2) [ expr_eval $VarVal(2) ] } ] == 1 } { set VarVal(2) 0.0; }
				if { [ catch { set VarVal(3) [ expr_eval $VarVal(3) ] } ] == 1 } { set VarVal(3) 0.0; }
				set tempstart $VarVal(2);
				set tempend $VarVal(3);
				} "Nth term =" "Starting n" "Terminating n";
			if { $tempret != -0.6714 } {
				set ret [ gen_list $tempexpr $tempstart $tempend "sumlist" ];
				set EntryVal $TEMP;
				trace variable EntryVal r read_entry;
				trace variable EntryVal w write_entry;
				unset tempexpr tempstart tempend TEMP; }; unset tempret; };
		set EntryVal $ret;
		set i [ string length $EntryDisp ];
		.calc.oper.r1.entryval icursor $i;
		update idletasks;
		unset sigx sig meanx sigx2 ret ;
	}
	unset marr Win_name temp temp2 temp3;
 }; }; };
button .calc.stat.corr   -background "#80d7ff" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "Correlation" -width 12 -height 1 -relief raised -command {
	if { $NumList != 0 } {
	set Win_name ".calc.sellst";
	set temp -0.6714;
	set temp2 -0.6714;
	set List1 0;
	set List2 0;
	select_list "Select List" "Double click to select \n first list" "stat" ListName 0 [ expr $NumList -1 ] 20 10;
	if { $temp != -0.6714 } {
		set temp2 [ string range $temp2 0 [ expr [ string first " " $temp2 ] -1 ] ];
		set i 0;
		while {	($i < $NumList) && ($ListName($i,0) != $temp2) } { incr i };
		if { $i != $NumList } { set List1 $i };
		set Win_name ".calc.sellst";
		set temp -0.6714;
		set temp2 -0.6714;
		select_list "Select List" "Double click to select \n second list" "stat" ListName 0 [ expr $NumList -1 ] 20 10;
		if { $temp != -0.6714 } {
			set temp2 [ string range $temp2 0 [ expr [ string first " " $temp2 ] -1 ] ];
			set i 0;
			while { ($i < $NumList) && ($ListName($i,0) != $temp2) } { incr i };
			if { $i != $NumList } { set List2 $i };
			set nelem 0;
			if { $ListName($List1,1) < $ListName($List2,1) } {
				set nelem $ListName($List1,1); } else {
				set nelem $ListName($List2,1); };
			set sx1 0;
			set sx2 0;
			set sx21 0;
			set sx22 0;
			set sxy 0;
			for { set i 2 } { $i < $nelem } { incr i } {
				set sx1 [ expr $sx1 + $ListName($List1,$i) ];
				set sx2 [ expr $sx2 + $ListName($List2,$i) ];
				set sx21 [ expr $sx21 + $ListName($List1,$i)*$ListName($List1,$i) ];
				set sx22 [ expr $sx22 + $ListName($List2,$i)*$ListName($List2,$i) ];
				set sxy [ expr $sxy + $ListName($List1,$i)*$ListName($List2,$i) ]; };
			set Corr [ expr ( $sx1*$sx2 - $sxy )/sqrt($sx1*$sx1 - $sx21/[ expr $nelem -2 ])/sqrt($sx2*$sx2 - $sx22/[ expr $nelem -2 ]) ];
			set EntryVal $Corr;
			set i [ string length $EntryDisp ];
			.calc.oper.r1.entryval icursor $i;
			update idletasks;
			unset nelem sx1 sx2 sx21 sx22 sxy Corr;
		};
		};
	unset temp temp2 Win_name List1 List2; }; };
pack .calc.stat.nlst .calc.stat.slst .calc.stat.ielem .calc.stat.relem .calc.stat.delem .calc.stat.genlst .calc.stat.srtlst .calc.stat.vlst .calc.stat.oper .calc.stat.corr -side top -ipadx 2 -ipady 1 -pady 1;

# udfs
label .calc.list.top.udf.label -foreground "#000000" -text "User Def. Funcs." -relief  groove -width 15;
listbox .calc.list.top.udf.func -background "#ffffcc" -foreground "#336697" -height 13 -relief raised -bd 2 -width 15 -yscrollcommand ".calc.list.top.udf.scroll set";
pack .calc.list.top.udf.label -side top -ipadx 2 -ipady 2 -padx 1 -fill x -pady 4;
pack .calc.list.top.udf.func -side left -ipadx 2 -ipady 2;
scrollbar .calc.list.top.udf.scroll  -background "#ffffff" -command ".calc.list.top.udf.func yview";
pack .calc.list.top.udf.scroll -side right -fill y -ipadx 2 -ipady 2;
for { set i 0 } { $i < $NumUdf } { incr i } { .calc.list.top.udf.func insert end $Udf($i); };
bind .calc.list.top.udf.func <Double-Button-1> {
	if { $NumUdf > 0 } {
	set temp1 [ .calc.list.top.udf.func get active ];
	for { set i 0 } { $i < $NumUdf } { incr i } { if { $Udf($i) == $temp1 } { break; } };
	set udfi $i;
	set temp2 {};
	for { set j 0 } { $j < $Udfdet($udfi,0) } { incr j } { lappend temp2 "$Udfdet($udfi,[ expr $j +2 ])"; }
	set tempret 0;
	mult_arg .calc.udfcall "UDF Function $temp1" "Enter values of parametres" "Param" $Udfdet($udfi,0) {
		global udfi;
		set temp {};
		lappend temp $VarVal(1);
		for { set u 1 } { $u < $Udfdet($udfi,0) } { incr u } { lappend temp $VarVal([ expr $u +1 ]);}
		set temp [ join [ split $temp " " ] "," ];
		set temp3 [ list $temp1 "(" $temp ")" ];
		regsub -all {\ *} $temp3 {} temp;
		set temp [ expr_eval "$temp" ];
		set EntryVal $temp;
		set o [ string length $EntryDisp ];
		.calc.oper.r1.entryval icursor $o;
		update idletasks;
	 } [ lindex $temp2 0 ] [ lindex $temp2 1 ] [ lindex $temp2 2 ] [ lindex $temp2 3 ] [lindex $temp2 4 ] [ lindex $temp2 5 ] [ lindex $temp2 6 ] [lindex $temp2 7 ] [ lindex $temp2 8 ] [ lindex $temp2 9 ] [ lindex $temp2 10 ] [ lindex $temp2 11 ] [ lindex $temp2 12 ] [ lindex $temp2 13 ] [lindex $temp2 14 ] [ lindex $temp2 15 ] [ lindex $temp2 16 ] [ lindex $temp2 17 ] [ lindex $temp2 18 ] [ lindex $temp2 19 ];
	 unset tempret;
	 unset j temp1 temp2 udfi; }; };

# answer history
label .calc.list.top.hist.label -foreground "#000000" -text "Answer History" -relief groove -width 15;
listbox .calc.list.top.hist.val  -background "#ffffcc" -foreground "#336697" -height 13 -relief raised -bd 2 -width 15 -yscrollcommand ".calc.list.top.hist.scroll set";
pack .calc.list.top.hist.label -side top -ipadx 2 -ipady 2 -padx 1 -fill x -pady 4;
pack .calc.list.top.hist.val -side left -ipadx 2 -ipady 2;
scrollbar .calc.list.top.hist.scroll  -background "#ffffff" -command ".calc.list.top.hist.val yview";
pack .calc.list.top.hist.scroll -side right -fill y -ipadx 2 -ipady 2;
for { set i [ expr $NumHist - 1 ] } { $i >= 0 } { incr i -1 } { .calc.list.top.hist.val insert end $AnsHist($i);};
bind .calc.list.top.hist.val <Double-Button-1> {
	set EntryVal [ .calc.list.top.hist.val get active ];
	set $i [ string length $EntryDisp ];
	.calc.oper.r1.entryval icursor $i;
	update idletasks; };

# variables(register)
checkbutton .calc.list.var.left.switch   -background "#00bcd6" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text Store -relief raised -width 6 -height 3 -variable StoreVar;
button .calc.list.var.right.c1.vara   -background "#ffff5a" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "A" -relief raised -command "main_var 0" -width 5;
button .calc.list.var.right.c1.varb   -background "#ffff5a" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "B" -relief raised -command "main_var 1" -width 5;
button .calc.list.var.right.c1.varc   -background "#ffff5a" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "C" -relief raised -command "main_var 2" -width 5;
button .calc.list.var.right.c2.vard   -background "#ffff5a" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "D" -relief raised -command "main_var 3" -width 5;
button .calc.list.var.right.c2.vare   -background "#ffff5a" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "E" -relief raised -command "main_var 4" -width 5;
button .calc.list.var.right.c2.varf   -background "#ffff5a" -foreground "#336697" -activebackground "#336697" -activeforeground "#ffffff" -text "F" -relief raised -command "main_var 5" -width 5;
pack .calc.list.var.left.switch -side left -pady 12;
pack .calc.list.var.right.c1.vara .calc.list.var.right.c1.varb .calc.list.var.right.c1.varc -side left -ipadx 2 -ipady 2 -padx 3 -pady 3;
pack .calc.list.var.right.c2.vard .calc.list.var.right.c2.vare .calc.list.var.right.c2.varf -side left -ipadx 2 -ipady 2 -padx 3 -pady 3;

# message box
canvas .msgbox.can -height 150 -width 640 -relief raised -background "#6e6066";
pack .msgbox.can -side left -ipadx 2 -ipady 2 -fill both -expand 1;
image create photo img1 -file {images/logo.gif} ;
.msgbox.can create image 525 75 -image img1 ;
.msgbox.can create text 105 30 -text "Offers you" -font -adobe-times-medium-r-normal------p---1 -fill "#ffffff" ;
.msgbox.can create text 105 55 -text "the Ultimate" -font -adobe-times-medium-r-normal------p---1 -fill "#ffffff" ;
.msgbox.can create text 105 80 -text "Control over" -font -adobe-times-medium-r-normal------p---1 -fill "#ffffff" ;
.msgbox.can create text 105 105 -text "Every Single" -font -adobe-times-medium-r-normal------p---1 -fill "#ffffff" ;
.msgbox.can create text 105 130 -text "Factor !" -font -adobe-times-medium-r-normal------p---1 -fill "#ffffff" ;

# start of operations
focus .calc.oper.r1.entryval;

trace variable EntryVal r read_entry;
trace variable EntryVal w write_entry;

