$fileTemplate = 'au3template';
$fileInH = 'H:/Progra~1/win32/Development/Languages/CPP/Mine/Include/AutoIt3.h';
#$fileInH = 'AutoIt3.h';
$fileGenCode = '../au3';
$declMacro = 'AU3_API';
$declPrefix = '_declspec(dllexport) void ';
$declPostfix = "(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),\n\t\tvoid (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,\n\t\tUINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)";
$opDivider = "\n//////////////////////////////////////////////////////////////////////////\n\n";
$templateBreak = '###end opening template segment####';
$argNameColWidth = 15;

$functionsExcluded{'RegDelete'} = 'Declared but does not link using lib file supplied';
#$functionsExcluded{'xxx'} = 'Declared but does not link using lib file supplied';

#$functionComments{'ClipGet'} =  'CRASHS POWERPRO.ON MY SYSTEM';
$functionComments{'xxx'} =  'CRASHS POWERPRO.ON MY SYSTEM';
    
$AU3_INTDEFAULT = 'AU3_INTDEFAULT (-2147483647)	';

open(OUTh, ">$fileGenCode.h");         
open(IN_TEMPLATEh, "$fileTemplate.h") || die "can't open $fileTemplate.h";         
while (<IN_TEMPLATEh>) {
	last if /$templateBreak/;
	print OUTh;
}

open(OUTcpp, ">$fileGenCode.cpp");
open(IN_TEMPLATEcpp, "$fileTemplate.cpp") || die "can't open $fileTemplate.cpp";         
while (<IN_TEMPLATEcpp>) {
	print OUTcpp;
}
close(IN_TEMPLATEcpp);

$fileDoc = $fileGenCode . 'Plugin.txt';
open(OUTdoc, ">$fileDoc");         
open(IN_TEMPLATEdoc, "$fileTemplate.txt") || die "can't open $fileTemplate.txt";         
while (<IN_TEMPLATEdoc>) {
#	last if /$templateBreak/;
	print OUTdoc;
}
 
close(IN_TEMPLATEdoc);
 
$bProcessDeclarations = 1;
open(INh, "$fileInH") || die "can't open $fileInH";         

while (<INh>) 
{  
 if (!$bProcessDeclarations) 
 {
   $bProcessDeclarations=1 if (/#endif/);
   next;
 } 
 if (/#else/) 
 {
 	$bProcessDeclarations=0;
 	next;
 }	
 next if (!(/$declMacro/ && /WINAPI/));
# got a declaration
 $declaration = $_;
# $declaration =~ s#/\*[^\*]*\*/##g;  #    kill stuff like /*[in,defaultvalue("")]*/
 $declaration =~ s#/\*\[in,##g;          #    kill stuff like /*[in,
 $declaration =~ s#\]\*/##g;  #    kill stuff like /*[in,defaultvalue("")]*/
 $declaration =~  /.*$declMacro (\w+)\s+WINAPI AU3_(\w+)\(/;

 $funcName = $2;
 next if ($functionsExcluded{$funcName});  

 $retType = $1;
 $funcNameLower = $2;
 $funcNameLower =~ tr/[A-Z]/[a-z]/;
 $auCall = "\t";
 $bIsReturnVal = 0;
 $comment  = $functionComments{$funcName};


 if ($retType =~ /long/)
 {
   $auCall = "\tLONG lRes = ";	
   $bIsReturnVal = 1;
 }
 $auCall .= "AU3_$funcName(";
 $auParamsDecl = '';
 $auParamsDesc = '';
 $declaration =~ /\((.+)\)/;
 $argList = $1;
 $argDesc = '';
 $argSanitised = $1;
 $argsMin = 0;
 $argsMax = 0;
 
  if ($argList ne 'void')    #   check for no args
  {
    @argList = split(/,/, $argList);
    $argsMax = @argList;
    $argsMin = $argsMax;
    @argListRev = reverse(@argList);

# figure out max, min args
    foreach (@argListRev) 
    {
    	 if (/char\s+\*/ && !/const/)  {$argsMin-- ;$argsMax-- ;}   # char* buff for output
      elsif (/nBufSize/)               {$argsMin-- ;$argsMax-- ;}    # buffser size
    	 elsif (!/defaultvalue\(\S+\)/) {last;}
      else                                      {$argsMin--;}                        # default val specified

    }

  }
  
 $argsMaxLim = $argsMax;
 $argsMaxLim = 9  if ($argsMaxLim > 9); 
 $argsMinLim = $argsMin;
 $argsMinLim = 9  if ($argsMinLim > 9); 
 
 print OUTh "//\t$comment <<<\n"    if ($comment); 
 print OUTh "$declPrefix$funcNameLower$declPostfix;\n\n"; 
 print OUTcpp "$declPrefix$funcNameLower$declPostfix\n{\n";
 print OUTcpp "//\t$comment <<<\n"    if ($comment); 
 if ($argsMin == $argsMax) {print OUTcpp "\tif (nargs != $argsMaxLim) ";}
 else                                       {print OUTcpp "\tif (nargs < $argsMinLim || nargs > $argsMaxLim) ";}
 
 print OUTcpp "{setErrMsg(\"$funcName\", szArgs, SetVar, ppsv); return;}\n\n";
 print OUTdoc "\t$funcName("; 

 $resultString = "";

#process args

  if ($argList ne 'void')    #   check for no args
  {
    @argList = split(/,/, $argList);
    $ppArgNo = $argsMax;

    $bNonDefaultEncountered = 0; 
    @argListRev = reverse(@argList);
    foreach (@argListRev) 
    {
    	&processArg(); 
    }
 }
  print OUTdoc "$auParamsDesc)\n"; 
  print OUTdoc "\t  >>> $comment <<<\n"    if ($comment); 
  $argDesc =~ s/AU3_INTDEFAULT/$AU3_INTDEFAULT/g;
  print OUTdoc "$argDesc\n";
  print OUTcpp "$auCall$auParamsDecl);\n";
  if ($resultString ne '')
  {
  	print OUTcpp "\treturntoPP($resultString, szArgs, SetVar, ppsv);\n";
  	$resultString = '';
  }	

#tail end, dealing with return fro AU3  function

  if ($retType =~ /long/) 
  {
   print OUTcpp "\tltoa(lRes, PP_PLUGIN_RET, 10);\n";
   print OUTdoc "\treturns an integer\n\n\n";
  } 
  else
  {
   print OUTdoc "\treturns nothing\n\n\n";
  }	

  print OUTcpp "}\n"; 
  print OUTcpp $opDivider; 

} #while(<INh>) 

while (<IN_TEMPLATEh>) 
{
	print OUTh;
} 

close(IN_TEMPLATEh);

close(OUTh);
close(OUTcpp);
close(INh);

print OUTdoc <<EOFX;
Service Omitted:

   The following services were not created even thogh they are declared in the header
   file from which code was generated:
   
EOFX

foreach $functionExcluded  (sort keys(%functionsExcluded))
 {print OUTdoc "\t$functionExcluded: $functionsExcluded{$functionExcluded}\n";}

close(OUTdoc);

#========================================================

sub processArg 
{
  $bArgAdded = 0;
  $anArg = $_;
  $argType = '';
  $argDescDefault = '';
  
  $defaultVal ='';
  if (/char\s+\*/ && !/const/)       {}   # char* buff for output
  elsif (/nBufSize/)                      {}    # buffser size
  elsif (s/defaultvalue\((\S+)\)//) {$defaultVal = $1 if !$bNonDefaultEncountered;}  # default val specified
  else                                           {$bNonDefaultEncountered = 1; }	                      

  $argDescDefault = ' optional: if omitted assumed to be ' . $defaultVal  if (length($defaultVal));
  $bIsConst = /const/;
  $auParamsDecl = ", $auParamsDecl"  if (length($auParamsDecl) > 0);
  $auParamsDesc = ", $auParamsDesc"  if (length($auParamsDesc) > 0);

  if ($anArg =~ /long\s*(\w+)/) 
  {
    $argType = 'integer';
    $argName = $1;
    $bArgAdded = 1;       
    if ($ppArgNo <= 9)
    {
   	 if (length($defaultVal))
  	 {
  	   print OUTcpp "\tLONG $1 = (nargs >= $ppArgNo) ? atol(PP_PLUGIN_ARG$ppArgNo) : $defaultVal;\n";
  	   $auParamsDecl = "$argName$auParamsDecl";
  	 }
  	 else
  	 {
  	    $auParamsDecl =  "atol(PP_PLUGIN_ARG$ppArgNo)$auParamsDecl";
  	 }
     $auParamsDesc = "$1$auParamsDesc";
    }  # if ($ppArgNo <= 9)
  }
  elsif ($anArg =~ /int\s+nBufSize/) 
  {
    $argType = 'integer';
    $bArgAdded = 0;
    $auParamsDecl =  "BUF_SIZE";
  }
  elsif ($anArg =~ /int\s*(\w+)/) 
  {
    $argType = 'integer';
    $argName = $1;
    $bArgAdded = 1;
    if ($ppArgNo <= 9)
    {
   	 if (length($defaultVal))
  	 {
  	   print OUTcpp "\tINT $1 = (nargs >= $ppArgNo) ? atoi(PP_PLUGIN_ARG$ppArgNo) : $defaultVal;\n";
  	   $auParamsDecl = "$argName$auParamsDecl";
  	 }
   	 else
  	 {
  	   $auParamsDecl =  "atoi(PP_PLUGIN_ARG$ppArgNo)$auParamsDecl";
  	 }
     $auParamsDesc = "$argName$auParamsDesc";
    }  # if ($ppArgNo <= 9)
  }
  elsif ($anArg =~ /char\s+\*\s*(\w+)/)
  {
    $argType = 'string';
    $argName = $1;
  	if (length($defaultVal))
   	{
      $bArgAdded = 1;
      if ($ppArgNo <= 9)
      {
  	   print OUTcpp "\tLPCSTR $1 = (nargs >= $ppArgNo) ? PP_PLUGIN_ARG$ppArgNo : $defaultVal;\n";
 	   $auParamsDecl = "$argName$auParamsDecl";
        $auParamsDesc = "$argName$auParamsDesc";
       } 
     }              
  	else # if (length($defaultVal))
  	{
  	 if ($bIsConst) 
  	 {
       if ($ppArgNo <= 9)
       {
  	    $auParamsDecl = "PP_PLUGIN_ARG$ppArgNo$auParamsDecl";
         $auParamsDesc = "$argName$auParamsDesc";
        } 
        $bArgAdded = 1;
  	  } 
  	  else
  	  {
        if ($resultString ne '')
  	    {
          print OUTcpp "//\tWARNING: SECOND NON-CONST STRING, DON'T KNOW WHAT TO RETURN: $anArg !!! ";
          print "warning: second non-const string, don't know what to return: $anArg for function $funcName";
  	    }	

  	    if ($bIsReturnVal)
  	    {
          print OUTcpp "//\tWARNING: NON-CONST STRING, _AND_ LONG RETURN TYPE DON'T KNOW WHAT TO RETURN: $anArg !!! ";
          print "warning: non-const string, _and_ long return type don't know what to return: $anArg for function $funcName";
  	    }	
  	    print OUTcpp "\tCHAR $1\[BUF_SIZE+1];\n";
 	    $auParamsDecl = "$argName$auParamsDecl";
 	    $resultString = $1;
  	   } # else if ($bIsConst) 

  	  } # else if (length($defaultVal))

    } # elsif ($anArg =~ /char\s+\*\s*(\w+)/) 
  else
  {
  	print "funny argument: $anArg for function $funcName\n";
     print OUTcpp "//\tWARNING: FUNNY ARGUMENT: $anArg !!! ";
  }

  if ($bArgAdded)
  {
    if ($ppArgNo <= 9)
    {
    	 $pad = ' ' x ( $argNameColWidth - length($argName));
     $argDescDefault =~ s/\"\"/null string/;
     $argDesc = "\t\t$argName$pad  ($argType)$argDescDefault\n$argDesc";
     $bArgAdded = 0;
    }
    $ppArgNo--;
  }

}	