$fileTemplate = 'au3template';
$fileInH = 'H:/Progra~1/win32/Development/Languages/CPP/Mine/Include/AutoIt3.h';
$fileGenCode = '../au3';
$declMacro = 'AU3_API';
$declPrefix = '_declspec(dllexport) void ';
$declPostfix = "(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),\n\t\tvoid (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,\n\t\tUINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)";
$opDivider = "\n//////////////////////////////////////////////////////////////////////////\n\n";
$templateBreak = '###end opening template segment####';
$argNameColWidth = 15;

$functionsExcluded{'RegDelete'} = 'Declared but does not link using lib file supplied';

$functionComments{'ClipGet'} =  'CRASHS POWERPRO.ON MY SYSTEM';
    
$AU3_INTDEFAULT = 'AU3_INTDEFAULT (-2147483647)	';

open(OUTh, ">$fileGenCode.h");         
open(IN_TEMPLATEh, "$fileTemplate.h") || die "can't open $fileTemplate.h";         
while (<IN_TEMPLATEh>) {
	last if /$templateBreak/;
	print OUTh;
}

open(OUTcpp, ">$fileGenCode.cpp");
open(IN_TEMPLATEcpp, "$fileTemplate.cpp") || die "can't open $fileTemplate.cpp";         
while (<IN_TEMPLATEcpp>) {
	print OUTcpp;
}
close(IN_TEMPLATEcpp);

$fileDoc = $fileGenCode . 'Plugin.txt';
open(OUTdoc, ">$fileDoc");         
open(IN_TEMPLATEdoc, "$fileTemplate.txt") || die "can't open $fileTemplate.txt";         
while (<IN_TEMPLATEdoc>) {
#	last if /$templateBreak/;
	print OUTdoc;
}
 
close(IN_TEMPLATEdoc);
 
$bProcessDeclarations = 1;
open(INh, "$fileInH") || die "can't open $fileInH";         

while (<INh>) 
{  
 if (!$bProcessDeclarations) 
 {
   $bProcessDeclarations=1 if (/#endif/);
   next;
 } 
 if (/#else/) 
 {
 	$bProcessDeclarations=0;
 	next;
 }	
 next if (!(/$declMacro/ && /WINAPI/));
# got a declaration
 $declaration = $_;
 $declaration =~ s#/\*[^\*]*\*/##g;  #    kill stuff like /*[in,defaultvalue("")]*/
 $declaration =~  /.*$declMacro (\w+)\s+WINAPI AU3_(\w+)\(/;

 $funcName = $2;
 next if ($functionsExcluded{$funcName});  

 $retType = $1;
 $funcNameLower = $2;
 $funcNameLower =~ tr/[A-Z]/[a-z]/;
 $auCall = "\t";
 $bIsReturnVal = 0;
 $comment  = $functionComments{$funcName};


 if ($retType =~ /long/)
 {
   $auCall = "\tLONG lRes = ";	
   $bIsReturnVal = 1;
 }
 $auCall .= "AU3_$funcName(";
 $declaration =~ /\((.+)\)/;
 $argList = $1;
 $argDesc = '';
 $argSanitised = $1;
 $argsMin = 0;
 $argsMax = 0;
 
  if ($argList ne 'void')    #   check for no args
  {
    @argList = split(/,/, $argList);
    $argsMax = @argList;
    $argsMax = 9  if ($argsMax > 9); 
    $argsMin = $argsMax;
    foreach (@argList)  
    {
    	  $argsMin-- if /=/;
    	  if ((!/long/) && (!/const/)) {$argsMin-- ;$argsMax-- ;}
    	}
  }
 print OUTh "//\t$comment <<<\n"    if ($comment); 
 print OUTh "$declPrefix$funcNameLower$declPostfix;\n\n"; 
 print OUTcpp "$declPrefix$funcNameLower$declPostfix\n{\n";
 print OUTcpp "//\t$comment <<<\n"    if ($comment); 
 if ($argsMin == $argsMax) {print OUTcpp "\tif (nargs != $argsMax) ";}
 else                                       {print OUTcpp "\tif (nargs < $argsMin || nargs > $argsMax) ";}
 
 print OUTcpp "{setErrMsg(\"$funcName\", szArgs, SetVar, ppsv); return;}\n\n";
 print OUTdoc "\t$funcName("; 

 $resultString = "";
#process args
  if ($argList ne 'void')    #   check for no args
  {
    @argList = split(/,/, $argList);
    $ppArgNo = 1;
    $bIsAlreadyHasArg = 0;
    foreach (@argList) 
    {
    	&processArg(); 
    	 if ($ppArgNo > 9) 
      {
       print "too many args: function $funcName\n";                
       print OUTcpp "//\tWARNING: TOO MANY ARGS!!!\n";
       $argDesc .= "\t\tTHE WRAPPED AU3 FUNCTION REQUIRES MORE THAN NINE ARGUMENTS\n";
       last;
      }
    }
 }
  print OUTdoc ")\n"; 
  print OUTdoc "\t  >>> $comment <<<\n"    if ($comment); 
  $argDesc =~ s/AU3_INTDEFAULT/$AU3_INTDEFAULT/g;
  print OUTdoc "$argDesc\n";
  print OUTcpp "$auCall);\n";
  if ($resultString ne '')
  {
  	print OUTcpp "\treturntoPP($resultString, szArgs, SetVar, ppsv);\n";
  	$resultString = '';
  }	
 
  print OUTcpp "\tltoa(lRes, PP_PLUGIN_RET, 10);\n"  if ($retType =~ /long/);
  print OUTcpp "}\n"; 
  print OUTcpp $opDivider; 

} #while(<INh>) 

while (<IN_TEMPLATEh>) 
{
	print OUTh;
} 

close(IN_TEMPLATEh);

close(OUTh);
close(OUTcpp);
close(INh);

print OUTdoc <<EOFX;
Service Omitted:

   The following services were not created even thogh they are declared in the header
   file from which code was generated:
   
EOFX

foreach $functionExcluded  (sort keys(%functionsExcluded))
 {print OUTdoc "\t$functionExcluded: $functionsExcluded{$functionExcluded}\n";}

close(OUTdoc);



#========================================================

sub processArg 
{
  $bArgAdded = 0;
  $anArg = $_;
  $argType = '';
  $argDescDefault = '';
  
  if (s/=\s*(\"\")//) {$defaultVal = '""'}
  elsif (s/=\s*(-?\d)//) {$defaultVal = $1;}
  elsif (s/=\s*(\"\w+\")//) {$defaultVal = $1;}
  elsif (s/=\s*(AU3_INTDEFAULT)//) {$defaultVal = $1;}
  else {$defaultVal ='';}	
  $argDescDefault = ' optional: if omitted assumed to be ' . $defaultVal  if (length($defaultVal));
  $bIsConst = /const/;
  $auCall .= ", "  if ($bIsAlreadyHasArg);
  if ($anArg =~ /long\s*(\w+)/) 
  {
    $argType = 'integer';
    $bArgAdded = 1;
  	if (length($defaultVal))
  	{
  	  print OUTcpp "\tLONG $1 = (nargs >= $ppArgNo) ? atol(PP_PLUGIN_ARG$ppArgNo) : $defaultVal;\n";
  	  $auCall .= $1;
  	}
  	else
  	{
  	   $auCall .=  "atol(PP_PLUGIN_ARG$ppArgNo)";
  	}
  }
  elsif ($anArg =~ /char\s+\*\s*(\w+)/)
  {
    $argType = 'string ';
  	if (length($defaultVal))
  	{
  	  print OUTcpp "\tLPCSTR $1 = (nargs >= $ppArgNo) ? PP_PLUGIN_ARG$ppArgNo : $defaultVal;\n";
 	  $auCall .= $1;
       $bArgAdded = 1;
      }              
  	else
  	{
  	 if ($bIsConst) 
  	 {
  	   $auCall .= "PP_PLUGIN_ARG$ppArgNo";
       $bArgAdded = 1;
  	 } 
  	 else
  	 {

  	  if ($resultString ne '')
  	  {
        print OUTcpp "//\tWARNING: SECOND NON-CONST STRING, DON'T KNOW WHAT TO RETURN: $anArg !!! ";
        print "warning: second non-const string, don't know what to return: $anArg for function $funcName";
  	  }	

  	  if ($bIsReturnVal)
  	  {
        print OUTcpp "//\tWARNING: NON-CONST STRING, _AND_ LONG RETURN TYPE DON'T KNOW WHAT TO RETURN: $anArg !!! ";
        print "warning: non-const string, _and_ long return type don't know what to return: $anArg for function $funcName";
  	  }	
  	  print OUTcpp "\tCHAR $1\[BUF_SIZE];\n";
 	  $auCall .= $1;                   
 	  $resultString = $1;
  	 }

  	}
  } 
  else
  {
  	print "funny argument: $anArg for function $funcName\n";
     print OUTcpp "//\tWARNING: FUNNY ARGUMENT: $anArg !!! ";
  }

  if ($bArgAdded)
  {
    $ppArgNo++;
    print OUTdoc ', '  if ($bIsAlreadyHasArg);
    print OUTdoc $1;     
    $pad = ' ' x ( $argNameColWidth - length($1));
    $argDescDefault =~ s/\"\"/null string/;
    $argDesc .= "\t\t$1$pad  ($argType)$argDescDefault\n";
    $bArgAdded = 0;
  }
  $bIsAlreadyHasArg = 1;
}	