

//*************************************************************************************
//Don't want the windows sockets stuff so I can use send and shutdown
//Copy of windows.h without socket

#define WIN32_LEAN_AND_MEAN
#pragma comment(linker, "/opt:NOWIN98")

#include "au3.h"
#include <stdlib.h>
#include <AutoIt3.h>

static HWND g_hwndPowerPro;
static HMODULE g_hAutoItX3;

LPCSTR G_PSZ_VERSION_NUMBER = "0060";

BOOL g_bUseErrorDialog = true;

/*
HMODULE loadLib(LPSTR pszLibName)
{
 HMODULE h= GetModuleHandle(pszLibName);
 if (!h)
 {
  HINSTANCE hi = LoadLibrary(pszLibName); 
  if (hi)
   h= GetModuleHandle(pszLibName);
 }
 return h;
}

*/

// Main DLL entry point.  Save handle to main PowerPro window.
BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD dwReason, LPVOID lpvReserved)
{

    if(dwReason == DLL_PROCESS_ATTACH)
    {
	 g_hwndPowerPro = FindWindow("PowerProMain",NULL);

     AU3_Init();
//     g_hAutoItX3 =loadLib("AutoItX3");
     g_hAutoItX3  = GetModuleHandle("AutoItX3");
     
    }
	else if(dwReason == DLL_PROCESS_DETACH)
    {
//		FreeLibrary(g_han);
    }

    return TRUE;
}

//////////////////////////////////////////////////////////////////////////

#define BUF_SIZE 16000
// "Default" value for _some_ int parameters (largest negative number)
#define AU3_INTDEFAULT			(-2147483647)	

//////////////////////////////////////////////////////////////////////////

void returntoPP(LPCTSTR pszStringIn, LPSTR* szArg,
                void (*SetVar)(LPSTR szVar, LPSTR szVal),
                PPROSERVICES* ppsv)
{
 int iLen = (strlen(pszStringIn));
 if (iLen < PP_VAR_SIZE)
   strcpy(*szArg, pszStringIn);
 else
 {
  LPSTR lpTemp = (ppsv->AllocTemp)(iLen + 1);
  strcpy(lpTemp, pszStringIn);
  (ppsv->ReturnString)(lpTemp, szArg);
 }
}

//////////////////////////////////////////////////////////////////////////

void setErrMsg(LPCTSTR lpFuncName, LPSTR* szArg,
				           void (*SetVar)(LPSTR szVar, LPSTR szVal),
                             PPROSERVICES* ppsv)
{
 LPTSTR pszErrType = "wrong number of arguments";
 if (g_bUseErrorDialog)  
 {
  CHAR pszMsgBuff[100];
   strcpy(pszMsgBuff, "ERROR: au3.");
   strcat(pszMsgBuff, lpFuncName);
   strcat(pszMsgBuff, ":");
   ppsv->ErrMessage(*szArg, pszErrType); // const_cast<LPTSTR>((LPCTSTR) csMsg1, const_cast<LPTSTR>((LPCTSTR) csMsg2)
 }
 strcpy(*szArg, "ERROR: ");
 strcat(*szArg, pszErrType);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(error_dialog_on)
{
	if (nargs > 0)  {setErrMsg("error_dialog_on", szArgs, SetVar, ppsv); return;}
	g_bUseErrorDialog = true;
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(error_dialog_off)
{
	if (nargs > 0)  {setErrMsg("error_dialog_off", szArgs, SetVar, ppsv); return;}
	g_bUseErrorDialog = false;
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(version)
{
// LPCSTR lpFuncName = STRINGIFY(JOIN(PLUGIN_NAME,.version));
 strcpy(PP_PLUGIN_RET, G_PSZ_VERSION_NUMBER);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(init)
{
	if (nargs != 0) {setErrMsg("Init", szArgs, SetVar, ppsv); return;}

	AU3_Init();
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(autoitsetoption)
{
	if (nargs != 2) {setErrMsg("AutoItSetOption", szArgs, SetVar, ppsv); return;}
     LPSTR pszEnd;
	LONG lRes = AU3_AutoItSetOption(PP_PLUGIN_ARG1, strtoul(PP_PLUGIN_ARG2, &pszEnd, 10));
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(blockinput)
{
	if (nargs != 1) {setErrMsg("BlockInput", szArgs, SetVar, ppsv); return;}
     LPSTR pszEnd;

	AU3_BlockInput(strtoul(PP_PLUGIN_ARG1, &pszEnd, 10));
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(cdtray)
{
	if (nargs != 2) {setErrMsg("CDTray", szArgs, SetVar, ppsv); return;}

	AU3_CDTray(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(clipget)
{
	if (nargs != 0) {setErrMsg("ClipGet", szArgs, SetVar, ppsv); return;}

	CHAR szClip[BUF_SIZE+1];
	AU3_ClipGet(szClip, BUF_SIZE);
	returntoPP(szClip, szArgs, SetVar, ppsv);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(clipput)
{
	if (nargs != 1) {setErrMsg("ClipPut", szArgs, SetVar, ppsv); return;}

	AU3_ClipPut(PP_PLUGIN_ARG1);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(controlclick)
{
	if (nargs < 4 || nargs > 7) {setErrMsg("ControlClick", szArgs, SetVar, ppsv); return;}

    LPSTR pszEnd;

    long nNumClicks = nargs > 4 ? strtoul(PP_PLUGIN_ARG5, &pszEnd, 10) : 1;  
    long nX = nargs > 5 ? strtoul(PP_PLUGIN_ARG6, &pszEnd, 10) : AU3_INTDEFAULT; 
    long nY = nargs > 6 ? strtoul(PP_PLUGIN_ARG7, &pszEnd, 10) : AU3_INTDEFAULT; 
//  AU3_ControlClick(            *szTitle,       *szText, const  *szControl,     *szButton,     
	LONG lRes = AU3_ControlClick(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, PP_PLUGIN_ARG3, PP_PLUGIN_ARG4, 
                                 nNumClicks, nX, nY);
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(controlcommand)
{
	if (nargs != 5) {setErrMsg("ControlCommand", szArgs, SetVar, ppsv); return;}

	CHAR szResult[BUF_SIZE+1];
	AU3_ControlCommand(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, PP_PLUGIN_ARG3, PP_PLUGIN_ARG4, PP_PLUGIN_ARG5, szResult, BUF_SIZE);
	returntoPP(szResult, szArgs, SetVar, ppsv);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(controllistview)
{
	if (nargs != 6) {setErrMsg("ControlListView", szArgs, SetVar, ppsv); return;}

	CHAR szResult[BUF_SIZE+1];
	AU3_ControlListView(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, PP_PLUGIN_ARG3, PP_PLUGIN_ARG4, PP_PLUGIN_ARG5, PP_PLUGIN_ARG6, szResult, BUF_SIZE);
	returntoPP(szResult, szArgs, SetVar, ppsv);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(controldisable)
{
	if (nargs != 3) {setErrMsg("ControlDisable", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_ControlDisable(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, PP_PLUGIN_ARG3);
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(controlenable)
{
	if (nargs != 3) {setErrMsg("ControlEnable", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_ControlEnable(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, PP_PLUGIN_ARG3);
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(controlfocus)
{
	if (nargs != 3) {setErrMsg("ControlFocus", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_ControlFocus(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, PP_PLUGIN_ARG3);
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(controlgetfocus)
{
	if (nargs != 2) {setErrMsg("ControlGetFocus", szArgs, SetVar, ppsv); return;}

	CHAR szControlWithFocus[BUF_SIZE+1];
	AU3_ControlGetFocus(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, szControlWithFocus, BUF_SIZE);
	returntoPP(szControlWithFocus, szArgs, SetVar, ppsv);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(controlgethandle)
{
	if (nargs != 3) {setErrMsg("ControlGetHandle", szArgs, SetVar, ppsv); return;}

	CHAR szRetText[BUF_SIZE+1];
	AU3_ControlGetHandle(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, PP_PLUGIN_ARG3, szRetText, BUF_SIZE);
	returntoPP(szRetText, szArgs, SetVar, ppsv);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(controlgetposx)
{
	if (nargs != 3) {setErrMsg("ControlGetPosX", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_ControlGetPosX(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, PP_PLUGIN_ARG3);
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(controlgetposy)
{
	if (nargs != 3) {setErrMsg("ControlGetPosY", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_ControlGetPosY(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, PP_PLUGIN_ARG3);
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(controlgetposheight)
{
	if (nargs != 3) {setErrMsg("ControlGetPosHeight", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_ControlGetPosHeight(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, PP_PLUGIN_ARG3);
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(controlgetposwidth)
{
	if (nargs != 3) {setErrMsg("ControlGetPosWidth", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_ControlGetPosWidth(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, PP_PLUGIN_ARG3);
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(controlgettext)
{
	if (nargs != 3) {setErrMsg("ControlGetText", szArgs, SetVar, ppsv); return;}

	CHAR szControlText[BUF_SIZE+1];
	AU3_ControlGetText(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, PP_PLUGIN_ARG3, szControlText, BUF_SIZE);
	returntoPP(szControlText, szArgs, SetVar, ppsv);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(controlhide)
{
	if (nargs != 3) {setErrMsg("ControlHide", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_ControlHide(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, PP_PLUGIN_ARG3);
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(controlmove)
{
	if (nargs < 5 || nargs > 7) {setErrMsg("ControlMove", szArgs, SetVar, ppsv); return;}
     LPSTR pszEnd;

	LONG nHeight = (nargs >= 7) ? strtoul(PP_PLUGIN_ARG7, &pszEnd, 10) : -1;
	LONG nWidth = (nargs >= 6) ? strtoul(PP_PLUGIN_ARG6, &pszEnd, 10) : -1;
	LONG lRes = AU3_ControlMove(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, PP_PLUGIN_ARG3, strtoul(PP_PLUGIN_ARG4, &pszEnd, 10), strtoul(PP_PLUGIN_ARG5, &pszEnd, 10), nWidth, nHeight);
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(controlsend)
{
	if (nargs < 4 || nargs > 5) {setErrMsg("ControlSend", szArgs, SetVar, ppsv); return;}
    LPSTR pszEnd;

	LONG nMode = (nargs >= 5) ? strtoul(PP_PLUGIN_ARG5, &pszEnd, 10) : 0;
	LONG lRes = AU3_ControlSend(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, PP_PLUGIN_ARG3, PP_PLUGIN_ARG4, nMode);
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(controlsettext)
{
	if (nargs != 4) {setErrMsg("ControlSetText", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_ControlSetText(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, PP_PLUGIN_ARG3, PP_PLUGIN_ARG4);
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(controlshow)
{
	if (nargs != 3) {setErrMsg("ControlShow", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_ControlShow(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, PP_PLUGIN_ARG3);
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(drivemapadd)
{
	if (nargs < 3 || nargs > 5) {setErrMsg("DriveMapAdd", szArgs, SetVar, ppsv); return;}
     LPSTR pszEnd;
	CHAR szResult[BUF_SIZE+1];
	LPCSTR szPwd = (nargs >= 5) ? PP_PLUGIN_ARG5 : "";
	LPCSTR szUser = (nargs >= 4) ? PP_PLUGIN_ARG4 : "";
	AU3_DriveMapAdd(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, strtoul(PP_PLUGIN_ARG3, &pszEnd, 10), szUser, szPwd, szResult, BUF_SIZE);
	returntoPP(szResult, szArgs, SetVar, ppsv);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(drivemapdel)
{
	if (nargs != 1) {setErrMsg("DriveMapDel", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_DriveMapDel(PP_PLUGIN_ARG1);
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(drivemapget)
{
	if (nargs != 1) {setErrMsg("DriveMapGet", szArgs, SetVar, ppsv); return;}

	CHAR szMapping[BUF_SIZE+1];
	AU3_DriveMapGet(PP_PLUGIN_ARG1, szMapping, BUF_SIZE);
	returntoPP(szMapping, szArgs, SetVar, ppsv);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(inidelete)
{
	if (nargs != 3) {setErrMsg("IniDelete", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_IniDelete(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, PP_PLUGIN_ARG3);
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(iniread)
{
	if (nargs != 4) {setErrMsg("IniRead", szArgs, SetVar, ppsv); return;}

	CHAR szValue[BUF_SIZE+1];
	AU3_IniRead(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, PP_PLUGIN_ARG3, PP_PLUGIN_ARG4, szValue, BUF_SIZE);
	returntoPP(szValue, szArgs, SetVar, ppsv);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(iniwrite)
{
	if (nargs != 4) {setErrMsg("IniWrite", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_IniWrite(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, PP_PLUGIN_ARG3, PP_PLUGIN_ARG4);
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(isadmin)
{
	if (nargs != 0) {setErrMsg("IsAdmin", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_IsAdmin();
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(mouseclick)
{
	if (nargs < 0 || nargs > 5) {setErrMsg("MouseClick", szArgs, SetVar, ppsv); return;}
     LPSTR pszEnd;
	LONG nSpeed = (nargs >= 5) ? strtoul(PP_PLUGIN_ARG5, &pszEnd, 10) : -1;
	LONG nClicks = (nargs >= 4) ? strtoul(PP_PLUGIN_ARG4, &pszEnd, 10) : 1;
	LONG nY = (nargs >= 3) ? strtoul(PP_PLUGIN_ARG3, &pszEnd, 10) : AU3_INTDEFAULT;
	LONG nX = (nargs >= 2) ? strtoul(PP_PLUGIN_ARG2, &pszEnd, 10) : AU3_INTDEFAULT;
	LPCSTR szButton = (nargs >= 1) ? PP_PLUGIN_ARG1 : "LEFT";
	LONG lRes = AU3_MouseClick(szButton, nX, nY, nClicks, nSpeed);
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(mouseclickdrag)
{
	if (nargs < 5 || nargs > 6) {setErrMsg("MouseClickDrag", szArgs, SetVar, ppsv); return;}
     LPSTR pszEnd;

	LONG nSpeed = (nargs >= 6) ? strtoul(PP_PLUGIN_ARG6, &pszEnd, 10) : -1;
	LONG lRes = AU3_MouseClickDrag(PP_PLUGIN_ARG1, strtoul(PP_PLUGIN_ARG2, &pszEnd, 10), strtoul(PP_PLUGIN_ARG3, &pszEnd, 10), strtoul(PP_PLUGIN_ARG4, &pszEnd, 10), strtoul(PP_PLUGIN_ARG5, &pszEnd, 10), nSpeed);
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(mousedown)
{
	if (nargs < 0 || nargs > 1) {setErrMsg("MouseDown", szArgs, SetVar, ppsv); return;}

	LPCSTR szButton = (nargs >= 1) ? PP_PLUGIN_ARG1 : "LEFT";
	AU3_MouseDown(szButton);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(mousegetcursor)
{
	if (nargs != 0) {setErrMsg("MouseGetCursor", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_MouseGetCursor();
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(mousegetposx)
{
	if (nargs != 0) {setErrMsg("MouseGetPosX", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_MouseGetPosX();
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(mousegetposy)
{
	if (nargs != 0) {setErrMsg("MouseGetPosY", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_MouseGetPosY();
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(mousemove)
{
	if (nargs < 2 || nargs > 3) {setErrMsg("MouseMove", szArgs, SetVar, ppsv); return;}
     LPSTR pszEnd;

	LONG nSpeed = (nargs >= 3) ? strtoul(PP_PLUGIN_ARG3, &pszEnd, 10) : -1;
	LONG lRes = AU3_MouseMove(strtoul(PP_PLUGIN_ARG1, &pszEnd, 10), strtoul(PP_PLUGIN_ARG2, &pszEnd, 10), nSpeed);
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(mouseup)
{
	if (nargs < 0 || nargs > 1) {setErrMsg("MouseUp", szArgs, SetVar, ppsv); return;}

	LPCSTR szButton = (nargs >= 1) ? PP_PLUGIN_ARG1 : "LEFT";
	AU3_MouseUp(szButton);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(mousewheel)
{
	if (nargs != 2) {setErrMsg("MouseWheel", szArgs, SetVar, ppsv); return;}
     LPSTR pszEnd;

	AU3_MouseWheel(PP_PLUGIN_ARG1, strtoul(PP_PLUGIN_ARG2, &pszEnd, 10));
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(opt)
{
	if (nargs != 2) {setErrMsg("Opt", szArgs, SetVar, ppsv); return;}
     LPSTR pszEnd;

	LONG lRes = AU3_Opt(PP_PLUGIN_ARG1, strtoul(PP_PLUGIN_ARG2, &pszEnd, 10));
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(pixelchecksum)
{
	if (nargs < 4 || nargs > 5) {setErrMsg("PixelChecksum", szArgs, SetVar, ppsv); return;}
     LPSTR pszEnd;
 
	LONG nStep = (nargs >= 5) ? strtoul(PP_PLUGIN_ARG5, &pszEnd, 10) : 1;
	LONG lRes = AU3_PixelChecksum(strtoul(PP_PLUGIN_ARG1, &pszEnd, 10), strtoul(PP_PLUGIN_ARG2, &pszEnd, 10), strtoul(PP_PLUGIN_ARG3, &pszEnd, 10), strtoul(PP_PLUGIN_ARG4, &pszEnd, 10), nStep);
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(pixelgetcolor)
{
	if (nargs != 2) {setErrMsg("PixelGetColor", szArgs, SetVar, ppsv); return;}
     LPSTR pszEnd;

	LONG lRes = AU3_PixelGetColor(strtoul(PP_PLUGIN_ARG1, &pszEnd, 10), strtoul(PP_PLUGIN_ARG2, &pszEnd, 10));
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(pixelsearch)
{
	if (nargs < 5 || nargs > 7) {setErrMsg("PixelSearch", szArgs, SetVar, ppsv); return;}

    LPSTR pszEnd;

    long nVar = nargs > 5 ? strtoul(PP_PLUGIN_ARG6, &pszEnd, 10) : 0;
    long nStep = nargs > 6 ? strtoul(PP_PLUGIN_ARG7, &pszEnd, 10) : 1; 

    POINT PointResult;
	CHAR szResult[BUF_SIZE+1];
//                  nLeft,                                nTop, 
	AU3_PixelSearch(strtoul(PP_PLUGIN_ARG1, &pszEnd, 10), strtoul(PP_PLUGIN_ARG2, &pszEnd, 10), 
//                  nRight,                               nBottom, 
                    strtoul(PP_PLUGIN_ARG3, &pszEnd, 10), strtoul(PP_PLUGIN_ARG4, &pszEnd, 10), 
//                  nCol,                    
                    strtoul(PP_PLUGIN_ARG5, &pszEnd, 10), nVar, nStep, &PointResult);
    ltoa(PointResult.x, szResult, 10);
    CHAR szVal[20];
    ltoa(PointResult.y, szVal, 10);
    strcat(szResult, " ");
    strcat(szResult, szVal);
	returntoPP(szResult, szArgs, SetVar, ppsv);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(processclose)
{
	if (nargs != 1) {setErrMsg("ProcessClose", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_ProcessClose(PP_PLUGIN_ARG1);
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(processexists)
{
	if (nargs != 1) {setErrMsg("ProcessExists", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_ProcessExists(PP_PLUGIN_ARG1);
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(processsetpriority)
{
	if (nargs != 2) {setErrMsg("ProcessSetPriority", szArgs, SetVar, ppsv); return;}
     LPSTR pszEnd;

	LONG lRes = AU3_ProcessSetPriority(PP_PLUGIN_ARG1, strtoul(PP_PLUGIN_ARG2, &pszEnd, 10));
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(processwait)
{
	if (nargs < 1 || nargs > 2) {setErrMsg("ProcessWait", szArgs, SetVar, ppsv); return;}
     LPSTR pszEnd;

	LONG nTimeout = (nargs >= 2) ? strtoul(PP_PLUGIN_ARG2, &pszEnd, 10) : 0;
	LONG lRes = AU3_ProcessWait(PP_PLUGIN_ARG1, nTimeout);
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(processwaitclose)
{
	if (nargs < 1 || nargs > 2) {setErrMsg("ProcessWaitClose", szArgs, SetVar, ppsv); return;}
     LPSTR pszEnd;

	LONG nTimeout = (nargs >= 2) ? strtoul(PP_PLUGIN_ARG2, &pszEnd, 10) : 0;
	LONG lRes = AU3_ProcessWaitClose(PP_PLUGIN_ARG1, nTimeout);
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(regenumkey)
{
	if (nargs != 2) {setErrMsg("RegEnumKey", szArgs, SetVar, ppsv); return;}
     LPSTR pszEnd;

	CHAR szResult[BUF_SIZE+1];
	AU3_RegEnumKey(PP_PLUGIN_ARG1, strtoul(PP_PLUGIN_ARG2, &pszEnd, 10), szResult, BUF_SIZE);
	returntoPP(szResult, szArgs, SetVar, ppsv);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(regenumval)
{
	if (nargs != 2) {setErrMsg("RegEnumVal", szArgs, SetVar, ppsv); return;}
     LPSTR pszEnd;

	CHAR szResult[BUF_SIZE+1];
	AU3_RegEnumVal(PP_PLUGIN_ARG1, strtoul(PP_PLUGIN_ARG2, &pszEnd, 10), szResult, BUF_SIZE);
	returntoPP(szResult, szArgs, SetVar, ppsv);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(regread)
{
	if (nargs != 2) {setErrMsg("RegRead", szArgs, SetVar, ppsv); return;}

	CHAR szRetText[BUF_SIZE+1];
	AU3_RegRead(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, szRetText, BUF_SIZE);
	returntoPP(szRetText, szArgs, SetVar, ppsv);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(regwrite)
{
	if (nargs != 4) {setErrMsg("RegWrite", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_RegWrite(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, PP_PLUGIN_ARG3, PP_PLUGIN_ARG4);
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(run)
{
	if (nargs < 1 || nargs > 3) {setErrMsg("Run", szArgs, SetVar, ppsv); return;}
     LPSTR pszEnd;

	LONG nShowFlags = (nargs >= 3) ? strtoul(PP_PLUGIN_ARG3, &pszEnd, 10) : 1;
	LPCSTR szDir = (nargs >= 2) ? PP_PLUGIN_ARG2 : "";
	LONG lRes = AU3_Run(PP_PLUGIN_ARG1, szDir, nShowFlags);
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(runasset)
{
	if (nargs != 4) {setErrMsg("RunAsSet", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_RunAsSet(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, PP_PLUGIN_ARG3, atoi(PP_PLUGIN_ARG4));
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(runwait)
{
	if (nargs < 1 || nargs > 3) {setErrMsg("RunWait", szArgs, SetVar, ppsv); return;}
     LPSTR pszEnd;

	LONG nShowFlags = (nargs >= 3) ? strtoul(PP_PLUGIN_ARG3, &pszEnd, 10) : 1;
	LPCSTR szDir = (nargs >= 2) ? PP_PLUGIN_ARG2 : "";
	LONG lRes = AU3_RunWait(PP_PLUGIN_ARG1, szDir, nShowFlags);
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(send)
{
	if (nargs < 1 || nargs > 2) {setErrMsg("Send", szArgs, SetVar, ppsv); return;}
     LPSTR pszEnd;

	LONG nMode = (nargs >= 2) ? strtoul(PP_PLUGIN_ARG2, &pszEnd, 10) : 0;
	AU3_Send(PP_PLUGIN_ARG1, nMode);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(shutdown)
{
	if (nargs != 1) {setErrMsg("Shutdown", szArgs, SetVar, ppsv); return;}
     LPSTR pszEnd;

	LONG lRes = AU3_Shutdown(strtoul(PP_PLUGIN_ARG1, &pszEnd, 10));
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(sleep)
{
	if (nargs != 1) {setErrMsg("Sleep", szArgs, SetVar, ppsv); return;}
     LPSTR pszEnd;

	AU3_Sleep(strtoul(PP_PLUGIN_ARG1, &pszEnd, 10));
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(statusbargettext)
{
	if (nargs < 1 || nargs > 3) {setErrMsg("StatusbarGetText", szArgs, SetVar, ppsv); return;}
    LPSTR pszEnd;

	CHAR szStatusText[BUF_SIZE+1];
	LONG nPart = (nargs >= 3) ? strtoul(PP_PLUGIN_ARG3, &pszEnd, 10) : 1;
	LPCSTR szText = (nargs >= 2) ? PP_PLUGIN_ARG2 : "";
	AU3_StatusbarGetText(PP_PLUGIN_ARG1, szText, nPart, szStatusText, BUF_SIZE);
	returntoPP(szStatusText, szArgs, SetVar, ppsv);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(tooltip)
{
	if (nargs < 1 || nargs > 3) {setErrMsg("ToolTip", szArgs, SetVar, ppsv); return;}
     LPSTR pszEnd;

	LONG nY = (nargs >= 3) ? strtoul(PP_PLUGIN_ARG3, &pszEnd, 10) : AU3_INTDEFAULT;
	LONG nX = (nargs >= 2) ? strtoul(PP_PLUGIN_ARG2, &pszEnd, 10) : AU3_INTDEFAULT;
	AU3_ToolTip(PP_PLUGIN_ARG1, nX, nY);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(winactivate)
{
	if (nargs < 1 || nargs > 2) {setErrMsg("WinActivate", szArgs, SetVar, ppsv); return;}

	LPCSTR szText = (nargs >= 2) ? PP_PLUGIN_ARG2 : "";
	AU3_WinActivate(PP_PLUGIN_ARG1, szText);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(winactive)
{
	if (nargs < 1 || nargs > 2) {setErrMsg("WinActive", szArgs, SetVar, ppsv); return;}

	LPCSTR szText = (nargs >= 2) ? PP_PLUGIN_ARG2 : "";
	LONG lRes = AU3_WinActive(PP_PLUGIN_ARG1, szText);
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(winclose)
{
	if (nargs < 1 || nargs > 2) {setErrMsg("WinClose", szArgs, SetVar, ppsv); return;}

	LPCSTR szText = (nargs >= 2) ? PP_PLUGIN_ARG2 : "";
	LONG lRes = AU3_WinClose(PP_PLUGIN_ARG1, szText);
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(winexists)
{
	if (nargs < 1 || nargs > 2) {setErrMsg("WinExists", szArgs, SetVar, ppsv); return;}

	LPCSTR szText = (nargs >= 2) ? PP_PLUGIN_ARG2 : "";
	LONG lRes = AU3_WinExists(PP_PLUGIN_ARG1, szText);
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(wingetcaretposx)
{
	if (nargs != 0) {setErrMsg("WinGetCaretPosX", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_WinGetCaretPosX();
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(wingetcaretposy)
{
	if (nargs != 0) {setErrMsg("WinGetCaretPosY", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_WinGetCaretPosY();
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(wingetclasslist)
{
	if (nargs < 1 || nargs > 2) {setErrMsg("WinGetClassList", szArgs, SetVar, ppsv); return;}

	CHAR szRetText[BUF_SIZE+1];
	LPCSTR szText = (nargs >= 2) ? PP_PLUGIN_ARG2 : "";
	AU3_WinGetClassList(PP_PLUGIN_ARG1, szText, szRetText, BUF_SIZE);
	returntoPP(szRetText, szArgs, SetVar, ppsv);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(wingetclientsizeheight)
{
	if (nargs < 1 || nargs > 2) {setErrMsg("WinGetClientSizeHeight", szArgs, SetVar, ppsv); return;}

	LPCSTR szText = (nargs >= 2) ? PP_PLUGIN_ARG2 : "";
	LONG lRes = AU3_WinGetClientSizeHeight(PP_PLUGIN_ARG1, szText);
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(wingetclientsizewidth)
{
	if (nargs < 1 || nargs > 2) {setErrMsg("WinGetClientSizeWidth", szArgs, SetVar, ppsv); return;}

	LPCSTR szText = (nargs >= 2) ? PP_PLUGIN_ARG2 : "";
	LONG lRes = AU3_WinGetClientSizeWidth(PP_PLUGIN_ARG1, szText);
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(wingethandle)
{
	if (nargs < 1 || nargs > 2) {setErrMsg("WinGetHandle", szArgs, SetVar, ppsv); return;}

	CHAR szRetText[BUF_SIZE+1];
	LPCSTR szText = (nargs >= 2) ? PP_PLUGIN_ARG2 : "";
	AU3_WinGetHandle(PP_PLUGIN_ARG1, szText, szRetText, BUF_SIZE);
	returntoPP(szRetText, szArgs, SetVar, ppsv);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(wingetposx)
{
	if (nargs < 1 || nargs > 2) {setErrMsg("WinGetPosX", szArgs, SetVar, ppsv); return;}

	LPCSTR szText = (nargs >= 2) ? PP_PLUGIN_ARG2 : "";
	LONG lRes = AU3_WinGetPosX(PP_PLUGIN_ARG1, szText);
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(wingetposy)
{
	if (nargs < 1 || nargs > 2) {setErrMsg("WinGetPosY", szArgs, SetVar, ppsv); return;}

	LPCSTR szText = (nargs >= 2) ? PP_PLUGIN_ARG2 : "";
	LONG lRes = AU3_WinGetPosY(PP_PLUGIN_ARG1, szText);
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(wingetposheight)
{
	if (nargs < 1 || nargs > 2) {setErrMsg("WinGetPosHeight", szArgs, SetVar, ppsv); return;}

	LPCSTR szText = (nargs >= 2) ? PP_PLUGIN_ARG2 : "";
	LONG lRes = AU3_WinGetPosHeight(PP_PLUGIN_ARG1, szText);
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(wingetposwidth)
{
	if (nargs < 1 || nargs > 2) {setErrMsg("WinGetPosWidth", szArgs, SetVar, ppsv); return;}

	LPCSTR szText = (nargs >= 2) ? PP_PLUGIN_ARG2 : "";
	LONG lRes = AU3_WinGetPosWidth(PP_PLUGIN_ARG1, szText);
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(wingetprocess)
{
	if (nargs < 1 || nargs > 2) {setErrMsg("WinGetProcess", szArgs, SetVar, ppsv); return;}

	CHAR szRetText[BUF_SIZE+1];
	LPCSTR szText = (nargs >= 2) ? PP_PLUGIN_ARG2 : "";
	AU3_WinGetProcess(PP_PLUGIN_ARG1, szText, szRetText, BUF_SIZE);
	returntoPP(szRetText, szArgs, SetVar, ppsv);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(wingetstate)
{
	if (nargs < 1 || nargs > 2) {setErrMsg("WinGetState", szArgs, SetVar, ppsv); return;}

	LPCSTR szText = (nargs >= 2) ? PP_PLUGIN_ARG2 : "";
	LONG lRes = AU3_WinGetState(PP_PLUGIN_ARG1, szText);
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(wingettext)
{
	if (nargs < 1 || nargs > 2) {setErrMsg("WinGetText", szArgs, SetVar, ppsv); return;}

	CHAR szRetText[BUF_SIZE+1];
	LPCSTR szText = (nargs >= 2) ? PP_PLUGIN_ARG2 : "";
	AU3_WinGetText(PP_PLUGIN_ARG1, szText, szRetText, BUF_SIZE);
	returntoPP(szRetText, szArgs, SetVar, ppsv);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(wingettitle)
{
	if (nargs < 1 || nargs > 2) {setErrMsg("WinGetTitle", szArgs, SetVar, ppsv); return;}

	CHAR szRetText[BUF_SIZE+1];
	LPCSTR szText = (nargs >= 2) ? PP_PLUGIN_ARG2 : "";
	AU3_WinGetTitle(PP_PLUGIN_ARG1, szText, szRetText, BUF_SIZE);
	returntoPP(szRetText, szArgs, SetVar, ppsv);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(winkill)
{
	if (nargs < 1 || nargs > 2) {setErrMsg("WinKill", szArgs, SetVar, ppsv); return;}

	LPCSTR szText = (nargs >= 2) ? PP_PLUGIN_ARG2 : "";
	LONG lRes = AU3_WinKill(PP_PLUGIN_ARG1, szText);
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(winmenuselectitem)
{
	if (nargs != 9) {setErrMsg("WinMenuSelectItem", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_WinMenuSelectItem(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, PP_PLUGIN_ARG3, PP_PLUGIN_ARG4, PP_PLUGIN_ARG5, PP_PLUGIN_ARG6, PP_PLUGIN_ARG7, PP_PLUGIN_ARG8, PP_PLUGIN_ARG9, "");
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(winminimizeall)
{
	if (nargs != 0) {setErrMsg("WinMinimizeAll", szArgs, SetVar, ppsv); return;}

	AU3_WinMinimizeAll();
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(winminimizeallundo)
{
	if (nargs != 0) {setErrMsg("WinMinimizeAllUndo", szArgs, SetVar, ppsv); return;}

	AU3_WinMinimizeAllUndo();
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(winmove)
{
	if (nargs < 4 || nargs > 6) {setErrMsg("WinMove", szArgs, SetVar, ppsv); return;}
     LPSTR pszEnd;

	LONG nHeight = (nargs >= 6) ? strtoul(PP_PLUGIN_ARG6, &pszEnd, 10) : -1;
	LONG nWidth = (nargs >= 5) ? strtoul(PP_PLUGIN_ARG5, &pszEnd, 10) : -1;
	LONG lRes = AU3_WinMove(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, strtoul(PP_PLUGIN_ARG3, &pszEnd, 10), strtoul(PP_PLUGIN_ARG4, &pszEnd, 10), nWidth, nHeight);
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(winsetontop)
{
	if (nargs != 3) {setErrMsg("WinSetOnTop", szArgs, SetVar, ppsv); return;}
     LPSTR pszEnd;

	LONG lRes = AU3_WinSetOnTop(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, strtoul(PP_PLUGIN_ARG3, &pszEnd, 10));
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(winsetstate)
{
	if (nargs != 3) {setErrMsg("WinSetState", szArgs, SetVar, ppsv); return;}
     LPSTR pszEnd;

	LONG lRes = AU3_WinSetState(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, strtoul(PP_PLUGIN_ARG3, &pszEnd, 10));
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(winsettitle)
{
	if (nargs != 3) {setErrMsg("WinSetTitle", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_WinSetTitle(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, PP_PLUGIN_ARG3);
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(winsettrans)
{
	if (nargs != 3) {setErrMsg("WinSetTrans", szArgs, SetVar, ppsv); return;}
     LPSTR pszEnd;

	LONG lRes = AU3_WinSetTrans(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, strtoul(PP_PLUGIN_ARG3, &pszEnd, 10));
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(winwait)
{
	if (nargs < 1 || nargs > 3) {setErrMsg("WinWait", szArgs, SetVar, ppsv); return;}
     LPSTR pszEnd;

	LONG nTimeout = (nargs >= 3) ? strtoul(PP_PLUGIN_ARG3, &pszEnd, 10) : 0;
	LPCSTR szText = (nargs >= 2) ? PP_PLUGIN_ARG2 : "";
	LONG lRes = AU3_WinWait(PP_PLUGIN_ARG1, szText, nTimeout);
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(winwaitactive)
{
	if (nargs < 1 || nargs > 3) {setErrMsg("WinWaitActive", szArgs, SetVar, ppsv); return;}
     LPSTR pszEnd;

	LONG nTimeout = (nargs >= 3) ? strtoul(PP_PLUGIN_ARG3, &pszEnd, 10) : 0;
	LPCSTR szText = (nargs >= 2) ? PP_PLUGIN_ARG2 : "";
	LONG lRes = AU3_WinWaitActive(PP_PLUGIN_ARG1, szText, nTimeout);
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(winwaitclose)
{
	if (nargs < 1 || nargs > 3) {setErrMsg("WinWaitClose", szArgs, SetVar, ppsv); return;}
     LPSTR pszEnd;

	LONG nTimeout = (nargs >= 3) ? strtoul(PP_PLUGIN_ARG3, &pszEnd, 10) : 0;
	LPCSTR szText = (nargs >= 2) ? PP_PLUGIN_ARG2 : "";
	LONG lRes = AU3_WinWaitClose(PP_PLUGIN_ARG1, szText, nTimeout);
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(winwaitnotactive)
{
	if (nargs < 1 || nargs > 3) {setErrMsg("WinWaitNotActive", szArgs, SetVar, ppsv); return;}
     LPSTR pszEnd;

	LONG nTimeout = (nargs >= 3) ? strtoul(PP_PLUGIN_ARG3, &pszEnd, 10) : 0;
	LPCSTR szText = (nargs >= 2) ? PP_PLUGIN_ARG2 : "";
	LONG lRes = AU3_WinWaitNotActive(PP_PLUGIN_ARG1, szText, nTimeout);
	ultoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(regdeleteval)
{
  if (nargs != 2) {setErrMsg("RegDeleteVal", szArgs, SetVar, ppsv); return;}
  LONG lRes = AU3_RegDeleteVal(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2);
  ultoa(lRes, PP_PLUGIN_RET, 10);
}		

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport)  PPSERVICE_DECLARE(regdeletekey)
{
  if (nargs != 1) {setErrMsg("RegDeleteKey", szArgs, SetVar, ppsv); return;}

  LONG lRes = AU3_RegDeleteKey(PP_PLUGIN_ARG1);
  ultoa(lRes, PP_PLUGIN_RET, 10);

}		

//////////////////////////////////////////////////////////////////////////

