

//*************************************************************************************
//Don't want the windows sockets stuff so I can use send and shutdown
//Copy of windows.h without socket

#define WIN32_LEAN_AND_MEAN
#pragma comment(linker, "/opt:NOWIN98")

#include "au3.h"
#include <stdlib.h>
#include <AutoIt3.h>

static HWND g_hwndPowerPro;
static HANDLE g_hAutoItX3;

BOOL g_bUseErrorDialog = true;

/*
HMODULE loadLib(LPSTR pszLibName)
{
 HMODULE h= GetModuleHandle(pszLibName);
 if (!h)
 {
  HINSTANCE hi = LoadLibrary(pszLibName); 
  if (hi)
   h= GetModuleHandle(pszLibName);
 }
 return h;
}
*/

// Main DLL entry point.  Save handle to main PowerPro window.
BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD dwReason, LPVOID lpvReserved)
{

    if(dwReason == DLL_PROCESS_ATTACH)
    {
	 g_hwndPowerPro = FindWindow("PowerProMain",NULL);

//   WHY???
     AU3_Init();
//     g_hAutoItX3 =loadLib("AutoItX3");
     g_hAutoItX3  = GetModuleHandle("AutoItX3");

    }
	else if(dwReason == DLL_PROCESS_DETACH)
    {
//		FreeLibrary(g_han);
    }

    return TRUE;
}

//////////////////////////////////////////////////////////////////////////

#define BUF_SIZE 16000
// "Default" value for _some_ int parameters (largest negative number)
#define AU3_INTDEFAULT			(-2147483647)	

//////////////////////////////////////////////////////////////////////////

void returntoPP(LPCTSTR pszStringIn, LPSTR* szArg,
                void (*SetVar)(LPSTR szVar, LPSTR szVal),
                PPROSERVICES* ppsv)
{
 int iLen = (strlen(pszStringIn));
 if (iLen < PP_VAR_SIZE)
   strcpy(*szArg, pszStringIn);
 else
 {
  LPSTR lpTemp = (ppsv->AllocTemp)(iLen + 1);
  strcpy(lpTemp, pszStringIn);
  (ppsv->ReturnString)(lpTemp, szArg);
 }
}

//////////////////////////////////////////////////////////////////////////

void setErrMsg(LPCTSTR lpFuncName, LPSTR* szArg,
				           void (*SetVar)(LPSTR szVar, LPSTR szVal),
                             PPROSERVICES* ppsv)
{
 LPTSTR pszErrType = "wrong number of arguments";
 if (g_bUseErrorDialog)  
 {
  CHAR pszMsgBuff[100];
   strcpy(pszMsgBuff, "ERROR: au3.");
   strcat(pszMsgBuff, lpFuncName);
   strcat(pszMsgBuff, ":");
   ppsv->ErrMessage(*szArg, pszErrType); // const_cast<LPTSTR>((LPCTSTR) csMsg1, const_cast<LPTSTR>((LPCTSTR) csMsg2)
 }
 strcpy(*szArg, "ERROR: ");
 strcat(*szArg, pszErrType);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void error_dialog_on(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs > 0)  {setErrMsg("error_dialog_on", szArgs, SetVar, ppsv); return;}
	g_bUseErrorDialog = true;
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void error_dialog_off(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs > 0)  {setErrMsg("error_dialog_off", szArgs, SetVar, ppsv); return;}
	g_bUseErrorDialog = false;
}

//////////////////////////////////////////////////////////////////////////
//not in header file!!!

_declspec(dllexport) void regdeleteval(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
  if (nargs != 2) {setErrMsg("RegDeleteVal", szArgs, SetVar, ppsv); return;}
  *PP_PLUGIN_RET = '\0';
  if (g_hAutoItX3 == NULL)
   return;

  LONG (WINAPI * pfnAU3_RegDeleteVal)(LPSTR, LPSTR);
  pfnAU3_RegDeleteVal = (LONG (WINAPI *)(LPSTR, LPSTR)) GetProcAddress(g_hAutoItX3, "AU3_RegDeleteVal");  

  if (pfnAU3_RegDeleteVal == NULL)
   return;

  LONG lRes = pfnAU3_RegDeleteVal(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2);
  ltoa(lRes, PP_PLUGIN_RET, 10);
}		

//////////////////////////////////////////////////////////////////////////
//not in header file!!!

_declspec(dllexport) void regdeletekey(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
  if (nargs != 1) {setErrMsg("RegDeleteKey", szArgs, SetVar, ppsv); return;}
  *PP_PLUGIN_RET = '\0';
  if (g_hAutoItX3 == NULL)
   return;

  LONG (WINAPI * pfnAU3_RegDeleteKey)(LPSTR);
  pfnAU3_RegDeleteKey = (LONG (WINAPI *)(LPSTR)) GetProcAddress(g_hAutoItX3, "AU3_RegDeleteKey");  

  if (pfnAU3_RegDeleteKey == NULL)
   return;

  LONG lRes = pfnAU3_RegDeleteKey(PP_PLUGIN_ARG1);
  ltoa(lRes, PP_PLUGIN_RET, 10);

}		

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////


