

//*************************************************************************************
//Don't want the windows sockets stuff so I can use send and shutdown
//Copy of windows.h without socket

#define WIN32_LEAN_AND_MEAN
#pragma comment(linker, "/opt:NOWIN98")

#include "au3.h"
#include <stdlib.h>
#include <AutoIt3.h>

static HWND g_hwndPowerPro;
static HMODULE g_hAutoItX3;

BOOL g_bUseErrorDialog = true;

/*
HMODULE loadLib(LPSTR pszLibName)
{
 HMODULE h= GetModuleHandle(pszLibName);
 if (!h)
 {
  HINSTANCE hi = LoadLibrary(pszLibName); 
  if (hi)
   h= GetModuleHandle(pszLibName);
 }
 return h;
}

*/

// Main DLL entry point.  Save handle to main PowerPro window.
BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD dwReason, LPVOID lpvReserved)
{

    if(dwReason == DLL_PROCESS_ATTACH)
    {
	 g_hwndPowerPro = FindWindow("PowerProMain",NULL);

     AU3_Init();
//     g_hAutoItX3 =loadLib("AutoItX3");
     g_hAutoItX3  = GetModuleHandle("AutoItX3");
     
    }
	else if(dwReason == DLL_PROCESS_DETACH)
    {
//		FreeLibrary(g_han);
    }

    return TRUE;
}

//////////////////////////////////////////////////////////////////////////

#define BUF_SIZE 16000
// "Default" value for _some_ int parameters (largest negative number)
#define AU3_INTDEFAULT			(-2147483647)	

//////////////////////////////////////////////////////////////////////////

void returntoPP(LPCTSTR pszStringIn, LPSTR* szArg,
                void (*SetVar)(LPSTR szVar, LPSTR szVal),
                PPROSERVICES* ppsv)
{
 int iLen = (strlen(pszStringIn));
 if (iLen < PP_VAR_SIZE)
   strcpy(*szArg, pszStringIn);
 else
 {
  LPSTR lpTemp = (ppsv->AllocTemp)(iLen + 1);
  strcpy(lpTemp, pszStringIn);
  (ppsv->ReturnString)(lpTemp, szArg);
 }
}

//////////////////////////////////////////////////////////////////////////

void setErrMsg(LPCTSTR lpFuncName, LPSTR* szArg,
				           void (*SetVar)(LPSTR szVar, LPSTR szVal),
                             PPROSERVICES* ppsv)
{
 LPTSTR pszErrType = "wrong number of arguments";
 if (g_bUseErrorDialog)  
 {
  CHAR pszMsgBuff[100];
   strcpy(pszMsgBuff, "ERROR: au3.");
   strcat(pszMsgBuff, lpFuncName);
   strcat(pszMsgBuff, ":");
   ppsv->ErrMessage(*szArg, pszErrType); // const_cast<LPTSTR>((LPCTSTR) csMsg1, const_cast<LPTSTR>((LPCTSTR) csMsg2)
 }
 strcpy(*szArg, "ERROR: ");
 strcat(*szArg, pszErrType);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void error_dialog_on(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs > 0)  {setErrMsg("error_dialog_on", szArgs, SetVar, ppsv); return;}
	g_bUseErrorDialog = true;
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void error_dialog_off(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs > 0)  {setErrMsg("error_dialog_off", szArgs, SetVar, ppsv); return;}
	g_bUseErrorDialog = false;
}

//////////////////////////////////////////////////////////////////////////


_declspec(dllexport) void init(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs != 0) {setErrMsg("Init", szArgs, SetVar, ppsv); return;}

	AU3_Init();
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void autoitsetoption(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs != 2) {setErrMsg("AutoItSetOption", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_AutoItSetOption(PP_PLUGIN_ARG1, atol(PP_PLUGIN_ARG2));
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void blockinput(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs != 1) {setErrMsg("BlockInput", szArgs, SetVar, ppsv); return;}

	AU3_BlockInput(atol(PP_PLUGIN_ARG1));
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void cdtray(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs != 2) {setErrMsg("CDTray", szArgs, SetVar, ppsv); return;}

	AU3_CDTray(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void clipget(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs != 0) {setErrMsg("ClipGet", szArgs, SetVar, ppsv); return;}

	CHAR szClip[BUF_SIZE+1];
	AU3_ClipGet(szClip, BUF_SIZE);
	returntoPP(szClip, szArgs, SetVar, ppsv);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void clipput(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs != 1) {setErrMsg("ClipPut", szArgs, SetVar, ppsv); return;}

	AU3_ClipPut(PP_PLUGIN_ARG1);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void controlclick(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs != 5) {setErrMsg("ControlClick", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_ControlClick(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, PP_PLUGIN_ARG3, PP_PLUGIN_ARG4, atol(PP_PLUGIN_ARG5));
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void controlcommand(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs != 5) {setErrMsg("ControlCommand", szArgs, SetVar, ppsv); return;}

	CHAR szResult[BUF_SIZE+1];
	AU3_ControlCommand(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, PP_PLUGIN_ARG3, PP_PLUGIN_ARG4, PP_PLUGIN_ARG5, szResult, BUF_SIZE);
	returntoPP(szResult, szArgs, SetVar, ppsv);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void controllistview(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs != 6) {setErrMsg("ControlListView", szArgs, SetVar, ppsv); return;}

	CHAR szResult[BUF_SIZE+1];
	AU3_ControlListView(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, PP_PLUGIN_ARG3, PP_PLUGIN_ARG4, PP_PLUGIN_ARG5, PP_PLUGIN_ARG6, szResult, BUF_SIZE);
	returntoPP(szResult, szArgs, SetVar, ppsv);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void controldisable(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs != 3) {setErrMsg("ControlDisable", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_ControlDisable(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, PP_PLUGIN_ARG3);
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void controlenable(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs != 3) {setErrMsg("ControlEnable", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_ControlEnable(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, PP_PLUGIN_ARG3);
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void controlfocus(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs != 3) {setErrMsg("ControlFocus", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_ControlFocus(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, PP_PLUGIN_ARG3);
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void controlgetfocus(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs != 2) {setErrMsg("ControlGetFocus", szArgs, SetVar, ppsv); return;}

	CHAR szControlWithFocus[BUF_SIZE+1];
	AU3_ControlGetFocus(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, szControlWithFocus, BUF_SIZE);
	returntoPP(szControlWithFocus, szArgs, SetVar, ppsv);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void controlgethandle(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs != 3) {setErrMsg("ControlGetHandle", szArgs, SetVar, ppsv); return;}

	CHAR szRetText[BUF_SIZE+1];
	AU3_ControlGetHandle(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, PP_PLUGIN_ARG3, szRetText, BUF_SIZE);
	returntoPP(szRetText, szArgs, SetVar, ppsv);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void controlgetposx(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs != 3) {setErrMsg("ControlGetPosX", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_ControlGetPosX(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, PP_PLUGIN_ARG3);
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void controlgetposy(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs != 3) {setErrMsg("ControlGetPosY", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_ControlGetPosY(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, PP_PLUGIN_ARG3);
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void controlgetposheight(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs != 3) {setErrMsg("ControlGetPosHeight", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_ControlGetPosHeight(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, PP_PLUGIN_ARG3);
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void controlgetposwidth(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs != 3) {setErrMsg("ControlGetPosWidth", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_ControlGetPosWidth(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, PP_PLUGIN_ARG3);
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void controlgettext(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs != 3) {setErrMsg("ControlGetText", szArgs, SetVar, ppsv); return;}

	CHAR szControlText[BUF_SIZE+1];
	AU3_ControlGetText(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, PP_PLUGIN_ARG3, szControlText, BUF_SIZE);
	returntoPP(szControlText, szArgs, SetVar, ppsv);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void controlhide(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs != 3) {setErrMsg("ControlHide", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_ControlHide(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, PP_PLUGIN_ARG3);
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void controlmove(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs < 5 || nargs > 7) {setErrMsg("ControlMove", szArgs, SetVar, ppsv); return;}

	LONG nHeight = (nargs >= 7) ? atol(PP_PLUGIN_ARG7) : -1;
	LONG nWidth = (nargs >= 6) ? atol(PP_PLUGIN_ARG6) : -1;
	LONG lRes = AU3_ControlMove(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, PP_PLUGIN_ARG3, atol(PP_PLUGIN_ARG4), atol(PP_PLUGIN_ARG5), nWidth, nHeight);
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void controlsend(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs < 4 || nargs > 5) {setErrMsg("ControlSend", szArgs, SetVar, ppsv); return;}

	LONG nMode = (nargs >= 5) ? atol(PP_PLUGIN_ARG5) : 0;
	LONG lRes = AU3_ControlSend(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, PP_PLUGIN_ARG3, PP_PLUGIN_ARG4, nMode);
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void controlsettext(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs != 4) {setErrMsg("ControlSetText", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_ControlSetText(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, PP_PLUGIN_ARG3, PP_PLUGIN_ARG4);
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void controlshow(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs != 3) {setErrMsg("ControlShow", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_ControlShow(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, PP_PLUGIN_ARG3);
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void drivemapadd(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs < 3 || nargs > 5) {setErrMsg("DriveMapAdd", szArgs, SetVar, ppsv); return;}

	CHAR szResult[BUF_SIZE+1];
	LPCSTR szPwd = (nargs >= 5) ? PP_PLUGIN_ARG5 : "";
	LPCSTR szUser = (nargs >= 4) ? PP_PLUGIN_ARG4 : "";
	AU3_DriveMapAdd(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, atol(PP_PLUGIN_ARG3), szUser, szPwd, szResult, BUF_SIZE);
	returntoPP(szResult, szArgs, SetVar, ppsv);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void drivemapdel(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs != 1) {setErrMsg("DriveMapDel", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_DriveMapDel(PP_PLUGIN_ARG1);
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void drivemapget(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs != 1) {setErrMsg("DriveMapGet", szArgs, SetVar, ppsv); return;}

	CHAR szMapping[BUF_SIZE+1];
	AU3_DriveMapGet(PP_PLUGIN_ARG1, szMapping, BUF_SIZE);
	returntoPP(szMapping, szArgs, SetVar, ppsv);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void inidelete(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs != 3) {setErrMsg("IniDelete", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_IniDelete(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, PP_PLUGIN_ARG3);
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void iniread(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs != 4) {setErrMsg("IniRead", szArgs, SetVar, ppsv); return;}

	CHAR szValue[BUF_SIZE+1];
	AU3_IniRead(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, PP_PLUGIN_ARG3, PP_PLUGIN_ARG4, szValue, BUF_SIZE);
	returntoPP(szValue, szArgs, SetVar, ppsv);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void iniwrite(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs != 4) {setErrMsg("IniWrite", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_IniWrite(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, PP_PLUGIN_ARG3, PP_PLUGIN_ARG4);
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void isadmin(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs != 0) {setErrMsg("IsAdmin", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_IsAdmin();
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void mouseclick(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs < 0 || nargs > 5) {setErrMsg("MouseClick", szArgs, SetVar, ppsv); return;}

	LONG nSpeed = (nargs >= 5) ? atol(PP_PLUGIN_ARG5) : -1;
	LONG nClicks = (nargs >= 4) ? atol(PP_PLUGIN_ARG4) : 1;
	LONG nY = (nargs >= 3) ? atol(PP_PLUGIN_ARG3) : AU3_INTDEFAULT;
	LONG nX = (nargs >= 2) ? atol(PP_PLUGIN_ARG2) : AU3_INTDEFAULT;
	LPCSTR szButton = (nargs >= 1) ? PP_PLUGIN_ARG1 : "LEFT";
	LONG lRes = AU3_MouseClick(szButton, nX, nY, nClicks, nSpeed);
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void mouseclickdrag(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs < 5 || nargs > 6) {setErrMsg("MouseClickDrag", szArgs, SetVar, ppsv); return;}

	LONG nSpeed = (nargs >= 6) ? atol(PP_PLUGIN_ARG6) : -1;
	LONG lRes = AU3_MouseClickDrag(PP_PLUGIN_ARG1, atol(PP_PLUGIN_ARG2), atol(PP_PLUGIN_ARG3), atol(PP_PLUGIN_ARG4), atol(PP_PLUGIN_ARG5), nSpeed);
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void mousedown(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs < 0 || nargs > 1) {setErrMsg("MouseDown", szArgs, SetVar, ppsv); return;}

	LPCSTR szButton = (nargs >= 1) ? PP_PLUGIN_ARG1 : "LEFT";
	AU3_MouseDown(szButton);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void mousegetcursor(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs != 0) {setErrMsg("MouseGetCursor", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_MouseGetCursor();
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void mousegetposx(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs != 0) {setErrMsg("MouseGetPosX", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_MouseGetPosX();
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void mousegetposy(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs != 0) {setErrMsg("MouseGetPosY", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_MouseGetPosY();
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void mousemove(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs < 2 || nargs > 3) {setErrMsg("MouseMove", szArgs, SetVar, ppsv); return;}

	LONG nSpeed = (nargs >= 3) ? atol(PP_PLUGIN_ARG3) : -1;
	LONG lRes = AU3_MouseMove(atol(PP_PLUGIN_ARG1), atol(PP_PLUGIN_ARG2), nSpeed);
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void mouseup(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs < 0 || nargs > 1) {setErrMsg("MouseUp", szArgs, SetVar, ppsv); return;}

	LPCSTR szButton = (nargs >= 1) ? PP_PLUGIN_ARG1 : "LEFT";
	AU3_MouseUp(szButton);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void mousewheel(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs != 2) {setErrMsg("MouseWheel", szArgs, SetVar, ppsv); return;}

	AU3_MouseWheel(PP_PLUGIN_ARG1, atol(PP_PLUGIN_ARG2));
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void opt(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs != 2) {setErrMsg("Opt", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_Opt(PP_PLUGIN_ARG1, atol(PP_PLUGIN_ARG2));
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void pixelchecksum(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs < 4 || nargs > 5) {setErrMsg("PixelChecksum", szArgs, SetVar, ppsv); return;}

	LONG nStep = (nargs >= 5) ? atol(PP_PLUGIN_ARG5) : 1;
	LONG lRes = AU3_PixelChecksum(atol(PP_PLUGIN_ARG1), atol(PP_PLUGIN_ARG2), atol(PP_PLUGIN_ARG3), atol(PP_PLUGIN_ARG4), nStep);
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void pixelgetcolor(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs != 2) {setErrMsg("PixelGetColor", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_PixelGetColor(atol(PP_PLUGIN_ARG1), atol(PP_PLUGIN_ARG2));
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void pixelsearch(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs != 7) {setErrMsg("PixelSearch", szArgs, SetVar, ppsv); return;}

	CHAR szResult[BUF_SIZE+1];
	AU3_PixelSearch(atol(PP_PLUGIN_ARG1), atol(PP_PLUGIN_ARG2), atol(PP_PLUGIN_ARG3), atol(PP_PLUGIN_ARG4), atol(PP_PLUGIN_ARG5), atol(PP_PLUGIN_ARG6), atol(PP_PLUGIN_ARG7), szResult, BUF_SIZE);
	returntoPP(szResult, szArgs, SetVar, ppsv);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void processclose(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs != 1) {setErrMsg("ProcessClose", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_ProcessClose(PP_PLUGIN_ARG1);
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void processexists(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs != 1) {setErrMsg("ProcessExists", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_ProcessExists(PP_PLUGIN_ARG1);
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void processsetpriority(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs != 2) {setErrMsg("ProcessSetPriority", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_ProcessSetPriority(PP_PLUGIN_ARG1, atol(PP_PLUGIN_ARG2));
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void processwait(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs < 1 || nargs > 2) {setErrMsg("ProcessWait", szArgs, SetVar, ppsv); return;}

	LONG nTimeout = (nargs >= 2) ? atol(PP_PLUGIN_ARG2) : 0;
	LONG lRes = AU3_ProcessWait(PP_PLUGIN_ARG1, nTimeout);
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void processwaitclose(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs < 1 || nargs > 2) {setErrMsg("ProcessWaitClose", szArgs, SetVar, ppsv); return;}

	LONG nTimeout = (nargs >= 2) ? atol(PP_PLUGIN_ARG2) : 0;
	LONG lRes = AU3_ProcessWaitClose(PP_PLUGIN_ARG1, nTimeout);
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void regenumkey(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs != 2) {setErrMsg("RegEnumKey", szArgs, SetVar, ppsv); return;}

	CHAR szResult[BUF_SIZE+1];
	AU3_RegEnumKey(PP_PLUGIN_ARG1, atol(PP_PLUGIN_ARG2), szResult, BUF_SIZE);
	returntoPP(szResult, szArgs, SetVar, ppsv);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void regenumval(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs != 2) {setErrMsg("RegEnumVal", szArgs, SetVar, ppsv); return;}

	CHAR szResult[BUF_SIZE+1];
	AU3_RegEnumVal(PP_PLUGIN_ARG1, atol(PP_PLUGIN_ARG2), szResult, BUF_SIZE);
	returntoPP(szResult, szArgs, SetVar, ppsv);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void regread(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs != 2) {setErrMsg("RegRead", szArgs, SetVar, ppsv); return;}

	CHAR szRetText[BUF_SIZE+1];
	AU3_RegRead(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, szRetText, BUF_SIZE);
	returntoPP(szRetText, szArgs, SetVar, ppsv);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void regwrite(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs != 4) {setErrMsg("RegWrite", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_RegWrite(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, PP_PLUGIN_ARG3, PP_PLUGIN_ARG4);
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void run(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs < 1 || nargs > 3) {setErrMsg("Run", szArgs, SetVar, ppsv); return;}

	LONG nShowFlags = (nargs >= 3) ? atol(PP_PLUGIN_ARG3) : 1;
	LPCSTR szDir = (nargs >= 2) ? PP_PLUGIN_ARG2 : "";
	LONG lRes = AU3_Run(PP_PLUGIN_ARG1, szDir, nShowFlags);
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void runasset(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs != 4) {setErrMsg("RunAsSet", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_RunAsSet(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, PP_PLUGIN_ARG3, atoi(PP_PLUGIN_ARG4));
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void runwait(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs < 1 || nargs > 3) {setErrMsg("RunWait", szArgs, SetVar, ppsv); return;}

	LONG nShowFlags = (nargs >= 3) ? atol(PP_PLUGIN_ARG3) : 1;
	LPCSTR szDir = (nargs >= 2) ? PP_PLUGIN_ARG2 : "";
	LONG lRes = AU3_RunWait(PP_PLUGIN_ARG1, szDir, nShowFlags);
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void send(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs < 1 || nargs > 2) {setErrMsg("Send", szArgs, SetVar, ppsv); return;}

	LONG nMode = (nargs >= 2) ? atol(PP_PLUGIN_ARG2) : 0;
	AU3_Send(PP_PLUGIN_ARG1, nMode);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void shutdown(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs != 1) {setErrMsg("Shutdown", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_Shutdown(atol(PP_PLUGIN_ARG1));
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void sleep(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs != 1) {setErrMsg("Sleep", szArgs, SetVar, ppsv); return;}

	AU3_Sleep(atol(PP_PLUGIN_ARG1));
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void statusbargettext(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs < 1 || nargs > 3) {setErrMsg("StatusbarGetText", szArgs, SetVar, ppsv); return;}

	CHAR szStatusText[BUF_SIZE+1];
	LONG nPart = (nargs >= 3) ? atol(PP_PLUGIN_ARG3) : 1;
	LPCSTR szText = (nargs >= 2) ? PP_PLUGIN_ARG2 : "";
	AU3_StatusbarGetText(PP_PLUGIN_ARG1, szText, nPart, szStatusText, BUF_SIZE);
	returntoPP(szStatusText, szArgs, SetVar, ppsv);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void tooltip(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs < 1 || nargs > 3) {setErrMsg("ToolTip", szArgs, SetVar, ppsv); return;}

	LONG nY = (nargs >= 3) ? atol(PP_PLUGIN_ARG3) : AU3_INTDEFAULT;
	LONG nX = (nargs >= 2) ? atol(PP_PLUGIN_ARG2) : AU3_INTDEFAULT;
	AU3_ToolTip(PP_PLUGIN_ARG1, nX, nY);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void winactivate(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs < 1 || nargs > 2) {setErrMsg("WinActivate", szArgs, SetVar, ppsv); return;}

	LPCSTR szText = (nargs >= 2) ? PP_PLUGIN_ARG2 : "";
	AU3_WinActivate(PP_PLUGIN_ARG1, szText);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void winactive(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs < 1 || nargs > 2) {setErrMsg("WinActive", szArgs, SetVar, ppsv); return;}

	LPCSTR szText = (nargs >= 2) ? PP_PLUGIN_ARG2 : "";
	LONG lRes = AU3_WinActive(PP_PLUGIN_ARG1, szText);
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void winclose(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs < 1 || nargs > 2) {setErrMsg("WinClose", szArgs, SetVar, ppsv); return;}

	LPCSTR szText = (nargs >= 2) ? PP_PLUGIN_ARG2 : "";
	LONG lRes = AU3_WinClose(PP_PLUGIN_ARG1, szText);
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void winexists(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs < 1 || nargs > 2) {setErrMsg("WinExists", szArgs, SetVar, ppsv); return;}

	LPCSTR szText = (nargs >= 2) ? PP_PLUGIN_ARG2 : "";
	LONG lRes = AU3_WinExists(PP_PLUGIN_ARG1, szText);
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void wingetcaretposx(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs != 0) {setErrMsg("WinGetCaretPosX", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_WinGetCaretPosX();
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void wingetcaretposy(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs != 0) {setErrMsg("WinGetCaretPosY", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_WinGetCaretPosY();
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void wingetclasslist(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs < 1 || nargs > 2) {setErrMsg("WinGetClassList", szArgs, SetVar, ppsv); return;}

	CHAR szRetText[BUF_SIZE+1];
	LPCSTR szText = (nargs >= 2) ? PP_PLUGIN_ARG2 : "";
	AU3_WinGetClassList(PP_PLUGIN_ARG1, szText, szRetText, BUF_SIZE);
	returntoPP(szRetText, szArgs, SetVar, ppsv);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void wingetclientsizeheight(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs < 1 || nargs > 2) {setErrMsg("WinGetClientSizeHeight", szArgs, SetVar, ppsv); return;}

	LPCSTR szText = (nargs >= 2) ? PP_PLUGIN_ARG2 : "";
	LONG lRes = AU3_WinGetClientSizeHeight(PP_PLUGIN_ARG1, szText);
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void wingetclientsizewidth(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs < 1 || nargs > 2) {setErrMsg("WinGetClientSizeWidth", szArgs, SetVar, ppsv); return;}

	LPCSTR szText = (nargs >= 2) ? PP_PLUGIN_ARG2 : "";
	LONG lRes = AU3_WinGetClientSizeWidth(PP_PLUGIN_ARG1, szText);
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void wingethandle(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs < 1 || nargs > 2) {setErrMsg("WinGetHandle", szArgs, SetVar, ppsv); return;}

	CHAR szRetText[BUF_SIZE+1];
	LPCSTR szText = (nargs >= 2) ? PP_PLUGIN_ARG2 : "";
	AU3_WinGetHandle(PP_PLUGIN_ARG1, szText, szRetText, BUF_SIZE);
	returntoPP(szRetText, szArgs, SetVar, ppsv);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void wingetposx(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs < 1 || nargs > 2) {setErrMsg("WinGetPosX", szArgs, SetVar, ppsv); return;}

	LPCSTR szText = (nargs >= 2) ? PP_PLUGIN_ARG2 : "";
	LONG lRes = AU3_WinGetPosX(PP_PLUGIN_ARG1, szText);
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void wingetposy(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs < 1 || nargs > 2) {setErrMsg("WinGetPosY", szArgs, SetVar, ppsv); return;}

	LPCSTR szText = (nargs >= 2) ? PP_PLUGIN_ARG2 : "";
	LONG lRes = AU3_WinGetPosY(PP_PLUGIN_ARG1, szText);
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void wingetposheight(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs < 1 || nargs > 2) {setErrMsg("WinGetPosHeight", szArgs, SetVar, ppsv); return;}

	LPCSTR szText = (nargs >= 2) ? PP_PLUGIN_ARG2 : "";
	LONG lRes = AU3_WinGetPosHeight(PP_PLUGIN_ARG1, szText);
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void wingetposwidth(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs < 1 || nargs > 2) {setErrMsg("WinGetPosWidth", szArgs, SetVar, ppsv); return;}

	LPCSTR szText = (nargs >= 2) ? PP_PLUGIN_ARG2 : "";
	LONG lRes = AU3_WinGetPosWidth(PP_PLUGIN_ARG1, szText);
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void wingetprocess(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs < 1 || nargs > 2) {setErrMsg("WinGetProcess", szArgs, SetVar, ppsv); return;}

	CHAR szRetText[BUF_SIZE+1];
	LPCSTR szText = (nargs >= 2) ? PP_PLUGIN_ARG2 : "";
	AU3_WinGetProcess(PP_PLUGIN_ARG1, szText, szRetText, BUF_SIZE);
	returntoPP(szRetText, szArgs, SetVar, ppsv);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void wingetstate(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs < 1 || nargs > 2) {setErrMsg("WinGetState", szArgs, SetVar, ppsv); return;}

	LPCSTR szText = (nargs >= 2) ? PP_PLUGIN_ARG2 : "";
	LONG lRes = AU3_WinGetState(PP_PLUGIN_ARG1, szText);
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void wingettext(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs < 1 || nargs > 2) {setErrMsg("WinGetText", szArgs, SetVar, ppsv); return;}

	CHAR szRetText[BUF_SIZE+1];
	LPCSTR szText = (nargs >= 2) ? PP_PLUGIN_ARG2 : "";
	AU3_WinGetText(PP_PLUGIN_ARG1, szText, szRetText, BUF_SIZE);
	returntoPP(szRetText, szArgs, SetVar, ppsv);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void wingettitle(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs < 1 || nargs > 2) {setErrMsg("WinGetTitle", szArgs, SetVar, ppsv); return;}

	CHAR szRetText[BUF_SIZE+1];
	LPCSTR szText = (nargs >= 2) ? PP_PLUGIN_ARG2 : "";
	AU3_WinGetTitle(PP_PLUGIN_ARG1, szText, szRetText, BUF_SIZE);
	returntoPP(szRetText, szArgs, SetVar, ppsv);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void winkill(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs < 1 || nargs > 2) {setErrMsg("WinKill", szArgs, SetVar, ppsv); return;}

	LPCSTR szText = (nargs >= 2) ? PP_PLUGIN_ARG2 : "";
	LONG lRes = AU3_WinKill(PP_PLUGIN_ARG1, szText);
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void winmenuselectitem(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs != 9) {setErrMsg("WinMenuSelectItem", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_WinMenuSelectItem(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, PP_PLUGIN_ARG3, PP_PLUGIN_ARG4, PP_PLUGIN_ARG5, PP_PLUGIN_ARG6, PP_PLUGIN_ARG7, PP_PLUGIN_ARG8, PP_PLUGIN_ARG9, "");
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void winminimizeall(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs != 0) {setErrMsg("WinMinimizeAll", szArgs, SetVar, ppsv); return;}

	AU3_WinMinimizeAll();
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void winminimizeallundo(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs != 0) {setErrMsg("WinMinimizeAllUndo", szArgs, SetVar, ppsv); return;}

	AU3_WinMinimizeAllUndo();
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void winmove(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs < 4 || nargs > 6) {setErrMsg("WinMove", szArgs, SetVar, ppsv); return;}

	LONG nHeight = (nargs >= 6) ? atol(PP_PLUGIN_ARG6) : -1;
	LONG nWidth = (nargs >= 5) ? atol(PP_PLUGIN_ARG5) : -1;
	LONG lRes = AU3_WinMove(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, atol(PP_PLUGIN_ARG3), atol(PP_PLUGIN_ARG4), nWidth, nHeight);
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void winsetontop(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs != 3) {setErrMsg("WinSetOnTop", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_WinSetOnTop(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, atol(PP_PLUGIN_ARG3));
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void winsetstate(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs != 3) {setErrMsg("WinSetState", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_WinSetState(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, atol(PP_PLUGIN_ARG3));
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void winsettitle(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs != 3) {setErrMsg("WinSetTitle", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_WinSetTitle(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, PP_PLUGIN_ARG3);
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void winsettrans(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs != 3) {setErrMsg("WinSetTrans", szArgs, SetVar, ppsv); return;}

	LONG lRes = AU3_WinSetTrans(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2, atol(PP_PLUGIN_ARG3));
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void winwait(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs < 1 || nargs > 3) {setErrMsg("WinWait", szArgs, SetVar, ppsv); return;}

	LONG nTimeout = (nargs >= 3) ? atol(PP_PLUGIN_ARG3) : 0;
	LPCSTR szText = (nargs >= 2) ? PP_PLUGIN_ARG2 : "";
	LONG lRes = AU3_WinWait(PP_PLUGIN_ARG1, szText, nTimeout);
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void winwaitactive(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs < 1 || nargs > 3) {setErrMsg("WinWaitActive", szArgs, SetVar, ppsv); return;}

	LONG nTimeout = (nargs >= 3) ? atol(PP_PLUGIN_ARG3) : 0;
	LPCSTR szText = (nargs >= 2) ? PP_PLUGIN_ARG2 : "";
	LONG lRes = AU3_WinWaitActive(PP_PLUGIN_ARG1, szText, nTimeout);
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void winwaitclose(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs < 1 || nargs > 3) {setErrMsg("WinWaitClose", szArgs, SetVar, ppsv); return;}

	LONG nTimeout = (nargs >= 3) ? atol(PP_PLUGIN_ARG3) : 0;
	LPCSTR szText = (nargs >= 2) ? PP_PLUGIN_ARG2 : "";
	LONG lRes = AU3_WinWaitClose(PP_PLUGIN_ARG1, szText, nTimeout);
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////

_declspec(dllexport) void winwaitnotactive(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
	if (nargs < 1 || nargs > 3) {setErrMsg("WinWaitNotActive", szArgs, SetVar, ppsv); return;}

	LONG nTimeout = (nargs >= 3) ? atol(PP_PLUGIN_ARG3) : 0;
	LPCSTR szText = (nargs >= 2) ? PP_PLUGIN_ARG2 : "";
	LONG lRes = AU3_WinWaitNotActive(PP_PLUGIN_ARG1, szText, nTimeout);
	ltoa(lRes, PP_PLUGIN_RET, 10);
}

//////////////////////////////////////////////////////////////////////////
//not in header file!!!

_declspec(dllexport) void regdeleteval(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
  if (nargs != 2) {setErrMsg("RegDeleteVal", szArgs, SetVar, ppsv); return;}
  *PP_PLUGIN_RET = '\0';
  if (g_hAutoItX3 == NULL)
   return;

  LONG (WINAPI * pfnAU3_RegDeleteVal)(LPSTR, LPSTR);
  pfnAU3_RegDeleteVal = (LONG (WINAPI *)(LPSTR, LPSTR)) GetProcAddress(g_hAutoItX3, "AU3_RegDeleteVal");  

  if (pfnAU3_RegDeleteVal == NULL)
   return;

  LONG lRes = pfnAU3_RegDeleteVal(PP_PLUGIN_ARG1, PP_PLUGIN_ARG2);
  ltoa(lRes, PP_PLUGIN_RET, 10);
}		

//////////////////////////////////////////////////////////////////////////
//not in header file!!!

_declspec(dllexport) void regdeletekey(LPSTR szv, LPSTR szx, BOOL (*GetVar)(LPSTR, LPSTR),
		void (*SetVar)(LPSTR, LPSTR), DWORD* pFlags,
		UINT nargs, LPSTR *szArgs, PPROSERVICES* ppsv)
{
  if (nargs != 1) {setErrMsg("RegDeleteKey", szArgs, SetVar, ppsv); return;}
  *PP_PLUGIN_RET = '\0';
  if (g_hAutoItX3 == NULL)
   return;

  LONG (WINAPI * pfnAU3_RegDeleteKey)(LPSTR);
  pfnAU3_RegDeleteKey = (LONG (WINAPI *)(LPSTR)) GetProcAddress(g_hAutoItX3, "AU3_RegDeleteKey");  

  if (pfnAU3_RegDeleteKey == NULL)
   return;

  LONG lRes = pfnAU3_RegDeleteKey(PP_PLUGIN_ARG1);
  ltoa(lRes, PP_PLUGIN_RET, 10);

}		

//////////////////////////////////////////////////////////////////////////

