// Credits: Bruce Switzer (plugin template)

// compiled with Visual C++ 6

#include <stdio.h>
#include <windows.h>
#include <IPHlpApi.h>
#include <Winsock.h>


#include "GetCpuUsage.h"

#define VAR_SIZE 264


static HWND g_hwndPowerPro;
static HANDLE hSDATA;

typedef struct tagPProServices
{
	void (*ErrMessage)(LPSTR, LPSTR);
	BOOL (*MatchCaption)(HWND, LPSTR);
	HWND (*FindMatchingWindow)(LPSTR,BOOL);
	BOOL (*IsRolled)(HWND hw);
	BOOL (*IsTrayMinned)(HWND hw);
	void (*GetExeFullPath)(HWND hw, LPSTR szt);
	void (*RollUp)(HWND hw);
	void (*TrayMin)(HWND hw);
	void (*SendKeys)(LPSTR sz);
	BOOL  (*EvalExpr)(LPSTR sz, LPSTR szo);
	void  (*Debug)(LPSTR sz1, LPSTR sz2,LPSTR sz3, LPSTR sz4, LPSTR sz5, LPSTR sz6);
	LPSTR (*AllocTemp)(UINT leng);
	void (*ReturnString)(LPSTR sz, LPSTR* szargs);
	LPSTR (*GetVarAddr)(LPSTR var);
	LPSTR (*SetVar)(LPSTR var, LPSTR val);

}
PPROSERVICES;

extern "C" {
BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD dwReason, LPVOID lpvReserved)
{
	if(dwReason == DLL_PROCESS_ATTACH)
	{
		g_hwndPowerPro = FindWindow("PowerProMain",NULL);
	}
	else if(dwReason == DLL_PROCESS_DETACH)
	{
		// Detaching process
	}
	return TRUE;
}
}


extern "C" {
_declspec(dllexport) void get_cpu_usage (LPSTR szv, LPSTR szx,
											BOOL(*GetVar)(LPSTR, LPSTR), 
											void(*SetVar)(LPSTR, LPSTR), 
											DWORD* pFlags, 
											UINT nargs, 
											LPSTR* szargs,
											PPROSERVICES *ppsv)
{
	double CpuUsage = GetCpuUsage();
	char buf[255];
	sprintf (buf, "%2.1f", CpuUsage);
	strcpy (*szargs, buf);
};
}
extern "C" {
_declspec(dllexport) void get_free_physical_memory (LPSTR szv, LPSTR szx,
												BOOL(*GetVar)(LPSTR, LPSTR), 
												void(*SetVar)(LPSTR, LPSTR), 
												DWORD* pFlags, 
												UINT nargs, 
												LPSTR* szargs,
												PPROSERVICES *ppsv)
{
	MEMORYSTATUS statex;	
		
	GlobalMemoryStatus (&statex);

	char buf[255];
	sprintf (buf, "%d", statex.dwAvailPhys);
	strcpy (*szargs, buf);
}
}
extern "C" {

_declspec(dllexport) void get_total_physical_memory (LPSTR szv, LPSTR szx,
												BOOL(*GetVar)(LPSTR, LPSTR), 
												void(*SetVar)(LPSTR, LPSTR), 
												DWORD* pFlags, 
												UINT nargs, 
												LPSTR* szargs,
												PPROSERVICES *ppsv)
{
	MEMORYSTATUS statex;	
		
	GlobalMemoryStatus (&statex);
	char buf[255];
	sprintf (buf, "%d", statex.dwTotalPhys);
	strcpy (*szargs, buf);
}
}
extern "C" {
_declspec(dllexport) void get_free_virtual_memory (LPSTR szv, LPSTR szx,
												BOOL(*GetVar)(LPSTR, LPSTR), 
												void(*SetVar)(LPSTR, LPSTR), 
												DWORD* pFlags, 
												UINT nargs, 
												LPSTR* szargs,
												PPROSERVICES *ppsv)
{
	MEMORYSTATUS statex;	

	
	GlobalMemoryStatus (&statex);
		
	char buf[255];
	sprintf (buf, "%d", statex.dwAvailVirtual);
	strcpy (*szargs, buf);
}
}
extern "C" {
_declspec(dllexport) void get_total_virtual_memory (LPSTR szv, LPSTR szx,
												BOOL(*GetVar)(LPSTR, LPSTR), 
												void(*SetVar)(LPSTR, LPSTR), 
												DWORD* pFlags, 
												UINT nargs, 
												LPSTR* szargs,
												PPROSERVICES *ppsv)
{
	MEMORYSTATUS statex;	

	
	GlobalMemoryStatus (&statex);
	
	char buf[255];
	sprintf (buf, "%d", statex.dwTotalVirtual);
	strcpy (*szargs, buf);
}
}
extern "C" {


_declspec(dllexport) void get_total_page_file (LPSTR szv, LPSTR szx,
												BOOL(*GetVar)(LPSTR, LPSTR), 
												void(*SetVar)(LPSTR, LPSTR), 
												DWORD* pFlags, 
												UINT nargs, 
												LPSTR* szargs,
												PPROSERVICES *ppsv)
{
	MEMORYSTATUS statex;	

	
	GlobalMemoryStatus (&statex);
	char buf[255];
	sprintf (buf, "%d", statex.dwTotalPageFile);
	strcpy (*szargs, buf);
}
}
extern "C" {

_declspec(dllexport) void get_free_page_file (LPSTR szv, LPSTR szx,
												BOOL(*GetVar)(LPSTR, LPSTR), 
												void(*SetVar)(LPSTR, LPSTR), 
												DWORD* pFlags, 
												UINT nargs, 
												LPSTR* szargs,
												PPROSERVICES *ppsv)
{
	MEMORYSTATUS statex;	

	
	GlobalMemoryStatus (&statex);

	char buf[255];
	sprintf (buf, "%d", statex.dwAvailPageFile);
	strcpy (*szargs, buf);
}

}

extern "C" {
_declspec(dllexport) void get_ip_address (LPSTR szv, LPSTR szx,
										  BOOL(*GetVar)(LPSTR, LPSTR), 
										  void(*SetVar)(LPSTR, LPSTR), 
										  DWORD* pFlags, 
										  UINT nargs, 
										  LPSTR* szargs,
										  PPROSERVICES *ppsv)
{
	// This fine piece of code by Jeff Lundgren (jlundgre@igate.sprint.com)
	// from www.codeguru.com

	WORD wVersionRequested;
    WSADATA wsaData;
    char name[255];
    char ip[255];
    
	PHOSTENT hostinfo;
    wVersionRequested = MAKEWORD( 2, 0 );
    if ( WSAStartup( wVersionRequested, &wsaData ) == 0 )
    {
      if( gethostname ( name, sizeof(name)) == 0)
      {
        if((hostinfo = gethostbyname(name)) != NULL)
        {
           strcpy (ip, inet_ntoa (*(struct in_addr *)*hostinfo->h_addr_list));
        }
      }
      WSACleanup( );
    } 

	
	strcpy (*szargs, ip);
}
}


extern "C" {
_declspec(dllexport) void get_hostname (LPSTR szv, LPSTR szx,
									    BOOL(*GetVar)(LPSTR, LPSTR), 
									    void(*SetVar)(LPSTR, LPSTR), 
									    DWORD* pFlags, 
									    UINT nargs, 
									    LPSTR* szargs,
									    PPROSERVICES *ppsv)
{
	// This fine piece of code by Jeff Lundgren (jlundgre@igate.sprint.com)
	// from www.codeguru.com

	WORD wVersionRequested;
    WSADATA wsaData;
    char name[255];
    
    wVersionRequested = MAKEWORD( 2, 0 );
    if ( WSAStartup( wVersionRequested, &wsaData ) == 0 )
    {
      if( gethostname ( name, sizeof(name)) == 0)
      {
		  strcpy (*szargs, name);
      }
      WSACleanup( );
    } 

	

}
}

extern "C" {
_declspec(dllexport) void beep (LPSTR szv, LPSTR szx,
							    BOOL(*GetVar)(LPSTR, LPSTR), 
							    void(*SetVar)(LPSTR, LPSTR), 
							    DWORD* pFlags, 
							    UINT nargs, 
							    LPSTR* szargs,
							    PPROSERVICES *ppsv)
{
	if (nargs == 2)
	{
		DWORD freq = atoi (*(szargs+1));
		DWORD length = atoi (*(szargs+2));

		Beep (freq, length);
	}
}
}





extern "C" {
_declspec(dllexport) void get_dun_received (LPSTR szv, LPSTR szx,
							                BOOL(*GetVar)(LPSTR, LPSTR), 
							                void(*SetVar)(LPSTR, LPSTR), 
							                DWORD* pFlags, 
							                UINT nargs, 
							                LPSTR* szargs,
							                PPROSERVICES *ppsv)
{
	PMIB_IFTABLE pIfTable;
	unsigned long size = 0;

	if (GetIfTable (NULL, &size, TRUE) != ERROR_INSUFFICIENT_BUFFER)
		return;

	pIfTable= (PMIB_IFTABLE) malloc (size);
	if (GetIfTable (pIfTable, &size, TRUE) == NO_ERROR)
	{
		for (DWORD i=0; i<=pIfTable->dwNumEntries; i++)
		{
			if ((pIfTable->table[i].dwType == MIB_IF_TYPE_PPP) )
			{
				sprintf (*szargs, "%d", pIfTable->table[i].dwInOctets);
			}
		}
	}
	free (pIfTable);
}
}

extern "C" {
_declspec(dllexport) void get_dun_sent (LPSTR szv, LPSTR szx,
							            BOOL(*GetVar)(LPSTR, LPSTR), 
							            void(*SetVar)(LPSTR, LPSTR), 
							            DWORD* pFlags, 
							            UINT nargs, 
							            LPSTR* szargs,
							            PPROSERVICES *ppsv)
{
	PMIB_IFTABLE pIfTable;
	unsigned long size = 0;
	
	if (GetIfTable (NULL, &size, TRUE) != ERROR_INSUFFICIENT_BUFFER)
		return;

	pIfTable= (PMIB_IFTABLE) malloc (size);
	if (GetIfTable (pIfTable, &size, TRUE) == NO_ERROR)
	{
		for (DWORD i=0; i<= (pIfTable->dwNumEntries); i++)
		{
			if ((pIfTable->table[i].dwType == MIB_IF_TYPE_PPP))
			{
				sprintf (*szargs, "%d", pIfTable->table[i].dwOutOctets);
			}
		}
	}
	free (pIfTable);
}
}