#if ! defined( POWERPRO_DEFINES_HEADER )


/////////////////////////////////////////////////////////////////////////////
// PowerProDefines.h
// version 1.17beta	 21 Dec 2002
//
// Copyright (C) 2002 by Alan Campbell
// All rights reserved
//
// Distribute freely, except: don't remove my name from the source or
// documentation (don't take credit for my work), mark your changes (don't
// get me blamed for your possible bugs), don't alter or remove this
// notice.

// No warranty of any kind, express or implied, is included with this
// software; use at your own risk, responsibility for damages (if any) to
// anyone resulting from the use of this software rests entirely with the
// user.
//
// Send bug reports, bug fixes, enhancements, requests, flames, etc., and
// I'll try to keep a version up to date.  I can be reached as follows:
//    CRegistryAdapter@alancampbell.freeserve.co.uk

// And thanks to Marko Bozikovic: I stole this comment header from him.

//#include <winsock2.h>
//#include <windows.h>

#ifdef __cplusplus
  #include "stdafx.h"
#else
  #include <windows.h>
#endif

//3.7.01
typedef struct tagPProServices
{
    void (*ErrMessage)(LPSTR, LPSTR);
	BOOL  (*MatchCaption)(HWND, LPSTR);
	HWND  (*FindMatchingWindow)(LPSTR,BOOL);
	BOOL  (*IsRolled)(HWND hw);
	BOOL  (*IsTrayMinned)(HWND hw);
	void  (*GetExeFullPath)(HWND hw, LPSTR szt);
	void  (*RollUp)(HWND hw);
	void  (*TrayMin)(HWND hw);
	void  (*SendKeys)(LPSTR sz);
	BOOL  (*EvalExpr)(LPSTR sz, LPSTR szo);
	void  (*Debug)(LPSTR sz1, LPSTR sz2,LPSTR sz3, LPSTR sz4, LPSTR sz5, LPSTR sz6);
	LPSTR (*AllocTemp)(UINT leng);
    void  (*ReturnString)(LPSTR sz, LPSTR* szargs);
	LPSTR (*GetVarAddr)(LPSTR var);
	LPSTR (*SetVar)(LPSTR var, LPSTR val);
	void  (*IgnoreNextClip)();
	void  (*Show)(HWND h);
	void  (*RunCmd)(LPSTR szCmd, LPSTR szParam, LPSTR szWork);
	BOOL  (*InsertStringForBar)( LPSTR szStr, LPSTR szCmd);
	void  (*ResetFocus)();
	HWND  (*NoteOpen)(LPSTR szFile, LPSTR szKeyWords);
	BOOL  (*PumpMessages)();
    BOOL (*RegForConfig)(void ( *callback )(LPSTR szList), BOOL bReg );  //not implemented
	void (*SetPreviousFocus)(HWND h );
	UINT (*SetDebug)(LPSTR sz,LPSTR sz2 );
	UINT (*ScriptCancel)(LPSTR sz );
	void (*GetCurrentDir)(HWND h,LPSTR szt);
    void (*RegisterNonModal)(HWND h, BOOL b);
    UINT (*GetVarSize)(LPSTR szvar);
    union
    {
//version >= 4.8.07S
	 BOOL (*RegisterSigOld)(BOOL b, LPSTR sig, LPSTR sig2, LPSTR szPlugName,
				 void (*callback)(LPSTR sz), LPSTR szGet, LPSTR szSet,LPSTR szDo );
     BOOL (*RegisterLocalFree)(BOOL b, LPSTR sig, void (*callback)(LPSTR sz));
    };
	void (*FreeIfHandle)(LPSTR sz); 
    int (*LastMouse)(UINT u);
    BOOL (*RegisterSig)(BOOL b, LPSTR sig, LPSTR sig2, LPSTR szPlugName,
                                          void (*callback)(LPSTR sz), LPSTR szGet, LPSTR szSet,LPSTR szDo, LPSTR szDoSet);
    union
    {
//version >= 4.7.07
     void (*ReturningNewHandle)();
	 void (*ReturningFreeableHandle)();
    };
    LPSTR (*GetStaticVarAddr)(LPSTR szName, LPSTR szScript);
    BOOL (*SetStaticVar)(LPSTR szName, LPSTR szScript, LPSTR szVal, BOOL bCreate);
    HWND (*ActiveMenu)(LPSTR szCap, LPSTR szSw);
    void (*SaveClip)(LPSTR szFileName, BOOL bTextOnly, BOOL bVerbose);
    void (*LoadClip)(LPSTR szFileName, BOOL bTextOnly, BOOL bVerbose);
    LPSTR (*EncodeFloat)(double x, LPSTR szBuff);
    double (*DecodeFloat)(LPSTR szBuff);
    void (*GetCaretPosScreen)(HWND h, POINT * pt); //XXX
    void (*SetAddRefCallback)(LPSTR sig1,void (*refcallback)(LPSTR sz, BOOL addref));
	void (*ChangeIfHandle)(LPSTR sz, BOOL b);
	BOOL (*CallScriptFile)(LPSTR szPath, int narg, LPSTR* pargs);
	LPSTR (*LoadScriptFile)(LPSTR szPath);
    BOOL (*RegisterForMouseUpDown)(BOOL b, void (*callback)(UINT msg, UINT msg2));
	LPSTR (*GetOutputAddr)(LPSTR szPath);

} PPROSERVICES;

/*
#define PPSERVICE(service_name) \
     void (* service_name) (LPSTR, LPSTR, \
	 int (*GetVar)(LPSTR, LPSTR), \
	 void (*SetVar)(LPSTR, LPSTR), DWORD*, \
     UINT, LPSTR*, PPROSERVICES*)
*/

#define PPSERVICE_DECLARE(service_name) \
     void service_name(LPSTR szv, LPSTR szx, \
	 int (*GetVar)(LPSTR szVar, LPSTR szVal), \
	 void (*SetVar)(LPSTR szVar, LPSTR szVal), DWORD* pFlags, \
     UINT nargs, LPSTR* szArgs, \
     PPROSERVICES* ppsv)

#define POWERPRO_VERSION_COLLECTIONS_HAVE_DELETEALL       4103
#define POWERPRO_VERSION_PICKLISTS_MULTIPLE_SELECTION     4104
#define POWERPRO_VERSION_CAN_GET_VAR_ADDR                 4310
#define POWERPRO_VERSION_23_ARGS                          4405
#define POWERPRO_VERSION_CAN_REGISTER_FREEABLE            4405
#define POWERPRO_VERSION_IS_REGISTER_SIG                  4406
#define POWERPRO_VERSION_CAN_REGISTER_DO                  4407
#define POWERPRO_VERSION_RETURNING_FREEABLE_HANDLE        4411
#define POWERPRO_VERSION_WITH_CALL                        4502
#define POWERPRO_VERSION_WITH_VEC_INTERFACE               4504
#define POWERPRO_VERSION_WITH_VEC_INTERFACE_INC_CREATION  4505
#define POWERPRO_VERSION_WITH_VEC_INTERFACE_INC_CREATE_2D 4506
#define POWERPRO_VERSION_WITH_FLOAT_SUPPORT               4512
#define POWERPRO_VERSION_WITH_MOUSE_REG_SUPPORT           4707

#define POWERPRO_DEFINES_HEADER

#define PP_VAR_NAME_SIZE 63
#define PP_VAR_SIZE 531

#define PP_FLOAT_PREFIX "r\x06"

struct SERVICE_DEF
{
 LPCSTR m_pszName;
 void (* m_service_name) (LPSTR, LPSTR, int (*GetVar)(LPSTR, LPSTR), void (*SetVar)(LPSTR, LPSTR), 
      DWORD*, UINT, LPSTR*, PPROSERVICES*);
};


#define PP_PLUGIN_MAX_ARG 23

#define PP_PLUGIN_RET  (*szArgs)
#define PP_PLUGIN_ARG1 (*(szArgs+1))
#define PP_PLUGIN_ARG2 (*(szArgs+2))
#define PP_PLUGIN_ARG3 (*(szArgs+3))
#define PP_PLUGIN_ARG4 (*(szArgs+4))
#define PP_PLUGIN_ARG5 (*(szArgs+5))
#define PP_PLUGIN_ARG6 (*(szArgs+6))
#define PP_PLUGIN_ARG7 (*(szArgs+7))
#define PP_PLUGIN_ARG8 (*(szArgs+8))
#define PP_PLUGIN_ARG9 (*(szArgs+9))
#define PP_PLUGIN_ARG10 (*(szArgs+10))
#define PP_PLUGIN_ARG11 (*(szArgs+11))
#define PP_PLUGIN_ARG12 (*(szArgs+12))
#define PP_PLUGIN_ARG13 (*(szArgs+13))
#define PP_PLUGIN_ARG14 (*(szArgs+14))
#define PP_PLUGIN_ARG15 (*(szArgs+15))
#define PP_PLUGIN_ARG16 (*(szArgs+16))
#define PP_PLUGIN_ARG17 (*(szArgs+17))
#define PP_PLUGIN_ARG18 (*(szArgs+18))
#define PP_PLUGIN_ARG19 (*(szArgs+19))
#define PP_PLUGIN_ARG20 (*(szArgs+20))
#define PP_PLUGIN_ARG21 (*(szArgs+21))
#define PP_PLUGIN_ARG22 (*(szArgs+22))
#define PP_PLUGIN_ARG23 (*(szArgs+23))

#ifndef INOUT
#define INOUT
#endif

#ifndef INOROUT
#define INOROUT
#endif

#ifndef JOIN
#  define JOIN(a,b) JOIN1(a,b)
#  define JOIN1(a,b) a##b
#endif

//from tcl.h
#ifndef STRINGIFY
#  define STRINGIFY(x) STRINGIFY1(x)
#  define STRINGIFY1(x) #x
#endif
 

#endif // ! defined( POWERPRO_DEFINES_HEADER )
