//19k with MFC: 28k without


// call enum stuff with no keys, means continue
//ditto more calls to getvalue for muti string

// To save memory if multiple plugins are loaded,
// consider using the dll msvcrt.dll of standard dll services by compiling with library MSVCRT.LIB
// and link options /nodefaultlib:"libcmt".
//DONE?

/////////////////////////////////////////////////////////////////////////////
// ppRegistry: a PowerPro Plugin to access the registry

// version 1.17beta	 21 Dec 2002
//
// Copyright (C) 2002 by Alan Campbell
// All rights reserved
//
// Distribute freely, except: don't remove my name from the source or
// documentation (don't take credit for my work), mark your changes (don't
// get me blamed for your possible bugs), don't alter or remove this
// notice.

// No warranty of any kind, express or implied, is included with this
// software; use at your own risk, responsibility for damages (if any) to
// anyone resulting from the use of this software rests entirely with the
// user.
//
// Send bug reports, bug fixes, enhancements, requests, flames, etc., and
// I'll try to keep a version up to date.  I can be reached as follows:
//    ppRegistry@AlanCampbellLists.fsnet.co.uk

// And thanks to Marko Bozikovic: I stole this comment header from him.

/////////////////////////////////////////////////////////////////////////////

//#include "..\..\Common\stdafx.h"
#include <windows.h>

#include "ppServices.h"
#include "powerProDefines.h"
//#include <crtdbg.h>

static PPROSERVICES*      g_ppsv = NULL;

static HWND               g_hwndPowerPro = NULL;
static HWND               g_hwndPowerProServicesWin = NULL;               

//static enum PowerproServType g_PowerproServTypeLast = ppServiceNone;

char                      g_pszClassName[] = "PowerProServicesServerWinClass";

HANDLE                    g_hFileMapping = NULL;
LPVOID                    g_pMem = NULL;
UINT                      g_uiFileMapDataLen = 0;
UINT                      g_uiFileMapLen = 4096;
DWORD                     g_dwResult = (DWORD) -1;

BOOL             makeWin(IN HINSTANCE hinstDLL);
LRESULT CALLBACK windowProc(HWND, UINT, WPARAM, LPARAM);
LRESULT          acceptRq(HWND hwnd, struct PowerProServiceRequest* pPowerProServiceRequest);

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

// Main DLL entry point.  Save handle to main PowerPro window.
BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD dwReason, LPVOID lpvReserved)
{
 if(dwReason == DLL_PROCESS_ATTACH)
 {
  g_hwndPowerPro = FindWindow("PowerProMain",NULL);
//instantiate singletons
//pVarSaveManager = PowerProVarManager::getInstance("ini_status","#");

#ifdef PP_PPSV_SNDMSG
  if (g_hwndPowerPro)
   g_ppsv = (PPROSERVICES*) SendMessage(g_hwndPowerPro, WM_USER+501, 0,0);
#endif

  makeWin(hinstDLL);

  g_hFileMapping = CreateFileMapping((HANDLE) 0xFFFFFFFF, NULL, PAGE_READWRITE, 0, g_uiFileMapLen, FILE_MAP_NAME);
  if (g_hFileMapping)
  {
//If is zero, the entire file is mapped.                       dwNumberOfBytesToMap 
   g_pMem = MapViewOfFile(g_hFileMapping, FILE_MAP_WRITE, 0, 0, 0); 
  }

 }
 else if(dwReason == DLL_PROCESS_DETACH)
 {
//close any windows, unregister any classes
  if (g_hwndPowerProServicesWin) DestroyWindow(g_hwndPowerProServicesWin); 
  if (g_pMem) UnmapViewOfFile(g_pMem);
  if (g_hFileMapping) CloseHandle(g_hFileMapping);
//destroy singleton; takes out PowerProVarManager singleton via base class destructor
 }

 return TRUE;
}

//////////////////////////////////////////////////////////////////////////


BOOL makeWin(IN HINSTANCE hinstDLL)
{
//MSG messages;            /* Here messages to the application are saved */
 WNDCLASSEX wincl;        /* Data structure for the windowclass */

 /* The Window structure */
 wincl.hInstance = hinstDLL; // hThisInstance;
 wincl.lpszClassName = g_pszClassName;
 wincl.lpfnWndProc = windowProc;      /* This function is called by windows */
 wincl.style = CS_DBLCLKS;            /* Catch double-clicks */
 wincl.cbSize = sizeof (WNDCLASSEX);

 /* Use default icon and mouse-pointer */
 wincl.hIcon = LoadIcon (NULL, IDI_APPLICATION);
 wincl.hIconSm = LoadIcon (NULL, IDI_APPLICATION);
 wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
 wincl.lpszMenuName = NULL;                 /* No menu */
 wincl.cbClsExtra = 0;                      /* No extra bytes after the window class */
 wincl.cbWndExtra = 0;                      /* structure or the window instance */
 /* Use Windows's default color as the background of the window */
 wincl.hbrBackground = (HBRUSH) COLOR_BACKGROUND;

 /* Register the window class, and if it fails quit the program */
 if (!RegisterClassEx (&wincl))
     return FALSE;

 /* The class is registered, let's create the program*/
 g_hwndPowerProServicesWin = CreateWindowEx (
        0,                   /* Extended possibilites for variation */
        g_pszClassName,         /* Classname */
        "PowerProServicesServerWin",       /* Title Text */
        WS_OVERLAPPEDWINDOW, /* default window */
        CW_USEDEFAULT,       /* Windows decides the position */
        CW_USEDEFAULT,       /* where the window ends up on the screen */
        544,                 /* The programs width */
        375,                 /* and height in pixels */
        g_hwndPowerPro,      // HWND_DESKTOP,        /* The window is a child-window to desktop */
        NULL,                /* No menu */
        hinstDLL,            // hThisInstance,       /* Program Instance handler */
        NULL                 /* No Window Creation data */
        );

 if (!g_hwndPowerProServicesWin)
  return FALSE;

 ShowWindow(g_hwndPowerProServicesWin, SW_HIDE);
 return TRUE;
}

//////////////////////////////////////////////////////////////////////////

LRESULT CALLBACK windowProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
 PCOPYDATASTRUCT pCOPYDATASTRUCT;
 switch (message)                  /* handle the messages */
 {
  case WM_COPYDATA:

   pCOPYDATASTRUCT = (PCOPYDATASTRUCT) lParam;
   return acceptRq((HWND) wParam, (struct PowerProServiceRequest*) pCOPYDATASTRUCT->lpData);           

  case MSG_TO_SERVICE_PLUGIN_TO_GET_DWORD_RESULT:

   return g_dwResult;

  case MSG_TO_SERVICE_PLUGIN_TO_GET_STRING_RESULT_LEN:

   return g_uiFileMapDataLen;

   break;
/*
  case WM_DESTROY:

   PostQuitMessage (0);       // send a WM_QUIT to the message queue 
   break;
*/
  default:                      /* for messages that we don't deal with */
   return DefWindowProc (hwnd, message, wParam, lParam);
 }

 return 0;
}

//////////////////////////////////////////////////////////////////////////

LRESULT acceptRq(HWND hwnd, struct PowerProServiceRequest* pPowerProServiceRequest)
{
 CHAR pszBuff[PP_VAR_SIZE+1];
 LPSTR pszBuffPtr = pszBuff;
 COPYDATASTRUCT cd;
 double dblVal = 0.0;

 g_dwResult = (DWORD) -1;
 g_uiFileMapDataLen = 0;
 *pszBuff = 0;

 *((LPSTR) g_pMem) = 0;
 FlushViewOfFile(g_pMem, g_uiFileMapDataLen);

 switch (pPowerProServiceRequest->ppServType)
 {
  case ppServiceStaticVarExists:

   g_dwResult = 
    (DWORD) (g_ppsv->GetStaticVarAddr(PP_STR_ARG(pPowerProServiceRequest, uiOffset1),
                                      PP_STR_ARG(pPowerProServiceRequest, uiOffset2)) != NULL);
   return TRUE; //data will be recovered via MSG_TO_SERVICE_PLUGIN_TO_GET_DWORD_RESULT:

  case ppServiceGetStaticVar:

   pszBuffPtr =
    g_ppsv->GetStaticVarAddr(PP_STR_ARG(pPowerProServiceRequest, uiOffset1),
                                     PP_STR_ARG(pPowerProServiceRequest, uiOffset2));
   if (pszBuffPtr)
    g_uiFileMapDataLen = strlen(pszBuffPtr) + 1;

   break;

  case ppServiceSetStaticVar:

   g_dwResult = 
    (DWORD) g_ppsv->SetStaticVar(PP_STR_ARG(pPowerProServiceRequest, uiOffset1), 
                        PP_STR_ARG(pPowerProServiceRequest, uiOffset2),
                        PP_STR_ARG(pPowerProServiceRequest, uiOffset3), 
                        pPowerProServiceRequest->dwArg4	);
   return TRUE; //data will be recovered via MSG_TO_SERVICE_PLUGIN_TO_GET_DWORD_RESULT:

  case ppServiceGetVarSize:

   g_dwResult = (DWORD) g_ppsv->GetVarSize(PP_STR_ARG(pPowerProServiceRequest, uiOffset1));
   return TRUE; //data will be recovered via MSG_TO_SERVICE_PLUGIN_TO_GET_DWORD_RESULT:

  case ppServiceVarExists:

   g_dwResult = (DWORD) (g_ppsv->GetVarAddr(PP_STR_ARG(pPowerProServiceRequest, uiOffset1)) !=NULL);
   return TRUE; //data will be recovered via MSG_TO_SERVICE_PLUGIN_TO_GET_DWORD_RESULT:

  case ppServiceGetVar:

   pszBuffPtr =
    g_ppsv->GetVarAddr(PP_STR_ARG(pPowerProServiceRequest, uiOffset1));

   if (pszBuffPtr)
    g_uiFileMapDataLen = strlen(pszBuffPtr) + 1;

   break;

  case ppServiceSetVar:

   g_ppsv->SetVar(PP_STR_ARG(pPowerProServiceRequest, uiOffset1), 
                  PP_STR_ARG(pPowerProServiceRequest, uiOffset2));
   return TRUE; 

  case ppServiceGetCurrentDir:

   g_ppsv->GetCurrentDir((HWND) pPowerProServiceRequest->dwArg1, pszBuff);
   g_uiFileMapDataLen = strlen(pszBuff) + 1;
   break;

  case ppServiceMatchCaption:

   g_dwResult = 
      (DWORD) g_ppsv->MatchCaption((HWND) pPowerProServiceRequest->dwArg1, 
                                          PP_STR_ARG(pPowerProServiceRequest, uiOffset2));
   return TRUE; //data will be recovered via MSG_TO_SERVICE_PLUGIN_TO_GET_DWORD_RESULT:

  case ppServiceFindMatchingWindow:

   g_dwResult = 
    (DWORD) g_ppsv->FindMatchingWindow(PP_STR_ARG(pPowerProServiceRequest, uiOffset1), 
                                       pPowerProServiceRequest->dwArg2);
   return TRUE; //data will be recovered via MSG_TO_SERVICE_PLUGIN_TO_GET_DWORD_RESULT:

  case ppServiceEvalExpr:

   if (g_ppsv->EvalExpr(PP_STR_ARG(pPowerProServiceRequest, uiOffset1), pszBuff))
    g_uiFileMapDataLen = strlen(pszBuff) + 1;
   break;

  case ppServiceIsRolled:

   g_dwResult = 
    (DWORD) (g_ppsv->IsRolled((HWND) pPowerProServiceRequest->dwArg1));
   return TRUE; //data will be recovered via MSG_TO_SERVICE_PLUGIN_TO_GET_DWORD_RESULT:

  case ppServiceIsTrayMinned:

   g_dwResult = 
    (DWORD) (g_ppsv->IsTrayMinned((HWND) pPowerProServiceRequest->dwArg1));
   return TRUE; //data will be recovered via MSG_TO_SERVICE_PLUGIN_TO_GET_DWORD_RESULT:


  case ppServiceEncodeFloat:

   if (g_ppsv->EncodeFloat(pPowerProServiceRequest->dblArg1, pszBuff))
    g_uiFileMapDataLen = strlen(pszBuff) + 1;
   break;

  case ppServiceDecodeFloat:

   dblVal = (g_ppsv->DecodeFloat(PP_STR_ARG(pPowerProServiceRequest, uiOffset1)));
   {
    g_uiFileMapDataLen = 8;
    *((double *) pszBuff) = dblVal;
   }
   break;
 }

 ZeroMemory(&cd, sizeof(cd));

 if (g_uiFileMapDataLen == 0)
  return TRUE; 

 if (g_uiFileMapDataLen > g_uiFileMapLen)
 {
  g_uiFileMapLen = g_uiFileMapDataLen * 2;
  if (g_pMem) UnmapViewOfFile(g_pMem);
  if (g_hFileMapping) CloseHandle(g_hFileMapping);

  g_hFileMapping = CreateFileMapping((HANDLE) 0xFFFFFFFF, NULL, PAGE_READWRITE, 0, g_uiFileMapLen, FILE_MAP_NAME);
  if (g_hFileMapping)
  {
//If is zero, the entire file is mapped.                       dwNumberOfBytesToMap 
   g_pMem = MapViewOfFile(g_hFileMapping, FILE_MAP_WRITE, 0, 0, 0); 
  }

 } // if (g_uiFileMapDataLen > g_uiFileMapLen)

 if (!g_pMem)
  return TRUE;

 strcpy((LPSTR) g_pMem, pszBuffPtr);
 FlushViewOfFile(g_pMem, g_uiFileMapDataLen);
 return TRUE;
}

//////////////////////////////////////////////////////////////////////////
//do nothing, loads dll

PPSERVICES_API PPSERVICE_DECLARE(start)
{
 return;
}

//////////////////////////////////////////////////////////////////////////
//do nothing, loads dll

PPSERVICES_API PPSERVICE_DECLARE(go)
{
 return;
}

//////////////////////////////////////////////////////////////////////////
// whether to display error dialog
//////////////////////////////////////////////////////////////////////////
/*
PPSERVICES_API PPSERVICE_DECLARE(error_dialog_on)
{
 LPCSTR lpFuncName = STRINGIFY(JOIN(PLUGIN_NAME,.error_dialog_on));

#ifndef PP_PPSV_SNDMSG
 resultType aResult = g_pVarRestoreManager->init(STRINGIFY(PLUGIN_NAME), ppsv,  resultOK, resultErrBadPowerProVersion);
#else
 resultType aResult = g_pVarRestoreManager->getInitResult();
#endif

 if (aResult == resultOK)
  g_pVarRestoreManager->useErrorDialog(true);
 
 g_pVarRestoreManager->setMsg(lpFuncName, aResult, aResult == resultOK, aResult != resultOK,
	                  NULL, ppsv, PP_PLUGIN_RET);

 return;

}

//////////////////////////////////////////////////////////////////////////

PPSERVICES_API PPSERVICE_DECLARE(error_dialog_off)
{
 LPCSTR lpFuncName = STRINGIFY(JOIN(PLUGIN_NAME,.error_dialog_off));

#ifndef PP_PPSV_SNDMSG
 resultType aResult = g_pVarRestoreManager->init(STRINGIFY(PLUGIN_NAME), ppsv,  resultOK, resultErrBadPowerProVersion);
#else
 resultType aResult = g_pVarRestoreManager->getInitResult();
#endif

 if (aResult == resultOK)
   g_pVarRestoreManager->useErrorDialog(false);

 g_pVarRestoreManager->setMsg(lpFuncName, aResult, aResult == resultOK, aResult != resultOK,
	                  NULL, ppsv, PP_PLUGIN_RET);
 return;
}

//////////////////////////////////////////////////////////////////////////

PPSERVICES_API PPSERVICE_DECLARE(config)
{
 LPCSTR lpFuncName = STRINGIFY(JOIN(PLUGIN_NAME,.config));
 if (!g_pVarRestoreManager->bServiceArgCntOK(nargs != 1, lpFuncName, SetVar, ppsv, PP_PLUGIN_RET)) return;
 g_pVarRestoreManager->resetConfigDone();
 resultType aResult = g_pVarRestoreManager->config(ppsv, PP_PLUGIN_ARG1);  // , PP_PLUGIN_ARG2

 g_pVarRestoreManager->setMsg(lpFuncName, aResult, aResult == resultOK, aResult != resultOK, // false
	                      NULL, ppsv, PP_PLUGIN_RET);
}

//////////////////////////////////////////////////////////////////////////

PPSERVICES_API PPSERVICE_DECLARE(version)
{
 strcpy(PP_PLUGIN_RET, g_pVarRestoreManager->getVersion());
}


//////////////////////////////////////////////////////////////////////////

*/