#if ! defined( POWERPRO_PLUGIN_PPSERVICES_HEADER )

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
// ppRegistry: a PowerPro Plugin to access the registry
// version 1.17beta	 21 Dec 2002

// Copyright (C) 2002 by Alan Campbell
// All rights reserved
//
// Distribute freely, except: don't remove my name from the source or
// documentation (don't take credit for my work), mark your changes (don't
// get me blamed for your possible bugs), don't alter or remove this
// notice.

// No warranty of any kind, express or implied, is included with this
// software; use at your own risk, responsibility for damages (if any) to
// anyone resulting from the use of this software rests entirely with the
// user.
//
// Send bug reports, bug fixes, enhancements, requests, flames, etc., and
// I'll try to keep a version up to date.  I can be reached as follows:
//    ppRegistry@AlanCampbellLists.fsnet.co.uk

// And thanks to Marko Bozikovic: I stole this comment header, and the
// macros below, from him.

/////////////////////////////////////////////////////////////////////////////

#define POWERPRO_PLUGIN_PPSERVICES_HEADER

//#include "..\..\Common\stdafx.h"
#include <windows.h>

#include "..\..\Common\PowerProDefines.h"


#ifdef PPSERVICES_EXPORTS
#define PPSERVICES_API __declspec(dllexport)
#else
#define PPSERVICES_API __declspec(dllimport)
#endif

//#define PP_ARG(basePtr, n) ((LPSTR) basePtr + sizeof(struct PowerProServiceRequest) + 4 + (PP_VAR_SIZE + 1) * n)
//#define PP_RET(basePtr)    ((LPSTR) basePtr + sizeof(struct PowerProServiceRequest) + 4)
#define PP_STR_ARG(P_BASE_PTR, OFFSET_MEMBER) (((LPSTR) P_BASE_PTR) + P_BASE_PTR->OFFSET_MEMBER)

#define MSG_TO_SERVICE_PLUGIN_TO_GET_DWORD_RESULT      WM_USER + 505
#define MSG_TO_SERVICE_PLUGIN_TO_GET_STRING_RESULT_LEN WM_USER + 506

enum PowerproServType 
{
 ppServiceNone = 1, 
 ppServiceStaticVarExists = 2, 
 ppServiceGetStaticVar = 3,
 ppServiceSetStaticVar = 4, 
 ppServiceGetVarSize = 5,
 ppServiceVarExists = 6, 
 ppServiceGetVar = 7,
 ppServiceSetVar = 8, 
 ppServiceGetCurrentDir = 9,
 ppServiceMatchCaption  = 10,
 ppServiceFindMatchingWindow = 11,
 ppServiceEvalExpr = 12,
 ppServiceIsRolled = 13,
 ppServiceIsTrayMinned = 14,
 ppServiceEncodeFloat = 15,
 ppServiceDecodeFloat = 16
};


struct PowerProServiceRequest
{
 enum ppServiceType  ppServType;
 union {DWORD dwArg1; UINT uiOffset1; double dblArg1;};
 union {DWORD dwArg2; UINT uiOffset2;};
 union {DWORD dwArg3; UINT uiOffset3;};
 union {DWORD dwArg4; UINT uiOffset4;}; 
};

#define FILE_MAP_NAME "PowerProServicesMappedFile"

#ifdef __cplusplus

extern "C"
{
/*
// PPSERVICES_API PPSERVICE_DECLARE(test);

 PPSERVICES_API PPSERVICE_DECLARE(save);

 PPSERVICES_API PPSERVICE_DECLARE(save_var);

 PPSERVICES_API PPSERVICE_DECLARE(restore);

 PPSERVICES_API PPSERVICE_DECLARE(restore_var);

 PPSERVICES_API PPSERVICE_DECLARE(chars_to_hex_encode);


 PPSERVICES_API PPSERVICE_DECLARE(error_dialog_on);

 PPSERVICES_API PPSERVICE_DECLARE(error_dialog_off);

 PPSERVICES_API PPSERVICE_DECLARE(config);

 PPSERVICES_API PPSERVICE_DECLARE(version);

*/
}

#endif // __cplusplus



#endif //  ! defined( POWERPRO_PLUGIN_PPSERVICES_HEADER )

