#include "ppServicesClient.h"
#include "ppServices.h"


/////////////////////////////////////////////////////////////////////////////

BOOL ppMatchCaption(HWND hwnd, LPSTR pszCaptionList, HWND hwndServer)
{
 COPYDATASTRUCT cd;
 struct PowerProServiceRequest* pPowerProServiceRequest;

 UINT uiBufLen = sizeof(struct PowerProServiceRequest) + strlen(pszCaptionList) + 1;
 cd.lpData = _alloca(uiBufLen);
 ZeroMemory(cd.lpData, uiBufLen);
 cd.cbData = uiBufLen; // sizeof(struct PowerProServiceRequest);
 pPowerProServiceRequest = (struct PowerProServiceRequest*) cd.lpData;

 pPowerProServiceRequest->ppServType = ppServiceMatchCaption;
 pPowerProServiceRequest->dwArg1 = (DWORD) hwnd;
 pPowerProServiceRequest->uiOffset2 = sizeof(struct PowerProServiceRequest);
 strcpy(PP_STR_ARG(pPowerProServiceRequest, uiOffset2), pszCaptionList);

 if (SendMessage(hwndServer, WM_COPYDATA, (WPARAM) NULL, (LPARAM) &cd))
  return SendMessage(hwndServer, MSG_TO_SERVICE_PLUGIN_TO_GET_DWORD_RESULT, 0, 0);
 else
  return FALSE;
}

/////////////////////////////////////////////////////////////////////////////

HWND ppFindMatchingWindow(LPSTR pszCaptionList, BOOL bHidden, HWND hwndServer)
{
 COPYDATASTRUCT cd;
 struct PowerProServiceRequest* pPowerProServiceRequest;
 UINT uiBufLen = sizeof(struct PowerProServiceRequest) + strlen(pszCaptionList) + 1;
 cd.lpData = _alloca(uiBufLen);
 ZeroMemory(cd.lpData, uiBufLen);
 cd.cbData = uiBufLen; // sizeof(struct PowerProServiceRequest);
 pPowerProServiceRequest = (struct PowerProServiceRequest*) cd.lpData;
 pPowerProServiceRequest->ppServType = ppServiceFindMatchingWindow;

 pPowerProServiceRequest->uiOffset1 = sizeof(struct PowerProServiceRequest);
 strcpy(PP_STR_ARG(pPowerProServiceRequest, uiOffset1), pszCaptionList);

 pPowerProServiceRequest->dwArg2 = bHidden;

 if (SendMessage(hwndServer, WM_COPYDATA, (WPARAM) NULL, (LPARAM) &cd))
  return (HWND) SendMessage(hwndServer, MSG_TO_SERVICE_PLUGIN_TO_GET_DWORD_RESULT, 0, 0);
 else
  return FALSE;
}

/////////////////////////////////////////////////////////////////////////////

BOOL ppIsRolled(HWND hwnd, HWND hwndServer)
{
 COPYDATASTRUCT cd;
 struct PowerProServiceRequest* pPowerProServiceRequest;
 UINT uiBufLen = sizeof(struct PowerProServiceRequest);
 cd.lpData = _alloca(uiBufLen);
 ZeroMemory(cd.lpData, uiBufLen);
 cd.cbData = uiBufLen; // sizeof(struct PowerProServiceRequest);
 pPowerProServiceRequest = (struct PowerProServiceRequest*) cd.lpData;

 pPowerProServiceRequest->ppServType = ppServiceIsRolled;
 pPowerProServiceRequest->dwArg1 = (DWORD) hwnd;

 if (SendMessage(hwndServer, WM_COPYDATA, (WPARAM) NULL, (LPARAM) &cd))
  return SendMessage(hwndServer, MSG_TO_SERVICE_PLUGIN_TO_GET_DWORD_RESULT, 0, 0);
 else
  return FALSE;
}

/////////////////////////////////////////////////////////////////////////////

BOOL ppIsTrayMinned(HWND hwnd, HWND hwndServer)
{
 COPYDATASTRUCT cd;
 struct PowerProServiceRequest* pPowerProServiceRequest;
 UINT uiBufLen = sizeof(struct PowerProServiceRequest);
 cd.lpData = _alloca(uiBufLen);
 cd.cbData = uiBufLen; // sizeof(struct PowerProServiceRequest);
 pPowerProServiceRequest = (struct PowerProServiceRequest*) cd.lpData;

 pPowerProServiceRequest->ppServType = ppServiceIsTrayMinned;
 pPowerProServiceRequest->dwArg1 = (DWORD) hwnd;

 if (SendMessage(hwndServer, WM_COPYDATA, (WPARAM) NULL, (LPARAM) &cd))
  return SendMessage(hwndServer, MSG_TO_SERVICE_PLUGIN_TO_GET_DWORD_RESULT, 0, 0);
 else
  return FALSE;
}

/////////////////////////////////////////////////////////////////////////////

BOOL ppStaticVarExists(LPSTR pszName, LPSTR pszScript, HWND hwndServer)
{
 COPYDATASTRUCT cd;
 struct PowerProServiceRequest* pPowerProServiceRequest;
 UINT uiBufLen = sizeof(struct PowerProServiceRequest) + 
                  strlen(pszName) + strlen(pszScript) + 2;
 cd.lpData = _alloca(uiBufLen);
 ZeroMemory(cd.lpData, uiBufLen);
 cd.cbData = uiBufLen; // sizeof(struct PowerProServiceRequest);
 pPowerProServiceRequest = (struct PowerProServiceRequest*) cd.lpData;

 pPowerProServiceRequest->ppServType = ppServiceStaticVarExists;

 pPowerProServiceRequest->uiOffset1 = sizeof(struct PowerProServiceRequest);
 strcpy(PP_STR_ARG(pPowerProServiceRequest, uiOffset1), pszName);
 pPowerProServiceRequest->uiOffset2 = 
  pPowerProServiceRequest->uiOffset1 + strlen(pszName) + 1;
 strcpy(PP_STR_ARG(pPowerProServiceRequest, uiOffset2), pszScript);

 if (SendMessage(hwndServer, WM_COPYDATA, (WPARAM) NULL, (LPARAM) &cd))
  return SendMessage(hwndServer, MSG_TO_SERVICE_PLUGIN_TO_GET_DWORD_RESULT, 0, 0);
 else
  return FALSE;
}

/////////////////////////////////////////////////////////////////////////////

BOOL ppGetStaticVar(LPSTR pszName, LPSTR pszScript, HWND hwndServer)
{
 COPYDATASTRUCT cd;
 struct PowerProServiceRequest* pPowerProServiceRequest;
 UINT uiBufLen = sizeof(struct PowerProServiceRequest) + 
                   strlen(pszName) + strlen(pszScript) + 2;

 cd.lpData = _alloca(uiBufLen);
 ZeroMemory(cd.lpData, uiBufLen);
 cd.cbData = uiBufLen; // sizeof(struct PowerProServiceRequest);
 pPowerProServiceRequest = (struct PowerProServiceRequest*) cd.lpData;

 pPowerProServiceRequest->ppServType = ppServiceGetStaticVar;

 pPowerProServiceRequest->uiOffset1 = sizeof(struct PowerProServiceRequest);
 strcpy(PP_STR_ARG(pPowerProServiceRequest, uiOffset1), pszName);
 pPowerProServiceRequest->uiOffset2 = 
  pPowerProServiceRequest->uiOffset1 + strlen(pszName) + 1;
 strcpy(PP_STR_ARG(pPowerProServiceRequest, uiOffset2), pszScript);

 return SendMessage(hwndServer, WM_COPYDATA, (WPARAM) NULL, (LPARAM) &cd);
}

/////////////////////////////////////////////////////////////////////////////

BOOL ppSetStaticVar(LPSTR pszName, LPSTR pszScript, LPSTR szVal, BOOL bCreate, HWND hwndServer)
{
 COPYDATASTRUCT cd;
 struct PowerProServiceRequest* pPowerProServiceRequest;
 UINT uiBufLen = sizeof(struct PowerProServiceRequest) + 
                   strlen(pszName) + strlen(pszScript) + strlen(szVal) + 3;

 cd.lpData = _alloca(uiBufLen);
 ZeroMemory(cd.lpData, uiBufLen);
 cd.cbData = uiBufLen; // sizeof(struct PowerProServiceRequest);
 pPowerProServiceRequest = (struct PowerProServiceRequest*) cd.lpData;

 pPowerProServiceRequest->ppServType = ppServiceSetStaticVar;

 pPowerProServiceRequest->uiOffset1 = sizeof(struct PowerProServiceRequest);
 strcpy(PP_STR_ARG(pPowerProServiceRequest, uiOffset1), pszName);

 pPowerProServiceRequest->uiOffset2 = 
  pPowerProServiceRequest->uiOffset1 + strlen(pszName) + 1;
 strcpy(PP_STR_ARG(pPowerProServiceRequest, uiOffset2), pszScript);

 pPowerProServiceRequest->uiOffset3 = 
  pPowerProServiceRequest->uiOffset2 + strlen(pszScript) + 1;
 strcpy(PP_STR_ARG(pPowerProServiceRequest, uiOffset3), szVal);

 pPowerProServiceRequest->dwArg4 = bCreate;

 if (SendMessage(hwndServer, WM_COPYDATA, (WPARAM) NULL, (LPARAM) &cd))
  return SendMessage(hwndServer, MSG_TO_SERVICE_PLUGIN_TO_GET_DWORD_RESULT, 0, 0);
 else
  return FALSE;
}

/////////////////////////////////////////////////////////////////////////////

UINT ppGetVarSize(LPSTR pszVar, HWND hwndServer)
{
 COPYDATASTRUCT cd;
 struct PowerProServiceRequest* pPowerProServiceRequest;
 UINT uiBufLen = sizeof(struct PowerProServiceRequest) + strlen(pszVar) + 1;

 cd.lpData = _alloca(uiBufLen);
 ZeroMemory(cd.lpData, uiBufLen);
 cd.cbData = uiBufLen; // sizeof(struct PowerProServiceRequest);
 pPowerProServiceRequest = (struct PowerProServiceRequest*) cd.lpData;

 pPowerProServiceRequest->ppServType = ppServiceGetVarSize;

 pPowerProServiceRequest->uiOffset1 = sizeof(struct PowerProServiceRequest);
 strcpy(PP_STR_ARG(pPowerProServiceRequest, uiOffset1), pszVar);

 if (SendMessage(hwndServer, WM_COPYDATA, (WPARAM) NULL, (LPARAM) &cd))
  return SendMessage(hwndServer, MSG_TO_SERVICE_PLUGIN_TO_GET_DWORD_RESULT, 0, 0);
 else
  return FALSE;
}

/////////////////////////////////////////////////////////////////////////////

BOOL ppVarExists(LPSTR pszVar, HWND hwndServer)
{
 COPYDATASTRUCT cd;
 struct PowerProServiceRequest* pPowerProServiceRequest;
 UINT uiBufLen = sizeof(struct PowerProServiceRequest) + strlen(pszVar) + 1;

 cd.lpData = _alloca(uiBufLen);
 ZeroMemory(cd.lpData, uiBufLen);
 cd.cbData = uiBufLen; // sizeof(struct PowerProServiceRequest);
 pPowerProServiceRequest = (struct PowerProServiceRequest*) cd.lpData;

 pPowerProServiceRequest->ppServType = ppServiceVarExists;

 pPowerProServiceRequest->uiOffset1 = sizeof(struct PowerProServiceRequest);
 strcpy(PP_STR_ARG(pPowerProServiceRequest, uiOffset1), pszVar);

 if (SendMessage(hwndServer, WM_COPYDATA, (WPARAM) NULL, (LPARAM) &cd))
  return SendMessage(hwndServer, MSG_TO_SERVICE_PLUGIN_TO_GET_DWORD_RESULT, 0, 0);
 else
  return FALSE;
}

/////////////////////////////////////////////////////////////////////////////

BOOL ppGetVar(LPSTR pszVar, HWND hwndServer)
{
 COPYDATASTRUCT cd;
 struct PowerProServiceRequest* pPowerProServiceRequest;
 UINT uiBufLen = sizeof(struct PowerProServiceRequest) + PP_VAR_NAME_SIZE + 1;
 cd.lpData = _alloca(uiBufLen);
 ZeroMemory(cd.lpData, uiBufLen);
 cd.cbData = uiBufLen; // sizeof(struct PowerProServiceRequest);
 pPowerProServiceRequest = (struct PowerProServiceRequest*) cd.lpData;

 pPowerProServiceRequest->ppServType = ppServiceGetVar;

 pPowerProServiceRequest->uiOffset1 = sizeof(struct PowerProServiceRequest);
 strcpy(PP_STR_ARG(pPowerProServiceRequest, uiOffset1), pszVar);

 return SendMessage(hwndServer, WM_COPYDATA, (WPARAM) NULL, (LPARAM) &cd);
}

/////////////////////////////////////////////////////////////////////////////

VOID ppSetVar(LPSTR pszVar, LPSTR pszValue, HWND hwndServer)
{
 COPYDATASTRUCT cd;
 struct PowerProServiceRequest* pPowerProServiceRequest;
 UINT uiBufLen = sizeof(struct PowerProServiceRequest) + 
                 strlen(pszVar) + strlen(pszValue) + 2;
 cd.lpData = _alloca(uiBufLen);
 ZeroMemory(cd.lpData, uiBufLen);
 cd.cbData = uiBufLen; // sizeof(struct PowerProServiceRequest);
 pPowerProServiceRequest = (struct PowerProServiceRequest*) cd.lpData;

 pPowerProServiceRequest->ppServType = ppServiceSetVar;

 pPowerProServiceRequest->uiOffset1 = sizeof(struct PowerProServiceRequest);
 strcpy(PP_STR_ARG(pPowerProServiceRequest, uiOffset1), pszVar);

 pPowerProServiceRequest->uiOffset2 = 
  pPowerProServiceRequest->uiOffset1 + strlen(pszVar) + 1;
 strcpy(PP_STR_ARG(pPowerProServiceRequest, uiOffset2), pszValue);

 SendMessage(hwndServer, WM_COPYDATA, (WPARAM) NULL, (LPARAM) &cd);
}

/////////////////////////////////////////////////////////////////////////////

BOOL ppGetCurrentDir(HWND hwnd, HWND hwndServer)
{
 COPYDATASTRUCT cd;
 struct PowerProServiceRequest* pPowerProServiceRequest;
 UINT uiBufLen = sizeof(struct PowerProServiceRequest); 

 cd.lpData = _alloca(uiBufLen);
 ZeroMemory(cd.lpData, uiBufLen);
 cd.cbData = uiBufLen; // sizeof(struct PowerProServiceRequest);
 pPowerProServiceRequest = (struct PowerProServiceRequest*) cd.lpData;

 pPowerProServiceRequest->ppServType = ppServiceGetCurrentDir;

 pPowerProServiceRequest->dwArg1 = (DWORD) hwnd;

 return SendMessage(hwndServer, WM_COPYDATA, (WPARAM) NULL, (LPARAM) &cd);
}

/////////////////////////////////////////////////////////////////////////////

BOOL ppEvalExpr(LPSTR pszExpr, HWND hwndServer)
{
 COPYDATASTRUCT cd;
 struct PowerProServiceRequest* pPowerProServiceRequest;
 UINT uiBufLen = sizeof(struct PowerProServiceRequest) + PP_VAR_SIZE + 1;

 cd.lpData = _alloca(uiBufLen);
 ZeroMemory(cd.lpData, uiBufLen);
 cd.dwData = 0;
 cd.cbData = uiBufLen; // sizeof(struct PowerProServiceRequest);
 pPowerProServiceRequest = (struct PowerProServiceRequest*) cd.lpData;

 pPowerProServiceRequest->ppServType = ppServiceEvalExpr;
 pPowerProServiceRequest->uiOffset1 = sizeof(struct PowerProServiceRequest);
 strcpy(PP_STR_ARG(pPowerProServiceRequest, uiOffset1), pszExpr);

 return SendMessage(hwndServer, WM_COPYDATA, (WPARAM) NULL, (LPARAM) &cd);
}

/////////////////////////////////////////////////////////////////////////////
 
BOOL ppEncodeFloat(double dblVal, HWND hwndServer)
{
 COPYDATASTRUCT cd;
 struct PowerProServiceRequest* pPowerProServiceRequest;
 UINT uiBufLen = sizeof(struct PowerProServiceRequest); 

 cd.lpData = _alloca(uiBufLen);
 ZeroMemory(cd.lpData, uiBufLen);
 cd.cbData = uiBufLen; // sizeof(struct PowerProServiceRequest);
 pPowerProServiceRequest = (struct PowerProServiceRequest*) cd.lpData;

 pPowerProServiceRequest->ppServType = ppServiceEncodeFloat;
 pPowerProServiceRequest->dblArg1 = dblVal;
 return SendMessage(hwndServer, WM_COPYDATA, (WPARAM) NULL, (LPARAM) &cd);
}

/////////////////////////////////////////////////////////////////////////////

BOOL ppDecodeFloat(LPSTR pszEncodedFloat, HWND hwndServer)
{
 COPYDATASTRUCT cd;
 struct PowerProServiceRequest* pPowerProServiceRequest;
 UINT uiBufLen = sizeof(struct PowerProServiceRequest) + strlen(pszEncodedFloat) + 1;

 cd.lpData = _alloca(uiBufLen);
 ZeroMemory(cd.lpData, uiBufLen);
 cd.cbData = uiBufLen; // sizeof(struct PowerProServiceRequest);
 pPowerProServiceRequest = (struct PowerProServiceRequest*) cd.lpData;

 pPowerProServiceRequest->ppServType = ppServiceDecodeFloat;
 pPowerProServiceRequest->uiOffset1 = sizeof(struct PowerProServiceRequest);
 strcpy(PP_STR_ARG(pPowerProServiceRequest, uiOffset1), pszEncodedFloat);
 return SendMessage(hwndServer, WM_COPYDATA, (WPARAM) NULL, (LPARAM) &cd);
}

/////////////////////////////////////////////////////////////////////////////
//service routines used by any of above that return a string
/////////////////////////////////////////////////////////////////////////////

LPSTR getMappedFile(HWND hwnd, OUT PHANDLE phmem)
{
 *phmem = OpenFileMapping(FILE_MAP_ALL_ACCESS, FALSE, FILE_MAP_NAME);
 if (*phmem)
 {   
  UINT uiFileMapDataLen = SendMessage(hwnd, MSG_TO_SERVICE_PLUGIN_TO_GET_STRING_RESULT_LEN, 0, 0);
//If is zero, the entire file is mapped.                        dwNumberOfBytesToMap 
  return (LPSTR) MapViewOfFile(*phmem, FILE_MAP_ALL_ACCESS, 0, 0, uiFileMapDataLen);
 }
 return NULL;
}

//////////////////////////////////////////////////////////////////////////

void closeMappedFile(LPSTR pszFileMap, HANDLE hmem)
{
 if (pszFileMap) UnmapViewOfFile(pszFileMap);
 if (hmem)       CloseHandle(hmem);
}

//////////////////////////////////////////////////////////////////////////
