// ppServicesClient.cpp : Defines the entry point for the console application.
//

#include <windows.h>
#include <stdio.h>
#include <malloc.h>

#include "..\ppServices.h"
#include "..\ppServicesClient.h"


//BOOL makeWin(IN HINSTANCE hinstDLL);
//LRESULT CALLBACK windowProc(HWND, UINT, WPARAM, LPARAM);
//LRESULT acceptRq(HWND hwnd, PCOPYDATASTRUCT pCd);

//TO DO KILL IF SEND \MESSAGES WORK WITH NULL WIN HANDLE
//static HWND g_hwndPowerProServicesReplyWin = NULL;               

char szClassName[] = "PowerProServicesClientWinClass";

//////////////////////////////////////////////////////////////////////////

int main(int argc, char* argv[])
{
 HWND hwndServer = NULL;
 HWND hwndNotepad;
 HWND hwndPowerPro = NULL;
 COPYDATASTRUCT cd;
 HINSTANCE hinst = GetModuleHandle(NULL);
 HANDLE hmem;
 LPSTR pszFileMap;
 UINT uiFileMapDataLen = 0;

 hwndPowerPro = FindWindow("PowerProMain",NULL);
 if (!hwndPowerPro)
 { 
  printf("PowerPro not running");
  return 0;
 }

//makeWin(hinst); // sets g_hwndPowerProServicesReplyWin

 ZeroMemory(&cd, sizeof(COPYDATASTRUCT));
 cd.lpData = "ppservices.start";
 cd.dwData = 1;
 cd.cbData = strlen(cd.lpData) + 1; 

 SendMessage(hwndPowerPro, WM_COPYDATA, (WPARAM) NULL, (LPARAM) &cd); //g_hwndPowerProServicesReplyWin

 hwndServer = FindWindow("PowerProServicesServerWinClass", "PowerProServicesServerWin");
 if (!hwndServer)
  return 0;

//===================================================

 if (ppEvalExpr("pprofolder", hwndServer))
 {
  pszFileMap = getMappedFile(hwndServer, &hmem);
  if (pszFileMap)
   printf("pprofolder is: %s\n", pszFileMap);
  closeMappedFile(pszFileMap, hmem);
 } 

//===================================================

 if (ppGetVar("g_ppServicesTest", hwndServer))
 {
  pszFileMap = getMappedFile(hwndServer, &hmem);
  if (pszFileMap)
   printf("global variable g_ppServicesTest is: %s\n", pszFileMap);
  closeMappedFile(pszFileMap, hmem);
 } 

//===================================================

 if (ppGetStaticVar("st_ppServicesTest", "ppServicesDemoScript", hwndServer))
 {
  pszFileMap = getMappedFile(hwndServer, &hmem);
  if (pszFileMap)
   printf("static variable st_ppServicesTest is: %s\n", pszFileMap);
  closeMappedFile(pszFileMap, hmem);
 } 

//===================================================

 if (ppGetStaticVecElement("st_ppServicesTestVec", "ppServicesDemoScript", 2, hwndServer))
 {
  pszFileMap = getMappedFile(hwndServer, &hmem);
  if (pszFileMap)
  {
   printf("third element of vec whose handle is in variable st_ppServicesTestVec is: %s\n", pszFileMap);
   printf("NB: this is in general dangerous because binary strings may not have terminating nulls\n"); 
   printf("but because I know this binary bloack was created from ascii string, it's safe\n");
   closeMappedFile(pszFileMap, hmem);
  }
 } 

//===================================================

 if (ppSetStaticVar("st_ppServicesTest", "ppServicesDemoScript", 
                    "new value of st_ppServicesTest", 0, hwndServer))
 {
  printf("static st_ppServicesTest changed successfully\n");
 } 


//===================================================

 if (ppGetStaticVar("st_ppServicesTest", "ppServicesDemoScript", hwndServer))
 {
  pszFileMap = getMappedFile(hwndServer, &hmem);
  if (pszFileMap)
   printf("modified static variable st_ppServicesTest is: %s\n", pszFileMap);
  closeMappedFile(pszFileMap, hmem);
 } 

//===================================================

 if (ppGetStaticVar("st_uString", "ppServicesDemoScript", hwndServer))
 {
  pszFileMap = getMappedFile(hwndServer, &hmem);
  if (pszFileMap)
  {
   MessageBoxW(NULL, (WCHAR*) pszFileMap, L"unicode pointed to by st_uString", MB_OK);
   closeMappedFile(pszFileMap, hmem);
  }
 } 

//===================================================

 if (ppGetStaticVar("st_hBin", "ppServicesDemoScript", hwndServer))
 {
  pszFileMap = getMappedFile(hwndServer, &hmem);
  if (pszFileMap)
  {
   printf("binary data pointed to by handle in variable st_hBin is: %s\n", pszFileMap);
   closeMappedFile(pszFileMap, hmem);
  }
 } 

//===================================================

 hwndNotepad = ppFindMatchingWindow("=notepad", 0, hwndServer);
 printf("handle to notepad window: %x\n", hwndNotepad);

//===================================================

 if (ppEncodeFloat(32.46, hwndServer))
 {
  pszFileMap = getMappedFile(hwndServer, &hmem);
  if (pszFileMap)
  {
   printf("32.46 encoded is: %s\n", pszFileMap);
   if (ppDecodeFloat(pszFileMap, hwndServer))
   {
    pszFileMap = getMappedFile(hwndServer, &hmem);
    if (pszFileMap)
     printf("32.46 encoded and decoded comes back is: %f\n", *((double*) pszFileMap));
   }
/*
   if (ppDecodeFloat(pszFileMap, hwndServer))
   {
    pszFileMap = getMappedFile(hwndServer, &hmem);
    if (pszFileMap)
     printf("32.46 encoded and decoded comes back is: %f\n", *( (double*) pszFileMap));
   }
*/
  }
  closeMappedFile(pszFileMap, hmem);
 } 

//===================================================

 printf("Hit any key to exit");
 getchar();
 return 0;
}

//////////////////////////////////////////////////////////////////////////

/*
BOOL makeWin(IN HINSTANCE hinstDLL)
{
//MSG messages;            // Here messages to the application are saved 
 WNDCLASSEX wincl;        // Data structure for the windowclass 

 wincl.hInstance = hinstDLL; // hThisInstance;
 wincl.lpszClassName = szClassName;
 wincl.lpfnWndProc = windowProc;      // This function is called by windows 
 wincl.style = CS_DBLCLKS;            // Catch double-clicks 
 wincl.cbSize = sizeof (WNDCLASSEX);

 // Use default icon and mouse-pointer 
 wincl.hIcon = LoadIcon (NULL, IDI_APPLICATION);
 wincl.hIconSm = LoadIcon (NULL, IDI_APPLICATION);
 wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
 wincl.lpszMenuName = NULL;                 // No menu 
 wincl.cbClsExtra = 0;                      // No extra bytes after the window class 
 wincl.cbWndExtra = 0;                      // structure or the window instance 
// Use Windows's default color as the background of the window 
 wincl.hbrBackground = (HBRUSH) COLOR_BACKGROUND;

// Register the window class, and if it fails quit the program 
 if (!RegisterClassEx (&wincl))
     return FALSE;

// The class is registered, let's create the program
 g_hwndPowerProServicesReplyWin = CreateWindowEx(
        0,                   // Extended possibilites for variation 
        szClassName,         // Classname 
        "PowerProServicesServerWin",       // Title Text 
        WS_OVERLAPPEDWINDOW, // default window 
        CW_USEDEFAULT,       // Windows decides the position 
        CW_USEDEFAULT,       // where the window ends up on the screen 
        544,                 // The programs width 
        375,                 // and height in pixels 
        HWND_DESKTOP,      // HWND_DESKTOP,         The window is a child-window to desktop 
        NULL,                // No menu 
        hinstDLL,            //  Program Instance handler 
        NULL                 // No Window Creation data 
        );

 if (!g_hwndPowerProServicesReplyWin)
  return FALSE;

 ShowWindow(g_hwndPowerProServicesReplyWin, SW_HIDE);


 return TRUE;
}
//////////////////////////////////////////////////////////////////////////

LRESULT CALLBACK windowProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
 switch (message)                  //handle the messages 
 {
  case WM_COPYDATA:

   return acceptRq((HWND) wParam, (PCOPYDATASTRUCT) lParam);           


//  case WM_DESTROY:

//   PostQuitMessage (0);       // send a WM_QUIT to the message queue 
//   break;

  default:                      // for messages that we don't deal with 
   return DefWindowProc (hwnd, message, wParam, lParam);
 }

 return 0;
}

//////////////////////////////////////////////////////////////////////////

LRESULT acceptRq(HWND hwnd, PCOPYDATASTRUCT pCd)
{
 DWORD dwResult = 0;
 if (pCd->lpData)
 {
 }
 else
 {
 }
 return 0;
}
*/