//19k with MFC: 28k without


// call enum stuff with no keys, means continue
//ditto more calls to getvalue for muti string

// To save memory if multiple plugins are loaded,
// consider using the dll msvcrt.dll of standard dll services by compiling with library MSVCRT.LIB
// and link options /nodefaultlib:"libcmt".
//DONE?

/////////////////////////////////////////////////////////////////////////////
// ppRegistry: a PowerPro Plugin to access the registry

// version 1.17beta	 21 Dec 2002
//
// Copyright (C) 2002 by Alan Campbell
// All rights reserved
//
// Distribute freely, except: don't remove my name from the source or
// documentation (don't take credit for my work), mark your changes (don't
// get me blamed for your possible bugs), don't alter or remove this
// notice.

// No warranty of any kind, express or implied, is included with this
// software; use at your own risk, responsibility for damages (if any) to
// anyone resulting from the use of this software rests entirely with the
// user.
//
// Send bug reports, bug fixes, enhancements, requests, flames, etc., and
// I'll try to keep a version up to date.  I can be reached as follows:
//    ppRegistry@AlanCampbellLists.fsnet.co.uk

// And thanks to Marko Bozikovic: I stole this comment header from him.

/////////////////////////////////////////////////////////////////////////////

//#include "..\..\Common\stdafx.h"
#include <windows.h>

#include "ppServices.h"
#include "powerProDefines.h"
//#include <crtdbg.h>
#include <stdio.h> //sprinf

#define ISALPHA(c) (c >= 'a' && c <= 'z')

#include "vec\vec.h"

#include "unicode\handleCollection.h"

#include "binary\handleCollection.h"
#include "binary\byteBlock.h"
#include "binary\binaryFormat.h"

//static enum PowerproServType g_PowerproServTypeLast = ppServiceNone;

//enum LastResultType {lastResultNone, lastResultDW, lastResultString);

static PPROSERVICES*                     g_ppsv = NULL;

static HWND                              g_hwndPowerPro = NULL;
static HWND                              g_hwndPowerProServicesWin = NULL;               

char                                     g_pszClassName[] = "PowerProServicesServerWinClass";

HANDLE                                   g_hFileMapping = NULL;
LPVOID                                   g_pMem = NULL;
UINT                                     g_uiFileMapDataLen = 0;
UINT                                     g_uiFileMapLen = 4096;
DWORD                                    g_dwResult = (DWORD) -1;
static CHAR                              g_pszLastHandle[20];

//LastResultType                           g_lastResultType = lastResultNone;

static HMODULE                           g_hmodule_vec = NULL;
static VECSERVICES*                      g_pVecServices = NULL;

static HMODULE                           g_hmodule_binary = NULL;
static struct BYTEBLOCK_INVAR_SERVICES*  g_pByteBlockInVarServices = NULL;
static struct BYTEBLOCK_HANDLE_SERVICES* g_pByteBlockWithHandleServices = NULL;

static CHAR                              g_pszDllVer[10];

static HMODULE                           g_hmodule_unicode = NULL;
static struct PPUNICODESERVICES*         g_pUnicodeServices = NULL;

BOOL             makeWin(IN HINSTANCE hinstDLL);
LRESULT CALLBACK windowProc(HWND, UINT, WPARAM, LPARAM);
LRESULT          dispatchRqToPowerPro(HWND hwnd, struct PowerProServiceRequest* pPowerProServiceRequest);

void             errorArg(IN LPCSTR pszEnum, UINT uiArg);

void             setVersion(IN HINSTANCE hinstDLL, IN LPCTSTR pszPluginName);

//stuff to deal with other plugins

void             unloadDlls();

BOOL             setDllAccess(IN LPSTR pszPluginName, 
                              IN LPSTR pszProcName, 
                              INOUT HMODULE* phModule,
                              INOUT LPVOID* ppPointerBlock);

void             unloadDll(INOUT HMODULE* phModule);
HMODULE          loadDLLincrUse(LPSTR dll_name);

BOOL             bVarNameOk(IN LPSTR pszVarName);

BOOL             vecCheck(    IN LPSTR pszVarName, IN LPSTR pszScriptStatic, OUT LPSTR pszHandle);
BOOL             unicodeCheck(IN LPSTR pszVarName, IN LPSTR pszScriptStatic, OUT LPSTR pszHandle);
BOOL             binaryCheck( IN LPSTR pszVarName, IN LPSTR pszScriptStatic, OUT LPSTR pszHandle);

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

// Main DLL entry point.  Save handle to main PowerPro window.
BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD dwReason, LPVOID lpvReserved)
{
 if(dwReason == DLL_PROCESS_ATTACH)
 {
  g_hwndPowerPro = FindWindow("PowerProMain",NULL);
//instantiate singletons
//pVarSaveManager = getInstance("ini_status","#");

#ifdef PP_PPSV_SNDMSG
  if (g_hwndPowerPro)
   g_ppsv = (PPROSERVICES*) SendMessage(g_hwndPowerPro, WM_USER+501, 0,0);
#endif

  setVersion(hinstDLL, "ppservices");
  makeWin(hinstDLL);

  g_hFileMapping = CreateFileMapping((HANDLE) 0xFFFFFFFF, NULL, PAGE_READWRITE, 0, g_uiFileMapLen, FILE_MAP_NAME);
  if (g_hFileMapping)
  {
//If is zero, the entire file is mapped.                       dwNumberOfBytesToMap 
   g_pMem = MapViewOfFile(g_hFileMapping, FILE_MAP_WRITE, 0, 0, 0); 
  }

  setDllAccess("vec", "getVecServices", &g_hmodule_vec, (LPVOID*) &g_pVecServices);

  setDllAccess("binary", "getByteBlockInVarServices", &g_hmodule_binary, 
               (LPVOID*) &g_pByteBlockInVarServices);

  if (!g_pByteBlockInVarServices)
   setDllAccess("binary", "getByteBlockWithHandleServices", &g_hmodule_binary, 
                (LPVOID*) &g_pByteBlockWithHandleServices);

  setDllAccess("unicode", "getUnicodeServices", &g_hmodule_unicode, 
               (LPVOID*) &g_pUnicodeServices);

 }
 else if(dwReason == DLL_PROCESS_DETACH)
 {
//close any windows, unregister any classes
  if (g_hwndPowerProServicesWin) DestroyWindow(g_hwndPowerProServicesWin); 
  if (g_pMem) UnmapViewOfFile(g_pMem);
  if (g_hFileMapping) CloseHandle(g_hFileMapping);
//destroy singleton; takes out PowerProVarManager singleton via base class destructor
 }

 return TRUE;
}

//////////////////////////////////////////////////////////////////////////

BOOL makeWin(IN HINSTANCE hinstDLL)
{
//MSG messages;            /* Here messages to the application are saved */
 WNDCLASSEX wincl;        /* Data structure for the windowclass */

 /* The Window structure */
 wincl.hInstance = hinstDLL; // hThisInstance;
 wincl.lpszClassName = g_pszClassName;
 wincl.lpfnWndProc = windowProc;      /* This function is called by windows */
 wincl.style = CS_DBLCLKS;            /* Catch double-clicks */
 wincl.cbSize = sizeof (WNDCLASSEX);

 /* Use default icon and mouse-pointer */
 wincl.hIcon = LoadIcon (NULL, IDI_APPLICATION);
 wincl.hIconSm = LoadIcon (NULL, IDI_APPLICATION);
 wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
 wincl.lpszMenuName = NULL;                 /* No menu */
 wincl.cbClsExtra = 0;                      /* No extra bytes after the window class */
 wincl.cbWndExtra = 0;                      /* structure or the window instance */
 /* Use Windows's default color as the background of the window */
 wincl.hbrBackground = (HBRUSH) COLOR_BACKGROUND;

 /* Register the window class, and if it fails quit the program */
 if (!RegisterClassEx (&wincl))
     return FALSE;

 /* The class is registered, let's create the program*/
 g_hwndPowerProServicesWin = CreateWindowEx(
        0,                   /* Extended possibilites for variation */
        g_pszClassName,         /* Classname */
        "PowerProServicesServerWin",       /* Title Text */
        WS_OVERLAPPEDWINDOW, /* default window */
        CW_USEDEFAULT,       /* Windows decides the position */
        CW_USEDEFAULT,       /* where the window ends up on the screen */
        544,                 /* The programs width */
        375,                 /* and height in pixels */
        g_hwndPowerPro,      // HWND_DESKTOP,        
        NULL,                /* No menu */
        hinstDLL,            // hThisInstance,       /* Program Instance handler */
        NULL                 /* No Window Creation data */
        );

 if (!g_hwndPowerProServicesWin)
  return FALSE;

 ShowWindow(g_hwndPowerProServicesWin, SW_HIDE);
 return TRUE;
}

/*
LPSTR ppStrArg(struct PowerProServiceRequest* pPowerProServiceRequest, UINT uiOff) 
{
 if P_BASE_PTR->OFFSET_MEMBER ? (((LPSTR) P_BASE_PTR) + P_BASE_PTR->ad[OFFSET_MEMBER].uiOff) : "")
*/
//////////////////////////////////////////////////////////////////////////

LRESULT CALLBACK windowProc(HWND hwnd, UINT uiMsg, WPARAM wParam, LPARAM lParam)
{
 PCOPYDATASTRUCT pCOPYDATASTRUCT;
 struct PowerProServiceRequest* pPowerProServiceRequest;
 UINT ui, uiSize, uiPowerProServiceRequestsize = sizeof(struct PowerProServiceRequest);
 uiSize = uiPowerProServiceRequestsize;

 switch (uiMsg)                  /* handle the messages */
 {
  case WM_COPYDATA:

   pCOPYDATASTRUCT = (PCOPYDATASTRUCT) lParam;
   pPowerProServiceRequest = (struct PowerProServiceRequest*) pCOPYDATASTRUCT->lpData;

   for (ui = 0; ui < ARG_DATA_CNT; ui++)
   {
//  if (pPowerProServiceRequest->ad[ui].dwLen != (DWORD) -1)
//  {
     uiSize += pPowerProServiceRequest->ad[ui].dwLen;
//  } 
   }

   if (uiSize != pCOPYDATASTRUCT->cbData)
    return 0;
   
   return dispatchRqToPowerPro((HWND) wParam, pPowerProServiceRequest);           

  case MSG_TO_SERVICE_PLUGIN_TO_GET_DWORD_RESULT:

   return g_dwResult;

  case MSG_TO_SERVICE_PLUGIN_TO_GET_STRING_RESULT_LEN:

   return g_uiFileMapDataLen;

   break;
/*
  case WM_DESTROY:

   PostQuitMessage (0);       // send a WM_QUIT to the uiMsg queue 
   break;
*/
  default:                      /* for messages that we don't deal with */
   return DefWindowProc (hwnd, uiMsg, wParam, lParam);
 }

 return 0;
}

//////////////////////////////////////////////////////////////////////////

LRESULT dispatchRqToPowerPro(HWND hwnd, struct PowerProServiceRequest* pPowerProServiceRequest)
{
 CHAR pszBuff[PP_VAR_SIZE+1];
 LPVOID pvBuffPtr = pszBuff;
 CHAR pszHandle[10];

 COPYDATASTRUCT cd;
 double dblVal = 0.0;

 g_dwResult = (DWORD) -1;
 g_uiFileMapDataLen = 0;
 *pszBuff = 0;
 *g_pszLastHandle = 0;

 *((LPSTR) g_pMem) = 0;
 FlushViewOfFile(g_pMem, g_uiFileMapDataLen);

 switch (pPowerProServiceRequest->ppServType)
 {
  case ppServiceGetVarSize:

   if (PP_STR_ARG_PRESENT(pPowerProServiceRequest, 0))
    g_dwResult = (DWORD) g_ppsv->GetVarSize(PP_STR_ARG(pPowerProServiceRequest, 0));
   else
    errorArg("ppServiceGetVarSize ", 0);

   return TRUE; //data will be recovered via MSG_TO_SERVICE_PLUGIN_TO_GET_DWORD_RESULT:

  case ppServiceVarExists:

   if (PP_STR_ARG_PRESENT(pPowerProServiceRequest, 0) && PP_STR_ARG_PRESENT(pPowerProServiceRequest, 1))
    pvBuffPtr =
      g_ppsv->GetStaticVarAddr(PP_STR_ARG(pPowerProServiceRequest,0),
                               PP_STR_ARG(pPowerProServiceRequest, 1));
   else if (PP_STR_ARG_PRESENT(pPowerProServiceRequest, 0))
    pvBuffPtr =
      g_ppsv->GetVarAddr(PP_STR_ARG(pPowerProServiceRequest, 0));
   else
    errorArg("ppServiceVarExists", 0);

   g_dwResult = pvBuffPtr != NULL;
   return TRUE; //data will be recovered via MSG_TO_SERVICE_PLUGIN_TO_GET_DWORD_RESULT:

  case ppServiceGetVar:

   if (!PP_STR_ARG_PRESENT(pPowerProServiceRequest, 0))
   {
    errorArg("ppServiceGetVar", 0);
    return TRUE; 
   }

   if (vecCheck(PP_STR_ARG(pPowerProServiceRequest, 0), 
                PP_STR_ARG(pPowerProServiceRequest, 1), pszHandle))
   {
    g_pVecServices->vec_get(pszHandle, pPowerProServiceRequest->ad[2].dw, (LPSTR*) &pvBuffPtr);
    strcpy(g_pszLastHandle, pszHandle);
   }
   else if (unicodeCheck(PP_STR_ARG(pPowerProServiceRequest, 0), 
                         PP_STR_ARG(pPowerProServiceRequest, 1), pszHandle))
   {
    WCHAR* pswzPtr = g_pUnicodeServices->get(pszHandle);
    g_uiFileMapDataLen = (wcslen(pswzPtr) + 1) * sizeof(WCHAR);
    pvBuffPtr = pswzPtr;
    strcpy(g_pszLastHandle, pszHandle);
   }
   else if (binaryCheck(PP_STR_ARG(pPowerProServiceRequest, 0), 
                        PP_STR_ARG(pPowerProServiceRequest, 1), pszHandle))
   {
    struct ByteBlockData* pByteBlockData;
    pByteBlockData = g_pByteBlockWithHandleServices->get(pszHandle, g_ppsv);
    if (pByteBlockData)
    {
     g_uiFileMapDataLen = pByteBlockData->iLen;
     pvBuffPtr = pByteBlockData->pbData;
     strcpy(g_pszLastHandle, pszHandle);
    }
   }
   else if (PP_STR_ARG_PRESENT(pPowerProServiceRequest, 1))
    pvBuffPtr =
      g_ppsv->GetStaticVarAddr(PP_STR_ARG(pPowerProServiceRequest,0),
                               PP_STR_ARG(pPowerProServiceRequest, 1));
   else
   {
    LPSTR pszPtr = PP_STR_ARG(pPowerProServiceRequest, 0); 
    pvBuffPtr =
      g_ppsv->GetVarAddr(PP_STR_ARG(pPowerProServiceRequest, 0));
   }

   g_dwResult = pvBuffPtr != NULL;
   if (pvBuffPtr && !g_uiFileMapDataLen)
    g_uiFileMapDataLen = strlen((LPSTR) pvBuffPtr) + 1;

   break;


  case ppServiceSetVar:

   if (!PP_STR_ARG_PRESENT(pPowerProServiceRequest, 0))
   {
    errorArg("ppServiceSetVar", 0);
    return TRUE; 
   }

   if (vecCheck(PP_STR_ARG(pPowerProServiceRequest, 0), 
                PP_STR_ARG(pPowerProServiceRequest, 1), pszHandle))
   {
    g_pVecServices->vec_set(pszHandle, pPowerProServiceRequest->ad[2].dw, 
                              PP_STR_ARG(pPowerProServiceRequest, 3));
   }
   else if (unicodeCheck(PP_STR_ARG(pPowerProServiceRequest, 0), 
                         PP_STR_ARG(pPowerProServiceRequest, 1), pszHandle))
   {
    g_pUnicodeServices->modify((WCHAR*) PP_STR_ARG(pPowerProServiceRequest, 2), 
                                pszHandle, g_ppsv);
   }
   else if (binaryCheck(PP_STR_ARG(pPowerProServiceRequest, 0), 
                        PP_STR_ARG(pPowerProServiceRequest, 1), pszHandle))
   {
    g_pByteBlockWithHandleServices->modify(pszHandle, 
                                           pPowerProServiceRequest->ad[3].dw,
                                           pPowerProServiceRequest->ad[3].dw,
                                           (BYTE*) PP_STR_ARG(pPowerProServiceRequest, 2), 
                                           g_ppsv);

   }
   else if (PP_STR_ARG_PRESENT(pPowerProServiceRequest, 1) && PP_STR_ARG_PRESENT(pPowerProServiceRequest, 2))
    g_dwResult = 
     (DWORD) g_ppsv->SetStaticVar(PP_STR_ARG(pPowerProServiceRequest, 0), 
                                  PP_STR_ARG(pPowerProServiceRequest, 1),
                                  PP_STR_ARG(pPowerProServiceRequest, 2), 
                                  pPowerProServiceRequest->ad[3].dw);

   else if (PP_STR_ARG_PRESENT(pPowerProServiceRequest, 1))
   {
    g_ppsv->SetVar(PP_STR_ARG(pPowerProServiceRequest, 0), 
                   PP_STR_ARG(pPowerProServiceRequest, 1));
    g_dwResult = 1;
   }
   else
    errorArg("ppServiceSetVar", 1);


   return TRUE; 


  case ppServiceGetCurrentDir:

   g_ppsv->GetCurrentDir((HWND) pPowerProServiceRequest->ad[0].dw, pszBuff);
   g_uiFileMapDataLen = strlen(pszBuff) + 1;
   break;


  case ppServiceMatchCaption:

   g_dwResult = 
      (DWORD) g_ppsv->MatchCaption((HWND) pPowerProServiceRequest->ad[0].dw, 
                                          PP_STR_ARG(pPowerProServiceRequest, 1));
   return TRUE; //data will be recovered via MSG_TO_SERVICE_PLUGIN_TO_GET_DWORD_RESULT:


  case ppServiceFindMatchingWindow:

   g_dwResult = 
    (DWORD) g_ppsv->FindMatchingWindow(PP_STR_ARG(pPowerProServiceRequest, 0), 
                                       pPowerProServiceRequest->ad[1].dw);
   return TRUE; //data will be recovered via MSG_TO_SERVICE_PLUGIN_TO_GET_DWORD_RESULT:


  case ppServiceEvalExpr:

   if (!PP_STR_ARG_PRESENT(pPowerProServiceRequest, 0))
   {
    errorArg("ppServiceEvalExpr", 0);
    return TRUE;
   }

   if (g_ppsv->EvalExpr(PP_STR_ARG(pPowerProServiceRequest, 0), pszBuff))
    g_uiFileMapDataLen = strlen(pszBuff) + 1;
   break;


  case ppServiceIsRolled:

   g_dwResult = 
    (DWORD) (g_ppsv->IsRolled((HWND) pPowerProServiceRequest->ad[0].dw));
   return TRUE; //data will be recovered via MSG_TO_SERVICE_PLUGIN_TO_GET_DWORD_RESULT:


  case ppServiceIsTrayMinned:

   g_dwResult = 
    (DWORD) (g_ppsv->IsTrayMinned((HWND) pPowerProServiceRequest->ad[0].dw));
   return TRUE; //data will be recovered via MSG_TO_SERVICE_PLUGIN_TO_GET_DWORD_RESULT:


  case ppServiceEncodeFloat:

   if (g_ppsv->EncodeFloat(pPowerProServiceRequest->dblArg, pszBuff))
    g_uiFileMapDataLen = strlen(pszBuff) + 1;
   break;


  case ppServiceDecodeFloat:

   if (!PP_STR_ARG_PRESENT(pPowerProServiceRequest, 0))
   {
    errorArg("ppServiceDecodeFloat", 0);
    return TRUE;
   }

   dblVal = (g_ppsv->DecodeFloat(PP_STR_ARG(pPowerProServiceRequest, 0)));
   {
    g_uiFileMapDataLen = 8;
    *((double *) pszBuff) = dblVal;
   }
   break;

 }

 ZeroMemory(&cd, sizeof(cd));

 if (g_uiFileMapDataLen == 0)
  return TRUE; 

 if (g_uiFileMapDataLen > g_uiFileMapLen)
 {
  g_uiFileMapLen = g_uiFileMapDataLen * 2;
  if (g_pMem) UnmapViewOfFile(g_pMem);
  if (g_hFileMapping) CloseHandle(g_hFileMapping);

  g_hFileMapping = CreateFileMapping((HANDLE) 0xFFFFFFFF, NULL, PAGE_READWRITE, 0, g_uiFileMapLen, FILE_MAP_NAME);
  if (g_hFileMapping)
  {
//If is zero, the entire file is mapped.                       dwNumberOfBytesToMap 
   g_pMem = MapViewOfFile(g_hFileMapping, FILE_MAP_WRITE, 0, 0, 0); 
  }

 } // if (g_uiFileMapDataLen > g_uiFileMapLen)

 if (!g_pMem)
  return TRUE;

 memcpy(g_pMem, pvBuffPtr, g_uiFileMapDataLen);
 FlushViewOfFile(g_pMem, g_uiFileMapDataLen);
 return TRUE;
}

//////////////////////////////////////////////////////////////////////////

void errorArg(IN LPCSTR pszEnum, UINT uiArg)
{
 CHAR pszBuff1[256];
 CHAR pszBuff2[256];
 sprintf(pszBuff1, "ppServices plugin: %s option", pszEnum);
 sprintf(pszBuff2, "string argument %d missing", uiArg + 1);
 g_ppsv->ErrMessage(pszBuff1, pszBuff2);
 g_dwResult = 0;
 return;
}

//////////////////////////////////////////////////////////////////////////

void setVersion(IN HINSTANCE hinstDLL, IN LPCTSTR pszPluginName)
{
 CHAR pszExt[_MAX_EXT];
 CHAR pszDir[_MAX_DIR];
 CHAR pszFname[_MAX_FNAME];
 CHAR pszBuffFN[MAX_PATH + 1];
 DWORD dwHandle = 0, dwSize = 0;
 LPSTR pszVerInfo = NULL;
 LPSTR pszDllVer = NULL;
 LPSTR pszBuffVerName = NULL; 
 LPSTR pszPtr = NULL;
 VOID* pBuffVerName;
 UINT uiLen, i = 0;

 *g_pszDllVer = 0;
 if (!GetModuleFileName(hinstDLL, pszBuffFN, MAX_PATH + 1))
  return;
//TO DO  THIS IS A FUDGE, CAUSE FOR DLL GET hinstDLL FOR POWERPRO.EXE, NOT DLL
 _splitpath(pszBuffFN, NULL, pszDir, pszFname, pszExt);
 if (stricmp(pszExt, ".exe") == 0)
  sprintf(pszBuffFN, "%s\\plugins\\%s.dll", pszDir, pszPluginName);

 dwSize = GetFileVersionInfoSize(pszBuffFN, &dwHandle);
 if (!dwSize)
  return;

 pszVerInfo = (LPSTR) _alloca(dwSize + 1);
 GetFileVersionInfo(pszBuffFN, 0, dwSize + 1, pszVerInfo); 
 if (!VerQueryValue(pszVerInfo,        // address of buffer for version resource 
                 TEXT("\\StringFileInfo\\080904b0\\FileVersion"),   // address of value to retrieve 
                 &pBuffVerName,  // address of buffer for version pointer 
                 &uiLen))          // address of version-value length buffer 
  return;

 pszDllVer = g_pszDllVer;
 pszBuffVerName = (LPSTR) pBuffVerName;
 for (i = 0; i < uiLen; i++)
 {
  if (*(pszBuffVerName + i) >= '0' && *(pszBuffVerName + i) <= '9')
  {
   *pszDllVer = *(pszBuffVerName + i);
   pszDllVer++;
  }
 }  
 *pszDllVer = 0;
}

//////////////////////////////////////////////////////////////////////////

void unloadDll(INOUT HMODULE* phModule)
{
 if (*phModule)
 {
  FreeLibrary(*phModule);
  *phModule = NULL;
 }
}

//////////////////////////////////////////////////////////////////////////

BOOL setDllAccess(IN LPSTR pszPluginName, 
                  IN LPSTR pszProcName, 
                  INOUT HMODULE* phModule,
                  INOUT LPVOID* ppPointerBlock)
{
 CHAR pszPluginBuff[100];
 if (ppPointerBlock) *ppPointerBlock = NULL;

 unloadDll(phModule);

 sprintf(pszPluginBuff, "plugins\\%s", pszPluginName);
 *phModule = loadDLLincrUse(pszPluginBuff);

 if (!(*phModule))
   *phModule = loadDLLincrUse(pszPluginName);

 if (!(*phModule))
  return FALSE;
 else
 {
  if (pszProcName && *pszProcName && ppPointerBlock)
  { 
   FARPROC fp = GetProcAddress(*phModule, pszProcName);
   if (fp)
    *ppPointerBlock = (LPVOID) fp();

   if (*ppPointerBlock == NULL)
   {
//  debugMsg(__FILE__, __LINE__);
	return FALSE;
   }
  }
 }
 return TRUE;
}

//////////////////////////////////////////////////////////////////////////

HMODULE loadDLLincrUse(LPSTR dll_name)
{
 HMODULE h = NULL;
 HINSTANCE hi = LoadLibraryA(dll_name); 
 if (hi)
  h = GetModuleHandleA(dll_name);
 return h;
}

//////////////////////////////////////////////////////////////////////////

void unloadDlls()
{
 if (g_hmodule_vec) 
 {
  g_pVecServices = NULL;
  FreeLibrary(g_hmodule_vec);
  g_hmodule_vec = NULL;
 }

 if (g_hmodule_binary) 
 {
  g_pByteBlockInVarServices = NULL;
  g_pByteBlockWithHandleServices = NULL;
  FreeLibrary(g_hmodule_binary);
  g_hmodule_binary = NULL;
 }

 if (g_hmodule_unicode) 
 {
  g_pUnicodeServices = NULL;
  FreeLibrary(g_hmodule_unicode);
  g_hmodule_unicode = NULL;
 }
}

//////////////////////////////////////////////////////////////////////////

BOOL bVarNameOk(IN LPSTR pszVarName)
{
 UINT n, i; 	
 CHAR c;
 if (g_ppsv->GetVarAddr(pszVarName))
  return TRUE;	
 
 n = strlen(pszVarName);
 if (n > PP_VAR_NAME_SIZE || n == 0)
   return FALSE;
 c = tolower(*pszVarName);
 if (!ISALPHA(c)) // first char must be letter
   return FALSE;

 for (i = 0; i < n; i++)  //PP's variable names can be no more than 63 chars long
 { 
  c = tolower(*pszVarName + i);
  if (!(ISALPHA(c) || c == '_' || (c >= '0' && c <= '9')))
    return FALSE;
  pszVarName++;
 }
 return TRUE;	
}

//////////////////////////////////////////////////////////////////////////

/*

BOOL checkForHandle(IN LPSTR pszVarName, IN LPSTR pszScriptStatic)
{
 if (*pszVarName)
 {
  if (!vecCheck(pszVarName, pszScriptStatic)) // sets g_pszVecHan
  {
   if (!binaryCheck(pszVarName, pszScriptStatic, g_pszBinaryHan)) // sets g_pszBinaryHan; pass local version in CPipe::getDataForTx
     unicodeCheck(pszVarName, pszScriptStatic, g_pszUnicodeHan);  // sets g_pszUnicodeHan; pass local version in CPipe::getDataForTx
  }

  if (!(*g_pszVecHan || *g_pszUnicodeHan || *g_pszBinaryHan || 
        bVarNameOk(pszVarName))) 
    return false;

  strcpy(g_pszVarName, pszVarName);
  strcpy(g_pszScriptStatic, pszScriptStatic);
 }
 else
  *g_pszVarName = *g_pszScriptStatic = *g_pszVecHan = *g_pszBinaryHan = *g_pszUnicodeHan = 0;

 return TRUE;
}


//////////////////////////////////////////////////////////////////////////

BOOL bReturnByVarOrScript()
{
 return *g_pszVarName || *g_pszScriptStatic || *g_pszScriptToCallPre || 
        *g_pszScriptToCallPost || *g_pszVecHan || *g_pszBinaryHan || *g_pszUnicodeHan;
}

//////////////////////////////////////////////////////////////////////////

BYTE* getDataForTx(IN LPSTR pszScriptStatic, IN LPSTR pszData, DWORD* pdwCount)
{
 CHAR pszUnicodeHan[20];
 CHAR pszBinaryHan[20];
 if (binaryCheck(pszData, pszScriptStatic, pszBinaryHan)) // sets g_pszBinaryHan
 {
  ByteBlockData* pByteBlockData = g_pByteBlockWithHandleServices->get(pszBinaryHan, g_ppsv);
  if (pByteBlockData && pByteBlockData->iLen) 
  {
   *pdwCount = pByteBlockData->iLen;
   return pByteBlockData->pbData;
  }
  else
   return NULL;
 }
 else if (unicodeCheck(pszData, pszScriptStatic, pszUnicodeHan))
 {
  LPWSTR pszwText = g_pUnicodeServices->get(pszUnicodeHan);
  if (pszwText)
   *pdwCount = wcslen(pszwText) * sizeof(WCHAR);
  return (BYTE*) pszwText;
 }
 else
 {
  *pdwCount = strlen(pszData);
  return (BYTE*) pszData;
 }
}
*/
//////////////////////////////////////////////////////////////////////////

BOOL 
binaryCheck(IN LPSTR pszVarName, IN LPSTR pszScriptStatic, OUT LPSTR pszHandle)
{
 LPTSTR pszVarVal = NULL;

 if (g_pByteBlockInVarServices && !g_pByteBlockWithHandleServices)
  return FALSE;

 *pszHandle = 0;

 if (bVarNameOk(pszVarName))
  pszVarVal = (pszScriptStatic && *pszScriptStatic) ? g_ppsv->GetStaticVarAddr(pszVarName, pszScriptStatic) :
                      g_ppsv->GetVarAddr(pszVarName);
 
 if (g_pByteBlockWithHandleServices)
 {
  if (g_pByteBlockWithHandleServices->get(pszVarName, g_ppsv))
  {
   strcpy(pszHandle, pszVarName);
   return TRUE;
  }
  else
  {
   if (pszVarVal && g_pByteBlockWithHandleServices->get(pszVarVal, g_ppsv))
   {
    strcpy(pszHandle, pszVarVal);
    return TRUE;
   }
  }
 } // if (g_pByteBlockWithHandleServices)

 if (g_pByteBlockInVarServices)
 {
  if (g_pByteBlockInVarServices->getCurrSizeVarBuff(pszVarName, g_ppsv))
   return TRUE; // TO DO
  else
  {
   if (pszVarVal && g_pByteBlockInVarServices->getCurrSizeVarBuff(pszVarVal, g_ppsv))
    return TRUE;
  }
 } // if (g_pByteBlockWithHandleServices)

 return FALSE;
}

//////////////////////////////////////////////////////////////////////////
/*
void binarySet(IN BYTE* pbMsg, IN DWORD dwBytesRead)
{
 if (!(*g_pszBinaryHan))
  return;

 if (!dwBytesRead)
  return;

 PBYTE pbResult = (PBYTE) malloc(dwBytesRead);
 if (!pbResult)
  return;

 memcpy(pbResult, pbMsg, dwBytesRead); // +i*lx

 if (*g_pszBinaryHan)
  g_pByteBlockWithHandleServices->modify(g_pszBinaryHan, dwBytesRead, dwBytesRead, pbResult, g_ppsv);
}
*/
//////////////////////////////////////////////////////////////////////////

BOOL unicodeCheck(IN LPSTR pszVarName, IN LPSTR pszScriptStatic, OUT LPSTR pszHandle)
{
 if (!g_pUnicodeServices)
  return FALSE;
 *pszHandle = 0;

 if (g_pUnicodeServices->get(pszVarName))
 {
  strcpy(pszHandle, pszVarName);
  return TRUE;
 }
 else
 {
  LPTSTR pszVarVal = NULL;
  if (bVarNameOk(pszVarName))
   pszVarVal = (pszScriptStatic && *pszScriptStatic) ? g_ppsv->GetStaticVarAddr(pszVarName, pszScriptStatic) :
                      g_ppsv->GetVarAddr(pszVarName);

  if (pszVarVal && g_pUnicodeServices->get(pszVarVal))
  {
   strcpy(pszHandle, pszVarVal);
   return TRUE;
  }
 }
 return FALSE;
}

//////////////////////////////////////////////////////////////////////////
/*
void unicodeSet(IN WCHAR* pszwMsg)
{
 if (!(*g_pszUnicodeHan))
  return;

 UINT uiLen = g_pUnicodeServices->getsize(g_pszUnicodeHan);
 if (uiLen > wcslen(pszwMsg))
 {
  WCHAR* pszwBuff = g_pUnicodeServices->get(g_pszUnicodeHan);
  wcscpy(pszwBuff, pszwMsg);
  return;
 }

 CHAR pszUnicodeHan[20];
 strcpy(pszUnicodeHan, g_pszUnicodeHan);
 g_pUnicodeServices->modify(pszwMsg, pszUnicodeHan, g_ppsv); 

 if (stricmp(g_pszUnicodeHan, pszUnicodeHan) == 0)
  return;

 // happens if try to turn null unicode string into something else
 if (*g_pszVarName)
 {
  if (*g_pszScriptStatic)
    g_ppsv->SetStaticVar(g_pszVarName, g_pszScriptStatic, pszUnicodeHan, 1);
  else
    g_ppsv->SetVar(g_pszVarName, pszUnicodeHan);
 }

 strcpy(g_pszUnicodeHan, pszUnicodeHan);

 return;
}
*/
//////////////////////////////////////////////////////////////////////////

BOOL vecCheck(IN LPSTR pszVarName, IN LPSTR pszScriptStatic, OUT LPSTR pszHandle)
{
 if (!g_pVecServices)
  return FALSE;
 *pszHandle = 0;

 if (g_pVecServices->vec_exists(pszVarName))
 {
  strcpy(pszHandle, pszVarName);
  return TRUE;
 }
 else
 {
  LPTSTR pszVarVal = NULL;
  if (bVarNameOk(pszVarName))
   pszVarVal = (pszScriptStatic && *pszScriptStatic) ? 
                g_ppsv->GetStaticVarAddr(pszVarName, pszScriptStatic) :
                g_ppsv->GetVarAddr(pszVarName);

  if (pszVarVal && g_pVecServices->vec_exists(pszVarVal))
  {
   strcpy(pszHandle, pszVarVal);
   return TRUE;
  }
 }
 return FALSE;
}

//////////////////////////////////////////////////////////////////////////
/*
void vecSet(IN LPSTR pszMsg)
{
//UINT nItems = g_pVecServices->vec_capacity(g_pszVecHan);
//BOOL bGrows = g_pVecServices->vec_grows(g_pszVecHan);

 LPSTR pszMsgPtr = getNextLine(pszMsg);
 while (pszMsgPtr)
 {
  if (*pszMsgPtr)
   g_pVecServices->vec_set(g_pszVecHan, g_uiVecItem++, pszMsgPtr);
//if (!bGrows && iVecItem > nItems)
// return xxxxxx;
  pszMsgPtr = getNextLine();
 } 
}

*/

//////////////////////////////////////////////////////////////////////////

PPSERVICES_API PPSERVICE_DECLARE(last_string_result)
{
 if (*g_pszLastHandle)
  strcpy(PP_PLUGIN_RET, g_pszLastHandle);
 else if (g_pMem)
 {
  int iLen = strlen(g_pMem);
  if (iLen < PP_VAR_SIZE)
   strcpy(PP_PLUGIN_RET, g_pMem);
  else
  {
   LPSTR lpTemp = g_ppsv->AllocTemp(iLen + 1);
   strcpy(lpTemp, g_pMem);
   g_ppsv->ReturnString(lpTemp, szArgs);
  }
 }
 return;
}

//////////////////////////////////////////////////////////////////////////

PPSERVICES_API PPSERVICE_DECLARE(last_numeric_result)
{
 ltoa(g_dwResult, PP_PLUGIN_RET, 10);
 return;
}

//////////////////////////////////////////////////////////////////////////

PPSERVICES_API PPSERVICE_DECLARE(version)
{
 strcpy(PP_PLUGIN_RET, g_pszDllVer);
 return;
}

//////////////////////////////////////////////////////////////////////////
//do nothing, loads dll

PPSERVICES_API PPSERVICE_DECLARE(start)
{
 return;
}

//////////////////////////////////////////////////////////////////////////
//do nothing, loads dll

PPSERVICES_API PPSERVICE_DECLARE(go)
{
 return;
}

//////////////////////////////////////////////////////////////////////////
// whether to display error dialog
//////////////////////////////////////////////////////////////////////////
/*
PPSERVICES_API PPSERVICE_DECLARE(error_dialog_on)
{
 LPCSTR lpFuncName = STRINGIFY(JOIN(PLUGIN_NAME,.error_dialog_on));

#ifndef PP_PPSV_SNDMSG
 resultType aResult = g_pVarRestoreManager->init(STRINGIFY(PLUGIN_NAME), ppsv,  resultOK, resultErrBadPowerProVersion);
#else
 resultType aResult = g_pVarRestoreManager->getInitResult();
#endif

 if (aResult == resultOK)
  g_pVarRestoreManager->useErrorDialog(true);
 
 g_pVarRestoreManager->setMsg(lpFuncName, aResult, aResult == resultOK, aResult != resultOK,
	                  NULL, ppsv, PP_PLUGIN_RET);

 return;

}

//////////////////////////////////////////////////////////////////////////

PPSERVICES_API PPSERVICE_DECLARE(error_dialog_off)
{
 LPCSTR lpFuncName = STRINGIFY(JOIN(PLUGIN_NAME,.error_dialog_off));

#ifndef PP_PPSV_SNDMSG
 resultType aResult = g_pVarRestoreManager->init(STRINGIFY(PLUGIN_NAME), ppsv,  resultOK, resultErrBadPowerProVersion);
#else
 resultType aResult = g_pVarRestoreManager->getInitResult();
#endif

 if (aResult == resultOK)
   g_pVarRestoreManager->useErrorDialog(false);

 g_pVarRestoreManager->setMsg(lpFuncName, aResult, aResult == resultOK, aResult != resultOK,
	                  NULL, ppsv, PP_PLUGIN_RET);
 return;
}

//////////////////////////////////////////////////////////////////////////

PPSERVICES_API PPSERVICE_DECLARE(config)
{
 LPCSTR lpFuncName = STRINGIFY(JOIN(PLUGIN_NAME,.config));
 if (!g_pVarRestoreManager->bServiceArgCntOK(nargs != 1, lpFuncName, SetVar, ppsv, PP_PLUGIN_RET)) return;
 g_pVarRestoreManager->resetConfigDone();
 resultType aResult = g_pVarRestoreManager->config(ppsv, PP_PLUGIN_ARG1);  // , PP_PLUGIN_ARG2

 g_pVarRestoreManager->setMsg(lpFuncName, aResult, aResult == resultOK, aResult != resultOK, // false
	                      NULL, ppsv, PP_PLUGIN_RET);
}



//////////////////////////////////////////////////////////////////////////
*/
