#include "ppServicesClient.h"
#include "ppServices.h"
//#include <glibc\stdlib.h>
#include <malloc.h>

#if defined (_MSC_VER)
 #define ALLOC _alloca
#else
 #define ALLOC malloc
#endif


/////////////////////////////////////////////////////////////////////////////

BOOL ppMatchCaption(HWND hwnd, LPSTR pszCaptionList, HWND hwndServer)
{
 COPYDATASTRUCT cd;
 LRESULT lResult = 0;
 struct PowerProServiceRequest* pPowerProServiceRequest;
 UINT uiPayload = strlen(pszCaptionList) + 1;
 UINT uiBufLen = sizeof(struct PowerProServiceRequest) + uiPayload;

 cd.lpData = (PVOID) ALLOC(uiBufLen);
 memset(cd.lpData, 0, uiBufLen);

 cd.cbData = uiBufLen; // sizeof(struct PowerProServiceRequest);
 pPowerProServiceRequest = (struct PowerProServiceRequest*) cd.lpData;

 pPowerProServiceRequest->ppServType = ppServiceMatchCaption;
 pPowerProServiceRequest->ad[0].dw = (DWORD) hwnd;
 pPowerProServiceRequest->ad[1].uiOff = sizeof(struct PowerProServiceRequest);
 strcpy(PP_STR_ARG(pPowerProServiceRequest, 1), pszCaptionList);

 if (SendMessage(hwndServer, WM_COPYDATA, (WPARAM) NULL, (LPARAM) &cd))
  lResult = SendMessage(hwndServer, MSG_TO_SERVICE_PLUGIN_TO_GET_DWORD_RESULT, 0, 0);

#if !defined (_MSC_VER)
 free((PVOID) cd.lpData);
#endif

 return lResult;
}

/////////////////////////////////////////////////////////////////////////////

HWND ppFindMatchingWindow(LPSTR pszCaptionList, BOOL bHidden, HWND hwndServer)
{
 COPYDATASTRUCT cd;
 HWND hwdResult = NULL;
 struct PowerProServiceRequest* pPowerProServiceRequest;
 UINT uiPayload = strlen(pszCaptionList) + 1;
 UINT uiBufLen = sizeof(struct PowerProServiceRequest) + uiPayload;

 cd.lpData = (PVOID) ALLOC(uiBufLen);
 memset(cd.lpData, 0, uiBufLen);

 cd.cbData = uiBufLen; // sizeof(struct PowerProServiceRequest);
 pPowerProServiceRequest = (struct PowerProServiceRequest*) cd.lpData;
 pPowerProServiceRequest->ppServType = ppServiceFindMatchingWindow;

 pPowerProServiceRequest->ad[0].uiOff = sizeof(struct PowerProServiceRequest);
 pPowerProServiceRequest->ad[0].dwLen = uiPayload;
 strcpy(PP_STR_ARG(pPowerProServiceRequest, 0), pszCaptionList);

 pPowerProServiceRequest->ad[1].dw = bHidden;

 if (SendMessage(hwndServer, WM_COPYDATA, (WPARAM) NULL, (LPARAM) &cd))
  hwdResult = (HWND) SendMessage(hwndServer, MSG_TO_SERVICE_PLUGIN_TO_GET_DWORD_RESULT, 0, 0);

#if !defined (_MSC_VER)
 free((PVOID) cd.lpData);
#endif

 return hwdResult;
}

/////////////////////////////////////////////////////////////////////////////

BOOL ppIsRolled(HWND hwnd, HWND hwndServer)
{
 COPYDATASTRUCT cd;
 LRESULT lResult = 0;
 struct PowerProServiceRequest* pPowerProServiceRequest;
 UINT uiBufLen = sizeof(struct PowerProServiceRequest);

 cd.lpData = (PVOID) ALLOC(uiBufLen);
 memset(cd.lpData, 0, uiBufLen);

 cd.cbData = uiBufLen; // sizeof(struct PowerProServiceRequest);
 pPowerProServiceRequest = (struct PowerProServiceRequest*) cd.lpData;

 pPowerProServiceRequest->ppServType = ppServiceIsRolled;
 pPowerProServiceRequest->ad[0].dw = (DWORD) hwnd;

 if (SendMessage(hwndServer, WM_COPYDATA, (WPARAM) NULL, (LPARAM) &cd))
  lResult = SendMessage(hwndServer, MSG_TO_SERVICE_PLUGIN_TO_GET_DWORD_RESULT, 0, 0);

#if !defined (_MSC_VER)
 free((PVOID) cd.lpData);
#endif

 return lResult;
}

/////////////////////////////////////////////////////////////////////////////

BOOL ppIsTrayMinned(HWND hwnd, HWND hwndServer)
{
 COPYDATASTRUCT cd;
 LRESULT lResult = 0;

 struct PowerProServiceRequest* pPowerProServiceRequest;
 UINT uiBufLen = sizeof(struct PowerProServiceRequest);

 cd.lpData = (PVOID) ALLOC(uiBufLen);
 memset(cd.lpData, 0, uiBufLen);

 cd.cbData = uiBufLen; // sizeof(struct PowerProServiceRequest);
 pPowerProServiceRequest = (struct PowerProServiceRequest*) cd.lpData;

 pPowerProServiceRequest->ppServType = ppServiceIsTrayMinned;
 pPowerProServiceRequest->ad[0].dw = (DWORD) hwnd;

 if (SendMessage(hwndServer, WM_COPYDATA, (WPARAM) NULL, (LPARAM) &cd))
  lResult = SendMessage(hwndServer, MSG_TO_SERVICE_PLUGIN_TO_GET_DWORD_RESULT, 0, 0);

#if !defined (_MSC_VER)
 free((PVOID) cd.lpData);
#endif

 return lResult;
}

/////////////////////////////////////////////////////////////////////////////

BOOL ppStaticVarExists(LPSTR pszName, LPSTR pszScript, HWND hwndServer)
{
 COPYDATASTRUCT cd;
 LRESULT lResult = 0;
 struct PowerProServiceRequest* pPowerProServiceRequest;
 UINT uiName = strlen(pszName) + 1;
 UINT uiScript = strlen(pszScript) + 1;
 UINT uiBufLen = sizeof(struct PowerProServiceRequest) + uiName  + uiScript;

 cd.lpData = (PVOID) ALLOC(uiBufLen);
 memset(cd.lpData, 0, uiBufLen);

 cd.cbData = uiBufLen; // sizeof(struct PowerProServiceRequest);
 pPowerProServiceRequest = (struct PowerProServiceRequest*) cd.lpData;

 pPowerProServiceRequest->ppServType = ppServiceGetVar;

 pPowerProServiceRequest->ad[0].uiOff = sizeof(struct PowerProServiceRequest);
 pPowerProServiceRequest->ad[0].dwLen = uiName;
 strcpy(PP_STR_ARG(pPowerProServiceRequest, 0), pszName);

 pPowerProServiceRequest->ad[1].uiOff = pPowerProServiceRequest->ad[0].uiOff + uiName;
 pPowerProServiceRequest->ad[1].dwLen = uiScript;
 strcpy(PP_STR_ARG(pPowerProServiceRequest, 1), pszScript);

 if (SendMessage(hwndServer, WM_COPYDATA, (WPARAM) NULL, (LPARAM) &cd))
  lResult = SendMessage(hwndServer, MSG_TO_SERVICE_PLUGIN_TO_GET_DWORD_RESULT, 0, 0);

#if !defined (_MSC_VER)
 free((PVOID) cd.lpData);
#endif

 return lResult;
}

/////////////////////////////////////////////////////////////////////////////

BOOL ppGetStaticVar(LPSTR pszName, LPSTR pszScript, HWND hwndServer)
{
 COPYDATASTRUCT cd;
 LRESULT lResult = 0;
 struct PowerProServiceRequest* pPowerProServiceRequest;
 UINT uiName = strlen(pszName) + 1;
 UINT uiScript = strlen(pszScript) + 1;
 UINT uiBufLen = sizeof(struct PowerProServiceRequest) + uiName  + uiScript;

 cd.lpData = (PVOID) ALLOC(uiBufLen);
 memset(cd.lpData, 0, uiBufLen);

 cd.cbData = uiBufLen; // sizeof(struct PowerProServiceRequest);
 pPowerProServiceRequest = (struct PowerProServiceRequest*) cd.lpData;

 pPowerProServiceRequest->ppServType = ppServiceGetVar;

 pPowerProServiceRequest->ad[0].uiOff = sizeof(struct PowerProServiceRequest);
 pPowerProServiceRequest->ad[0].dwLen = uiName;
 strcpy(PP_STR_ARG(pPowerProServiceRequest, 0), pszName);

 pPowerProServiceRequest->ad[1].uiOff = pPowerProServiceRequest->ad[0].uiOff + uiName;
 pPowerProServiceRequest->ad[1].dwLen = uiScript;
 strcpy(PP_STR_ARG(pPowerProServiceRequest, 1), pszScript);

 lResult = SendMessage(hwndServer, WM_COPYDATA, (WPARAM) NULL, (LPARAM) &cd);

#if !defined (_MSC_VER)
 free((PVOID) cd.lpData);
#endif

 return lResult;
}

/////////////////////////////////////////////////////////////////////////////

BOOL ppGetStaticVecElement(LPSTR pszName, LPSTR pszScript, UINT uiElem, HWND hwndServer)
{
 COPYDATASTRUCT cd;
 LRESULT lResult = 0;
 struct PowerProServiceRequest* pPowerProServiceRequest;
 UINT uiName = strlen(pszName) + 1;
 UINT uiScript = strlen(pszScript) + 1;
 UINT uiBufLen = sizeof(struct PowerProServiceRequest) + uiName  + uiScript;

 cd.lpData = (PVOID) ALLOC(uiBufLen);
 memset(cd.lpData, 0, uiBufLen);

 cd.cbData = uiBufLen; // sizeof(struct PowerProServiceRequest);
 pPowerProServiceRequest = (struct PowerProServiceRequest*) cd.lpData;

 pPowerProServiceRequest->ppServType = ppServiceGetVar;

 pPowerProServiceRequest->ad[0].uiOff = sizeof(struct PowerProServiceRequest);
 pPowerProServiceRequest->ad[0].dwLen = uiName;
 strcpy(PP_STR_ARG(pPowerProServiceRequest, 0), pszName);

 pPowerProServiceRequest->ad[1].uiOff = pPowerProServiceRequest->ad[0].uiOff + uiName;
 pPowerProServiceRequest->ad[1].dwLen = uiScript;
 strcpy(PP_STR_ARG(pPowerProServiceRequest, 1), pszScript);

 pPowerProServiceRequest->ad[2].dw = uiElem;

 lResult = SendMessage(hwndServer, WM_COPYDATA, (WPARAM) NULL, (LPARAM) &cd);

#if !defined (_MSC_VER)
 free((PVOID) cd.lpData);
#endif

 return lResult;
}

/////////////////////////////////////////////////////////////////////////////

BOOL ppSetStaticVar(LPSTR pszName, LPSTR pszScript, LPSTR pszVal, BOOL bCreate, HWND hwndServer)
{
 COPYDATASTRUCT cd;
 LRESULT lResult = 0;
 struct PowerProServiceRequest* pPowerProServiceRequest;
 UINT uiName =   strlen(pszName) + 1;
 UINT uiScript = strlen(pszScript) + 1;
 UINT uiVal =    strlen(pszVal) + 1;
 UINT uiBufLen = sizeof(struct PowerProServiceRequest) + uiName  + uiScript + uiVal;

 cd.lpData = (PVOID) ALLOC(uiBufLen);
 memset(cd.lpData, 0, uiBufLen);

 cd.cbData = uiBufLen; // sizeof(struct PowerProServiceRequest);
 pPowerProServiceRequest = (struct PowerProServiceRequest*) cd.lpData;

 pPowerProServiceRequest->ppServType = ppServiceSetVar;

 pPowerProServiceRequest->ad[0].uiOff = sizeof(struct PowerProServiceRequest);
 pPowerProServiceRequest->ad[0].dwLen = uiName;
 strcpy(PP_STR_ARG(pPowerProServiceRequest, 0), pszName);

 pPowerProServiceRequest->ad[1].uiOff = pPowerProServiceRequest->ad[0].uiOff + uiName;
 pPowerProServiceRequest->ad[1].dwLen = uiScript;
 strcpy(PP_STR_ARG(pPowerProServiceRequest, 1), pszScript);

 pPowerProServiceRequest->ad[2].uiOff = pPowerProServiceRequest->ad[1].uiOff + uiScript;
 pPowerProServiceRequest->ad[2].dwLen = uiVal;
 strcpy(PP_STR_ARG(pPowerProServiceRequest, 2), pszVal);

 pPowerProServiceRequest->ad[3].dw = bCreate;

 if (SendMessage(hwndServer, WM_COPYDATA, (WPARAM) NULL, (LPARAM) &cd))
  lResult = SendMessage(hwndServer, MSG_TO_SERVICE_PLUGIN_TO_GET_DWORD_RESULT, 0, 0);

#if !defined (_MSC_VER)
 free((PVOID) cd.lpData);
#endif

 return lResult;
}

/////////////////////////////////////////////////////////////////////////////

UINT ppGetVarSize(LPSTR pszVar, HWND hwndServer)
{
 COPYDATASTRUCT cd;
 LRESULT lResult = 0;
 struct PowerProServiceRequest* pPowerProServiceRequest;
 UINT uiVar = strlen(pszVar) + 1;
 UINT uiBufLen = sizeof(struct PowerProServiceRequest) + uiVar;

 cd.lpData = (PVOID) ALLOC(uiBufLen);
 memset(cd.lpData, 0, uiBufLen);

 cd.cbData = uiBufLen; // sizeof(struct PowerProServiceRequest);
 pPowerProServiceRequest = (struct PowerProServiceRequest*) cd.lpData;

 pPowerProServiceRequest->ppServType = ppServiceGetVarSize;

 pPowerProServiceRequest->ad[0].uiOff = sizeof(struct PowerProServiceRequest);
 pPowerProServiceRequest->ad[0].dwLen = uiVar;
 strcpy(PP_STR_ARG(pPowerProServiceRequest, 0), pszVar);

 if (SendMessage(hwndServer, WM_COPYDATA, (WPARAM) NULL, (LPARAM) &cd))
  lResult = SendMessage(hwndServer, MSG_TO_SERVICE_PLUGIN_TO_GET_DWORD_RESULT, 0, 0);

#if !defined (_MSC_VER)
 free((PVOID) cd.lpData);
#endif

 return lResult;
}

/////////////////////////////////////////////////////////////////////////////

BOOL ppVarExists(LPSTR pszVar, HWND hwndServer)
{
 COPYDATASTRUCT cd;
 LRESULT lResult = 0;
 struct PowerProServiceRequest* pPowerProServiceRequest;
 UINT uiVar = strlen(pszVar) + 1;
 UINT uiBufLen = sizeof(struct PowerProServiceRequest) + uiVar;

 cd.lpData = (PVOID) ALLOC(uiBufLen);
 memset(cd.lpData, 0, uiBufLen);

 cd.cbData = uiBufLen; // sizeof(struct PowerProServiceRequest);
 pPowerProServiceRequest = (struct PowerProServiceRequest*) cd.lpData;

 pPowerProServiceRequest->ppServType = ppServiceGetVar;

 pPowerProServiceRequest->ad[0].uiOff = sizeof(struct PowerProServiceRequest);
 pPowerProServiceRequest->ad[0].dwLen = uiVar;
 strcpy(PP_STR_ARG(pPowerProServiceRequest, 0), pszVar);

 if (SendMessage(hwndServer, WM_COPYDATA, (WPARAM) NULL, (LPARAM) &cd))
  lResult = SendMessage(hwndServer, MSG_TO_SERVICE_PLUGIN_TO_GET_DWORD_RESULT, 0, 0);

#if !defined (_MSC_VER)
 free((PVOID) cd.lpData);
#endif

 return lResult;
}

/////////////////////////////////////////////////////////////////////////////

BOOL ppGetVar(LPSTR pszVar, HWND hwndServer)
{
 COPYDATASTRUCT cd;
 LRESULT lResult = 0;
 struct PowerProServiceRequest* pPowerProServiceRequest;
 UINT uiVar = strlen(pszVar) + 1;
 UINT uiBufLen = sizeof(struct PowerProServiceRequest) + uiVar;

 cd.lpData = (PVOID) ALLOC(uiBufLen);
 memset(cd.lpData, 0, uiBufLen);

 cd.cbData = uiBufLen; // sizeof(struct PowerProServiceRequest);
 pPowerProServiceRequest = (struct PowerProServiceRequest*) cd.lpData;

 pPowerProServiceRequest->ppServType = ppServiceGetVar;

 pPowerProServiceRequest->ad[0].uiOff = sizeof(struct PowerProServiceRequest);
 pPowerProServiceRequest->ad[0].dwLen = uiVar;
 strcpy(PP_STR_ARG(pPowerProServiceRequest, 0), pszVar);

 lResult = SendMessage(hwndServer, WM_COPYDATA, (WPARAM) NULL, (LPARAM) &cd);

#if !defined (_MSC_VER)
 free((PVOID) cd.lpData);
#endif

 return lResult;
}

/////////////////////////////////////////////////////////////////////////////

VOID ppSetVar(LPSTR pszVar, LPSTR pszValue, HWND hwndServer)
{
 COPYDATASTRUCT cd;
 LRESULT lResult = 0;
 struct PowerProServiceRequest* pPowerProServiceRequest;
 UINT uiVar = strlen(pszVar) + 1;
 UINT uiValue = strlen(pszValue) + 1;
 UINT uiBufLen = sizeof(struct PowerProServiceRequest) + uiVar + uiValue;

 cd.lpData = (PVOID) ALLOC(uiBufLen);
 memset(cd.lpData, 0, uiBufLen);

 cd.cbData = uiBufLen; // sizeof(struct PowerProServiceRequest);
 pPowerProServiceRequest = (struct PowerProServiceRequest*) cd.lpData;

 pPowerProServiceRequest->ppServType = ppServiceSetVar;

 pPowerProServiceRequest->ad[0].uiOff = sizeof(struct PowerProServiceRequest);
 pPowerProServiceRequest->ad[0].dwLen =    uiVar;
 strcpy(PP_STR_ARG(pPowerProServiceRequest, 0), pszVar);

 pPowerProServiceRequest->ad[1].uiOff = pPowerProServiceRequest->ad[0].uiOff + uiVar;
 pPowerProServiceRequest->ad[1].dwLen =    uiValue;
 strcpy(PP_STR_ARG(pPowerProServiceRequest, 1), pszValue);

 SendMessage(hwndServer, WM_COPYDATA, (WPARAM) NULL, (LPARAM) &cd);

#if !defined (_MSC_VER)
 free((PVOID) cd.lpData);
#endif

 return;
}

/////////////////////////////////////////////////////////////////////////////

BOOL ppGetCurrentDir(HWND hwnd, HWND hwndServer)
{
 COPYDATASTRUCT cd;
 LRESULT lResult = 0;
 struct PowerProServiceRequest* pPowerProServiceRequest;
 UINT uiBufLen = sizeof(struct PowerProServiceRequest);

 cd.lpData = (PVOID) ALLOC(uiBufLen);
 memset(cd.lpData, 0, uiBufLen);

 cd.cbData = uiBufLen; // sizeof(struct PowerProServiceRequest);
 pPowerProServiceRequest = (struct PowerProServiceRequest*) cd.lpData;

 pPowerProServiceRequest->ppServType = ppServiceGetCurrentDir;

 pPowerProServiceRequest->ad[0].dw = (DWORD) hwnd;

 lResult = SendMessage(hwndServer, WM_COPYDATA, (WPARAM) NULL, (LPARAM) &cd);

#if !defined (_MSC_VER)
 free((PVOID) cd.lpData);
#endif

 return lResult;
}

/////////////////////////////////////////////////////////////////////////////

BOOL ppEvalExpr(LPSTR pszExpr, HWND hwndServer)
{
 COPYDATASTRUCT cd;
 LRESULT lResult = 0;
// LPSTR pszPtr = NULL;

 struct PowerProServiceRequest* pPowerProServiceRequest;
 UINT uiBufLen = sizeof(struct PowerProServiceRequest) + PP_VAR_SIZE + 1;

 cd.lpData = (PVOID) ALLOC(uiBufLen);
 memset(cd.lpData, 0, uiBufLen);

 cd.dwData = 0;
 cd.cbData = uiBufLen; // sizeof(struct PowerProServiceRequest);
 pPowerProServiceRequest = (struct PowerProServiceRequest*) cd.lpData;

 pPowerProServiceRequest->ppServType = ppServiceEvalExpr;
 pPowerProServiceRequest->ad[0].uiOff = sizeof(struct PowerProServiceRequest);
 pPowerProServiceRequest->ad[0].dwLen = PP_VAR_SIZE + 1;
// pszPtr = PP_STR_ARG(pPowerProServiceRequest, 0); 
 strcpy(PP_STR_ARG(pPowerProServiceRequest, 0), pszExpr);

 lResult = SendMessage(hwndServer, WM_COPYDATA, (WPARAM) NULL, (LPARAM) &cd);

#if !defined (_MSC_VER)
 free((PVOID) cd.lpData);
#endif

 return lResult;
}

/////////////////////////////////////////////////////////////////////////////

BOOL ppEncodeFloat(double dblVal, HWND hwndServer)
{
 COPYDATASTRUCT cd;
 LRESULT lResult = 0;
 struct PowerProServiceRequest* pPowerProServiceRequest;
 UINT uiBufLen = sizeof(struct PowerProServiceRequest);

 cd.lpData = (PVOID) ALLOC(uiBufLen);
 memset(cd.lpData, 0, uiBufLen);

 cd.cbData = uiBufLen; // sizeof(struct PowerProServiceRequest);
 pPowerProServiceRequest = (struct PowerProServiceRequest*) cd.lpData;

 pPowerProServiceRequest->ppServType = ppServiceEncodeFloat;
 pPowerProServiceRequest->dblArg = dblVal;
 lResult = SendMessage(hwndServer, WM_COPYDATA, (WPARAM) NULL, (LPARAM) &cd);

#if !defined (_MSC_VER)
 free((PVOID) cd.lpData);
#endif

 return lResult;
}

/////////////////////////////////////////////////////////////////////////////

BOOL ppDecodeFloat(LPSTR pszEncodedFloat, HWND hwndServer)
{
 COPYDATASTRUCT cd;
 LRESULT lResult = 0;
 struct PowerProServiceRequest* pPowerProServiceRequest;
 UINT uiPayload = strlen(pszEncodedFloat) + 1;
 UINT uiBufLen = sizeof(struct PowerProServiceRequest) + uiPayload;

 cd.lpData = (PVOID) ALLOC(uiBufLen);
 memset(cd.lpData, 0, uiBufLen);

 cd.cbData = uiBufLen; // sizeof(struct PowerProServiceRequest);
 pPowerProServiceRequest = (struct PowerProServiceRequest*) cd.lpData;

 pPowerProServiceRequest->ppServType = ppServiceDecodeFloat;

 pPowerProServiceRequest->ad[0].uiOff = sizeof(struct PowerProServiceRequest);
 pPowerProServiceRequest->ad[0].dwLen = uiPayload;
 strcpy(PP_STR_ARG(pPowerProServiceRequest, 0), pszEncodedFloat);

 lResult = SendMessage(hwndServer, WM_COPYDATA, (WPARAM) NULL, (LPARAM) &cd);

#if !defined (_MSC_VER)
 free((PVOID) cd.lpData);
#endif

 return lResult;
}

/////////////////////////////////////////////////////////////////////////////
//service routines used by any of above that return a string
/////////////////////////////////////////////////////////////////////////////

LPSTR getMappedFile(HWND hwnd, OUT PHANDLE phmem)
{
 *phmem = OpenFileMapping(FILE_MAP_ALL_ACCESS, FALSE, FILE_MAP_NAME);
 if (*phmem)
 {
  UINT uiFileMapDataLen = SendMessage(hwnd, MSG_TO_SERVICE_PLUGIN_TO_GET_STRING_RESULT_LEN, 0, 0);
//If is zero, the entire file is mapped.                        dwNumberOfBytesToMap
  return (LPSTR) MapViewOfFile(*phmem, FILE_MAP_ALL_ACCESS, 0, 0, uiFileMapDataLen);
 }
 return NULL;
}

//////////////////////////////////////////////////////////////////////////

void closeMappedFile(LPSTR pszFileMap, HANDLE hmem)
{
 if (pszFileMap) UnmapViewOfFile(pszFileMap);
 if (hmem)       CloseHandle(hmem);
}

//////////////////////////////////////////////////////////////////////////
