
/////////////////////////////////////////////////////////////////////////////
// sampleUnicodeClientPlugin: a PowerPro Plugin illustrating use of BytelBlock interface

// version 0.32beta	 27 ec 2005
//
// Copyright (C) 2005 by Alan Campbell
// All rights reserved
//
// Distribute freely, except: don't remove my name from the source or
// documentation (don't take credit for my work), mark your changes (don't
// get me blamed for your possible bugs), don't alter or remove this
// notice.

// No warranty of any kind, express or implied, is included with this
// software; use at your own risk, responsibility for damages (if any) to
// anyone resulting from the use of this software rests entirely with the
// user.
//
// Send bug reports, bug fixes, enhancements, requests, flames, etc., and
// I'll try to keep a version up to date.  I can be reached via the
// PowerPro forum

// And thanks to Marko Bozikovic: I stole this comment header from him.

/////////////////////////////////////////////////////////////////////////////

#include <windows.h>
#include "PowerProDefines.h"

struct PPUNICODESERVICES
{
 BOOL   (* bFreeSpace)();
 WCHAR* (* get)       (IN LPSTR);
 BOOL   (*add)        (IN WCHAR* ,LPSTR);
 BOOL   (* remove)    (IN LPSTR);
};                                              

#ifdef SAMPLE_PLUGIN_EXPORTS
#define SAMPLE_PLUGIN_API __declspec(dllexport)
#else
#define SAMPLE_PLUGIN_API __declspec(dllimport)
#endif

//////////////////////////////////////////////////////////////////////////

#ifndef PLUGIN_NAME
   #define PLUGIN_NAME sample
#endif

LPCSTR G_PSZ_VERSION_NUMBER = "0053";

static HWND g_hwndPowerPro;

PPROSERVICES* g_ppsv = NULL;
HMODULE g_hmodule_unicode = NULL;

static struct PPUNICODESERVICES* g_pUnicodeServices;

HMODULE loadDLL(LPTSTR dll_name);

// Main DLL entry point.  Save handle to main PowerPro window.
BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD dwReason, LPVOID lpvReserved)
{

 if(dwReason == DLL_PROCESS_ATTACH)
 {

//nothing to do with using binary.dll, just do this so I have...
  g_hwndPowerPro = FindWindow("PowerProMain",NULL);

//...a PPROSERVICES* pointer
  if (g_hwndPowerPro)
   g_ppsv = (PPROSERVICES*) SendMessage(g_hwndPowerPro, WM_USER+501, 0,0);

//get binary.dll func ptrs
  g_hmodule_unicode = loadDLL("plugins\\unicode");
  if (!g_hmodule_unicode)
    g_hmodule_unicode = loadDLL("unicode");

  if (g_hmodule_unicode)
  {
   struct PPUNICODESERVICES* (* pfn_getUnicodeServices) () =
     (struct PPUNICODESERVICES* (*) ()) 
       GetProcAddress(g_hmodule_unicode, "getUnicodeServices");;

   if (pfn_getUnicodeServices) 
    g_pUnicodeServices = pfn_getUnicodeServices();
  } // if (g_hmodule_unicode)

 } // if(dwReason == DLL_PROCESS_ATTACH)

 else if(dwReason == DLL_PROCESS_DETACH)
 {
//close any windows, unregister any classes
  if (g_hmodule_unicode) 
    FreeLibrary(g_hmodule_unicode);
 }

 return TRUE;
}

//////////////////////////////////////////////////////////////////////////
//RETURN SECOND ARGUMENT SURROUNDED BY NULL BYTES

SAMPLE_PLUGIN_API void sample(LPSTR szv, LPSTR szx,
	 int (*GetVar)(LPSTR szVar, LPSTR szVal),
	 void (*SetVar)(LPSTR szVar, LPSTR szVal), DWORD* pFlags,
     UINT nargs, LPSTR* szArgs,
     PPROSERVICES* ppsv )
{
 WCHAR* pszwString;	
//LPCSTR lpFuncName = STRINGIFY(JOIN(PLUGIN_NAME,.sample));
 if (nargs == 0)
   return;

 *PP_PLUGIN_RET = 0;

 if (!g_pUnicodeServices)
   return;

 pszwString = g_pUnicodeServices->get(PP_PLUGIN_ARG1);
 if (pszwString)
   MessageBoxW(g_hwndPowerPro, pszwString, L"Message From Mars", MB_OK);
}

//////////////////////////////////////////////////////////////////////////


SAMPLE_PLUGIN_API void version(LPSTR szv, LPSTR szx,
	 int (*GetVar)(LPSTR szVar, LPSTR szVal),
	 void (*SetVar)(LPSTR szVar, LPSTR szVal), DWORD* pFlags,
     UINT nargs, LPSTR* szArgs, PPROSERVICES* ppsv )
{
// LPCSTR lpFuncName = STRINGIFY(JOIN(PLUGIN_NAME,.version));
 strcpy(PP_PLUGIN_RET, G_PSZ_VERSION_NUMBER);
}


//////////////////////////////////////////////////////////////////////////
//private
//////////////////////////////////////////////////////////////////////////

HMODULE loadDLL(LPTSTR dll_name)
{
/*
MSDN says:

  Note that the reference count is used in FreeLibrary to determine whether to 
  unmap the function from the address space of the process. For this reason, 
  use care when using a handle returned by GetModuleHandle in a call to FreeLibrary 
  because doing so can cause a dynamic-link library (DLL) module to be 
  unmapped prematurely. 

*/

 HMODULE h = NULL; // = GetModuleHandle(dll_name);
// if (!h)
// {
 HINSTANCE hi = LoadLibrary(dll_name); 
 if (hi)
   h= GetModuleHandle(dll_name);
// }
 return h;
}

//////////////////////////////////////////////////////////////////////////

